<?
#
# Upgrade Manager - error page
#
# Bogdan Stancescu <bogdan@lanifex.com>, January 2002
# Revision 1.0
  include "../include/OPT_lib.php";
  auth_open();
  if ($CRM_comp!=1)
  {
    exit;
  }
  include "$CRM_path/UpgradeManager/upg_lib.php";
  include "$CRM_path/UpgradeManager/xml_lib.php";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>OPT Upgrade</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../images");
  make_main_title("OPT Upgrade Error","../images");
  echo("<div align='center' class='regular'>\n");
  if ($err=="perm")
  {
    echo("<b>User ".exec("whoami")." user doesn't have permissions to modify file
      $CRM_path/$file</b>
      <p>You should simply change the permissions for the whole OPT directory for the
      duration of this upgrade. Obviously, you could also set permissions only for the
      files being changed, but that's much more tedious.
      <p>Another way to deal with frequent upgrades without the permissions hassle
      would be to set user ".exec("whoami")." as the owner of the whole OPT directory.
      You can do this by typing the following line from a console, running as root:
      <pre>chown -R ".exec("whoami")." $CRM_path</pre>
      You could optionally also set a restrictive permissions policy by typing
      <pre>chmod -R 700 $CRM_path</pre>
      This way nobody but administrators and ".exec("whoami")." have access to the OPT files,
      so you don't have to bother with permissions anymore!");
  }
  elseif ($err=="upg")
  {
    echo("<b>File $CRM_path/UpgradeManager/$loc/Files/$file does not exist</b>
      <p>Either your OPT upgrade package is incomplete or user ".exec("whoami").
      " doesn't have read permissions on this file. You should make sure that the
      file above exists and that anybody can read it.");
  }
  elseif ($err=="type")
  {
    echo("<b>Directive &quot;$type&quot; for file $CRM_path/UpgradeManager/$loc/Files/$file
      is not supported by this version of OPT</b>
      <p>Unfortunately this means that you'll have to try to make out what this
      directive means and manually perform the operation yourself.
      <p>Please e-mail
      <a class='regular' href='mailto:bogdan@lanifex.com'>bogdan@lanifex.com</a>
      and let him know about this bug - you're not supposed to get in this situation.");
  }
  elseif ($err=="sql")
  {
    echo("<b>An SQL statement in file $CRM_path/UpgradeManager/$loc/Files/$file
      issued errors</b>
      <p>This should never happen unless you messed with the database. Otherwise this
      is either a bug or a problem with your download.
      <p>Please try retrieving the upgrade file again and placing the resulting directory
      in $CRM_path/UpgradeManager/$loc
      <p>If this doesn't work, please submit a bug report on the <a class=\"regular\"
      href=\"http://sourceforge.net/projects/outreach\">OPT sourceforge page</a> or
      via e-mail at <a class=\"regular\" href=\"mailto:bogdan@lanifex.com\">bogdan@lanifex.com</a>.");
  }
  elseif ($err=="bakdir")
  {
    echo("<b>Unable to create backup directory for file $CRM_path/UpgradeManager/$loc/Files/$file</b>
      <p>Future versions of OPT Upgrade Manager will give you the opportunity to go back
      to previous versions of OPT even after performing an upgrade. This is done by
      creating backups of every file overwritten in the upgrade process. The backup is
      made in the same directory as the file by creating a directory named &quot;backup&quot;.
      <p>The problem here is that the backup directory could not be created.
      Most probably this is a permissions problem - we recommend setting full permissions
      on the whole OPT directory for the duration of this upgrade in order to avoid
      such problems.
      <p>Another way to deal with frequent upgrades without the permissions hassle
      would be to set user ".exec("whoami")." as the owner of the whole OPT directory.
      You can do this by typing the following line from a console, running as root:
      <pre>chown -R ".exec("whoami")." $CRM_path</pre>
      You could optionally also set a restrictive permissions policy by typing
      <pre>chmod -R 700 $CRM_path</pre>
      This way nobody but administrators and ".exec("whoami")." have access to the OPT files,
      so you don't have to bother with permissions anymore!");
  }
  elseif ($err=="bakfil")
  {
    echo("<b>Unable to create backup directory for file $CRM_path/UpgradeManager/$loc/Files/$file</b>
      <p>Future versions of OPT Upgrade Manager will give you the opportunity to go back
      to previous versions of OPT even after performing an upgrade. This is done by
      creating backups of every file overwritten in the upgrade process. The backup is
      made in the same directory as the file by creating a directory named &quot;backup&quot;.
      <p>The problem here is that the file can't be written in the directory.
      Most probably this is a permissions problem - we recommend setting full permissions
      on the whole OPT directory for the duration of this upgrade in order to avoid
      such problems.
      <p>Another way to deal with frequent upgrades without the permissions hassle
      would be to set user ".exec("whoami")." as the owner of the whole OPT directory.
      You can do this by typing the following line from a console, running as root:
      <pre>chown -R ".exec("whoami")." $CRM_path</pre>
      You could optionally also set a restrictive permissions policy by typing
      <pre>chmod -R 700 $CRM_path</pre>
      This way nobody but administrators and ".exec("whoami")." have access to the OPT files,
      so you don't have to bother with permissions anymore!");
  }
  elseif ($err=="cpyfil")
  {
    echo("<b>Unable to replace file $CRM_path/$loc/Files/$file</b>
      <p>This is most unusual - although all the tests were passed for copying, this file
      could not be overwritten. The most probable cause would be disk space.");
  }
  elseif ($err=="var")
  {
    echo("<b>Unable to find variable $var in file $CRM_path/UpgradeManager/$loc/Files/$file</b>
      <p>This error occurs when a &quot;change variable&quot; directive is included in the upgrade
      XML and the file where the variable to be changed does not contain the respective
      variable at all.
      <p>A typical example is the fact that upgrades have to change the version number
      of OPT. The version number is stored in a file as a variable. If you edit the
      respective file and wipe out the version, this is the kind of error you'll get when
      trying to upgrade.
      <p>You'll have to download a full version of OPT and replace the offending file with the
      one from the full install.");
  }
  elseif ($err=="parse")
  {
    echo("<b>Unable to parse file $CRM_path/$file</b>
      <p>Upgrade Manager needs to parse the initialization file above and
      it was unable to. This normally is a packaging error - the file to be parsed should normally
      come with this package. All you can do is look who the packager was and send him/her an e-mail
      notifying about this problem - normally you can find that in the changes log for this package
      from the main Upgrade Manager page.");
  }
  elseif ($err=="parse_not_found")
  {
    echo("<b>Unable to find file $CRM_path/$file</b>
      <p>Upgrade Manager needs to parse the initialization file above and
      it can't find it. This normally is a packaging error - the file to be parsed should normally
      come with this package. All you can do is look who the packager was and send him/her an e-mail
      notifying about this problem - normally you can find that in the changes log for this package
      from the main Upgrade Manager page.");
  }
  elseif ($err=="file")
  {
    echo("<b>Unable to find file $CRM_path/UpgradeManager/$loc/Files/$file</b>
      <p>Upgrade Manager needs to edit the file above and
      it can't find it. This would be easily solvable for files which come with the
      upgrade - it would simply create the file from scratch. Unfortunately, it doesn't
      find a file which contains data specific to this server so it can't simply be
      replaced.
      <p>You'll have to download a full version of OPT and replace the offending file with the
      one from the full install.");
  }
  elseif ($err=="mkdirperm")
  {
    echo("<b>User ".exec("whoami")." doesn't have permissions to create directory $loc.</b>
      <p>Upgrade Manager needs to create the directory above and doesn't have the required
      permissions to.
      <p>We recommend setting full permissions
      on the whole OPT directory for the duration of this upgrade in order to avoid
      such problems.
      <p>Another way to deal with frequent upgrades without the permissions hassle
      would be to set user ".exec("whoami")." as the owner of the whole OPT directory.
      You can do this by typing the following line from a console, running as root:
      <pre>chown -R ".exec("whoami")." $CRM_path</pre>
      You could optionally also set a restrictive permissions policy by typing
      <pre>chmod -R 700 $CRM_path</pre>
      This way nobody but administrators and ".exec("whoami")." have access to the OPT files,
      so you don't have to bother with permissions anymore!");
  }
  else
  {
    echo("<b>Unknown error</b>
      <p>I really can't tell what kind of an error you've got there. Maybe you were
      just checking out random URL's? :-)
      <p>If you used a link to get here, please e-mail
      <a class='regular' href='mailto:bogdan@lanifex.com'>bogdan@lanifex.com</a>
      and tell him that you've got a bug in OPT with error type &quot;$err&quot;");
  }
  echo("</div>\n");
  auth_close();
?>
</BODY>
</HTML>
