<?
#
# Upgrade Manager main page
#
# Bogdan Stancescu <bogdan@lanifex.com>, January 2002
# Revision 1.0
  include "../include/OPT_lib.php";
  auth_open();
  if (($CRM_comp!=1) || ($CRM_guest) || ($CRM_demo))
  {
      OPT_error("Sorry.  Either you don't have permissions to be here or are logged into demo mode.");
      exit;
  }
  include "$CRM_path/UpgradeManager/upg_lib.php";
  include "$CRM_path/UpgradeManager/xml_lib.php";

  if ($feedback)
  {
    CRM_run_query("delete from settings where name=\"feedback_interval\"");
    CRM_run_query("insert into settings set name=\"feedback_interval\", value=\"".
      OPT_gpc_slashes($often)."\"");
    $type="";
    if ($srvname)
    {
      $type.="s";
    }
    if ($users)
    {
      $type.="u";
    }
    if ($proj)
    {
      $type.="p";
    }
    if ($notes)
    {
      $type.="n";
    }
    if ($nl)
    {
      $type.="l";
    }
    if ($feednow)
    {
      $type.="w"; // Now (after upgrade)
    }
    CRM_run_query("delete from settings where name=\"feedback_type\"");
    CRM_run_query("insert into settings set name=\"feedback_type\", value=\"$type\"");
  }
  $sql="select count(*) from settings where name=\"feedback_interval\"";
  $result=CRM_run_query($sql);
  $myrow=OPT_fetch_row($result);
  if (!$myrow[0])
  {
    include("$CRM_path/UpgradeManager/welcome.php");
    auth_close();
    exit;
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>OPT Upgrade Manager</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../images");
  make_main_title("OPT Upgrade Manager","../images");
  if ($action=="delete")
  {
    include "$CRM_path/UpgradeManager/dodelete.php";
    echo("<div class=\"regular\" align=\"center\">");
    $loc=deletePackage($loc);
    if ($loc)
    {
      echo("<b>Unable to delete $loc</b><br>");
      echo("Please check the permissions and <a class=\"regular\" href=\"./?action=delete&loc=".rawurlencode($loc)."\">try again</a>!<br><br>");
    }
    else
    {
      echo("<b>Package deleted</b>");
    }
    echo("</div>\n");
  }
  startTables();
?>
<tr>
  <td class="ah4" bgcolor="<? echo $OPT_col_dk; ?>" align="center" colspan="4">
<?
  echo("Your current version of OPT is $CRM_ver $CRM_subver");
?>
  </td>
</tr>
<tr>
  <td class="small" bgcolor="<? echo $OPT_col_md; ?>" align="center" colspan="4">
    Click <a class="small" href="welcome.php" target="_blank">here</a> for more information
    on the Upgrade Manager.
  </td>
</tr>
<?
  $d=dir("./");
  $first=true;
  $anyfits=false;
  while ($entry=$d->read())
  {
    if (is_dir($entry) && ($entry[0]!="."))
    {
      if (is_file($entry."/upgrade.xml"))
      {
        if ($first)
        {
          echo("<tr><td class='regular' bgcolor='$OPT_col_md' align='center'><b>Comment</b></td>".
            "<td class='regular' bgcolor='$OPT_col_md' align='center'><b>Location</b></td>".
            "<td class='regular' bgcolor='$OPT_col_md' align='center' colspan='2'><b>Action</b></td></tr>\n");
          $first=false;
        }
        $xml = implode("", file($entry."/upgrade.xml"));
        $array = parse_xml($xml);
        $anyfits=$anyfits | CheckUpgrade($array["upgrade"][0],1,$show=="all");
      }
    }
  }
  $d->close();
  if (($anyfits) && (!$forceremote))
  {
    echo("<tr><td class='small' bgcolor='$OPT_col_dk' align='center' colspan='4'>
      Since local matching upgrades were found, no remote locations were searched.
      </td></tr>\n");
  }
  if ((!$anyfits) || ($forceremote)) // Let's do the remote search
  {
    // A lot to explain here - enough said that since this might be this
    // user's first page view after login we need to auth_close() on him
    // before opening the new window in order to register his session.
    // Since we don't want phplib to send any headers, we'll inhibate
    // that by setting $CRM_noheaders.
    $CRM_noheaders=true;
    auth_close();
    auth_open();
    echo("<SCRIPT LANGUAGE='JavaScript1.1' type='text/javascript'>\n<!--\n");
    echo("var emailWin;\nemailWin=window.open('remote.php?which=1','_blank','width=300,height=100,status=no,toolbar=no,menubar=no,location=no,resizable=no,titlebar=no,scrollbars=no,fullscreen=no,top=2,left=2');\n");
    echo("//--></script>\n");
    flush();
    set_time_limit(30);
    $upgrades=@file("http://www.guydavis.ca/opt_releases/upgrades.xml");
    if (!$upgrades)
    {
        echo("<SCRIPT LANGUAGE='JavaScript1.1' type='text/javascript'>\n<!--\n");
        echo("emailWin.location='remote.php?which=3';\n");
        echo("//--></script>\n");
        flush();
        set_time_limit(30);
        // Note: This link will likely never work due to the mirror thing at SF
        $upgrades=@file("http://prdownloads.sourceforge.net/outreach/upgrades_max.xml");
        if (!$upgrades)
        {
            echo("<SCRIPT LANGUAGE='JavaScript1.1' type='text/javascript'>\n<!--\n");
            echo("emailWin.close();\n");
            echo("//--></script>\n");
            flush();
            echo("<tr><td class='regular' bgcolor='$OPT_col_md' align='center' colspan='4'>
            Unable to retrieve the list of remote upgrades! Please check your server's
            Internet connection!
            <p>If your server doesn't have a working Internet connection then Upgrade
            Manager's part of checking for and retrieving remote upgrades doesn't work.<br>
            In this case you should manually check
            <a class='regular' href='http://sourceforge.net/projects/outreach' target='_blank'>
            OPT's sourceforge page</a> for upgrades. Unzip and untar the upgrade file in
            $CRM_path/UpgradeManager/ and reload this page.</td></tr>\n");
            endTables();
            echo("</body></html>\n");
            auth_close();
            exit;
        }
    }
    echo("<SCRIPT LANGUAGE='JavaScript1.1' type='text/javascript'>\n<!--\n");
    echo("emailWin.close();\n");
    echo("//--></script>\n");
    flush();
    $xml = implode("", $upgrades);
    $array = parse_xml($xml);
    for ($i=0;($upgrade=$array["upgrades"][0]["upgrade"][$i]);$i++)
    {
      if ($first)
      {
        echo("<tr><td class='regular' bgcolor='$OPT_col_md' align='center'><b>Comment</b></td>".
          "<td class='regular' bgcolor='$OPT_col_md' align='center'><b>Location</b></td>".
          "<td class='regular' bgcolor='$OPT_col_md' align='center' colspan='2'><b>Action</b></td></tr>\n");
        $first=false;
      }
      $anyfits=$anyfits | CheckUpgrade($upgrade,0);
    }
    if ($anyfits)
    {
      echo("<tr><td class='small' bgcolor='$OPT_col_dk' align='center' colspan='4'>
        You must download remote upgrade packages before installing them.
        </td></tr>\n");
    }
  }
  if ($first)
  {
    echo("<tr><td class='regular' bgcolor='$OPT_col_lt' align='center' colspan='4'>
      No upgrades found.</td></tr>\n");
  }
  elseif (!$anyfits)
  {
    echo("<tr><td class='regular' bgcolor='$OPT_col_dk' align='center' colspan='4'>
      No matching upgrades found.</td></tr>\n");
  }
  endTables();
?>
</body>
</html>
<?
  auth_close();
?>
