<?
#
# Upgrade Manager - performing the upgrade
#
# Bogdan Stancescu <bogdan@lanifex.com>, January 2002
# Revision 1.0
  include "../include/OPT_lib.php";
  auth_open();
  if (($CRM_comp!=1) || ($CRM_guest) || ($CRM_demo)) {
    exit;
  }
  include "$CRM_path/UpgradeManager/upg_lib.php";
  include "$CRM_path/UpgradeManager/xml_lib.php";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>OPT Upgrade - Upgrading</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../images");
  make_main_title("Upgrading OPT","../images");
  $slocation=rawurlencode($location);
  if ((!$location) || (!is_dir($location))) {
    echo("Please use <a class='regular' href='./'>this</a> link in order to
    properly start an upgrade");
    auth_close();
    exit;
  }
  $result=CRM_run_query("select value from settings where name=\"UM_loc\"",0);
  $pos=0;
  if (list($oldloc)=OPT_fetch_row($result)) {
    if ($oldloc!=$location) {
      echo("You have an unfinished upgrade in progress. Please use
        <a class='regular' href='./upgrade.php?location='".rawurlencode($oldloc).
        "'>this link</a> in order to resume the previously abored upgrade.");
      auth_close();
      exit;
    }
    $result=CRM_run_query("select value from settings where name=\"UM_pos\"",0);
    list($pos)=OPT_fetch_row($result);
  }
  if (is_file($location."/default_pre1.php")) {
    if ($run_pre) {
      include("$location/default_pre1.php");
      echo("</body></html>\n");
      auth_close();
      exit;
    } elseif (!$ran_pre) {
      startTables();
      echo("<tr><td bgcolor='$OPT_col_lt'>\n");
      echo("This package requires a PHP file to run before performing the actual upgrade.
        Please <a class='regular' href='./doupgrade.php?location=$slocation&run_pre=1'>click
        here</a> in order to run it. If you want to check the code before running it, the
        PHP which will run is located here: $CRM_path/UpgradeManager/$location/default_pre1.php");
      if (is_file($location."/default_pre2.php")) {
        echo("Please be aware that $CRM_path/UpgradeManager/$location/default_pre2.php will also run
          on the page immediately after default_pre1.php, so you may want to check that as well.");
      }
      echo("</td></tr>\n");
      endTables();
      echo("</body></html>\n");
      auth_close();
      exit;
    } elseif (is_file($location."/default_pre2.php")) {
      include($location."/default_pre2.php");
    }
  }
  if (is_file($location."/upgrade.xml")) {
    startTables();
    $xml = implode("", file($location."/upgrade.xml"));
    $array = parse_xml($xml);
    $oldver=$array["upgrade"][0]["version"][0]["oldver"][0];
    $newver=$array["upgrade"][0]["version"][0]["newver"][0];
    $upg_system=$array["upgrade"][0]["system"][0];
    $upg_name=$array["upgrade"][0]["version"][0]["name"][0];
    if (!$upg_name) {
      $upg_name="OPT";
    }
    echo("<tr><td class='ah4' align='center' bgcolor='$OPT_col_dk' colspan='2'>\n");
    if (($upg_system=="OPT") && ($oldver!=$CRM_ver) && ($oldver!="*")) {
      echo("You somehow managed to specify a wrong upgrade.
        Please use <a class='ah4' href='./'>this</a> link in order to
        properly start an upgrade.</td></tr>");
      endTables();
      auth_close();
      exit;
    }
    if ($upg_system=="OPT") {
      echo("Upgrading from $upg_name $oldver to $newver</td></tr>\n");
    } elseif ($upg_system=="OPT Plugin") {
      echo("Installing plugin $upg_name $newver</td></tr>\n");
    } elseif ($upg_system=="OPT Plugin Upgrade") {
      echo("Upgrading plugin $upg_name from $oldver to $newver</td></tr>\n");
    }
    echo("<tr><td class='small' align='center' bgcolor='$OPT_col_md' colspan='2'>\n");
    echo("This page performs the actual upgrade. The upgrade elements and their
      status is displayed below.");
    echo("</td></tr>\n");
    $offending=-1;

    // WALKING UPGRADE.XML ACTION TAGS
    for ($i=0;($action=$array["upgrade"][0]["actions"][0]["action"][$i]);$i++) {

      // ALREADY DONE
      if ($i<$pos) { //>
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." ".$CRM_path."/".
          $action["target"][0]."/".$action["filename"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        echo("<i>Done in a previous pass</i>\n");

      // NOT DONE YET
      } elseif ($offending!=-1) {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." ".$CRM_path."/".
          $action["target"][0]."/".$action["filename"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        echo("<i>Didn't get there</i>\n");

      // REPLACE AND REPLACE NEW TAGS
      } elseif (($action["type"][0]=="replace") || ($action["type"][0]=="replace new")) {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." ".$CRM_path."/".
          $action["target"][0]."/".$action["filename"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        if ($f=@fopen($location."/Files/".$action["target"][0]."/".$action["filename"][0],"r")) {
          fclose($f);
          if ($f=@fopen($CRM_path."/".$action["target"][0]."/".$action["filename"][0],"a+")) {
            fclose($f);
            if (!is_dir($location."/Files/".$action["target"][0]."/backup")) {
              $temp_err=!@mkdir($location."/Files/".$action["target"][0]."/backup",0777);
              if ($temp_err) {
                echo("<a class='regular' href='err.php?file=".
                  rawurlencode($action["target"][0]."/".$action["filename"][0]).
                  "&loc=".rawurlencode($location).
                  "&err=bakdir' target='_blank'>Unable to create backup directory!</a>");
                $offending=$i;
              }
            }
            if ($offending==-1) {
              // We sometimes create files instead of replacing so there's nothing to back up.
              if (is_file($CRM_path."/".$action["target"][0]."/".$action["filename"][0])) {
                $temp_err=!@copy($CRM_path."/".$action["target"][0]."/".$action["filename"][0],
                  $location."/Files/".$action["target"][0]."/backup/".$action["filename"][0]);
              } else {
                $temp_err=false;
              }
              if ($temp_err) {
                echo("<a class='regular' href='err.php?file=".
                  rawurlencode($action["target"][0]."/".$action["filename"][0]).
                  "&loc=".rawurlencode($location).
                  "&err=bakfil' target='_blank'>Unable to create backup file!</a>");
                $offending=$i;
              } else { // Ok, we're done with the backup. Let's now do the actual replacement
                $temp_err=!copy($location."/Files/".$action["target"][0]."/".$action["filename"][0],
                  $CRM_path."/".$action["target"][0]."/".$action["filename"][0]);
                if ($temp_error) {
                  echo("<a class='regular' href='err.php?file=".
                    rawurlencode($action["target"][0]."/".$action["filename"][0]).
                    "&loc=".rawurlencode($location).
                    "&err=cpyfil' target='_blank'>Unable to replace file!</a>");
                  $offending=$i;
                } else {
                  echo("OK");
                }
              }
            }
          } else {
            echo("<a class='regular' href='err.php?file=".
              rawurlencode($action["target"][0]."/".$action["filename"][0]).
              "&loc=".rawurlencode($location).
              "&err=perm' target='_blank'>No permissions!</a>");
            $offending=$i;
          }
        } else {
            echo("<a class='regular' href='err.php?file=".
              rawurlencode($action["target"][0]."/".$action["filename"][0]).
              "&loc=".rawurlencode($location).
              "&err=upg' target='_blank'>Upgrade file not found!</a>");
          $offending=$i;
        }

      // REMOVE TAG
      } elseif ($action["type"][0]=="remove") {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." ".$CRM_path."/".
          $action["target"][0]."/".$action["filename"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");

        if ($f=@fopen($CRM_path."/".$action["target"][0]."/".$action["filename"][0],"a+")) {
          fclose($f);
          if (!is_dir($location."/Files/".$action["target"][0]."/backup")) {
            $temp_err=!@mkdir($location."/Files/".$action["target"][0]."/backup",0777);
            if ($temp_err) {
              echo("<a class='regular' href='err.php?file=".
                rawurlencode($action["target"][0]."/".$action["filename"][0]).
                "&loc=".rawurlencode($location).
                "&err=bakdir' target='_blank'>Unable to create backup directory!</a>");
              $offending=$i;
            }
          }
          if ($offending==-1) {
            $temp_err=!@copy($CRM_path."/".$action["target"][0]."/".$action["filename"][0],
              $location."/Files/".$action["target"][0]."/backup/".$action["filename"][0]);
            if ($temp_err) {
              echo("<a class='regular' href='err.php?file=".
                rawurlencode($action["target"][0]."/".$action["filename"][0]).
                "&loc=".rawurlencode($location).
                "&err=bakfil' target='_blank'>Unable to create backup file!</a>");
              $offending=$i;
            } else { // Ok, we're done with the backup. Let's remove the file
              $temp_err=!@unlink($CRM_path."/".$action["target"][0]."/".$action["filename"][0]);
              if ($temp_error) {
                echo("<a class='regular' href='err.php?file=".
                  rawurlencode($action["target"][0]."/".$action["filename"][0]).
                  "&loc=".rawurlencode($location).
                  "&err=cpyfil' target='_blank'>Unable to remove file!</a>");
                $offending=$i;
              } else {
                echo("OK");
              }
            }
          }
        } else {
          echo("<a class='regular' href='err.php?file=".
            rawurlencode($action["target"][0]."/".$action["filename"][0]).
            "&loc=".rawurlencode($location).
            "&err=perm' target='_blank'>No permissions!</a>");
          $offending=$i;
        }

      // PARSE INIT FILE TAG
      } elseif ($action["type"][0]=="parse init file") {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." ".$CRM_path."/".
          $action["target"][0]."/".$action["filename"][0]." into ".
          $action["target"][0]."/".$action["value"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        if ($f=@fopen($location."/Files/".$action["target"][0]."/".$action["filename"][0],"r")) {
          fclose($f);
          if ($f=@fopen($CRM_path."/".$action["target"][0]."/".$action["filename"][0],"a+")) {
            fclose($f);
            if (!is_dir($location."/Files/".$action["target"][0]."/backup")) {
              $temp_err=!@mkdir($location."/Files/".$action["target"][0]."/backup",0777);
              if ($temp_err) {
                echo("<a class='regular' href='err.php?file=".
                  rawurlencode($action["target"][0]."/".$action["value"][0]).
                  "&loc=".rawurlencode($location).
                  "&err=bakdir' target='_blank'>Unable to create backup directory!</a>");
                $offending=$i;
              }
            }
            if ($offending==-1) {
              // We sometimes create files instead of replacing so there's nothing to back up.
              if (is_file($CRM_path."/".$action["target"][0]."/".$action["value"][0])) {
                $temp_err=!@copy($CRM_path."/".$action["target"][0]."/".$action["value"][0],
                  $location."/Files/".$action["target"][0]."/backup/".$action["value"][0]);
              } else {
                $temp_err=false;
              }
              if ($temp_err) {
                echo("<a class='regular' href='err.php?file=".
                  rawurlencode($action["target"][0]."/".$action["value"][0]).
                  "&loc=".rawurlencode($location).
                  "&err=bakfil' target='_blank'>Unable to create backup file!</a>");
                $offending=$i;
              } else { // Ok, we're done with the backup. Let's now do the actual parsing
                $temp_err=!parseInitFile($CRM_path."/".$action["target"][0]."/".$action["filename"][0],
                  $CRM_path."/".$action["target"][0]."/".$action["value"][0]);
                if ($temp_error) {
                  echo("<a class='regular' href='err.php?file=".
                    rawurlencode($action["target"][0]."/".$action["filename"][0]).
                    "&loc=".rawurlencode($location).
                    "&err=parse' target='_blank'>Unable to parse file!</a>");
                  $offending=$i;
                } else {
                  echo("OK");
                }
              }
            }
          } else {
            echo("<a class='regular' href='err.php?file=".
              rawurlencode($action["target"][0]."/".$action["value"][0]).
              "&loc=".rawurlencode($location).
              "&err=perm' target='_blank'>No permissions!</a>");
            $offending=$i;
          }
        } else {
            echo("<a class='regular' href='err.php?file=".
              rawurlencode($action["target"][0]."/".$action["filename"][0]).
              "&loc=".rawurlencode($location).
              "&err=parse_not_found' target='_blank'>Original file not found!</a>");
          $offending=$i;
        }

      // CHANGE VARIABLE TAG
      } elseif ($action["type"][0]=="change variable") {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." in ".$CRM_path."/".
          $action["target"][0]."/".$action["filename"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        if ($f=@fopen($CRM_path."/".$action["target"][0]."/".$action["filename"][0],"r")) {
          if ($f=@fopen($CRM_path."/".$action["target"][0]."/".$action["filename"][0],"a+")) {
            fclose($f);
            $file=file($CRM_path."/".$action["target"][0]."/".$action["filename"][0]);
            $found=false;
            $var=$action["variable"][0];
            for ($j=0;(($j<sizeOf($file)) && (!$found));$j++) { //>
              if (substr(trim($file[$j]),0,strlen($var))==$var) {
                $found=true;
              }
            }
            if ($found) {
              if (!is_dir($location."/Files/".$action["target"][0]."/backup")) {
                $temp_err=!@mkdir($location."/Files/".$action["target"][0]."/backup",0777);
              } else {
                $temp_err=false;
              }
              if ($temp_err) {
                echo("<a class='regular' href='err.php?file=".
                  rawurlencode($action["target"][0]."/".$action["filename"][0]).
                  "&loc=".rawurlencode($location).
                  "&err=bakdir' target='_blank'>Unable to create backup directory!</a>");
                $offending=$i;
              } else {
                $temp_err=!@copy($CRM_path."/".$action["target"][0]."/".$action["filename"][0],
                  $location."/Files/".$action["target"][0]."/backup/".$action["filename"][0]);
                if ($temp_err) {
                  echo("<a class='regular' href='err.php?file=".
                    rawurlencode($action["target"][0]."/".$action["filename"][0]).
                    "&loc=".rawurlencode($location).
                    "&err=bakfil' target='_blank'>Unable to create backup file!</a>");
                  $offending=$i;
                } else {
                  $fin=fopen($CRM_path."/".$action["target"][0]."/".$action["filename"][0],"r");
                  $fout=fopen("temp_varchange","w");
                  while(!feof($fin)) {
                    $line=fgets($fin,4096);
                    if (substr(trim($line),0,strlen($var))==$var) {
                      $line="  ".$var."=".$action["value"][0].";\n";
                    }
                    fputs($fout,$line);
                  }
                  fclose($fin);
                  fclose($fout);
                  copy("temp_varchange",$CRM_path."/".$action["target"][0]."/".$action["filename"][0]);
                  unlink("temp_varchange");
                  echo("OK\n");
                }
              }
            } else {
              echo("<a class='regular' href='err.php?file=".
                rawurlencode($action["target"][0]."/".$action["filename"][0]).
                "&loc=".rawurlencode($location)."&var=".rawurlencode($var).
                "&err=var' target='_blank'>Variable not found!</a>");
              $err=true;
            }
          } else {
            echo("<a class='regular' href='err.php?file=".
              rawurlencode($action["target"][0]."/".$action["filename"][0]).
              "&loc=".rawurlencode($location).
              "&err=perm' target='_blank'>No permissions!</a>");
            $err=true;
          }
        } else {
          echo("<a class='regular' href='err.php?file=".
            rawurlencode($action["target"][0]."/".$action["filename"][0]).
            "&loc=".rawurlencode($location).
            "&err=file' target='_blank'>File not found!</a>");
          $err=true;
        }

      // RUN SQL FILE TAG
      } elseif ($action["type"][0]=="run SQL file") {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." from ".$CRM_path."/UpgradeManager/$location/Files/".
          $action["target"][0]."/".$action["filename"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        if ($f=@fopen($CRM_path."/UpgradeManager/$location/Files/".$action["target"][0]."/".$action["filename"][0],"r")) {
          if (install_SQL($CRM_path."/UpgradeManager/$location/Files/".$action["target"][0]."/".$action["filename"][0])) {
              if ($CRM_may_demo && strlen($CRM_db_demo_db))
              {   // Only try to upgrade the demo db if this site has it set up
                  $CRM_demo=1;
                  if (install_SQL($CRM_path."/UpgradeManager/$location/Files/".$action["target"][0]."/".$action["filename"][0])) {
                      echo("OK\n");
                  } else {
                      $err=true;
                  }
                  $CRM_demo=0;
              }
              else
              {
                 echo("OK\n"); 
              } 
          } else {
              $err=true;
          }
          if ($err) {
            echo("<a class='regular' href='err.php?file=".
              rawurlencode($action["target"][0]."/".$action["filename"][0]).
              "&loc=".rawurlencode($location).
              "&err=sql' target='_blank'>SQL statement failed!</a>");
          }
        } else {
          echo("<a class='regular' href='err.php?file=".
            rawurlencode($action["target"][0]."/".$action["filename"][0]).
            "&loc=".rawurlencode($location).
            "&err=upg' target='_blank'>Upgrade file not found!</a>");
          $err=true;
        }
        echo("</td></tr>\n");

      // RUN SQL TAG
      } elseif ($action["type"][0]=="run SQL") {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0])." ".$action["value"][0]);
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        $sql = str_replace("&lt;", "<", $action["value"][0]);
        $sql = str_replace("&gt;", ">", $sql);
        if (CRM_run_query($sql)) {
            if ($CRM_may_demo && strlen($CRM_db_demo_db))
            {   // Only try to upgrade the demo db if this site has it set up
                $CRM_demo=1;
                if (CRM_run_query($sql)) {
                    echo("OK");
                } else {
                    $err=true;
                }
                $CRM_demo=0;
            }
            else
            {
                echo("OK\n"); 
            }
        } else {
          $err=true;
        }
        if ($err) {
          echo("SQL failed");
          $err=false;
        }

      // RELOAD TAG
      } elseif($action["type"][0]=="reload") {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0]));
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        echo("<b>Please reload this page</b>\n");
        $offending=$i+1;

      // MAKE DIR TAG
      } elseif($action["type"][0]=="make dir") {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0]." ".$action["target"][0]));
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        if (is_dir($CRM_path."/".$action["target"][0]) ||
            mkdir($CRM_path."/".$action["target"][0],0777)) {
          echo("OK");
        } else {
          echo("<a class='regular' href='err.php?file=".
            rawurlencode($action["target"][0]."/".$action["filename"][0]).
            "&loc=".rawurlencode($location).
            "&err=mkdirperm' target='_blank'>No permissions!</a>");
          $offending=$i;
        }

      // NEW ACTIONS TAG
      } elseif ($action["type"][0]=="new actions") {
        // We just ignore new action directives - the upgrade maintainer should do
        // the thinking and package the upgrade files and directives in the correct order.
      } else {
        echo("<tr><td class='regular' bgcolor='$OPT_col_lt'>");
        echo(ucfirst($action["type"][0]));
        echo("</td><td class='regular' bgcolor='$OPT_col_lt'>");
        echo("<a class='regular' href='err.php?file=".
            rawurlencode($action["target"][0]).
            "&loc=".rawurlencode($location)."&type=".rawurlencode($action["type"][0]).
            "&err=type' target='_blank'>Unknown directive</a>");
        $offending=$i;
      }
      echo("</td></tr>\n");
    }
    // ------- FINISHED PARSING ---------

    echo("<tr><td class='regular' align='center' bgcolor='$OPT_col_md' colspan='2'>");
    if ($offending==-1) {
      if (($upg_system=="OPT Plugin") ||
          ($upg_system=="OPT Plugin Upgrade")) {
        $plugin=addslashes($array["upgrade"][0]["version"][0]["name"][0]);
        $plugin_ver=addslashes($array["upgrade"][0]["version"][0]["newver"][0]);
        $sql="select id from installed_plugins where name=\"$plugin\"";
        $result=crm_run_query($sql);
        list($upg_id)=OPT_fetch_row($result);
        if (!$upg_id) {
          $sql="insert into installed_plugins set name=\"$plugin\", version=\"$plugin_ver\"";
        } else {
          $sql="update installed_plugins set version=\"$plugin_ver\" where id=\"$upg_id\"";
        }
        crm_run_query($sql);
      }
      if (is_file($location."/default_post.php")) {
        echo("<b>You have finished the REGULAR part of the upgrade but the
        packager of this upgrade included a php to be run after the end of this
        stage of the upgrade - please read on</b> (the installation is not yet complete!)
        <p>Please click <a class='regular' href='$location/default_post.php'>here</a>
        in order to run the PHP included by the packager. If you want to check
        the code before running it, the PHP which will run is located here:
        $CRM_path/UpgradeManager/$location/default_post.php
        <p>Please don't forget to reset the permissions to default for the
        whole OPT directory if you changed them for the upgrade process!");
      } else {
        echo("<b>Congratulations! You successfully installed OPT $newver!</b>
          <p><b>Don't forget to reset the permissions to default for the
          whole OPT directory if you changed them for the upgrade process!</b>
          <p>Please use <a class='regular' href='$CRM_URL' target='_top'>this link</a>
          in order to start using OPT in case you came here directly.
          <p>Or you may want to start by reading the <a class='regular' href='$location/CHANGES'>change log</a>
          <p>Or you may check for further upgrades by going back to the <a class='regular' href='index.php'>main Upgrade Manager page</a>
          <p>Since you finished this install successfully, you might consider <a class=\"regular\" href=\"delete.php?location=".rawurlencode($location)."\">deleting the downloaded files</a>");
      }
      if (strpos(" ".get_setting("feedback_type"),"w")) {
        if ((abs($newver)) && ($upg_system=="OPT")) {
          $CRM_ver=$newver;
        }
        include("$CRM_inc/HTTP_lib.php");
        SendFeedback();
      }
    } else {
      echo("Errors found. Please solve the problems as suggested by clicking on them and reload this frame afterwards.\n");
    }
    echo("</td></tr>\n");
    endTables();
  } else {
    $noUpg=1;
  }
  if ($noUpg) {
    OPT_message("The upgrade isn't here. Hummm!");
  }
  CRM_run_query("delete from settings where name=\"UM_pos\"",0);
  CRM_run_query("delete from settings where name=\"UM_loc\"",0);
  if ($offending!=-1) {
    CRM_run_query("replace into settings set name=\"UM_pos\", value=\"$offending\"",0);
    CRM_run_query("replace into settings set name=\"UM_loc\", value=\"$location\"",0);
  }
?>
</body>
</html>
<?
  auth_close();
  exit;
?>
