<?
#
# Upgrade Manager library
#
# Bogdan Stancescu <bogdan@lanifex.com>, January 2002
# Revision 1.0

  function CheckUpgrade($array,$local_upg,$show_obsolete=false)
  {
    global $CRM_ver, $OPT_col_lt, $entry;
    $anyfits=false;

    // Get CRM_ver to be an int
    $CRM_ver = intVal(str_replace(".", "", $CRM_ver));
    
    // We'll use this ugly method instead of output control functions because
    // we want to keep PHP 3 users happy. It's not their fault, you know - it may be
    // the provider or something out of their hands...
    $output="<tr><td class='regular' align='center' bgcolor='$OPT_col_lt'>\n";
    $oldver=intVal(str_replace(".", "", $array["version"][0]["oldver"][0]));
    $newver=intVal(str_replace(".", "", $array["version"][0]["newver"][0]));
    $output.=$array["version"][0]["comment"][0]."<br>\n";
    $output.="</td><td class='regular' align='center' bgcolor='$OPT_col_lt'>\n";
    if ($local_upg)
    {
      $output.="Local\n";
      $Changelog="$entry/CHANGES";
    }
    else
    {
      $output.="Remote\n";
      $Changelog=$array["version"][0]["changes"][0];
    }

    // Ok, let's start processing this upgrade. First, let's check if it's a regular
    // OPT upgrade.
    $output.="</td><td class='regular' align='center' bgcolor='$OPT_col_lt'>\n";
    if ($array["system"][0]=="OPT")
    {
      if (($CRM_ver==$oldver) || ($oldver=="*"))
      {
        if ($local_upg)
        {
          $URLentry=rawurlencode($entry);
          $output.="<a class='regular' href='upgrade.php?location=$URLentry'>Upgrade</a><br>\n".
                  "<a class='regular' href='delete.php?location=$URLentry'>Delete</a>\n";
        }
        else
        {
          $URLentry=rawurlencode($array["version"][0]["location"][0]);
          $output.="<a class='regular' href='download.php?location=$URLentry'>Download!</a>\n";
        }
        $anyfits=true;
      }
      elseif ($CRM_ver>$oldver) // >
      {
        $URLentry=rawurlencode($entry);
        $output.="<i>Already installed</i><br>\n".
                "<a class='regular' href='delete.php?location=$URLentry'>Delete</a>\n";
      }
      elseif ($CRM_ver<$oldver) // >
      {
        $output.="<i>You need other upgrades before</i>\n";
      }
    }
    // But it may also be a plugin. Not a plugin upgrade, mind you, we're
    // only checking if it's a full plugin for now:
    elseif ($array["system"][0]=="OPT Plugin")
    {
      // Right. It's a plugin. Ok, then we'll find out what plugin it is and
      // check if it's already installed. If it's not installed then we allow
      // the user to install. Otherwise, we only allow him to delete this package.
      $plugin=addslashes($array["version"][0]["name"][0]);
      $sql="select id from installed_plugins where name=\"$plugin\"";
      $result=crm_run_query($sql);
      $myrow=OPT_fetch_row($result);
      if (!$myrow[0])
      {
        if ($local_upg)
        {
          $URLentry=rawurlencode($entry);
          $output.="<a class='regular' href='upgrade.php?location=$URLentry'>Upgrade</a><br>\n".
                  "<a class='regular' href='delete.php?location=$URLentry'>Delete</a>\n";
        }
        else
        {
          $URLentry=rawurlencode($array["version"][0]["location"][0]);
          $output.="<a class='regular' href='download.php?location=$URLentry'>Download!</a>\n";
        }
        $anyfits=true;
      }
      elseif ($local_upg)
      {
        $URLentry=rawurlencode($entry);
        $output.="<i>Already installed</i><br>\n".
                "<a class='regular' href='delete.php?location=$URLentry'>Delete</a>\n";
      }
    }
    // Ok, last chance. Let's see if it's a plugin upgrade.
    elseif ($array["system"][0]=="OPT Plugin Upgrade")
    {
      // ..so it's a plugin upgrade. This is trickier. We first have to check
      // that the plugin was installed. If it was, we check if we have the right
      // version to install this upgrade. And finally, if everything's ok then
      // we allow the user to upgrade.
      $plugin=addslashes($array["version"][0]["name"][0]);
      $sql="select id, version from installed_plugins where name=\"$plugin\"";
      $result=crm_run_query($sql);
      $myrow=OPT_fetch_row($result);
      if (!$myrow[0])
      {
        $output.="<i>This is an upgrade - you need to install the plugin first</i>\n";
      }
      elseif (($myrow[1]>$oldver) && ($local_upg))
      {
        $URLentry=rawurlencode($entry);
        $output.="<i>Already installed</i><br>\n".
                "<a class='regular' href='delete.php?location=$URLentry'>Delete</a>\n";
      }
      elseif (($myrow[1]<$oldver) && ($local_upg)) //>
      {
        $output.="<i>You need other upgrades before</i>\n";
      }
      elseif ($myrow[1]==$oldver)
      {
        if ($local_upg)
        {
          $URLentry=rawurlencode($entry);
          $output.="<a class='regular' href='upgrade.php?location=$URLentry'>Upgrade</a><br>\n".
                  "<a class='regular' href='delete.php?location=$URLentry'>Delete</a>\n";
        }
        else
        {
          $URLentry=rawurlencode($array["version"][0]["location"][0]);
          $output.="<a class='regular' href='download.php?location=$URLentry'>Download!</a>\n";
        }
        $anyfits=true;
      }
    }
    else
    {
      $output.="<i>Not an OPT upgrade</i>\n";
    }
    $output.="</td>\n<td class='regular' align='center' bgcolor='$OPT_col_lt'>\n";
    $output.="<a class='regular' href='$Changelog' target='_blank'>Read Change Log</a>\n";
    $output.="</td></tr>\n";

    if ($anyfits || $show_obsolete)
    {
      echo($output);
    }

    return($anyfits);
  }

  function FindUpgrades()
  {
    $anyfits=false;
    echo(" ");
    flush();
    set_time_limit(30);
    $upgrades=@file("http://opt.lanifex.com/upgrade/?file=upgrades.xml");
    if (!$upgrades)
    {
      echo(" ");
      flush();
      set_time_limit(30);
      $upgrades=@file("http://prdownloads.sourceforge.net/outreach/upgrades.xml");
      // We get a second chance on sourceforge because they have a problem with
      // file uploads - if a file is deleted and another file with the same
      // name is uploaded instead, their mechanism sometimes retains the old file.
      if (!$upgrades)
      {
        echo(" ");
        flush();
        set_time_limit(30);
        $upgrades=@file("http://prdownloads.sourceforge.net/outreach/upgrades2.xml");
        if (!$upgrades)
        {
          return(false);
        }
      }
    }
    echo(" ");
    $xml = implode("", $upgrades);
    $array = parse_xml($xml);
    for ($i=0;($upgrade=$array["upgrades"][0]["upgrade"][$i]);$i++)
    {
      global $CRM_ver;
      if ($upgrade["version"][0]["oldver"][0]==$CRM_ver)
      {
        $anyfits=$upgrade["version"][0]["newver"][0];
      }
    }
    return($anyfits);
  }

  // This file is normally identical to install_SQL()
  // in opt/setup/setup_lib.php
  // It has been copied here for greater independence.
  function install_SQL($file)
  {
    $fr=fopen($file,"r");
    if (!$fr)
    {
      return(false);
    }
    $SQLline="";
    while (!feof($fr))
    {
      $SQLline.=trim(fgets($fr,4096));
      if (substr($SQLline,0,1)=="#")
      {
        $SQLline="";
      }
      elseif (substr($SQLline,-2)==");")
      {
        if (!crm_run_query($SQLline))
        {
          return(false);
        }
        $SQLline="";
      }
    }
    fclose($fr);
    return(true);
  }

  // Parses an init file and changes special placeholder lines to
  // proper PHP formatting.
  // Normally identical to the function with the same name in opt/setup/setup_lib.php.
  // Copied for independence.
  function parseInitFile($init_file, $final_file)
  {
    $fr=@fopen($init_file, "r");
    if (!$fr)
    {
      echo("<h4><strong>Failed</strong>: Unable to open $init_file for reading!</h4>");
      return(false);
    }

    $fw=@fopen($final_file, "w");
    if (!$fw)
    {
      echo("<h4><strong>Failed</strong>: Unable to open $final_file for writing!</h4>");
      return(false);
    }

    while (!feof($fr))
    {
      $buffer=fgets($fr, 4096);
      if (substr($buffer,0,5)=="#OPT*")
      {
        list($dump,$var)=explode("*",$buffer);
        if ($var)
        {
          global $$var;
          $buffer="  \$$var=\"".$$var."\";\n";
        }
        else
        {
          $buffer="";
        }
      }
      if ($buffer)
      {
        fputs($fw,$buffer);
      }
    }
    fclose($fw);
    fclose($fr);
  }
?>
