<?
#
# Database Integrity Check
#
# Bogdan Stancescu <bogdan@lanifex.com>, August 2002
# Revision 1.0
  $root="../../..";
  include "$root/include/OPT_lib.php";
  auth_open();

  function bye() {
    auth_close();
    endTables();
    echo("</BODY>\n</HTML>\n");
    exit;
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>Database Integrity</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="<? echo $root; ?>/include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  if (!is_admin() || $CRM_guest) {
    OPT_error(__("Classified"));
    auth_close();
    exit;
  }

  mainBody("$root/images");
  make_main_title("Database Integrity","$root/images");
  startTables();

  // CREATING LOCK
  echo("<tr><th bgcolor='$OPT_col_dk' colspan='2'>Checking Database Integrity</th></tr>\n");
  echo("<tr><td bgcolor='$OPT_col_md'>Creating database lock at $OPT_db_lock</td><td bgcolor='$OPT_col_lt'>");
  if (file_exists($OPT_db_lock)) {
    OPT_error("Already locked! Please remove the file if you know for sure it shouldn't be there!");
    echo("</td></tr>");
    bye();
  } elseif (!$fp=@fopen($OPT_db_lock,"w")) {
    OPT_error("Unable to create lock! Please make sure that directory exists and that PHP has write permissions there!");
    echo("</td></tr>");
    bye();
  }
  fclose($fp);
  echo("OK</td></tr>\n");
  $OPT_db_lock_bypass=true;

  // RETRIEVING DATA
  echo("<tr><td bgcolor='$OPT_col_md'>Retrieving data</td><td bgcolor='$OPT_col_lt'>");

  $sql="select id,company from people";
  $result=OPT_run_query($sql);
  while (list($people_id[], $people_comp[])=OPT_fetch_row($result));

  $sql="select id, contact from companies";
  $result=OPT_run_query($sql);
  while (list($companies_id[], $companies_contact[])=OPT_fetch_row($result));

  echo("OK</td></tr>\n");

  // CHECKING DATA
  echo("<tr><td bgcolor='$OPT_col_md'>Checking data</td><td bgcolor='$OPT_col_lt'>");

  $err=false;
  while(list($p_array_id,$p_comp)=each($people_comp)) {
    if (!@in_array($p_comp,$companies_id)) {
      OPT_error("User ".implode(" ",getvalue("people",array("fname", "lname"),$people_id[$p_array_id]))." is attached to an invalid company! ".
        "(Company ID=$p_comp)");
      $err=true;
    }
  }

  // And so on and so forth. But I'll be in Prague, so if anybody cares to continue
  // developing this, be my guest!

  // To do: make links to the users/companies/projects/etc with problems.

  if (!$err) {
    echo("OK</td></tr>\n");
  }

  // REMOVING LOCK
  echo("<tr><td bgcolor='$OPT_col_md'>Removing database lock</td><td bgcolor='$OPT_col_lt'>");
  if (!file_exists($OPT_db_lock)) {
    OPT_error("Already removed! Please check the database integrity again!");
    echo("</td></tr>");
    bye();
  } elseif (!@unlink($OPT_db_lock)) {
    OPT_error("Unable to remove lock! This is very strange - please remove it manually and report this problem! (See the FAQ link at the top of any help page)");
    echo("</td></tr>");
    bye();
  }
  echo("OK</td></tr>\n");

  endTables();
  auth_close();
?>
</BODY>
</HTML>
