<?
#
# Translations chooser page
#
# Selecting the string to translate - looking up the Romanian
# translations because those are known to exist wherever there's
# translation support
#
# Bogdan Stancescu <bogdan@lanifex.com>, June 2002
# Revision 1.0
  include "../../include/OPT_lib.php";
  include "$CRM_path/admin/translate/translate_lib.php";
  if ($lang) {
    $_OPT["local"]["force_encoding"]=getvalue("lang","encoding",$lang);
  }
  auth_open();

  if (!$folder) {
    $folder="/";
  }
  if (!$reflang) {
    $reflang=read_Xtra("people",$CRM_user,"OPT_translations","refLang");
  } else {
    write_Xtra("people",$CRM_user,"OPT_translations","refLang",$reflang);
  }
  if (!$reflang) {
    $reflang="ro";
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Translations")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../images");
  // We're not going to allow anyone to type relative paths. If however
  // the administrator allowed for symbolic link within the OPT structure,
  // AND if the links point to sensitive files AND the user running Apache
  // does have rights there AND php.ini is configured to allow following symlinks,
  // then any user with ADMIN privileges will be able to see those.
  // But hey! Those are just too many coincidences to really bother.
  if ((!system_perm("translations")) || (strpos(" ".$folder,".."))) {
    OPT_error(__("Classified"));
    exit;
  }
  if (!$lang) {
    OPT_error(__("Please select a language to translate to first!"));
    exit;
  }
  $langName=getvalue("lang","name",$lang);
  make_main_title(__("Translate Message"),"../../images");

  startTables();

  // ===========================
  //        TABLE HEADER
  // ===========================

?>
<script language="javascript">
<!--
var advance='';
if ((parent.leftFrame.document.forms.length) && (!(parent.leftFrame.document.forms[0][0].checked))) {
  advance='&disable_advance=1';
}
parent.leftFrame.location='leftMenu.php?lang=<? echo($lang); ?>'+advance;
function formSubmit() {
  if ((parent.leftFrame.document.forms.length) && (!(parent.leftFrame.document.forms[0][0].checked))) {
    document.editForm.next.value=-1;
  }
  document.editForm.submit();
}
// -->
</script>
  <tr>
    <td class="ah4" colspan="2" bgcolor="<? echo $OPT_col_dk; ?>" align="center">
      <? echo(__("Please make the choices below in order to manage translations")); ?>
    </td>
  </tr>
  <tr>
    <td class="regular" colspan="2" bgcolor="<? echo $OPT_col_md; ?>" align="center">
      <? echo(sprintf(__("Managing %s translations"),"<b>".$langName."</b>")); ?><br>
      <? echo(sprintf(__("Folder %s"),"<b>$folder</b>")); ?>
    </td>
  </tr>
  <tr>
    <td class="small" colspan="2" bgcolor="<? echo $OPT_col_lt; ?>" align="center">
      <? echo(__("Either browse the directory tree to search for ".
        "files to translate, or use the menu to the left to find strings which need ".
        "to be translated to this language")); ?>
    </td>
  </tr>
  <tr>
    <td class="regular" align="right" bgcolor="<? echo $OPT_col_md; ?>">
      <b><? echo(__("Folder")); ?></b>
    </td>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>">
  <?

  // ===========================
  //       CHOOSING FOLDER
  // ===========================

  if ($folder!="/") {
    $pfolder=substr($folder,0,strrpos(substr($folder,0,-1),"/"))."/";
    if (checkFolder($CRM_path.$pfolder)) {
      $b[0]="<b>";
      $b[1]="</b>";
    }
    echo("<a class='regular' href='$PHP_SELF?folder=".rawurlencode($pfolder)."&lang=$lang'>$b[0][".__("Parent folder")."]$b[1]</a>");
  }

  $theFolder=$CRM_path.$folder;
  $d=dir($theFolder);
  // Using the array method in order to sort the subdirs;
  // using the keysort in order to sort case-insensitive.
  while ($entry=$d->read())
  {
    if (is_dir($theFolder.$entry) && ($entry[0]!=".")) {
      $subdirs[strtolower($entry)]=$entry;
    }
  }
  if ($subdirs) {
    ksort($subdirs);
    reset($subdirs);
    $first=true;
    while(list(,$entry)=each($subdirs)) {
      if ($entry=="OPT_lang") {
        continue;
      }
      if ($first && $pfolder) {
        $first=false;
        echo("<br><br>\n");
      }
      if (checkFolder($theFolder.$entry)) {
        $b[0]="<b>";
        $b[1]="</b>";
      } else {
        $b[0]=$b[1]="";
      }
      echo("<a class='regular' href='$PHP_SELF?folder=".rawurlencode($folder.$entry."/")."&lang=$lang'>$b[0]$entry$b[1]</a><br>\n");
    }
  }
  ?>
    </td>
  </tr>
  <?

  // ===========================
  //   CHECKING FOLDER FOR REF
  // ===========================

  if (checkFolder($theFolder)) {
    $refFile=$theFolder."OPT_lang/$reflang/LC_MESSAGES/OPT_local.po";
    $transFile=$theFolder."OPT_lang/$lang/LC_MESSAGES/OPT_local.po";
    if (!is_readable($refFile)) {
      endTables();
      echo("<br>\n");
      OPT_error(__("Can't read reference language translation file in this directory!"));
      exit;
    }

    // ===========================
    //  CHECKING FOLDER FOR LANG
    // ===========================

    if (is_file($transFile) && (!is_readable($transFile))) {
      endTables();
      echo("<br>\n");
      OPT_error(sprintf(__("Can't read %s translation file in this directory!"),$langName));
      exit;
    }
    if (is_file($transFile) && (!is_writable($transFile))) {
      endTables();
      echo("<br>\n");
      OPT_error(sprintf(__("Can't write into %s translation file in this directory!"),$langName));
      exit;
    }

    $refstrings=parseTrans($refFile);
    $langstrings=parseTrans($transFile);
    $matchstrings=matchTrans($langstrings,$refstrings);

    // ===========================
    //    APPLYING TRANSLATION
    // ===========================

    if ($action=="translate") {
      $newstring["head"]=$langstrings["head"];
      while (list($key,$val)=each($head_key)) {
        $newstring["head"][OPT_gpc_unslash($val)]=OPT_gpc_unslash($head_val[$key]);
      }
      write_Xtra("people",$CRM_user,"OPT_translations","translator",$newstring["head"]["Last-Translator"]);
      write_Xtra("people",$CRM_user,"OPT_translations","team",$newstring["head"]["Language-Team"]);
      write_Xtra("people",$CRM_user,"OPT_translations","proj_id",$newstring["head"]["Project-Id-Version"]);
      reset($newstring["head"]);
      while (list($key,$val)=each($newstring["head"])) {
        $newstring["head"][$key]=$val."\\n";
      }
      while (list($key,$val)=each($refstrings["content"])) {
        $newstring["content"][$key]["id"]=$refstrings["content"][$key]["id"];
        $newstring["content"][$key]["str"]=$langstrings["content"][$matchstrings["content"][$key]]["str"];
        $newstring["comments"][$key]=$langstrings["comments"][$matchstrings["content"][$key]];
      }
      $newstring["content"][$id]["str"]=OPT_gpc_unslash($trans);
      $newstring["comments"][$id]=explode("\n",OPT_gpc_unslash($comm));
      $backedUp=@copy($transFile,$transFile."~");
      writeTrans($newstring,$transFile);

      $action="edit";
      if (isset($next) && ($next!=-1)) {
        $id=$next;
      }

      @exec("msgfmt -o \"".$theFolder."OPT_lang/$lang/LC_MESSAGES/OPT_local.mo\" \"$transFile\" 2>&1",$dump,$err);
      if ($err) {
        echo("<tr><td class='regular' bgcolor='$OPT_col_md'>\n");
        OPT_error("msgfmt failed:<br>".implode("<br>",$dump));
        if($bakedUp) {
          OPT_confirm(sprintf(__("You can find a backup of the original file at %s. ".
            "Please note that if you translate again, the backup will be overwritten."),$transFile."~"));
        }
        echo("</td></tr>\n");
      } else {
        @unlink($transFile."~");
      }

      // And we're going to emulate a tape recorder with three heads :)
      $refstrings=parseTrans($refFile);
      $langstrings=parseTrans($transFile);
      $matchstrings=matchTrans($langstrings,$refstrings);
    }

    // ===========================
    //   DISPLAYING EDIT MESSAGE
    // ===========================

    if ($action=="edit") {
    ?>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk_dk; ?>" colspan="2"><img src='../../images/spacer.gif'></td>
  </tr>
    <?
      if ($refstrings["comments"][$id]) {
    ?>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" colspan="2">
      <b><? echo(__("Reference String Comment")); ?></b>
    </td>
  </tr>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_lt; ?>" colspan="2">
      <? echo(nl2br(htmlspecialchars(@implode("\n",$refstrings["comments"][$id])))); ?>
    </td>
  </tr>
    <?
      }
    ?>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" colspan="2">
      <b><? echo(__("Reference String")); ?></b>
    </td>
  </tr>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>" colspan="2">
      <? echo(nl2br(str_replace("\n","&para;\n",htmlspecialchars($refstrings["content"][$id]["id"])))); ?>
    </td>
  </tr>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" colspan="2">
      <b><? echo(__("Translated String")); ?></b>
    </td>
  </tr>
  <form action='<? echo $PHP_SELF; ?>' method='post' name='editForm'>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>" colspan="2" align='center'>
      <textarea name='trans' wordwrap='virtual' cols='40', rows='<? echo(floor(strlen($refstrings["content"][$id]["id"])/20)+2); ?>'><?
        echo(htmlspecialchars($langstrings["content"][$matchstrings["content"][$id]]["str"]));
      ?></textarea>
    </td>
  </tr>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" colspan="2">
      <b><? echo(__("Translated String Comment")); ?></b>
    </td>
  </tr>
  <tr>
    <form action='<? echo $PHP_SELF; ?>' method='post'>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>" colspan="2" align='center'>
      <textarea name='comm' wordwrap='virtual' cols='40', rows='<? echo(floor(strlen($refstrings["content"][$id]["id"])/20)+2); ?>'><?
        echo(htmlspecialchars(@implode("\n",$langstrings["comments"][$matchstrings["content"][$id]])));
      ?></textarea>
    </td>
  </tr>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" colspan="2">
      <input type='hidden' name='action' value='translate'>
      <input type='hidden' name='lang' value='<? echo $lang; ?>'>
      <input type='hidden' name='id' value='<? echo $id; ?>'>
      <input type='hidden' name='folder' value='<? echo $folder; ?>'>
      <input type='button' name='button' value='<? echo(__("Translate")); ?>' onClick='formSubmit()'>
    </td>
  </tr>
    <?
    }

    // ===========================
    //   DISPLAYING HEADER EDIT
    // ===========================
    ?>

  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk_dk; ?>" colspan="2"><img src='../../images/spacer.gif'></td>
  </tr>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" colspan="2">
      <b><? echo(__("Translation File Header")); ?></b>
    </td>
  </tr>
  <?

    // Initializing header, if needed
    $tz=read_Xtra("people",$CRM_user,"OPT_user","TZ");
    $cldate=date('Y-m-j H:i',OPT_local_date($tz))." ".$tz; // Current local date
    if (!$langstrings["head"]) {
      $head["Project-Id-Version"]='n/a';
      $head["POT-Creation-Date"]=$cldate;
      $head["PO-Revision-Date"]=$cldate;
      $head["Last-Translator"]='n/a';
      $head["Language-Team"]='n/a';
      $head["MIME-Version"]='1.0';
      $head["Content-Type"]='text/plain; charset='.$_OPT["local"]["force_encoding"];
      $head["Content-Transfer-Encoding"]='8bit';
      $langstrings["head"]=$head;
    }

    if (isset($id)) {
      // Filling up header with default values
      $proj_id=read_Xtra("people",$CRM_user,"OPT_translations","proj_id");
      $langstrings["head"]["Project-Id-Version"]=$proj_id;
      $langstrings["head"]["PO-Revision-Date"]=$cldate;
      $translator=read_Xtra("people",$CRM_user,"OPT_translations","translator");
      if (!$translator) {
        $tdata[]='fname';
        $tdata[]='lname';
        $tdata[]='email';
        $tdata=getvalue("people",$tdata,$CRM_user);
        $translator="$tdata[0] $tdata[1] <$tdata[2]>";
      }
      $langstrings["head"]["Last-Translator"]=$translator;
      $team=read_Xtra("people",$CRM_user,"OPT_translations","team");
      if (!$team) {
        $team=getvalue("companies","shortname",$CRM_comp);
      }
      $langstrings["head"]["Language-Team"]=$team;
    }

    while(list($key,$val)=@each($langstrings["head"])) {
    ?>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align='right'>
      <? echo($key); ?>
    </td>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>">
      <?
      if ($action=="edit") {
        echo("<input type='hidden' size='40' name='head_key[]' value='".htmlspecialchars($key)."'>");
        echo("<input type='text' size='40' name='head_val[]' value='".htmlspecialchars($val)."'>");
      } else {
        echo(htmlspecialchars($val));
      }
      ?>
    </td>
  </tr>
    <?
    }

    // ===========================
    //   DISPLAYING REF MESSAGES
    // ===========================

  ?>
  <tr>
    <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk_dk; ?>" colspan="2"><img src='../../images/spacer.gif'></td>
  </tr>
  <tr>
    <td class="regular" align="right" bgcolor="<? echo $OPT_col_md; ?>" rowspan="<? echo sizeOf($refstrings["content"]); ?>">
      <b><? echo(__("String to translate")); ?></b>
    </td>
    <?
    $first=true;
    $firstUntranslated=true;
    reset($refstrings["content"]);
    while (list($idx,$entry)=each($refstrings["content"])) {
      if ($first) {
        $first=false;
      } else {
        echo("<tr>\n");
      }
      if ((isset($matchstrings["content"][$idx])) && ($langstrings["content"][$matchstrings["content"][$idx]]["str"])) {
        $b[0]=$b[1]="";
      } else {
        $b[0]="<b>";
        $b[1]="</b>";
        if (($firstUntranslated) && ($idx!=$id)) {
          $firstUntranslated=false;
          echo("<input type='hidden' name='next' value='$idx'>\n");
        }
      }
      echo("<td class='regular' bgcolor='$OPT_col_lt'>\n");
      echo("<a class='regular' href='$PHP_SELF?lang=$lang&folder=".rawurlencode($folder)."&action=edit&id=$idx'>");
      echo($b[0].nl2br(htmlspecialchars($entry["id"])).$b[1]);
      echo("</a>\n");
      echo("</td></tr>\n");
    }
  }
  if ($action=="edit") {
    echo("</form>");
  }
  ?>
<?
  endTables();
  auth_close();
?>
</BODY>
</HTML>
