<?
#
# Import translations page
#
# Imports the selected language archive into OPT
#
# Bogdan Stancescu <bogdan@lanifex.com>, June 2002
# Revision 1.0
  include "../../include/OPT_lib.php";
  auth_open();
  include "$CRM_path/admin/translate/translate_lib.php";
  include "$CRM_path/UpgradeManager/xml_lib.php";
  include "$CRM_inc/HTTP_lib.php";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Import Translations")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
<script language="javascript">
<!--
  parent.leftFrame.location='leftMenu.php?lang=<? echo $lang; ?>';
  var manual_edit=false;
  function changeFile() {
    if (manual_edit) {
      return(false);
    }
    if (document.importSelect.what[1].checked) {
      document.importSelect.save_loc.value=document.importSelect.temp_path.value+"/OPT_lang_all.tar.gz";
    } else {
      document.importSelect.save_loc.value=document.importSelect.temp_path.value+"/OPT_lang_"+
        document.importSelect.lang[document.importSelect.lang.selectedIndex].value+".tar.gz";
    }
  }
//-->
</script>
</HEAD>
<?
  mainBody("../../images");
  if (!system_perm("translations"))
  {
    OPT_error(__("Classified"));
    exit;
  }
  make_main_title(__("Import Translations"),"../../images");
  if (!$lang) {
    $lang=getvalue("people","preflang",$CRM_user);
  }

  function get_file() {
    global $temp_CRM_dir;
    $i=0;
    while (is_file($file="$temp_CRM_dir/temp_lang_download$i")) {
      $i++;
    }
    $fout=@fopen($file,"wb");
    if (!$fout) {
      ?>
        <tr>
          <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
            <? OPT_error(sprintf(__("Unable to create temp file %s! Please check permissions!"),$file)); ?>
          </td>
        </tr>
      <?
      return(false);
    } else {
      fclose($fout);
      return($file);
    }
  }

  function parse_import($file,$preserve_archive=false) {
    global $temp_CRM_dir, $OPT_col_dk, $OPT_col_md, $OPT_col_lt;
    if (!$file) {
      return(false);
    }

    // First create the temp dir where we'll untar
    $i=0;
    while(is_dir("$temp_CRM_dir/temp_OPT_lang_dir$i")) {
      $i++;
    }
    $tmdir="$temp_CRM_dir/temp_OPT_lang_dir$i";
    if (!@mkdir($tmdir,0700)) {
      ?>
        <tr>
          <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
            <? OPT_error(sprintf(__("Unable to create temp directory %s!"),$tmdir)); ?>
          </td>
        </tr>
      <?
      return(false);
    }

    // Then obviously unzip and untar
    exec("gzip -dc $file 2>&1 > \"$tmdir/temp_import.tar\"",$dump,$err);
    if (!$err) {
      if (!$preserve_archive) {
        @unlink($file);
      }
      chdir($tmdir);
      exec("tar -xf - < \"$tmdir/temp_import.tar\" 2>&1",$dump,$err); // >
      if (!$err) {
        @unlink("$tmdir/temp_import.tar");
        echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\">".
          __("Archive successfully uncompressed.")."</td></tr>\n");
      } else {
        $err="<br>\n".implode(" ",$dump);
        echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_md\" align=\"center\">\n");
        OPT_error(sprintf(__("Unable to untar $tmdir/temp_import.tar. The error issued by tar was: %s"),$err));
        echo("</td></tr>\n");
        return(false);
      }
    } else {
      $err="<br>\n".implode(" ",$dump);
      echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_md\" align=\"center\">\n");
      OPT_error(sprintf(__("Unable to unzip $file. The error issued by gzip was %s"),$err));
      echo("</td></tr>\n");
      return(false);
    }

    // Ok, we have the directory tree under $tmdir. Let's process it.
    // First applying the proper incoming encoding(s)
    if (!is_file("$tmdir/lang_info.xml")) {
      echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_md\" align=\"center\">\n");
      OPT_error(__("Archive is not a valid translation package - unable to find definition file lang_info.xml!"));
      echo("</td></tr>\n");
      return(false);
    }
    $xml = implode("", file("$tmdir/lang_info.xml"));
    $langinfo = parse_xml($xml);
    for ($i=0;$i<sizeOf($langinfo["languages"][0]["lang"]);$i++) { // >
      $clang=$langinfo["languages"][0]["lang"][$i];
      OPT_run_query("update lang set encoding='".addslashes($clang["encoding"][0])."' where id='".$clang["id"][0]."'");
    }
    echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\">\n");
    echo(__("Language encoding successfully read and applied."));
    echo("</td></tr>\n");

    // Finally copying the files to the destination
    echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\">\n");
    if (copy_trans($tmdir)) {
      echo(__("Successfully copied the translation files."));
      echo("</td></tr>\n");
    } else {
      echo(__("Unable to copy or parse some of the translation files."));
      echo("</td></tr>\n");
      return(false);
    }

    echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\">\n");
    if (@rmdir($tmdir)) {
      echo(__("Deleted all temp files. Done importing."));
    } else {
      echo(sprintf(__("Some temp files remained under %s. Done importing (probably with errors)."),$tmdir));
    }
    echo("</td></tr>\n");
    return(true);
  }

  function get_lang_info($lang,$langdata) {
    global $lang_info_count;
    if(!$lang_info_count) {
      $lang_info_count=1;
    } else {
      $lang_info_count++;
    }
    $result=OPT_run_query("select installed from lang where id='$lang'");
    list($ver)=OPT_fetch_row($result);
    $temp[]="lang_ids[$lang_info_count]";
    $temp[]=$lang;
    $langdata[]=$temp;
    unset($temp);
    $temp[]="lang_vers[$lang_info_count]";
    $temp[]=$ver;
    $langdata[]=$temp;
    return($langdata);
  }

  // Implemented as a function so we can exit at any time and continue displaying stuff
  function do_import() {
    global $OPT_col_lt, $OPT_col_dk, $OPT_col_md,
      $where, $save_loc, $client_archive, $temp_CRM_dir, $what, $lang,
      $remote_errors, $download_confirm;

    // Checking the import source, downloading if needed, checking permissions etc.
    if ($where=="download") {
      // ============= REPOSITORY IMPORT ==================
      $langs[]="";
      if($what=="single") {
        $langdata=get_lang_info($lang,$langdata);
        $langcount=1;
        $langs[]=$lang;
      } else {
        $result=OPT_run_query("select id from lang");
        while(list($lang)=OPT_fetch_row($result)) {
          $langdata=get_lang_info($lang,$langdata);
          $langcount++;
          $langs[]=$lang;
        }
      }
      flush();
      // Debugging
      /*
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
            <?
              echo("langdata: ".serialize($langdata));
            ?>
            </td>
          </tr>
        <?
      */
      if(!($response=sendRequest("http://opt.lanifex.com/translate/download.php",$langdata,"translate"))) {
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
              <? OPT_error(__("Unable to connect to the remote server! Please check your Internet connection!")); ?>
            </td>
          </tr>
        <?
        return(false);
      } elseif (!parseResponse($response,"translate")) {
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
            <?
              OPT_error(__("Connected, but unable to parse server response!"));
               echo("<hr>".nl2br($response));
            ?>
            </td>
          </tr>
        <?
        return(false);
      } elseif ($remote_errors) {
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
              <? OPT_error(__("Connected, parsed server response, but the remote server issued an error:")."<br>$remote_errors"); ?>
            </td>
          </tr>
        <?
        return(false);
      } elseif (!$download_confirm) {
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
              <? OPT_error(__("Connected, parsed server response, the remote server didn't issue any error, but it didn't properly confirm the transfer!")); ?>
            </td>
          </tr>
        <?
        return(false);
      } else {
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_lt; ?>' align='center'>
              <? OPT_message(__("Connected, parsed server response, finished transfer.")); ?>
            </td>
          </tr>
        <?
        flush();
        for($i=1;$i<=$langcount;$i++) { //>
          $tmp="global_ids_$i";
          global $$tmp;
          if (!isset($$tmp)) {
            $skip_count++;
            continue;
          }
          ?>
            <tr>
              <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
                <? OPT_message(sprintf(__("Parsing %s language file..."),$clang=getvalue("lang","name",$langs[$i]))); ?>
              </td>
            </tr>
          <?
          $lang_no=$i;
          $lang_id=$$tmp;
          $tmp="global_ver_$i";
          global $$tmp;
          $lang_ver=$$tmp;
          $tmp="global_data_$i";
          global $$tmp;
          $lang_data=imap_base64($$tmp);
          $file=get_file();
          $fp=fopen($file,"wb");
          fwrite($fp,$lang_data);
          fclose($fp);
          if (parse_import($file))
          {
          ?>
            <tr>
              <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_lt; ?>' align='center'>
                <? echo(sprintf(__("Updating local version from %s to %s."),getvalue("lang","installed",$langs[$i]),$lang_ver)); ?>
              </td>
            </tr>
          <?
            OPT_run_query("update lang set installed='$lang_ver' where id='$langs[$i]'");
          }
          $parse_count++;
        }
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
              <? OPT_message(sprintf(__("%d languages skipped, %d languages parsed"),$skip_count,$parse_count)); ?>
            </td>
          </tr>
        <?
      }
    } elseif ($where=="server") {
      // ============= SERVER IMPORT ==================
      if ((is_file($save_loc)) && (is_readable($save_loc))) {
        parse_import($save_loc,1);
      } else {
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
              <? OPT_error(sprintf(__("File %s does not exist!"),$save_loc)); ?>
            </td>
          </tr>
        <?
        return(false);
      }
    } elseif ($where=="client") {
      // ============= CLIENT IMPORT ==================
      if ((is_uploaded_file($client_archive)) && (!get_setting("disable_translate_server"))) {
        parse_import($client_archive);
      } else {
        ?>
          <tr>
            <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
              <? OPT_error(__("You don't have permissions to do that.")); ?>
            </td>
          </tr>
        <?
        return(false);
      }
    } else {
      ?>
        <tr>
          <td class='regular' colspan='2' bgcolor='<? echo $OPT_col_md; ?>' align='center'>
            <? OPT_error(__("Unknown source")); ?>
          </td>
        </tr>
      <?
      return(false);
    }
  } // -------------- finished do_import() ---------------------------

  // Importing
  if ($action=="import") {
    startTables();
    echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_dk\" align=\"center\">\n");
    echo("<b>".__("Importing")."</b>");
    echo("</td></tr>\n");
    do_import();
    endTables();
    echo("<br>\n");
  }

  // Displaying the interface
  startTables();
?>
  <form name='importSelect' action="<? echo $PHP_SELF; ?>" method="post" enctype="multipart/form-data">
  <tr>
    <td class='regular' colspan='4' bgcolor='<? echo $OPT_col_dk; ?>' align='center'>
      <b><? echo(__("Please make a choice on what to import")); ?></b>
      <div class='small'><? echo(__("This setting is relevant only if you download from the global repository")); ?></div>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' align='center' colspan='2'>
      <input type='radio' name='what' value='single' checked onClick='changeFile()'> <? echo(__("Single language")); ?>
    </td>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' align='center' colspan='2' rowspan='2'>
      <input type='radio' name='what' value='all' onClick='changeFile()'> <? echo(__("All language files")); ?>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_md; ?>' align='right' width='25%'><b><? echo(__("Language")); ?></b></td>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' width='25%'>
     <?
        if (!$lang) {
          $lang=getvalue("people","preflang",$CRM_user);
        }
        $result=OPT_run_query("select id, name from lang");
        if (OPT_num_rows($result)) {
          echo("<select name=\"lang\" onChange=\"changeFile()\">\n");
          while ($myrow=OPT_fetch_row($result)) {
            if ($myrow[0]==$lang) {
              $sel="selected";
            } else {
              $sel="";
            }
            echo("<option value='$myrow[0]' $sel>$myrow[1]</option>\n");
          }
        }
        // build_empty_select_box(OPT_run_query("SELECT id, name FROM lang"),"lang",$lang);
      ?>
    </td>
  </tr>
  <tr>
    <td class='regular' colspan='4' bgcolor='<? echo $OPT_col_dk; ?>' align='center'>
      <b><? echo(__("Please make a choice on where to import from")); ?></b>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' align='center' colspan='4'>
      <table><tr><td><input type='radio' name='where' value='server'></td><td><? echo(__("Archive on server")); ?></td></tr></table>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_md; ?>' align='right' colspan='2'><b><? echo(__("File")); ?></b></td>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' colspan='2'>
      <input type='text' name='save_loc' value='<? echo $temp_CRM_dir; ?>/OPT_lang_<? echo $lang; ?>.tar.gz' size='32' onFocus='document.importSelect.where[0].checked=true' onChange='manual_edit=true'>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' align='center' colspan='4'>
      <table><tr><td><input type='radio' name='where' value='client'></td><td><? echo(__("Archive on client")); ?></td></tr></table>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_md; ?>' align='right' colspan='2'><b><? echo(__("File")); ?></b></td>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' colspan='2'>
      <input type='file' name='client_archive' value='' size='32' onFocus='document.importSelect.where[1].checked=true'>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_lt; ?>' align='center' colspan='4'>
      <table><tr><td><input type='radio' name='where' value='download' checked></td><td><? echo(__("Download from global OPT repository")); ?></td></tr></table>
    </td>
  </tr>
  <tr>
    <td class='regular' bgcolor='<? echo $OPT_col_dk; ?>' colspan='4' align='center'>
      <input type='submit' name='submitter' value='<? echo(__("Import")); ?>'>
    </td>
  </tr>
  <input type='hidden' name='temp_path' value='<? echo $temp_CRM_dir; ?>'>
  <input type='hidden' name='action' value='import'>
  </form>
<?
  endTables();
  auth_close();
?>
</BODY>
</HTML>
