<?

function month_name($month)
{
  $month = ($month - 1) % 12 + 1;
  switch($month) {
    case 1:  return __('January');
    case 2:  return __('February');
    case 3:  return __('March');
    case 4:  return __('April');
    case 5:  return __('May');
    case 6:  return __('June');
    case 7:  return __('July');
    case 8:  return __('August');
    case 9:  return __('September');
    case 10: return __('October');
    case 11: return __('November');
    case 12: return __('December');
  }
}

function short_month_name($month)
{
  $month = ($month - 1) % 12 + 1;
  switch($month) {
    case 1:  return __('Jan');
    case 2:  return __('Feb');
    case 3:  return __('Mar');
    case 4:  return __('Apr');
    case 5:  return __('May');
    case 6:  return __('Jun');
    case 7:  return __('Jul');
    case 8:  return __('Aug');
    case 9:  return __('Sep');
    case 10: return __('Oct');
    case 11: return __('Nov');
    case 12: return __('Dec');
  }
}

// Show the deadlines for requests and tasks for a project or person
function person_deadlines_for_day_cell($year, $month, $day, $id)
{
    $the_day="$year-$month-$day";
    $timestamp=strtotime($the_day);
    if ($timestamp < strtotime(date("Y-m-d")))
    {
        $past_day=1;
    }
    
    $req_sql="select id, title, aproj, status from requests where (deadline >= '$the_day') AND (deadline < 
         DATE_ADD('$the_day', INTERVAL 1 DAY)) and owner=$id";
    $task_sql="select id, TaskName, ProjectID, PercentComplete from task,person_task where 
                  (EndDatePlanned >= '$timestamp') AND (EndDatePlanned < 
                  ($timestamp+60*60*24)) and  person_task.personID=$id and person_task.taskID=task.id";

    // List all requests whose deadline is this day
    $result=crm_run_query($req_sql);
    while ($row=OPT_fetch_row($result))
    {
        echo("<br />");  // break previous line
        $proj_name=getvalue("projects", "name", $row[2]);
        $safe_title=str_replace("\"", "\\\"",(stripslashes($row[1]).' ('.$proj_name.')'));
        if ($row[3] == 2)
        {  // This request is complete
            echo("<a href='../rt/req_view/?proj=$row[2]&req=$row[0]' title=\"$safe_title\">
                  <font color='green'> Request #$row[0] is done.</font></a>"); 
        }
        else  // Request is not complete yet, is it overdue?
        {
            if ($past_day)
            {
                // Ahh! This request is overdue
                echo("<a href='../rt/req_view/?proj=$row[2]&req=$row[0]' title=\"$safe_title\">
                 <b><font color='red'>Request #$row[0] is late!</font></b></a>"); 
            }
            else
            {
                // This request is not overdue
                echo("<a href='../rt/req_view/?proj=$row[2]&req=$row[0]' 
                      title=\"$safe_title\">Request #$row[0] is due.</a>");
            }
        }
    }

    // List all tasks whose deadline is this day
    $result=crm_run_query($task_sql);
    while ($row=OPT_fetch_row($result))
    {
        echo("<br />");  // break previous line
        $proj_name=getvalue("projects", "name", $row[2]);
        $safe_title=str_replace("\"", "\\\"",(stripslashes($row[1]).' ('.$proj_name.')'));
        if (intVal($row[3]) == 100)
        {
            // This task is complete.
            echo("<a href='../tasks/task/?proj=$row[2]&task=$row[0]&action=display' 
                  title=\"$safe_title\"><font color='green'>Task #$row[0] is done.</font></a>");
        }
        else 
        { 
            if ($past_day)
            {   // Ahh! This task is overdue!
                echo("<a href='../tasks/task/?proj=$row[2]&task=$row[0]&action=display' title=\"$safe_title\">
                  <b><font color='red'>Task #$row[0] is late!</font></b></a>");
            }
            else
            {   // This task is not overdue yet.
                echo("<a href='../tasks/task/?proj=$row[2]&task=$row[0]&action=display' 
                      title=\"$safe_title\">Task #$row[0] is due.</a>");
            }
        }
    }
}

// Show the deadlines for tasks or requests for a project
function project_deadlines_for_day_cell($year, $month, $day, $id, $show)
{
    $the_day="$year-$month-$day";
    $timestamp=strtotime($the_day);
    if ($timestamp < strtotime(date("Y-m-d")))
    {
        $past_day=1;
    }
    
    // SHOW TASKS
    if ($show == "Task")
    {
        $task_sql="select id, TaskName, ProjectID, PercentComplete from task where 
                  (EndDatePlanned >= '$timestamp') AND (EndDatePlanned < ($timestamp+60*60*24))
                  and task.ProjectID = $id";
        $result=crm_run_query($task_sql);
        while ($row=OPT_fetch_row($result))
        {
            echo("<br />");  // break previous line
            $task_id = $row[0];
            $owner_sql="select concat(fname, ' ', lname) from people, person_task where taskID=$task_id and personID=id and owner='Y'";
            
            $owner_result=CRM_run_query($owner_sql);
            $owner_row=OPT_fetch_row($owner_result);
            $safe_title=str_replace("\"", "\\\"",(stripslashes($row[1]).' ('.$owner_row[0].')'));
            if (intVal($row[3]) == 100)
            {
                // This task is complete.
                echo("<a href='../tasks/task/?proj=$row[2]&task=$row[0]&action=display' 
                  title=\"$safe_title\"><font color='green'>Task #$row[0] is done.</font></a>");
            }
            else 
            { 
                if ($past_day)
                {   // Ahh! This task is overdue!
                    echo("<a href='../tasks/task/?proj=$row[2]&task=$row[0]&action=display' title=\"$safe_title\">
                  <b><font color='red'>Task #$row[0] is late!</font></b></a>");
                }
                else
                {   // This task is not overdue yet.
                    echo("<a href='../tasks/task/?proj=$row[2]&task=$row[0]&action=display' 
                      title=\"$safe_title\">Task #$row[0] is due.</a>");
                }
            }
        }
    }
    else  // SHOW REQUESTS
    {
        $req_sql="select id, title, aproj, status, owner from requests where (deadline >= '$the_day') 
                  AND (deadline < DATE_ADD('$the_day', INTERVAL 1 DAY)) and aproj=$id";
        
        // List all requests whose deadline is this day
        $result=crm_run_query($req_sql);
        while ($row=OPT_fetch_row($result))
        {
            echo("<br />");  // break previous line
            $owner=getvalue("people", "CONCAT(fname, ' ', lname)", $row[4]);
            $safe_title=str_replace("\"", "\\\"",(stripslashes($row[1]).' ('.$owner.')'));
            if ($row[3] == 2)
            {  // This request is complete
                echo("<a href='../rt/req_view/?proj=$row[2]&req=$row[0]' title=\"$safe_title\">
                      <font color='green'>Request #$row[0] is done.</font></a>"); 
            }
            else  // Request is not complete yet, is it overdue?
            {
                if ($past_day) 
                {
                    // Ahh! This request is overdue
                    echo("<a href='../rt/req_view/?proj=$row[2]&req=$row[0]' title=\"$safe_title\">
                          <b><font color='red'>Request #$row[0] is late!</font></b></a>"); 
                }
                else
                {
                    // This request is not overdue
                    echo("<a href='../rt/req_view/?proj=$row[2]&req=$row[0]' 
                      title=\"$safe_title\">Request #$row[0] is due.</a>");
                }
            }
        }
    }
}

// List all absences for this day
function absences_for_day_cell($year, $month, $day, $reason_filter, $group_filter)
{
    // TO-DO add stat holidays (how to support locales?)
    $weekday = date("w", strtotime("$year-$month-$day"));
    if (($weekday != 0) && ($weekday != 6))
    {
        if (sizeOf($reason_filter) && ($reason_filter >=0))
        {
            $reason_filter_sql=" and reason = $reason_filter";
        }
        if ($group_filter && ($group_filter > 0))
        {
            $group_filter_sql=" and people.company = $group_filter";
        }

        $sql="select distinct(absences.id), person, UNIX_TIMESTAMP(start_date), UNIX_TIMESTAMP(end_date) 
          from absences, people where (start_date <= DATE_ADD('$year-$month-$day', 
          INTERVAL 1 DAY)) and (end_date >= '$year-$month-$day') 
          and people.id = person $reason_filter_sql $group_filter_sql order by fname";
        $result=CRM_run_query($sql);
        while ($row=OPT_fetch_row($result))
        {
            echo("<br />");  // break previous line
            $name=getvalue("people", "CONCAT(fname,' ',lname)", $row[1]);
            $start_time="08:00";  // default
            $end_time="17:00";    // default
            if ($row[2] > strtotime("$year-$month-$day 08:00"))
            {
               $start_time=date("H:i", $row[2]);
            }
            if ($row[3] < strtotime("$year-$month-$day 17:00"))
            {
               $end_time=date("H:i", $row[3]);
            }
            if (($start_time != "08:00") || ($end_time != "17:00"))
            {
               $hint = "$start_time to $end_time";
            }
            else
            {
               $hint = "All Day";
            }
            echo("<a href='absences/absence_view/?absence=$row[0]' title='$hint'>$name</a>");
        }    
    }
}

// List all events for this day, if proj==0 then global events shown
function events_for_day_cell($year, $month, $day, $proj, $scope)
{
    $sql="select id, title from events where (start_date <= '$year-$month-$day') and 
          (end_date >= '$year-$month-$day') and project = ".abs($proj);
    $result=CRM_run_query($sql);
    while ($row=OPT_fetch_row($result))
    {
        echo("<br />");  // break previous line
        echo("<a href='events/event_view/?proj=$proj&event=$row[0]&events=$scope'>$row[1]</a>");
    }
}

?>
