<?
#
# Event viewing page
#
# Also  handles event add/edit form submits
#
  include "../../../include/OPT_lib.php";
  auth_open();

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Event Details")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../../images");
  make_main_title(__("Event Details"),"../../../images");

  if ($add)
  {
      // Get params safely
      $event=OPT_get_id("events");
      $title=OPT_gpc_slashes($title);
      $description=OPT_gpc_slashes($description);
      $start_date=OPT_gpc_slashes($start_date);
      $end_date=OPT_gpc_slashes($end_date);
      $proj=abs($proj);

      // Confirm that they submitted something
      if (!$title || !$start_date || !$end_date)
      {
          OPT_error(__("You must provide an event title, start date, and end date."));
          exit;
      }

      if (strtotime($start_date) > strtotime($end_date))
      {
          OPT_error(__("The start date can not be later than the end date!"));
          exit;
      }
      
      $sql="insert into events (id, title, description, start_date, end_date, project, src) VALUES (
            $event, '$title', '$description', '$start_date', '$end_date', $proj, $CRM_user)";
      CRM_run_query($sql);
      OPT_confirm("Successfully added new event: $title");

      // Now send out notification to entire team if asked to...
      if ($notify_team && $proj)
      {
          $v[]="email";
          $v[]="sal";
          $v[]="fname";
          $v[]="lname";
          $s=getvalue("people",$v,$CRM_user);
          $title=stripslashes($title);
          $proj_name=getvalue("projects", "name", $proj);
          $result = get_people_involved_with_project($proj);
          while ($row=OPT_fetch_row($result))
          {
              $dst[] = $row[0];
          }
          
          for ($i=0;$i<sizeOf($dst);$i++) 
          {
              OPT_locale($dst[$i]);
              $d=getvalue("people",$v,$dst[$i]);
              $name="$d[1] $d[3]";
              OPT_notify($dst[$i],sprintf(__("New OPT event %s"),"\"$title\""),
                         sprintf(__("Dear %s,\n".
                                    "%s posted a new event for the \"%s\" project entitled: %s\n\n".
                                    "The event description follows:\n".
                                    "------------------------------------------------------------------------\n".
                                    "%s\n".
                                    "------------------------------------------------------------------------\n\n".
                                    "This event is accessible on the OPT server at this URL:\n"),$name,
                                    "$s[1] $s[2] $s[3]",$proj_name,stripslashes($title),stripslashes($description)).
                         "http://$SERVER_NAME$CRM_URL?URL=".
                         rawurlencode("calendar/events/event_view/?proj=$proj&event=$event"),
                         __("You may post comments on this event by replying ".
                            "to this e-mail. Please note only the message body will be ".
                            "uploaded to OPT. You may also post comments by ".
                            "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
                            "please don't quote the original message since the quotation ".
                            "will also get unnecessarily posted on OPT.\n\nThank you!"),
                         "OPT event #$event <$CRM_system_email>");
          }
          OPT_locale();
      }
  } 
  elseif ($edit && $event)
  {
      // Get params safely
      $title=OPT_gpc_slashes($title);
      $description=OPT_gpc_slashes($description);
      $start_date=OPT_gpc_slashes($start_date);
      $end_date=OPT_gpc_slashes($end_date);

      // Confirm that they submitted something
      if (!$title || !$start_date || !$end_date)
      {
          OPT_error(__("You must provide an event title, start date, and end date."));
          exit;
      }

      if (strtotime($start_date) > strtotime($end_date))
      {
          OPT_error(__("The start date can not be later than the end date!"));
          exit;
      }
      
      $sql="update events set title='$title', description='$description', start_date='$start_date', 
            end_date='$end_date', project=project, src='$CRM_user' where id = $event";
      CRM_run_query($sql);
      OPT_confirm("Successfully changed event: $title");
  }
  else
  {
     $event=abs($event);

     // No request selected
     if (!$event)
     {
         OPT_error(__("Please select an event first!"));
         exit;
     }
  }

  // No permissions
  if ($proj && !crm_perm("projects",$proj))
  {
    OPT_error(__("Classified"));
    exit;
  }

  // Add a new comment
  if ($addcomment && $comment)
  {
    unset($dst);
    $scomment=OPT_gpc_slashes($comment);
    $sql="insert into event_comments set comment=\"$scomment\",
          src=$CRM_user, event=$event";
    $result=CRM_run_query($sql);
    // This is where the notification takes place!
    $event_fields[]="title";
    $event_fields[]="description";
    $event_fields[]="src";
    $event_info=getvalue("events",$event_fields,$event);
    $title=$event_info[0];
    $comments=$event_info[1];
    $src=$event_info[2];
    $submitter=getvalue("people","CONCAT(sal,' ',fname,' ',lname)",$CRM_user);

    // Notify the source of the event
    if ($CRM_user != $src)
    {
      $dst[]=$src;
    }

    // Send to "Additional notifications" if any chosen
    for ($i=0; $i<sizeOf($additional_notifications); $i++)
    {
        if (!@in_array($addtional_notifications[$i], $dst))
        {
           $dst[] = $additional_notifications[$i];
        }
    }

    $v[]="email";
    $v[]="sal";
    $v[]="fname";
    $v[]="lname";
    $s=getvalue("people",$v,$CRM_user);
    $title=stripslashes($title);

    for ($i=0;$i<sizeOf($dst);$i++) // >
    {
      OPT_locale($dst[$i]);
      $d=getvalue("people",$v,$dst[$i]);
      $name="$d[1] $d[3]";
      OPT_notify($dst[$i],sprintf(__("New comment on OPT event %s"),"\"$title\""),
        sprintf(__("Dear %s,\n".
        "%s posted a new comment on event %s\n\n".
        "The event description follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n\n".
        "The newly posted COMMENT follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n".
        "This event is accessible on the OPT server at this URL:\n"),$name,
        "$s[1] $s[2] $s[3]","\"$title\"",$comments,$comment).
        "http://$SERVER_NAME$CRM_URL?URL=".
        rawurlencode("calendar/events/event_view/?proj=$proj&event=$event"),
        __("You may post comments on this event by replying ".
        "to this e-mail. Please note only the message body will be ".
        "uploaded to OPT. You may also post comments by ".
        "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
        "please don't quote the original message since the quotation ".
        "will also get unnecessarily posted on OPT.\n\nThank you!"),
        "OPT event #$event <$CRM_system_email>");
    }
    OPT_locale();
  }

$sql="select title, project, start_date, end_date, description, src from events where id = $event";
$result=CRM_run_query($sql);
make_vars($result);
startTables();
?>

   <tr>
      <td class="ah4" colspan="2" bgcolor="<? echo $OPT_col_dk; ?>" align="center">
         <?echo($title)?>
      </td>
    </tr>

 <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right" width="50%"><b><? echo(__("Start Date")); ?></b></td>
      <td class="regular"  align="left" bgcolor="<? echo $OPT_col_lt; ?>">
      <? echo(niceDate("events","start_date",$event, 1)); ?>
      </td>
</tr>
 <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("End Date")); ?></b></td>
      <td class="regular"  align="left" bgcolor="<? echo $OPT_col_lt; ?>">
      <? echo(niceDate("events","end_date",$event, 1)); ?>
       </td>
    </tr>

<tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Submitted by")); ?></b></td>
      <td class="regular"  align="left" bgcolor="<? echo $OPT_col_lt; ?>">
      <?
       if (crm_perm("people",$src))
       {
         $a[0]="<a href=\"../../../people/admin/?action=display&id=".$src."\">";
         $a[1]="</a>";
       }
       else
       {
         $a[0]="";
         $a[1]="";
       }
       $submitter_name="$a[0]".getvalue("people", "CONCAT(fname,' ',lname)", $src)."$a[1]";
       echo($submitter_name);
       ?>
       </td>
    </tr>

    <tr>
      <td colspan="2" class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b><? echo(__("Event Description")); ?></b></td>
    </tr>

    <tr>
      <td colspan="2" class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>">
      <?echo(nl2br(htmlspecialchars(stripslashes($description))))?>
      </td>
    </tr>

<?
  $sql="select * from event_comments where event=$event order by date";
  $result=CRM_run_query($sql);
  if (OPT_num_rows($result))
  {
    echo("<tr><td class='regular' bgcolor='$OPT_col_dk' align='center' colspan='2'><b>".__("Comments on this event")."</b></td></tr>\n");
    $src_r[]="fname";
    $src_r[]="lname";
    while ($myrow=OPT_fetch_array($result))
    {
      echo("<tr><td class='regular' bgcolor='$OPT_col_lt' colspan='2'>\n");
      echo("<table width='100%' cellspacing='0' cellpadding='2' border='0'><tr>\n");
      $date=niceDate("event_comments","date",$myrow["id"]);
      if (crm_perm("people",$myrow["src"]))
      {
        $src=getvalue("people",$src_r,$myrow["src"]);
        $a[0]="<A class=\"small\" href=\"../../people/admin/?action=display&id=".$myrow["src"]."\">";
        $a[1]="</A>";
        //Bertelsen edited 1 line: $src changed to $src[0] $src[1] (bux fix)
        $theSrc=sprintf(__("Posted by %s on %s"),"$a[0] $src[0] $src[1] $a[1]",$date);
      }
      else
      {
        $theSrc=sprintf(__("Posted on %s"),$date);
      }
      echo("  <td class=\"small\" bgcolor=\"$OPT_col_md\" align='left'><i>$theSrc</i></td>\n");
      echo("</tr>\n<tr>\n");
      echo("  <td class=\"regular\"  align=left bgcolor=\"$OPT_col_lt\">".nl2br(htmlspecialchars(stripslashes($myrow["comment"])))."</td>\n");
      echo("</tr>\n");
      echo("</table></td></tr>\n");
    }
  }
  if ((!$CRM_guest) && (!$pf))
  {
?>
<tr>
<td class='regular' bgcolor="<? echo $OPT_col_md; ?>" align="center" colspan="2">
<b><? echo(__("You may post a comment below")); ?></b><br>
<form action="./" method="post">
  <input type="hidden" name="event" value="<? echo $event; ?>">
  <input type="hidden" name="proj" value="<? echo $proj; ?>">
  <input type="hidden" name="events" value="<? echo $events; ?>">
  <?
  if ($proj)
  {
  ?>
  <table cellpadding="2" cellspacing="2" width="100%"><tr><td align="right">
  <textarea name="comment" cols="65" rows="7" wrap="VIRTUAL"></textarea>
  </td><td align="center">
  <i>Also notify:</i></br>
  <select name='additional_notifications[]' multiple size="5">
  <? // Generate a list of team members on the project who aren't automatically notified
     $result = get_people_involved_with_project($proj);
     $notify_person_ids[] = $CRM_user;  // don't want option to notify self given
     $notify_person_ids[] = $src;  // don't want option to notify event source
     while ($row = OPT_fetch_row($result))
     {
        if (!@in_array($row[0], $notify_person_ids))
        {
           echo("<option value='$row[0]'>$row[1] $row[2]</option>");
        }
     }
  ?>
  </select><br /> 
  <span class='small'><? echo($submitter_name); ?><br />automatically notified.</span>
  </td></tr></table>
  <?
  }
  else
  {
  ?>
  <textarea name="comment" cols="65" rows="5" wrap="VIRTUAL"></textarea><br />
  <?
  }
  ?>
  <input type="submit" name="addcomment" value="<? echo(__("Add Comment")); ?>">
</form>

<?
  }
  endTables();
  auth_close();
?>

<script language="javascript">
<!--
parent.leftFrame.location="leftMenu/?month=<?echo($month);?>&year=<?echo($year);?>&proj=<?echo($proj);?>&event=<?echo($event);?>&events=<?echo($events);?>";
// -->
</script>
</BODY>
</HTML>
