<?
#
# Generic calendar for displaying various things based on their time
#
# Displays either absences, deadlines for a project, or deadlines for a person
#

include "../include/OPT_lib.php";
auth_open();
include "$CRM_path/calendar/calendar.inc";

// Initialize settings
$start_monday="1";
$hours24="1";

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Calendar")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>

<?
if ($person)
{
    $title="Deadlines for " . getvalue("people", "CONCAT(fname, ' ', lname)", $person);
}
elseif ($absences)
{
    $title="Office Absence Board";
}
elseif ($events)
{
    $title="Event Board";
}
elseif ($proj)  // This must be the last elseif before the else error case!
{
    $title="$show Deadlines for " . getvalue("projects", "name", $proj);
}
else
{
    OPT_error(__("Error! Not sure what type of calendar you're trying to view.  Contact administrator."));
    exit;
}

mainBody("../images"); 
make_main_title(__("$title"),"../images");
startTables();

// Render the calendar
$currentday = date("j");
$currentmonth = date("n");
$currentyear = date("Y");
if (!$month)
{
    $month=$currentmonth;
}
if (!$year)
{
    $year=$currentyear;
}
if ($month == 1)
{
    $prev_year_link=$year-1;
    $next_year_link=$year;
    $prev_month_link=12;
    $next_month_link=$month+1;
} 
elseif ($month == 12)
{
    $prev_year_link=$year;
    $next_year_link=$year+1;
    $prev_month_link=$month-1;
    $next_month_link=1;
}
else
{
    $prev_year_link=$year;
    $next_year_link=$year;
    $prev_month_link=$month-1;
    $next_month_link=$month+1;
}

if(empty($start_monday)) 
{
    $firstday = date("w", mktime(0,0,0,$month,1,$year));
}
else 
{
    $firstday = (date("w", mktime(0,0,0,$month,1,$year)) + 6) % 7;
}
$lastday = date("t", mktime(0,0,0,$month,1,$year));
?>

<?
if ($absences)
{
    if (sizeOf($reason_filter) || $group_filter)
    {
        $sql="DELETE FROM user_settings where person=$CRM_user and project=0 and type='absence_filters'";
        CRM_run_query($sql);
        $sql="INSERT INTO user_settings (person, project, type, name, value) VALUES   
         ($CRM_user, 0, 'absence_filters', 'reason_filter', '$reason_filter'),
         ($CRM_user, 0, 'absence_filters', 'group_filter', '$group_filter')";
        CRM_run_query($sql);
    }
    else 
    {  // User likely just didn't specify any filters, so let's retrieve their saved settings
       $sql="SELECT name, value FROM user_settings WHERE person=$CRM_user and type='absence_filters'";
       $settings_result=CRM_run_query($sql);
       while ($settings_row=OPT_fetch_row($settings_result))
       {
           if ($settings_row[0] == "reason_filter")
           {
               $reason_filter=intval($settings_row[1]);
           }
           else if ($settings_row[0] == "group_filter")
           {
               $group_filter=intval($settings_row[1]);
           }
       }
    }
?>
<tr>
<td colspan="7" bgcolor=<?echo($OPT_col_lt);?> align="center">
<form style="margin:0;" method="POST" action=".">
<input type="hidden" name="absences" value="1" />
<input type="hidden" name="proj" value="<?echo($proj)?>" />
<input type="hidden" name="month" value="<?echo($month)?>" />
<input type="hidden" name="year" value="<?echo($year)?>" />
<b>Filter by</b>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Reason:
<select name="reason_filter" onchange="form.submit()">
  <option value="-1">All</a>
<?
  $reasons = preg_split('/\|/', get_setting("timesheet_nonproj_reasons"));
  for($val=0; $val < sizeof($reasons); $val++) 
  {
      if (sizeOf($reason_filter) && ($val == $reason_filter))
      {
          $sel = "selected";
      }
      else
      {
          unset($sel);
      }
      echo("<option value='$val' $sel>".__($reasons[$val])."</option>");
  }
?>
      </select>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
Group:
<select name="group_filter" onchange="form.submit()">
  <option value="-1">All</a>
<?
     $group_result=crm_elements("companies", "order by shortname");
     while ($group_row=OPT_fetch_array($group_result))
     { 
         if ($group_row["id"] == $group_filter)
         {
             $sel = "selected";
         }
         else
         {
             unset($sel);
         }
         echo("<option value='".$group_row["id"]."' $sel>".$group_row["shortname"]."</option>");
     }
?>
</select>
</b>
</form>
</td>
</tr>
<?
}
?>

<tr>
<td colspan="1" bgcolor=<?echo($OPT_col_md);?> align="left">
<div class="small">
<a href="./?proj=<?echo($proj);?>&year=<?echo($prev_year_link);?>&month=<?echo($prev_month_link);?>&person=<?echo($person);?>&events=<?echo($events);?>&absences=<?echo($absences);?>">
&lt;&lt; Previous</a></div>
</td>
<td colspan="5" bgcolor=<?echo($OPT_col_md);?> align="center">
<b><? echo(month_name($month).' '.$year); ?></b>
</td>
<td colspan="1" bgcolor=<?echo($OPT_col_md);?> align="right">
<div class="small">
<a href="./?proj=<?echo($proj);?>&year=<?echo($next_year_link);?>&month=<?echo($next_month_link);?>&person=<?echo($person);?>&events=<?echo($events);?>&absences=<?echo($absences);?>">
Next &gt;&gt;</a></div>
</td>
</tr>

<?
if(empty($start_monday)) 
{
    echo('<td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">'. __('Sunday') . '</td>' . "\n");
}

echo('<td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">' .  __('Monday') . '</td>
      <td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">' .  __('Tuesday') . '</td>
      <td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">' .  __('Wednesday') . '</td>
      <td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">' .  __('Thursday') . '</td>
      <td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">' .  __('Friday') . '</td>
      <td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">' .  __('Saturday') . '</td>');

if(!empty($start_monday)) 
{
    echo('<td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">'. __('Sunday') . '</td>' . "\n");
}
?>
</tr>

<?

// Loop to render the calendar
$day_of_month=1;
for ($week_index = 0; $week_index<6; $week_index++) {
    if($day_of_month < $lastday) {
        echo('<tr>');
        // 
        for ($day_of_week = 0; $day_of_week < 7; $day_of_week++) {
            $i = $week_index * 7 + $day_of_week;
            $day_of_month = $i - $firstday + 1;
            
            if($i < $firstday || $day_of_month > $lastday) {
                echo('<td class="small" bgcolor="'.$OPT_col_lt.'">&nbsp;</td>');
                continue;
            }
            
            // Color the current day different from others (md)
            if (($year==$currentyear) && ($month==$currentmonth) && ($day_of_month==$currentday)) {
                $cell_col=$OPT_col_md;
            } else {
                $cell_col=$OPT_col_lt;
            }
?>
                                                     
<td valign="top" class="small" bgcolor="<?echo($cell_col)?>" align='left' style="height:60px">
<b><?echo($day_of_month);?></b>
<?
if ($person)
{
    person_deadlines_for_day_cell($year, $month, $day_of_month, $person);
}
elseif ($absences)
{
    absences_for_day_cell($year, $month, $day_of_month, $reason_filter, $group_filter);
}
elseif ($events)
{
    events_for_day_cell($year, $month, $day_of_month, $proj, $events);
}
elseif ($proj)  // This must be the last case!
{
    project_deadlines_for_day_cell($year, $month, $day_of_month, $proj, $show);
}
?>
</td>

<?
        }
        echo('</tr>');
    }
}
?>

</table>

<script language="javascript">
<!--
parent.leftFrame.location="leftMenu/?month=<?echo($month);?>&year=<?echo($year);?>&proj=<?echo($proj);?>&person=<?echo($person);?>&events=<?echo($events);?>&absences=<?echo($absences);?>";
// -->
</script>

<?
endTables();
auth_close();
?>

</BODY>
</HTML>