<?
#
# Daily display/editor of a user's project specific timesheet
#

include "../../include/OPT_lib.php";
auth_open();

include "$CRM_path/calendar/timesheets/timesheets.inc";

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Project Timesheet Editor")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>

<?
if ($person)
{
    $title="Timesheet for " . getvalue("people", "CONCAT(fname, ' ', lname)", $person);
}
else
{
    OPT_error(__("Error! Contact administrator."));
    exit;
}

mainBody("../../images"); 
make_main_title(__("$title"),"../../images");
include "$CRM_path/calendar/timesheets/task_hours_handler.inc";
include "$CRM_path/calendar/timesheets/hour_handler.inc";       // Handle any hours being submitted
?>

<script language="javascript">
  <!--
    function deleteTimeRecord(time_record)
    {
        if (confirm("Are you sure you want to remove this time record?"))
        { 
          document.location="./daily.php?person=<?echo($person)?>&date=<?echo($date)?>&delete_time_record="+time_record;
        }
    }
  // -->
</script>

<?

if (!$date)
{
    OPT_error("You must provide a valid date first!");
    exit(0);
}

$prev_day=strtotime("-1 day", $date);
$next_day=strtotime("+1 day", $date);

// Handle any form submissions first thing
if (($submit == "Update") && timesheet_edit_permission($person))
{
    for ($i=0; $i<sizeOf($task_ids); $i++)
    {
        if ($task_hours[$i] > 0)
        {
            $sql="update task_progress_history set date=date, 
                  worked = SEC_TO_TIME($task_hours[$i]*3600) 
                  where id = $task_ids[$i] and person = $CRM_user";
            CRM_run_query($sql); 
        }
        else
        {
            OPT_error("You must provide a valid number greater than zero for hours.");
            exit;
        }
    }
    
    for ($i=0; $i<sizeOf($misc_ids); $i++)
    {
        if ($misc_hours[$i] > 0)
        {
            $sql="update misc_time set worked = $misc_hours[$i] where
                  id = $misc_ids[$i] and person = $CRM_user";
            CRM_run_query($sql);
        }
        else
        {
            OPT_error("You must provide a valid number greater than zero for hours.");
            exit;
        }
    }
}

// Handle individual time deletions
if ($delete_time_record && timesheet_edit_permission($person))
{
    if (intval($delete_time_record) < 0)
    {
        $delete_time_record = abs($delete_time_record); // trick that negative num means a task time
        $sql="delete from task_progress_history where id = $delete_time_record and person = $person";
        CRM_run_query($sql);
    }
    else
    {
        $sql="delete from misc_time where id = $delete_time_record and person = $person";
        CRM_run_query($sql);
    }
}


// Start the page display below
if (timesheet_edit_permission($person))
{
    echo("<form action='daily.php' method='post' />");
    echo("<input type='hidden' name='person' value='$person' />");
    echo("<input type='hidden' name='date' value='$date' />");
}

startTables();
?>

<? if (timesheet_edit_permission($person) && !$pf)
{
    $colspan=6;
}
else
{
    $colspan=5;
}
?>
<tr>
<td colspan="1" bgcolor=<?echo($OPT_col_lt);?> align="left" nowrap>
<div class="small">
<a href="./daily.php?person=<?echo($person);?>&date=<?echo($prev_day);?>">
&lt;&lt; Previous</a></div>
</td>
<td align="center" bgcolor="<?echo($OPT_col_lt);?>" colspan="3">

<?
if (timesheet_edit_permission($person) & (!$pf))
{
?>
<i>Edit your timesheet for <?echo(date("l, F j, Y", $date))?> below...</i>
<?
}
else
{
?>
<i><?echo(date("l, F j, Y", $date))?></i>
<?
}
?>
</td>

<?
if (timesheet_edit_permission($person))
{
?>
<td bgcolor=<?echo($OPT_col_lt);?> align="right" colspan="2">
<div class="small">
<a href="./daily.php?person=<?echo($person);?>&date=<?echo($next_day);?>">
Next &gt;&gt;</a></div>
</td>
<?
}
else
{
?>
<td bgcolor=<?echo($OPT_col_lt);?> align="right" colspan="1">
<div class="small">
<a href="./daily.php?person=<?echo($person);?>&date=<?echo($next_day);?>">
Next &gt;&gt;</a></div>
</td>
<?
}
?>

</tr> 

<tr>
<td align="center" bgcolor="<?echo($OPT_col_dk);?>"><b>Project</b></td>
<td align="center" bgcolor="<?echo($OPT_col_dk);?>"><b>Task/Reason</b></td>
<td align="center" bgcolor="<?echo($OPT_col_dk);?>"><b>When</b></td>
<td align="center" bgcolor="<?echo($OPT_col_dk);?>"><b>Comment</b></td>
<td align="center" bgcolor="<?echo($OPT_col_dk);?>"><b>Hours</b></td>
<?
if (timesheet_edit_permission($person) && !$pf)
{?>
    <td align="center" bgcolor="<?echo($OPT_col_dk);?>"></td>
<?}?>
</tr>

<?
$no_rows_found=1;
// First list all task specific time for this project
$sql="select tph.id, t.id, t.TaskName, tph.workfrom, tph.workto, TIME_TO_SEC(tph.worked)/3600, p.id, p.name, tph.comment
          from task_progress_history as tph, task as t, projects as p
          where tph.taskID=t.id and tph.worked > 0 and p.id = t.ProjectID
          and tph.person=$person and tph.date >= FROM_UNIXTIME($date)
          and DATE_ADD(FROM_UNIXTIME($date), INTERVAL 1 DAY) > tph.date
          order by p.name";
$result=CRM_run_query($sql);
while ($row=OPT_fetch_row($result))
{    $no_rows_found=0;
    if ($col_color==$OPT_col_lt)
    {
        $col_color=$OPT_col_md;
    }
    else
    {
        $col_color=$OPT_col_lt;
    }
    echo("<tr>");

    // Project column
    if (crm_perm("projects", $row[6], VIEW))
    {
        echo("<td align='center' bgcolor='".$col_color."'><a href='../../projects/Proj_View/?proj=$row[6]'>$row[7]</td>");
    }
    else
    {
        echo("<td align='center' bgcolor='".$col_color."'>$row[7]</td>");
    }

    // Task column
    if (crm_perm("task", $row[1], VIEW))
    {
        echo("<td align='left' bgcolor='".$col_color."'><a href='../../tasks/task/?proj=$row[6]&task=$row[1]&action=display'>$row[2]</td>");
    }
    else
    {
        echo("<td align='left' bgcolor='".$col_color."'>$row[2]</td>");
    }

    // When column
    if ($row[3] && $row[4])
    {
        echo("<td align='center' bgcolor='".$col_color."'>".makeNiceTime($row[3])." - ".makeNiceTime($row[4])."</td>");
    }
    else
    {
        echo("<td align='center' bgcolor='".$col_color."'><i>n/a</i></td>");
    }
    
    // Comment column
    echo("<td align='left' bgcolor='".$col_color."'>".stripslashes($row[8])."&nbsp;</td>");

    // Hours column
    if (timesheet_edit_permission($person) && !$pf)
    {
        echo("<td align='center' bgcolor='".$col_color."'>");
        echo("<input type='hidden' name='task_ids[]' value='$row[0]'/>");
        echo("<input type='text' size='5' name='task_hours[]' value='".sprintf("%.1f", $row[5])."' />");
        echo("</td>");
        echo("<td align='center' bgcolor='".$col_color."'>");
        echo("<a href='#' onclick=\"return deleteTimeRecord(-$row[0]);\"><img src='../../images/trash.gif' height='15' border='0' /></a>");
        echo("</td>");
    }
    else
    {
        echo("<td align='center' bgcolor='".$col_color."'>".sprintf("%.1f", $row[5])."</td>");
    }
    $total_hours += $row[5];  // add to running total
    echo("</tr>");
}

// Now show all miscellaneous time assigned to this project
$sql="select id, worked, project, comment from misc_time where project > 0 and reason = -1 and 
      person=$person and day = FROM_UNIXTIME($date)";
$result=CRM_run_query($sql);
while ($row=OPT_fetch_row($result))
{
    $no_rows_found=0;
    if ($col_color==$OPT_col_lt)
    {
        $col_color=$OPT_col_md;
    }
    else
    {
        $col_color=$OPT_col_lt;
    }
    echo("<tr>");
    
    // Project column
    if (crm_perm("projects", $row[2], VIEW))
    {
        echo("<td align='center' bgcolor='".$col_color."'><a href='../../projects/Proj_View/?proj=$row[2]'>".getvalue("projects", "name", $row[2])."</td>");
    }
    else
    {
        echo("<td align='center' bgcolor='".$col_color."'>".getvalue("projects", "name", $row[2])."</td>");
    }

    // Task column
    echo("<td align='left' bgcolor='".$col_color."'>Miscellaneous time</td>"); 

    // When  column
    echo("<td align='center' bgcolor='".$col_color."'><i>n/a</i></td>");
    
    // Comment column
    echo("<td align='left' bgcolor='".$col_color."'>".stripslashes($row[3])."&nbsp;</td>");
    
    // Hours column
    if (timesheet_edit_permission($person) && !$pf)
    {
        echo("<td align='center' bgcolor='".$col_color."'>");
        echo("<input type='hidden' name='misc_ids[]' value='$row[0]'/>");
        echo("<input type='text' size='5' name='misc_hours[]' value='".sprintf("%.1f", $row[1])."' />");
        echo("</td>");
        echo("<td align='center' bgcolor='".$col_color."'>");
        echo("<a href='#' onclick=\"return deleteTimeRecord($row[0]);\"><img src='../../images/trash.gif' height='15' border='0' /></a>");
        echo("</td>");
    }
    else
    {
        echo("<td align='center' bgcolor='".$col_color."'>".sprintf("%.1f", $row[1])."</td>");
    }
    $total_hours += $row[1];  // add to running total
    echo("</tr>");   
}



// Now show all non-project time
$sql="select id, worked, reason, comment from misc_time where project = 0 and reason >= 0 and 
      person=$person and day = FROM_UNIXTIME($date)";
$result=CRM_run_query($sql);
$reasons=preg_split('/\|/', get_setting("timesheet_nonproj_reasons"));
while ($row=OPT_fetch_row($result))
{
    $no_rows_found=0;
    if ($col_color==$OPT_col_lt)
    {
        $col_color=$OPT_col_md;
    }
    else
    {
        $col_color=$OPT_col_lt;
    }
    echo("<tr>");
    
    // Project column 
    echo("<td align='center' bgcolor='".$col_color."'><i>n/a</i></td>");

    // Task/Reason column
    echo("<td align='left' bgcolor='".$col_color."'>".$reasons[$row[2]]."</td>"); 

    // When  column
    echo("<td align='center' bgcolor='".$col_color."'><i>n/a</i></td>");

    // Comment column
    echo("<td align='left' bgcolor='".$col_color."'>".stripslashes($row[3])."&nbsp;</td>");

    // Hours column
    if (timesheet_edit_permission($person) && !$pf)
    {
        echo("<td align='center' bgcolor='".$col_color."'>");
        echo("<input type='hidden' name='misc_ids[]' value='$row[0]'/>");
        echo("<input type='text' size='5' name='misc_hours[]' value='".sprintf("%.1f", $row[1])."' />");
        echo("</td>");
        echo("<td align='center' bgcolor='".$col_color."'>");
        echo("<a href='#' onclick=\"return deleteTimeRecord($row[0]);\"><img src='../../images/trash.gif' height='15' border='0' /></a>");
        echo("</td>");
    }
    else
    {
        echo("<td align='center' bgcolor='".$col_color."'>".sprintf("%.1f", $row[1])."</td>");
    }
    $total_hours += $row[1];  // add to running total
    echo("</tr>");   
}

// Now include all non-proj reasons when the user was absent from the office
// Assumes a one hour lunch hour between 12 and 1 (don't count lunch)
// Max amount is 8 to 5 minus lunch hour so 8 hours  (don't count on weekends!)
$weekday = date("w", $date);
if (($weekday != 0) && ($weekday != 6))
{
    $sql="select reason, UNIX_TIMESTAMP(start_date), UNIX_TIMESTAMP(end_date), id, notes
              from absences where person=$person and start_date <= 
              DATE_ADD(FROM_UNIXTIME($date), INTERVAL 1 DAY) and end_date > FROM_UNIXTIME($date)  
              and reason >=0 and count_on_timesheet = 1";
    $result=CRM_run_query($sql);
    while($row=OPT_fetch_row($result))
    {
        $no_rows_found=0;        // Need to figure out how many hours to count
        $strdate=date("Y-m-d", $date);
        $noon = strtotime("$strdate 12:00:00");
        $onepm = strtotime("$strdate 13:00:00");
        $eightam = strtotime("$strdate 08:00:00");
        $fivepm = strtotime("$strdate 17:00:00");
        if ($row[1] < $eightam)
        {
            $row[1] = $eightam;
        }
        if ($row[2] > $fivepm)
        {
            $row[2] = $fivepm;
        }
        $secs=$row[2] - $row[1];
        
        if (($row[1] <= $noon) && ($row[2] > $onepm))
        {
            $secs -= (60*60); // minus one hour for lunch
        }
        if ($secs > (8 * 60 * 60))
        {   // limit to 8 hrs in day
            $secs = 8 * 60 * 60;
        }

        $absent_hours = $secs/3600;
        
        if ($col_color==$OPT_col_lt)
        {
            $col_color=$OPT_col_md;
        }
        else
        {
            $col_color=$OPT_col_lt;
        }
        echo("<tr>");
        
        // Project column 
        echo("<td align='center' bgcolor='".$col_color."'><i>n/a</i></td>");
        
        // Task/Reason column
        echo("<td align='left' bgcolor='".$col_color."'><a href='../absences/absence_view/?absence=$row[3]'>".$reasons[$row[0]]."</a>");
        echo("</td>");

        // When  column
        echo("<td align='center' bgcolor='".$col_color."'>".date("H:i", $row[1])." - ".date("H:i", $row[2])."</td>");
   
        // Comment column
        echo("<td align='left' bgcolor='".$col_color."'>".stripslashes($row[4])."&nbsp;</td>");
    
        // Hours
        echo("<td align='center' bgcolor='".$col_color."'>".sprintf("%.1f", $absent_hours)."</td>");
        if (timesheet_edit_permission($person) && !$pf)
        {
            echo("<td align='center' bgcolor='".$col_color."'>");
            echo("<a href='#' onclick=\"alert('This time entry is for an office absence that may span multiple days.  To delete this entry you must delete entire absence entry.');\"><img src='../../images/trash.gif' height='15' border='0' /></a>");
            echo("</td>");
        }
        $total_hours += $absent_hours;  // add to running total
        echo("</tr>");   
    }
}



if ($no_rows_found)
{
    echo("<tr><td align='center' bgcolor='$OPT_col_lt' colspan='$colspan'><b>No hours found...</b>");
    echo("</td></tr>");
}

// Output a total count
echo("<tr><td  align='center' bgcolor='$OPT_col_dk'><b>Total</b></td>");
echo("<td  align='left' bgcolor='$OPT_col_dk' colspan='".($colspan-3)."'>&nbsp;</td>");
if (timesheet_edit_permission($person) && !$pf)
{
    echo("<td align='center' bgcolor='$OPT_col_dk'><b>".sprintf("%.1f", $total_hours)."</b></td>");
    echo("<td bgcolor='$OPT_col_dk'>&nbsp;</td>");
}
else
{
    echo("<td bgcolor='$OPT_col_dk'>&nbsp;</td>");
    echo("<td align='center' bgcolor='$OPT_col_dk'><b>".sprintf("%.1f", $total_hours)."</b></td>");
}
echo("</tr>");

if (timesheet_edit_permission($person) && (!$pf))
{
    echo("<tr><td align='center' bgcolor='$OPT_col_md' colspan='$colspan'><input type='submit' name='submit' value='Update' />");
    echo("</td></tr></form>");
}
?>



<?
endTables();
?>

<?
// Now show the editing area if person is looking at their own timesheet (also hide if printing)
if (timesheet_edit_permission($person) && (!$pf))
{
    $daily_view = 1;
    $nice_sdate=date("Y-m-d", $date);
    $misc_date=$nice_sdate;
    $nonproj_date=$nice_sdate;
    include "$CRM_path/calendar/timesheets/hours_form.inc";
}  // end of if (timesheet_edit_permission($person) && !$pf)


auth_close();
?>
</BODY>
</HTML>
