<?

// Handle Task time submission if made (complements hour_form.inc)
if (strlen(trim($nice_sdate)) && timesheet_edit_permission($person) && ($add_task_time)) 
{
    addTaskHours(0, $from, $to, $worked_hrs, $nice_sdate, $comment, $hrs_remaining, $tasks, $complete, $person);
} 
else
{   // didn't get a date so lets use today
    $nice_sdate=date("Y-m-d");
}

// Handle form submission for addition of misc hours
if (timesheet_edit_permission($person) && ($add_misc_time))
{
    if ($misc_hours <= 0)
    {
        OPT_error("Sorry, you must provide the number of miscellaneous hours to add.");
    }
    elseif (intval($project) <= 0)
    {
        OPT_error("Sorry, you must provide a valid project.");
    }
    elseif (!$misc_date)
    {
        OPT_error("Sorry, you must provide a valid date.");
    }
    else
    {
        $misc_hours=myfloatval($misc_hours);
        $project=intVal($project);
        $misc_date=OPT_gpc_slashes($misc_date);
        $misc_comment=OPT_gpc_slashes($misc_comment);
        $sql="insert into misc_time (project, person, day, worked, reason, comment) values
          ('$project', '$person', '$misc_date', '$misc_hours', -1, '$misc_comment')";
        CRM_run_query($sql);
        OPT_confirm("Added $misc_hours hour(s) of miscellaneous time to ". getvalue("projects", "name", $project));  

	// Save the last project they added hours to
	CRM_run_query("delete from user_settings where person = $person and type = 'timesheets' and name = 'project'");
	CRM_run_query("insert into user_settings (person, type, name, value) values ($person, 'timesheets', 'project', '$project')");
    }
}

// Handle form submission for addition of nonproj hours
if (timesheet_edit_permission($person) && ($add_nonproj_time))
{
    if ($nonproj_hours <= 0)
    {
        OPT_error("Sorry, you must provide the number of non-project specific hours to add.");
    }
    elseif (intval($reason) < 0)
    {
        OPT_error("Sorry, you must provide a valid reason.");
    }
    elseif (!$nonproj_date)
    {
        OPT_error("Sorry, you must provide a valid date.");
    }
    else
    {
        $nonproj_hours=myfloatval($nonproj_hours);
        $reason=intval($reason);
        $nonproj_date=OPT_gpc_slashes($nonproj_date);
        $nonproj_comment=OPT_gpc_slashes($nonproj_comment);
        $sql="insert into misc_time (project, person, day, worked, reason, comment) values
          (0, '$person', '$nonproj_date', '$nonproj_hours', $reason, '$nonproj_comment')";
        CRM_run_query($sql);
        $reasons = preg_split('/\|/', get_setting("timesheet_nonproj_reasons"));
        OPT_confirm("Added $nonproj_hours hour(s) for reason: $reasons[$reason]");

	// Save the last reason they added hours to	
	CRM_run_query("delete from user_settings where person = $person and type = 'timesheets' and name = 'reason'");
	CRM_run_query("insert into user_settings (person, type, name, value) values ($person, 'timesheets', 'reason', '$reason')");
    }
}
?>
