<?
#
# Weekly editor/display of a users timesheets
#

include "../../include/OPT_lib.php";
auth_open();
include "$CRM_path/calendar/calendar.inc";
include "$CRM_path/calendar/timesheets/timesheets.inc";
include "$CRM_path/calendar/timesheets/task_hours_handler.inc";
$cur_date=date("Y-m-d");

// Converts a week and year to a date
function get_date_from_week($year, $week)
{
    $first_day = strtotime($year."-01-01");
    $is_monday = date("w", $first_day) == 1;
    $is_weekone = strftime("%V", $first_day) == 1;
    if($is_weekone)
    {
        $week_one_start = $is_monday ? $first_day : strtotime("last monday", $first_day);
    }
    else
    {
        $week_one_start = strtotime("next monday", $first_day);
    }
    return $week_one_start+(3600*24*7*($week-1));
}


// Initialize settings
$start_monday="1";
$hours24="1";

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Calendar")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>

<?
if ($person)
{
    $title="Timesheet for " . getvalue("people", "CONCAT(fname, ' ', lname)", $person);
}
else
{
    OPT_error(__("Error! Contact administrator."));
    exit;
}

mainBody("../../images"); 
make_main_title(__("$title"),"../../images");
include "$CRM_path/calendar/timesheets/hour_handler.inc";   // Handle any hours being submitted
?>
<script language="JavaScript" src="../../tasks/task/ts_picker.js"></script>
<?
startTables();

// Render the calendar
$currentday = date("j");
$currentweek = date("W");
$currentmonth = date("n");
$currentyear = date("Y");
if (!$week)
{
    $week=$currentweek;
}
if (!$year)
{
    $year=$currentyear;
}
if ($week == 1)
{
    $prev_year_link=$year-1;
    $next_year_link=$year;
    $prev_week_link=52;
    $next_week_link=$week+1;
} 
elseif ($week == 52)
{
    $prev_year_link=$year;
    $next_year_link=$year+1;
    $prev_week_link=$week-1;
    $next_week_link=1;
}
else
{
    $prev_year_link=$year;
    $next_year_link=$year;
    $prev_week_link=$week-1;
    $next_week_link=$week+1;
}

?>

<tr>
<td colspan="1" bgcolor=<?echo($OPT_col_md);?> align="left">
<div class="small">
<a href="./?proj=<?echo($proj);?>&year=<?echo($prev_year_link);?>&week=<?echo($prev_week_link);?>&person=<?echo($person);?>">
&lt;&lt; Previous</a></div>
</td>
<td colspan="5" bgcolor=<?echo($OPT_col_md);?> align="center">
<b><? echo(__("Hours per Project or Reason")); ?></b>
</td>
<td colspan="1" bgcolor=<?echo($OPT_col_md);?> align="right">
<div class="small">
<a href="./?proj=<?echo($proj);?>&year=<?echo($next_year_link);?>&week=<?echo($next_week_link);?>&person=<?echo($person);?>">
Next &gt;&gt;</a></div>
</td>
</tr>

<?

// Loop to determine dates this week
for ($day_of_week = 0; $day_of_week < 7; $day_of_week++) 
{
    $week_start=get_date_from_week($year, $week);
    $the_date=strtotime("+$day_of_week DAY", $week_start);
    $dates[] = $the_date;  // save in an array
}

// Now loop to output the date headers
echo("<tr>");
for ($day_of_week = 0; $day_of_week < 7; $day_of_week++) 
{
    $date_str=strftime("<b><a href='daily.php?person=$person&date=$dates[$day_of_week]'>%A</a></b><br />%b %e, %Y", $dates[$day_of_week]);
    echo('<td align="center" width="14%" bgcolor="'.$OPT_col_dk.'">'.$date_str. '</td>');
}
echo("</tr>");

// Loop to render the week (Monday first)
echo("<tr>");
for ($day_of_week = 0; $day_of_week < 7; $day_of_week++) {

    // Color the current day different from others (md)
    $currentday = date("w") - 1 ;  // rotate 1 to get Monday first
    if ($currentday == -1)
    {
        $currentday = 6;  // This is a Sunday
    }
    if (($currentyear==$year) && ($currentweek==$week) && ($day_of_week == $currentday))
    {
        $cell_col=$OPT_col_md;
    } else {
        $cell_col=$OPT_col_lt;
    }
        ?>
                                                                                              
<td valign="top" class="small" bgcolor="<?echo($cell_col)?>" style="height:60px">

<?
     $total_hours[$day_of_week] = 0;
     echo("<table width='100%' cellspacing='0' cellpadding='0' >");
     $total_hours[$day_of_week] += displayHoursPerProject($dates[$day_of_week], $person);
     $total_hours[$day_of_week] += displayHoursPerReason($dates[$day_of_week], $person);
     echo("</table>");
?>

</td>

<?
}
?>

</tr>

<?
// Now loop to show the last row containing daily totals
echo("<tr>");
for ($day_of_week = 0; $day_of_week < 7; $day_of_week++) {
   // Color the current day different from others (md)
    $currentday = date("w") - 1 ;  // rotate 1 to get Monday first
    if ($currentday == -1)
    {
        $currentday = 6;  // This is a Sunday
    }
    if (($currentyear==$year) && ($currentweek==$week) && ($day_of_week == $currentday))
    {
        $cell_col=$OPT_col_md;
    } else {
        $cell_col=$OPT_col_lt;
    }
?>
<td valign="top" class="small" bgcolor="<?echo($cell_col)?>">
<?
echo("<table width='100%' cellspacing='0' cellpadding='0' ><tr>");
echo("<td align='left' class='small'><b>Total hours </b></td><td align='right' valign='middle' class='small'><b>");
     echo(sprintf("%.1f", $total_hours[$day_of_week])."</b></td></tr></table>");   
?>
</td>
<?
      $weekly_total += $total_hours[$day_of_week];
         } // end of for loop displaying daily totals
?>
</tr>

<tr>
<td align="right" bgcolor="<?echo($OPT_col_md);?>" class='small' colspan="6">&nbsp;</td>
<td align="right" bgcolor="<?echo($OPT_col_md);?>" class='small' colspan="6">
<table width='100%' cellspacing='0' cellpadding='0' ><tr><td align='left' class='small'><b>Weekly total</b></td>
<td align='right' valign='middle' class='small'><b><?echo(sprintf("%.1f", $weekly_total));?></b>
</td></tr></table>


</td>
</tr>
</table>

<?
endTables();

// Now show the editing area if person is looking at their own timesheet (also hide if printing)
if (timesheet_edit_permission($person) && (!$pf))
{
    include "$CRM_path/calendar/timesheets/hours_form.inc";
}  
auth_close();
?>




<script language="javascript">
<!--
parent.leftFrame.location="leftMenu/?week=<?echo($week);?>&year=<?echo($year);?>&proj=<?echo($proj);?>&person=<?echo($person);?>";
// -->
</script>

</BODY>
</HTML>


<?

// Show all the hours recorded for tasks on this day by this person
function displayHoursPerProject($date, $person)
{
    $total_hours = 0;

    // Now get hours worked on tasks
    $sql="select p.id, SUM(TIME_TO_SEC(tph.worked))/3600
          from task_progress_history as tph, task as t, projects as p
          where tph.taskID=t.id and tph.worked > 0 and p.id = t.ProjectID
                and tph.person=$person and tph.date >= FROM_UNIXTIME($date)
                and DATE_ADD(FROM_UNIXTIME($date), INTERVAL 1 DAY) > tph.date
          group by p.id";
    $result=CRM_run_query($sql);
    while ($row=OPT_fetch_row($result))
    {
        $hours[$row[0]] += $row[1];
    }
    
    // Also include any miscellaneous time for this project/person/day (reason = -1 for misc)
    $sql="select project, SUM(worked) from misc_time where person=$person and day = FROM_UNIXTIME($date)
                 and reason=-1 and project > 0 GROUP BY project";
    $misc_result=CRM_run_query($sql);
    while ($misc_row=OPT_fetch_row($misc_result))
    {
        $hours[$misc_row[0]] += $misc_row[1];
    }
 
    // Now loop through all projects this person has access to and display hours if any
    $proj_result=crm_elements("projects","order by name");
    while ($proj_row=OPT_fetch_row($proj_result))
    {
        if ($hours[$proj_row[0]] > 0)
        {
            echo("<tr>");
            echo("<td align='left' class='small'>$proj_row[1]</td>");
            echo("<td align='right' valign='middle' class='small'>");
            echo(sprintf("%.1f", $hours[$proj_row[0]])."</td></tr>");
            $total_hours += $hours[$proj_row[0]];
        }
    
    }
    return $total_hours;
}


// Show all the hours recorded for non-project reasons (including absences)
function displayHoursPerReason($date, $person)
{
    $total_hours = 0;
    
    // First get all valid reasons for a non-project time entry
    $reasons = preg_split('/\|/', get_setting("timesheet_nonproj_reasons"));

    // Now get all hours added as non-proj hours on a specific day
    $sql="select reason, SUM(worked) from misc_time where person=$person and day = FROM_UNIXTIME($date)
                 and reason >=0 and project = 0 GROUP BY reason";
    $result=CRM_run_query($sql);
    while($row=OPT_fetch_row($result))
    {
        $reason_time[$row[0]] = $row[1];
        if ($max_reason < $row[0])
        {
            $max_reason = $row[0];
        }
    }

    // Now include all non-proj reasons when the user was absent from the office
    // Assumes a one hour lunch hour between 12 and 1 (don't count lunch)
    // Max amount is 8 to 5 minus lunch hour so 8 hours  (don't count on weekends!)
    $weekday = date("w", $date);
    if (($weekday != 0) && ($weekday != 6))
    {
        $sql="select reason, UNIX_TIMESTAMP(start_date), UNIX_TIMESTAMP(end_date)
              from absences where person=$person and start_date <= 
              DATE_ADD(FROM_UNIXTIME($date), INTERVAL 1 DAY) and end_date > FROM_UNIXTIME($date)  
              and reason >=0 and count_on_timesheet = 1";
        $result=CRM_run_query($sql);
        while($row=OPT_fetch_row($result))
        {
            // Need to figure out how many hours to count
            $strdate=date("Y-m-d", $date);
            $noon = strtotime("$strdate 12:00:00");
            $onepm = strtotime("$strdate 13:00:00");
            $eightam = strtotime("$strdate 08:00:00");
            $fivepm = strtotime("$strdate 17:00:00");
            if ($row[1] < $eightam)
            {
                $row[1] = $eightam;
            }
            if ($row[2] > $fivepm)
            {
                $row[2] = $fivepm;
            }
            $secs=$row[2] - $row[1];

            if (($row[1] <= $noon) && ($row[2] > $onepm))
            {
                $secs -= 60*60; // minus one hour for lunch
            }
            if ($secs > (8 * 60 *60))
            {
                $secs = 8 * 60 * 60;
            }
            $reason_time[$row[0]] += ($secs/3600); // add on hours per reason 
            
            if ($max_reason < $row[0])
            {
                $max_reason = $row[0];
            }
        }
    }
    
    for ($i=0; $i<=$max_reason; $i++)
    {
        if ($reason_time[$i] > 0)
        {
            $reason_name=$reasons[$i];
            echo("<tr>");
            echo("<td align='left' class='small'>$reason_name</td>");
            echo("<td align='right' valign='middle' class='small'>");
            echo(sprintf("%.1f", $reason_time[$i])."</td></tr>");
            $total_hours += $reason_time[$i];
        }
    }
    return $total_hours;
}

?>