<?
#
# Function for handling a timesheet record from task_hours_form.inc
#
function addTaskHours($i, $from, $to, $worked_hrs, $nice_sdate, $comment, $hrs_remaining, $tasks, $complete, $person)
{
      if (($from[$i] > 0) || ($to[$i] > 0))
      {
          $time_range=1;  // we have a valid from - to time range
      }
 
      $from_count=sizeOf(explode(":",$from[$i]));
      if ($from_count==1) {
        $from[$i].=":00:00";
      } elseif ($from_count==2) {
        $from[$i].=":00";
      }
      $to_count=sizeOf(explode(":",$to[$i]));
      if ($to_count==1) {
        $to[$i].=":00:00";
      } elseif ($to_count==2) {
        $to[$i].=":00";
      }

      // This can be a time with : or a decimal number of hours
      $work_count=sizeOf(explode(":",$worked_hrs[$i]));
      if ($work_count==1) {
        $worked_hrs[$i] = myfloatval($worked_hrs[$i]);
      } elseif ($work_count==2) {
        $work_list = explode(":",$worked_hrs[$i]);
        $worked_hrs[$i] = $work_list[0] + $work_list[1]/60;
      }
      else
      {
        OPT_error(__("Hours worked must be in H:M or integer or decimal format."));
        exit;
      }     

      $from[$i] = $nice_sdate." ".$from[$i];
      $to[$i] = $nice_sdate." ".$to[$i];

      if ($time_range) 
      {  // Set progress to occur at the end of the work period
         $nice_sdate=$to[$i];
      }
      else if ($nice_sdate == date("Y-m-d"))
      {  // If this change is for hours today, use the current time
         $nice_sdate = date("Y-m-d H:i:s");
      }
      else
      {  // Add progress to occur at the very end of the previous day
         $nice_sdate=$nice_sdate . " 23:59:59";
      }      

      if ($worked_hrs[$i] > 0 && $tasks[$i]) {
        $estimated_secs=getvalue("task", "TIME_TO_SEC(estimated)", $tasks[$i]);
        if ($complete[$i] != '') {
          $hrs_remaining=intVal($complete[$i]);  
          if ($estimated_secs != 0)
          {       
              $complete[$i] = intVal(100 - ($complete[$i]*3600*100/$estimated_secs));
          }
          else
          {
              $complete[$i] = 100;  // We're now complete if no hours remaining
          }     
          
          // Don't exceed percent range
          if ($complete[$i] < 0) {
              $complete[$i] = 0;
          } elseif ($complete[$i] >= 100) {
              $complete[$i] = 100;
              $end_date_sql=", EndDate=UNIX_TIMESTAMP(now()) ";
          }
          
          // Get the current StartDate to see if it needs to be set
          if ($complete[$i] > 0)
          {
             $StartDate = getvalue("task", "StartDate", $tasks[$i]);
             if ($StartDate == 0)
             {
                $start_date_sql = ", StartDate=UNIX_TIMESTAMP(now()) ";
             }            
          }         

          $sql="UPDATE task SET PercentComplete='$complete[$i]', StatusUpdated=".time().", date=date $start_date_sql $end_date_sql WHERE id=$tasks[$i]";
          $result=crm_run_query($sql);
          $prog_query = "progress='$complete[$i]',";
          $remaining="remaining='$hrs_remaining', ";
        } 
        else {
          $prog_query = "";
          $remaining="remaining='".getvalue("task", "TIME_TO_SEC(estimated) * (100-PercentComplete) 
                                       / 360000", $tasks[$i])."', ";
          $prog_query="progress='".getvalue("task", "PercentComplete", $tasks[$i])."', ";
        }

        $Scomment=OPT_gpc_slashes($comment[$i]);
        if ($time_range)
        {
            $work_period = "workfrom='$from[$i]', workto='$to[$i]', ";
        }
         
        $sql="insert into task_progress_history set $prog_query $remaining taskID='$tasks[$i]', 
              worked=SEC_TO_TIME(3600*$worked_hrs[$i]), 
              $work_period comment='$Scomment', person=$person, date='$nice_sdate'";
        crm_run_query($sql);
        OPT_confirm(__("Added $worked_hrs[$i] hours on task '".getvalue("task","TaskName",$tasks[$i])."'"));

	// Save the last task they added hours to
        CRM_run_query("delete from user_settings where person = $person and type = 'timesheets' and name = 'task'");
        CRM_run_query("insert into user_settings (person, type, name, value) values ($person, 'timesheets', 'task', '$tasks[$i]')");
      }
}
?>



