<?
#
# CVS Information page for projects with unconfigured CVS or users who haven't used it at all yet.
#
  include("../include/OPT_lib.php");
  auth_open();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>Project Source Code</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
$rep = abs($rep);
if (!$rep)
{
   OPT_error("A valid repository must be provided!");
   exit;
}

mainBody("../images");
make_main_title($action,"../images");

$proj = abs($proj);
if (!$proj)
{
   OPT_error("Error, you shouldn't be here without specifying a project.");
   exit;
}

if (!is_admin() && !crm_project_participant($CRM_user, $proj, DEVELOPER))
{
   OPT_error("Access denied.");
   exit;
}


// Handle the submission of an add or an update using MySQL REPLACE
if ($submit)
{
    // Verify that we have the required fields
    if (!$name || !$title || !$location || !$root_dir)
    {
        OPT_error("Missing required field. Please provide at least a name, title, location, and root directory.");
        exit;
    }

    // Ensure that the location contains a CVSROOT directory,
    // otherwise general system browsing would be possible
    if (!is_dir(realpath($location) . "/CVSROOT"))
    {
        OPT_error("You've specified a location directory that does not appear to be a valid CVS repository.");
        exit;
    }    

    $sname = OPT_gpc_slashes($name);
    $stitle = OPT_gpc_slashes($title);
    $slocation = OPT_gpc_slashes(realpath($location));
    $scvsusers = OPT_gpc_slashes($cvsusers);
    $sroot_dir = OPT_gpc_slashes($root_dir);
    $srestrictions = OPT_gpc_slashes($restrictions);
    $sql = "replace into code_repositories (id, project, name, title, location, cvsusers, root_dir, restrictions) values
             ($rep, $proj, '$sname', '$stitle', '$slocation', '$scvsusers', '$sroot_dir', '$srestrictions')";
    crm_run_query($sql);  // insert or update 
    OPT_confirm("Successfully updated repository details.");
}
else
{   // Get the details from the database
    $sql = "select name, title, location, root_dir, cvsusers, restrictions from code_repositories 
                  where project = $proj and id = $rep";
    $result = CRM_run_query($sql);
    if (OPT_num_rows($result) != 1)
    {
        OPT_error("Error: Repository not found!");
        exit;
    }
    
    $row = OPT_fetch_row($result);
    $name = $row[0];
    $title = $row[1];
    $location = $row[2];
    $root_dir = $row[3];
    $cvsusers = $row[4];
    $restrictions = $row[5];
}

startTables();
?>

<tr><td colspan='2' bgcolor='<?echo($OPT_col_dk);?>' align='center'><b>
<a href="../include/horde/chora/cvs.php?proj=<?echo($proj);?>&rep=<?echo($rep);?>&f=<?echo($root_dir);?>"><?echo($name)?></a>
</b></td></tr>

<tr><td bgcolor='<?echo($OPT_col_md);?>' align='right' width='50%'><b>Title</b>
<div class='small'>A phrase to describe this repository.</div></td>
<td bgcolor='<?echo($OPT_col_lt);?>' align='left'><?echo($title);?>
</td></tr>

<tr><td bgcolor='<?echo($OPT_col_md);?>' align='right' width='50%'><b>Location</b>
<div class='small'>The path to the CVS repository on either local disk or via a network share like NFS. Should contain a CVSROOT directory.</div></td>
<td bgcolor='<?echo($OPT_col_lt);?>' align='left'><?echo($location);?>
</td></tr>

<tr><td bgcolor='<?echo($OPT_col_md);?>' align='right' width='50%'><b>Root Directory</b>
<div class='small'>Project team will have access to all data from this directory down.  Typically this is '/', but when multiple projects share the same repository, you can specify only a certain path for this project.</div></td>
<td bgcolor='<?echo($OPT_col_lt);?>' align='left'><?echo($root_dir);?>
</td></tr>

<tr><td bgcolor='<?echo($OPT_col_md);?>' align='right' width='50%'><b>Location</b>
<div class='small'>Optionally, provide a user address map.  Often 'CVSROOT/cvsusers'.</div></td>
<td bgcolor='<?echo($OPT_col_lt);?>' align='left'><?echo($cvsusers);?>
</td></tr>

<tr><td bgcolor='<?echo($OPT_col_md);?>' align='right' width='50%'><b>Restrictions</b>
<div class='small'>List (comma-separated) of perl-style regular expressions for those files
whose contents should be protected and not displayed. For example, '^/?projectA/secrets/*','^/?projectA/secrets/*'</div></td>
<td bgcolor='<?echo($OPT_col_lt);?>' align='left'><?echo($restrictions);?>
</td></tr>

<?
endTables();
auth_close();
?>

<script language="javascript">
<!--
parent.leftFrame.location="leftMenu/index.php?proj=<?echo($proj);?>&rep=<?echo($rep);?>";
// -->
</script>
</BODY>
</HTML>
