<?
#
# Document upload and editing form
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  include "../../include/OPT_lib.php";
  auth_open();
  include "$CRM_path/documents/doc_lib.php";

  if (! $proj) {
    OPT_error(__("Please select a project first"));
    exit;
  }

  if (crm_perm("projects",$proj) < VIEW) {
    OPT_error(__("Classified"));
    exit;
  }
  if ($update) {
    $title=__("Update a Document or Bookmark");
  } else {
    $title=__("Add a New Document or Bookmark");
    $upd_ver="1.0";
  }
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo($title); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../images");
  make_main_title($title,"../../images");

$locked_by = getvalue("documents","locked_by",abs($update));
if ($update && $locked_by && ($locked_by != $CRM_user))
{
    if (crm_perm("people",$locked_by)) 
    {
        $a_start = "<a href=\"../../people/admin?action=display&id=$locked_by\">";
        $a_end = "</a>";
    }
    OPT_error("Sorry, $a_start".getvalue("people","CONCAT(fname,' ',lname)",$locked_by).
         "$a_end has had an update lock on this document since ". niceDate("documents","lock_date", $update).".");
    exit;
} 

  startTables();
?>
<form name="theForm" method="post" action="../Doc_View/" enctype="multipart/form-data">
  <tr>
    <td class="small" bgcolor="<? echo $OPT_col_dk; ?>" colspan="2" align="center">
      <? echo(__("You may use the form below in order to create a new document or bookmark")); ?>
    </td>
  </tr>
    <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right" width="50%">
        <strong><? echo(__("Title")); ?></strong>
        <div class="small"><? echo(__("The document title, as it will be displayed in the documents list")); ?></div>
      </td>
      </td>
      <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>" width="50%">
        <?
          if ($update) {
            $upd_get[]="title";
            $upd_get[]="ver";
            $upd_get[]="doc";
            $upd_get[]="fname";
            $upd_data=getvalue("documents",$upd_get,$update);
            $upd_title=$upd_data[0];
            // The str_replace is needed to ensure that locales which use comma as
            // fraction separator don't affect versions (AFAIK, versions are always
            // separated by periods, regardless of language/locale).
            $upd_ver=str_replace(",",".",($upd_data[1]+0.1));
          } 
        ?>
        <input type="text" name="title" value="<? echo htmlspecialchars($upd_title) ?>" size="40">
      </td>
    </tr>
        <tr>
          <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
            <strong><? echo(__("Document")); ?></strong>
            <div class="small"><? echo(__("You must specify a document here or a bookmark below")); ?></div>
          </td>
          <td class="regular"  align="left" bgcolor="<? echo $OPT_col_lt; ?>">
            <input type="file" name="data" size="25">
          </td>
        </tr>
    </tr>
        <tr>
          <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
            <strong><? echo(__("PDF preview")); ?></strong>
            <div class="small"><? echo(__("You may optionally also provide a PDF preview of the document here")); ?></div>
          </td>
          <td class="regular"  align="left" bgcolor="<? echo $OPT_col_lt; ?>">
            <input type="file" name="pdf" size="25">
          </td>
        </tr>
        <tr>
          <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
            <strong><? echo(__("Bookmark")); ?></strong>
            <div class="small"><? echo(__("Instead of a file you can add a bookmark. Please leave above Document and PDF preview blank and enter the URL here")); ?></div>
          </td>
          <td class="regular"  align="left" bgcolor="<? echo $OPT_col_lt; ?>">
            <input type="text" value="<?   if (($update) && (getvalue("documents","type",$update)=="bookmark")) { echo $upd_data[3];} else { echo "http://";} ?>" name="bmark" size="30">
          </td>
        </tr>
    <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
        <strong><? echo(__("Version")); ?></strong>
      </td>
      <td class="regular"  align="left" bgcolor="<? echo $OPT_col_lt; ?>">
        <input type="text" name="ver" value="<? echo $upd_ver ?>">
      </td>
    </tr>
    <tr>
      <td class="regular" colspan="2" align="center" bgcolor="<? echo $OPT_col_md; ?>">
        <strong><? echo(__("Document description")); ?></strong>
      </td>
    </tr>
    <tr>
      <td class="regular" colspan="2" align="center" bgcolor="<? echo $OPT_col_lt; ?>">
        <textarea name="the_text" wrap="VIRTUAL" cols="65" rows="10"><? echo htmlspecialchars($upd_data[2]); ?></textarea>
      </td>
    </tr>
<?
if ($task)
{
?>
    <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
        <strong><? echo(__("Task")); ?></strong>
        <div class="small"><? echo(__("This document will be associated with this task.")); ?></div>
      </td>
      <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>">
        <input type="hidden" name="task" value="<?echo($task);?>">
        <a class='regular' href="../../tasks/task/?proj=<?echo($proj)?>&task=<?echo($task)?>&action=display" onclick="parent.topFrame.location='../../main_menu/?m1=Projects&m2=Tasks&proj=<?echo($proj)?>&noupd=1';">
        <?echo(getvalue("task", "TaskName", $task));?></a>
      </td>
    </tr>
<?
      }
?>

<?
if ($req)
{
?>
    <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
        <strong><? echo(__("Request")); ?></strong>
        <div class="small"><? echo(__("This document will be associated with this request.")); ?></div>
      </td>
      <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>">
        <input type="hidden" name="req" value="<?echo($req);?>">
        <a class='regular' href="../../rt/req_view/?proj=<?echo($proj);?>&req=<?echo($req);?>" 'onclick="parent.topFrame.location='../../main_menu/?m1=Projects&m2=Requests&proj=<?echo($proj);?>&noupd=1';">
        <?echo(getvalue("requests", "title", $req));?></a>
      </td>
    </tr>
<?
      }
?>

   <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
        <strong><? echo(__("Directory")); ?></strong>
        <div class="small"><? echo(__("The document should also appear in this directory.")); ?></div>
      </td>
      <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>">
      <?
        if (sizeOf($dir) > 0)
        {
           $dir = intVal($dir);
        }
        else
        {
           $dir = -1;
        } 

        // If this is to be associated with a task or request, default is hidden
        if ($task || $req)
        {
           showDirectoryPickList($proj, $dir, 1);
        }
        else
        {  // Just a doc, not associated so default is root
           showDirectoryPickList($proj, $dir); 
        }
      ?>
      </td>
    </tr>


    <tr>
      <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
      <strong><? echo(__("Notify")); ?></strong>
      <div class="small">
        <? echo(__("The people you select from the list to the right will be notified ".
        "by e-mail about this document upload.")); ?>
      </div>
      </td>
      <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>">
        <select name="dst[]" size="5" multiple>
<?
      
      $result=get_people_involved_with_project($proj); 
      while ($myrow=OPT_fetch_row($result)) {
        if ($CRM_user != $myrow[0])
        {
           echo("          <option value=\"$myrow[0]\">$myrow[1] $myrow[2]</option>\n");
        }
      }
?>
        </select>
      </td>
    </tr>
    <tr>
      <td class="regular" colspan="2" align="center" bgcolor="<? echo $OPT_col_dk; ?>">
        <input type="hidden" name="proj" value="<? echo $proj ?>">
        <input type="hidden" name="dir" value="<? echo $dir ?>">
        <input type="hidden" name="update" value="<? echo $update ?>">
        <input type="hidden" name="action" value="add_doc">
        <input type="submit" name="submit" value="<? echo(__("Add")); ?>">
      </td>
    </tr>
</form>
<?
  endTables();
  auth_close();
?>
<script language="javascript">
<!--
parent.topFrame.location="../../main_menu/?m1=Projects&m2=Documents&proj=<?echo($proj);?>&noupd=1";
parent.leftFrame.location="../leftMenu/?proj=<?echo($proj);?>&dir=<?echo($dir);?>";
// -->
</script>
</BODY>
</HTML>
