<?
#
# Add Document Script
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
#
# Rick Sjogren <ricks@toll.com.au> added $_FILES fix for register_globals=Off in php.ini

  $proj=abs($proj);

  // First we have to make sure a project is set.
  if (! $proj)
  {
    OPT_error(__("Please select a project first."));
    exit;
  }

  // Ok, the project variable has been passed.
  // But is this user allowed to see the documents in this project?
  if (! crm_perm("projects",$proj))
  {
    OPT_error(__("Classified"));
    exit;
  }

  $data_name = $_FILES['data']['name']; 
  $data_type = $_FILES['data']['type']; 
  $data_size = $_FILES['data']['size']; 
  $data_tmp_name = $_FILES['data']['tmp_name']; 
  $data_error = $_FILES['data']['error']; 

  $pdf_name = $_FILES['pdf']['name']; 
  $pdf_type = $_FILES['pdf']['type']; 
  $pdf_size = $_FILES['pdf']['size']; 
  $pdf_tmp_name = $_FILES['pdf']['tmp_name']; 
  $pdf_error = $_FILES['pdf']['error']; 

if (($action==__("add_doc")) && !$CRM_guest)
{        
    // Ensure that if we're updating with a newer version that an update lock isn't being breached
    if ($update)
    {
        $locked_by = getvalue("documents", "locked_by", $update);
        if ($locked_by && ($locked_by != $CRM_user))
        {
            OPT_error("Sorry, you don't have an update lock on this document.");
            exit;
        }
    }

    if (!strlen($title))
    {
      OPT_error(__("Document not added -- you must specify a title!"));
      exit;
    }
    elseif ($data_name=="") 
    {
      if ((!$bmark) || ($bmark=="") || ($bmark=="http://")) {
        OPT_error(__("Document not added -- you must specify a document file!"));
	exit;
      } else {
        // Link specified
        $description=$the_text;
        $the_text=OPT_gpc_slashes($the_text);
        $Stitle=OPT_gpc_slashes($title);
        if (!$ver)
        {
          $ver="1.0";
        }
        else
        {
          $ver=OPT_gpc_slashes($ver);
        }
        $doc=OPT_get_ID("documents");
        $sql="insert into documents set id=$doc,
              ver=\"$ver\", doc=\"$the_text\",
              title=\"$Stitle\", chinby=$CRM_user, src=$CRM_user,
              type=\"bookmark\", fname=\"$bmark\", aproj=$proj,
              path=\"$directory\"";
        $result=CRM_run_query($sql);
        
        if ($task)
        {  // Add association to task
           $task = abs($task);
           crm_run_query("replace into document_associations (doc, att_to, att_type)
                          values ($doc, $task, 'task')"); 
        }
        
        if ($req)
        {  // Add association to request
           $req = abs($req);
           crm_run_query("replace into document_associations (doc, att_to, att_type)
                          values ($doc, $req, 'requests')"); 
        }
        
        if ($update)
        {
          $update=OPT_gpc_slashes($update);
          $sql="update documents set obsoletedby=$doc, chindate=chindate where id=\"$update\"";
          $obso_title=getvalue("documents","title",$update);
          $obso_ver=getvalue("documents","ver",$update);
          if (crm_run_query($sql))
          {
            OPT_confirm(sprintf(__("Document %s is now obsolete"),"<i>$obso_title v$obso_ver</i>"));
            $obso=1;
          }
          // If we got this far, then we should clear any lock on the obsolete doc if found
          $locked_by = getvalue("documents", "locked_by", $update);
          if ($locked_by)
          {
              crm_run_query("update documents set locked_by = 0, lock_date = 0 where id = $update");
              $entry = "Document updated; update lock removed.";
              crm_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('documents', $update, $CRM_user, '$entry')");
          }
        }
        $v[]="email";
        $v[]="sal";
        $v[]="fname";
        $v[]="lname";
        $p_n=getvalue("projects","name",$proj);
        $s=getvalue("people",$v,$CRM_user);
        $title=stripslashes($title);

        // Sending notifications
        for ($i=0;$i<sizeOf($dst);$i++)
        {
          $d=getvalue("people",$v,$dst[$i]);
          $name="$d[1] $d[3]";
          OPT_locale($dst[$i]);
          if ($obso) {
            $obso_email=__(" (updating a previous version)");
          }
          OPT_notify($dst[$i],sprintf(__("New OPT document: %s"),"\"$title\""),
            sprintf(__("Dear %s,\n".
            "A new document was uploaded on OPT%s ".
            "related to the %s project and ".
            "%s wanted to notify you about it.\n\n".
            "%s's description follows:\n".
            "------------------------------------------------------------------------\n".
            "%s\n".
            "------------------------------------------------------------------------\n".
            "Please use the URL below in order to access this document:\n".
            "%s"),$name,$obso_email,
            "\"$p_n\"","$s[1] $s[2] $s[3]","$s[1] $s[3]",$description,"http://$SERVER_NAME$CRM_URL?URL=".
            rawurlencode("documents/Doc_View/?proj=$proj&doc=$doc")),
            __("You may post comments on this document by replying ".
            "to this e-mail. Please note only the message body will be ".
            "uploaded to OPT. You may also post comments by ".
            "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
            "please don't quote the original message since the quoted text ".
            "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
            sprintf("OPT document #%d <%s>",$doc,$CRM_system_email));
        }
      }
    }
    else
    {
      $description=$the_text;
      $the_text=OPT_gpc_slashes($the_text);
      $Stitle=OPT_gpc_slashes($title);
      if (!$ver)
      {
        $ver="1.0";
      }
      else
      {
        $ver=OPT_gpc_slashes($ver);
      }

      if (is_uploaded_file($data_tmp_name)) 
      {
        $data_name=OPT_runtime_slashes($data_name);
        // If the originating computer doesn't know what the MIME type
        // is for this file we'll try to use Linux's magic file in order
        // to retrieve some relevant data. If Linux doesn't recognize the
        // file type it will return "data", in which case we leave it as
        // it was ("application/data-stream").
        $system_data_type=OPT_runtime_slashes(exec("file -b $data_name")); 
        if ($data_type=="application/octet-stream")
        {
          if ($system_data_type!="data")
          {
            $sql="select web_mime from mime_translate
                  where linux_mime like \"$system_data_type%\"";
            $result=crm_run_query($sql);
            if ($myrow=OPT_fetch_row($result))
            {
              $data_type=$myrow[0];
            }
          }
        }
        else
        {
          // If the originating computer does know what the MIME type is but
          // we don't have any matching entry in the mime translation table,
          // then we'll learn it.
          $sql="select linux_mime from mime_translate
                where web_mime='$data_type' or linux_mime like '$system_data_type%'";
          $result=crm_run_query($sql);
          if (!OPT_num_rows($result))
          {
            if ($system_data_type!="data")
            {
              $sql="insert into mime_translate
                    set linux_mime='$system_data_type',
                        web_mime='$data_type'"; 
              crm_run_query($sql);
            }
          }
        }
        $data_type=OPT_runtime_slashes($data_type);
        $i=1;
        $asize=filesize($data_tmp_name);

        $data_big=OPT_runtime_slashes(fread(fopen($data_tmp_name, "r"), $asize)); 
        $ssize=strlen($data_big);

        if ($ssize>=$CRM_limit)
        {
          // Arrrgh! BIG file - we'll have to chop it...
          $data_start=$CRM_limit;
          $init_data=substr($data_big,0,$CRM_limit);
          while (substr($init_data,-1)=="\\")
          {
            $init_data=substr($init_data,0,-1);
            $data_start--;
          }
          $doc=OPT_get_ID("documents");
          $sql="insert into documents set id=$doc,
                ver=\"$ver\", doc=\"$the_text\",
                title=\"$Stitle\", chinby=$CRM_user, src=$CRM_user,
                content=\"$init_data\", type=\"$data_type\", asize=$asize,
                fname=\"$data_name\", aproj=$proj, path=\"$directory\"";
          unset($init_data); // Freeing some memory
          $result=CRM_run_query($sql);
        
          if ($task)
          {  // Add association to task
             $task = abs($task);
             crm_run_query("replace into document_associations (doc, att_to, att_type)
                            values ($doc, $task, 'task')"); 
          }
        
          if ($req)
          {  // Add association to request
             $req = abs($req);
             crm_run_query("replace into document_associations (doc, att_to, att_type)
                            values ($doc, $req, 'requests')"); 
          }

          $data_left=$ssize-$data_start;
          while ($data_left)
          {
            if ($data_left>$CRM_limit)
            {
              $chunk=$CRM_limit;
            }
            else
            {
              $chunk=$data_left;
            }
            $rest_data=substr($data_big,$data_start,$chunk);
            if ($chunk!=$data_left)
            {
              while (substr($rest_data,-1)=="\\")
              {
                $rest_data=substr($rest_data,0,-1);
                $chunk--;
              }
            }
            $sql="insert into document_part set document=$doc, content=\"$rest_data\"";
            CRM_run_query($sql);
            $data_left-=$chunk;
            $data_start+=$chunk;
          }
        }
        else
        {
          $doc=OPT_get_ID("documents");
          $sql="insert into documents set id=$doc,
                ver=\"$ver\", doc=\"$the_text\",
                title=\"$Stitle\", chinby=$CRM_user, src=$CRM_user,
                content=\"$data_big\", type=\"$data_type\", asize=$asize,
                fname=\"$data_name\", aproj=$proj, path=\"$directory\"";
          $result=CRM_run_query($sql);

          if ($task)
          {  // Add association to task
             $task = abs($task);
             crm_run_query("replace into document_associations (doc, att_to, att_type)
                            values ($doc, $task, 'task')"); 
          }
        
          if ($req)
          {  // Add association to request
             $req = abs($req);
             crm_run_query("replace into document_associations (doc, att_to, att_type)
                            values ($doc, $req, 'requests')"); 
          }
        }
        if ($result)
        {
          OPT_confirm(sprintf(__("Document %s successfully added to archive"),"<strong>$title</strong>"));
          if (($pdf_name!="") && (is_uploaded_file($pdf_tmp_name))) 
          {
            $data_name=OPT_runtime_slashes($pdf_name);
            $data_big=OPT_runtime_slashes(fread(fopen($pdf_tmp_name, "r"),
                      $fsize=filesize($pdf_tmp_name))); 
            $sql="insert into pdf_docs set content=\"$data_big\",
                  document=$doc, fname=\"$data_name\", fsize=$fsize";
            $result2=crm_run_query($sql);
            if ($result2)
            {
              OPT_confirm(sprintf(__("PDF file %s successfully added to archive"),"<strong>$pdf_name</strong>"));
            }
          }
          if ($update)
          {
            $update=OPT_gpc_slashes($update);
            $sql="update documents set obsoletedby=$doc, chindate=chindate where id=\"$update\"";
            $obso_title=getvalue("documents","title",$update);
            $obso_ver=getvalue("documents","ver",$update);
            if (crm_run_query($sql))
            {
              OPT_confirm(sprintf(__("Document %s is now obsolete"),"<i>$obso_title v$obso_ver</i>"));
              $obso=1;
            }
          }
        }

        $v[]="email";
        $v[]="sal";
        $v[]="fname";
        $v[]="lname";
        $p_n=getvalue("projects","name",$proj);
        $s=getvalue("people",$v,$CRM_user);
        $title=stripslashes($title);

        // Sending notifications
        for ($i=0;$i<sizeOf($dst);$i++)
        {
          $d=getvalue("people",$v,$dst[$i]);
          $name="$d[1] $d[3]";
          OPT_locale($dst[$i]);
          if ($obso) {
            $obso_email=__(" (updating a previous version)");
          }
          OPT_notify($dst[$i],sprintf(__("New OPT document: %s"),"\"$title\""),
            sprintf(__("Dear %s,\n".
            "A new document was uploaded on OPT%s ".
            "related to the %s project and ".
            "%s wanted to notify you about it.\n\n".
            "%s's description follows:\n".
            "------------------------------------------------------------------------\n".
            "%s\n".
            "------------------------------------------------------------------------\n".
            "Please use the URL below in order to access this document:\n".
            "%s"),$name,$obso_email,
            "\"$p_n\"","$s[1] $s[2] $s[3]","$s[1] $s[3]",$description,"http://$SERVER_NAME$CRM_URL?URL=".
            rawurlencode("documents/Doc_View/?proj=$proj&doc=$doc")),
            __("You may post comments on this document by replying ".
            "to this e-mail. Please note only the message body will be ".
            "uploaded to OPT. You may also post comments by ".
            "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
            "please don't quote the original message since the quoted text ".
            "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
            sprintf("OPT document #%d <%s>",$doc,$CRM_system_email));
        }
      }
    }
  }
  OPT_locale();
?>
