<?
#
# Document details page
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  include "../../include/OPT_lib.php";
  auth_open();
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Document Details")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>

<?
  mainBody("../../images");
  make_main_title(__("Document Details"),"../../images");
?>
<span class="regular">
<?
  include("$CRM_path/documents/Doc_List/admin_doc.inc");
?>
</span>
<?
if (!$doc && $dedit)
{
    $doc = abs($dedit);
}
$doc=abs($doc);
$proj=getvalue("documents","aproj",$doc);
$dir=getvalue("documents","path",$doc);
$locked_by=getvalue("documents", "locked_by",$doc);

// The lock holder or PM can clear a lock
if (($action == "clear") && (is_project_manager($proj) || $locked_by == $CRM_user))
{
    crm_run_query("update documents set locked_by = 0, lock_date = 0 where id = ".abs($doc));
    $entry = "Document update lock cleared.";
    crm_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('documents', $doc, $CRM_user, '$entry')");
    OPT_confirm("Successfully cleared document lock.");
}

// If doc is not locked, any team member can lock it
if (($action == "lock") && (!$locked_by) && (crm_project_participant($CRM_user, $proj)))
{
    crm_run_query("update documents set locked_by = $CRM_user, lock_date = now() where id = ".abs($doc));
    $entry = "Document update lock obtained.";
    crm_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('documents', $doc, $CRM_user, '$entry')");
    OPT_confirm("Successfully locked this document for exclusive editing.");
}

  if (!$doc) {
    OPT_error(__("Please use the documents list to select a document!"));
    exit;
  }

  if (!CRM_perm("documents",$doc, VIEW)) {
    OPT_error(__("Classified"));
    exit;
  }

  // Adding a PDF preview
  if (($AddPDF=="Add") && (!$CRM_guest)) {
    $data_name=OPT_runtime_slashes($pdf_name);
    $doc=OPT_gpc_slashes($doc);
    if (is_uploaded_file($pdf))
    {
      $data_big=OPT_runtime_slashes(fread(fopen($pdf, "rb"),
                $fsize=filesize($pdf)));
      $sql="insert into pdf_docs set content=\"$data_big\",
            document=\"$doc\", fname=\"$data_name\", fsize=$fsize";
      crm_run_query($sql);
      OPT_confirm(__("PDF preview successfully added"));
    }
  }

  // Add a new comment
  if (($addcomment) && (!$CRM_guest) && ($comment)) {
    $scomment=OPT_gpc_slashes($comment);
    $doc=OPT_gpc_slashes($doc);
    $sql="insert into document_answers set comment=\"$scomment\",
          src=$CRM_user, document=$doc";
    $result=CRM_run_query($sql);

    // This is where the notification takes place!
    $dc[]="title";
    $dc[]="src";
    $dc=getvalue("documents",$dc,$doc);
    $title=$dc[0];
    $dst[]=$dc[1];
    $o[]="sal";
    $o[]="fname";
    $o[]="lname";
    $own=getvalue("people",$o,$CRM_user);
    $own="$own[0] $own[1] $own[2]";

    // Send to "Additional notifications" if any chosen
    for ($i=0; $i<sizeOf($additional_notifications); $i++)
    {
        if (!@in_array($addtional_notifications[$i], $dst))
        {
           $dst[] = $additional_notifications[$i];
        }
    }

    // We'll find out who's involved.
    $v[]="email";
    $v[]="sal";
    $v[]="fname";
    $v[]="lname";
    $s=getvalue("people",$v,$CRM_user);

    for ($i=0;$i<sizeOf($dst);$i++) // >
    {
        OPT_locale($dst[$i]);
        $d=getvalue("people",$v,$dst[$i]);
        $p_n=getvalue("projects","name",$proj);
        $name="$d[1] $d[3]";
        OPT_notify($dst[$i],sprintf(__("New comment on OPT document %s"),"\"$title\""),
                   sprintf(__("Dear %s,\n".
                              "%s posted a new comment on document %s ".
                              "related to the %s project.\n\n".
                              "The comment follows:\n".
                              "------------------------------------------------------------------------\n".
                              "%s\n".
                              "------------------------------------------------------------------------\n"),
                           $name,"$s[1] $s[2] $s[3]","\"$title\"","\"$p_n\"",$comment),
                   __("You may post comments on the document by replying ".
                      "to this e-mail. Please note only the message body will be ".
                      "uploaded to OPT. You may also post comments by ".
                      "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
                      "please don't quote the original message since the quoted text ".
                      "will also get unnecessarily posted on OPT.\n\nThank you!"),
                   "OPT document #$doc <$CRM_system_email>");
    }
    OPT_locale();
  }
    
  $sql="select
          src,title,ver,doc,id,aproj,chinby,fname,asize,locked_by,lock_date
        from documents where id=$doc";
  $result=CRM_run_query($sql);
  $myrow=OPT_fetch_array($result);
  $chindate=niceDate("documents","chindate",$doc);
  $source = $myrow["src"];
  startTables();

  // Any newer versions?
  $thedoc=$doc;
  while ($newer=getvalue("documents","obsoletedby",$thedoc)) {
    $thedoc=$newer;
  }
  if ($thedoc!=$doc) {
    $newest_title=getvalue("documents","title",$thedoc);
    $newest_ver=getvalue("documents","ver",$thedoc);
    echo("  <tr>\n");
    echo("    <td class='small' colspan='2' bgcolor='$OPT_col_lt' align=\"center\">".
      sprintf(__("This document is outdated! The most current version is %s"),
        "<a class='small' href='./?proj=$proj&doc=$thedoc'>$newest_title v$newest_ver</a>")."</td>\n");
    echo("  </tr>\n");
  }
?>
  <tr>
    <td class="ah4" bgcolor="<? echo $OPT_col_dk; ?>" align="center" colspan="2"><? echo($myrow["title"]); ?></td>
  </tr>
  <tr>
    <td class="small" bgcolor="<? echo $OPT_col_lt; ?>" colspan="2" align="right"><?
    if (crm_perm("people",$myrow["src"])) {
      $person=sprintf(__("Uploaded by %s on %s"),
        "<A class=\"small\" href=\"../../people/admin?action=display&id=".$myrow["src"]."\">".
        getvalue("people","fname",$myrow["src"])." ".
        getvalue("people","lname",$myrow["src"])."</a>",$chindate);
    } else {
      $person=sprintf(__("Uploaded on %s"),$chindate);
    }
    echo("$person&nbsp;&nbsp;"); ?>
    </td></tr>

 


  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right" width="30%">
      <strong>
          <?
          echo $myrow["type"];
          if (getvalue("documents","type",$thedoc)=="bookmark") {
              echo (__("Bookmark"));
          } else {
              echo (__("Document"));
          }
          ?>
      </strong>
    </td>
    <td class="regular" align='left' bgcolor="<? echo $OPT_col_lt; ?>">
<?
  $fname=$myrow["fname"];
  if (getvalue("documents","type",$thedoc)=="bookmark") {
      echo("    <A class=\"regular\" HREF=\"$fname\" target=\"_blank\">$fname</A>\n");
  } else {
      echo("    <A class=\"regular\" HREF=\"../Att_View/?proj=$proj&doc=$doc\" target=\"_blank\">$fname</A>&nbsp;(".niceSize($myrow["asize"]).")\n");
  }
?>
    </td>
  </tr>
<?   if (!getvalue("documents","type",$thedoc)!="bookmark") { ?>

  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right">
      <strong><? echo(__("PDF preview")); ?></strong>
    </td>
<?
  $sql="select id, fname from pdf_docs where document=$doc";
  $result2=crm_run_query($sql);
  if ($myrow2=OPT_fetch_row($result2))
  {
    $pdf=$myrow2[0];
    $fname=$myrow2[1];
    $pdfsize=getvalue("pdf_docs","fsize",$pdf);
    echo("    <td class=\"regular\" bgcolor=\"$OPT_col_lt\" valign=\"center\">\n");
    echo("    <A class=\"regular\" HREF=\"../PDF_View/index.php?proj=$proj&doc=$doc&pdf=$pdf\" target=\"_blank\">$fname</A>&nbsp;(".niceSize($pdfsize).")\n");
    echo("    </td>\n");
  }
  else
  {
    if ((!$CRM_guest) && (!$pf))
    {
      echo("    <form enctype='multipart/form-data' method='post' action='./'>
                <td align='left' class=\"regular\" bgcolor=\"$OPT_col_lt\" valign=\"center\">
                <table border='0' cellpadding='0' cellspacing='0'><tr><td><input type='file' name='pdf'></td>
                <input type='hidden' name='doc' value=$doc><input type='hidden' name='proj' value=$proj>
                <td><input type='submit' name='AddPDF' value='Add'></td></tr></table></td></form>");
    }
    else
    {
      echo("    <td align='left' class=\"regular\" bgcolor=\"$OPT_col_lt\" valign=\"center\">\n");
      echo("    n/a");
      echo("    </td>\n");
    }
  }
?></td>
  </tr>
<? } ?>


 <?  // Only show request row if there are associated requests
  $sql = "select att_to from document_associations where att_type = 'requests' and doc = ".$myrow["id"];
  $req_result = CRM_run_query($sql);
  if (OPT_num_rows($req_result) > 0)
  {
    ?>
    <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><strong><? echo(__("Associated with Request")); ?></strong></td>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>">
    <?
    
     while ($req_row = OPT_fetch_row($req_result))
     {
         $a[0]="<A class=\"regular\" href=\"../../rt/req_view/?proj=$proj&req=".$req_row[0]."\">";
         $a[1]="</A>";
         echo($a[0].getvalue("requests","title",$req_row[0]).$a[1]);
     } 
  ?>
    </td>
    </tr>
  <?
  }
  ?>


 <?  // Only show task rows if there are associated tasks
  $sql = "select att_to from document_associations where att_type = 'task' and doc = ".$myrow["id"];
  $task_result = CRM_run_query($sql);
  if (OPT_num_rows($task_result) > 0)
  {
    ?>
    <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><strong><? echo(__("Associated with Task")); ?></strong></td>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>">
    <?
    
     while ($task_row = OPT_fetch_row($task_result))
     {
         $a[0]="<A class=\"regular\" href=\"../../tasks/task/?proj=$proj&task=".$task_row[0]."&action=display\">";
         $a[1]="</A>";
         echo($a[0].getvalue("task","TaskName",$task_row[0]).$a[1]);
     } 
  ?>
    </td>
    </tr>
  <?
  }
  ?>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><strong><? echo(__("Version")); ?></strong></td>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>" align="left"><?
      if ($myrow["ver"])
      {
        echo($myrow["ver"]);
      }
      else
      {
        echo("&nbsp;");
      } ?></td>

  </tr>
  <tr>
    <td class="regular" valign="top" bgcolor="<? echo $OPT_col_md; ?>" align="right"><strong><? echo(__("Previous versions")); ?></strong></td> 
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>" align="left"><?
      $thedoc=$doc;
      while (!$previous_done)
      {
        $sql="select id, title, ver from documents where obsoletedby=$thedoc";
        $result=crm_run_query($sql);
        if ($myrow2=OPT_fetch_row($result))
        {
          $thedoc=$myrow2[0];
          if ($found_some)
          {
            $br="<br>\n";
          }
          else
          {
            $found_some=1;
          }
          echo("$br<a class='regular' href='./?proj=$proj&doc=$thedoc'>$myrow2[1] v$myrow2[2]</a> (".niceDate("documents","chindate",$thedoc).")");
        }
        else
        {
          $previous_done=1;
        }
      }
      if (!$found_some)
      {
        echo("none");
      }?>
      </td>
  </tr>

<?
// If user is team member then they can set an update lock to reserve doc for editing (and a PM can clear stale locks)
if (crm_project_participant($CRM_user, $proj) && (get_project_setting($proj, "allow_whole_team_to_update_documents") == "1"))
{
?>
 <tr>
    <td class="regular" valign="top" bgcolor="<? echo $OPT_col_md; ?>" align="right"><strong><? echo(__("Update Lock")); ?></strong></td>
    <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>" align="left">
<?
if ($myrow["locked_by"]) 
{
    if (crm_perm("people",$myrow["locked_by"])) 
    {
        $a_start = "<a href=\"../../people/admin?action=display&id=".$myrow["locked_by"]."\">";
        $a_end = "</a>";
    }
    
    echo("Lock held by $a_start".getvalue("people","CONCAT(fname,' ',lname)",$myrow["locked_by"]).
         "$a_end since ". niceDate("documents","lock_date", $doc));
    // Lock can be cleared by holder or project manager
    if (($myrow["locked_by"] == $CRM_user) || is_project_manager($proj))
    {
        echo("&nbsp;&nbsp;&nbsp;&nbsp;(<a href='index.php?proj=$proj&doc=$doc&dir=$dir&action=clear'>Clear lock</a>)");
    }
}
else
{
   echo("<a href='index.php?proj=$proj&doc=$doc&dir=$dir&action=lock'>Lock for exclusive editing</a>");
}
?>

    </td>
</tr>
<?
}
?>                                                                                                                                 

 <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="center" colspan="2">
      <strong><? echo(__("Description")); ?></strong>
    </td>
  </tr>
  <tr>
    <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>" colspan="2">
        <? if ($myrow["doc"])
          {
            echo(nl2br($myrow["doc"]));
          }
          else
          {
            echo("&nbsp;");
          } ?>
    </td>
  </tr>

<?
  $sql="select * from document_answers where document=$doc order by date asc";
  $result=CRM_run_query($sql);
  if (OPT_num_rows($result))
  {
    echo("<tr><td class='regular' bgcolor='$OPT_col_dk' align='center' colspan='2'><strong>".__("Comments on this document")."</strong></td></tr>\n");
    while ($myrow=OPT_fetch_array($result))
    {
      echo("<tr>\n");
      echo("<td class='regular' bgcolor='$OPT_col_lt' colspan='2'>\n");
      echo("<table width='100%' cellspacing='0' cellpadding='2' border='0'>\n");
      echo("<tr>\n");
      $src_r[]="fname";
      $src_r[]="lname";
      $src=getvalue("people",$src_r,$myrow["src"]);
      if (crm_perm("people",$myrow["src"]))
      {
        $a[0]="<A class=\"small\" href=\"../../people/admin?action=display&id=".$myrow["src"]."\">";
        $a[1]="</A>";
      }
      else
      {
        $a[0]="";
        $a[1]="";
      }
      $src=$a[0].$src[0]." ".$src[1].$a[1];
      $date=niceDate("document_answers","date",$myrow["id"]);
      echo("  <td class=\"small\" bgcolor=\"$OPT_col_md\"><i>".sprintf(__("Posted by %s on %s"),$src,$date)."</i></td>\n");
      echo("</tr>\n<tr>\n");
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_lt\">".nl2br(htmlspecialchars($myrow["comment"]))."</td>\n");
      echo("</tr>\n");
      echo("</table>\n");
      echo("</tr>\n");
    }
  }
  if ((!$CRM_guest) && (!$pf))
  {
?>
<tr>
<td class='regular' bgcolor="<? echo $OPT_col_md; ?>" align="center" colspan="2">
<b><? echo(__("You may post a comment below")); ?></b><br>
<form action="./" method="post">
  <input type="hidden" name="req" value="<? echo $req; ?>">
  <input type="hidden" name="proj" value="<? echo $proj; ?>">
  <input type="hidden" name="doc" value="<? echo $doc; ?>">
  <table cellpadding="2" cellspacing="2" width="100%"><tr><td align="right">
  <textarea name="comment" cols="65" rows="7" wrap="VIRTUAL"></textarea>
  </td><td align="center">
  <i>Also notify:</i></br>
  <select name='additional_notifications[]' multiple size="5">
  <? // Generate a list of team members on the project who aren't automatically notified
     $result = get_people_involved_with_project($proj);
     $notify_person_ids[] = $CRM_user;  // don't want option to notify self given
     $notify_person_ids[] = $source;  // don't want option to notify source
     while ($row = OPT_fetch_row($result))
     {
        if (!@in_array($row[0], $notify_person_ids))
        {
           echo("<option value='$row[0]'>$row[1] $row[2]</option>");
        }
     }
  ?>
  </select><br />
  <? if ($source)
  {
        if (crm_perm("people",$source))
        {
           $a[0]="<a href=\"../../people/admin/?action=display&id=".$source."\">";
           $a[1]="</a>";
           $source_name = "$a[0]".getvalue("people", "CONCAT(fname,' ',lname)", $source)."$a[1]";
        }
        else
        {
           $source_name=getvalue("people", "CONCAT(fname,' ',lname)", $source);
        } 
  ?>
  <span class='small'><? echo($source_name) ?><br />automatically notified.</span>
  <?
  }
  ?>
  </td></tr></table>
  <input type="submit" name="addcomment" value="<? echo(__("Add Comment")); ?>">
</form>
</tr>
<?
  }

  endTables();
  auth_close();
?>

<script language="javascript">
<!--
parent.leftFrame.location='../../documents/leftMenu/?proj=<? echo("$proj&doc=$doc&dir=$dir"); ?>';
// -->
</script>

</BODY>
</HTML>
