<?
#
# Document library
#
# Bogdan Stancescu <bogdan@lanifex.com>, February 2001
# Revision 1.0

  function xform_one_doc($doc,$action)
  {
    if (getvalue("documents","flags",$doc) & 2)
    {
      $type="dir";
      $result=array(0,1);
    }
    else
    {
      $type="doc";
      $result=array(1,0);
    }
    if ($action=="info")
    {
      return($result);
    }
    if ($action=="delete")
    {
      if ($type=="doc")
      {
        $sql="select id,title,ver from documents where obsoletedby=$doc";
        $result=crm_run_query($sql);
        if ($myrow=OPT_fetch_row($result))
        {
          if ($obso=getvalue("documents","obsoletedby",$doc))
          {
            $sql="update documents set obsoletedby=$obso where id=$myrow[0]";
            crm_run_query($sql);
          }
          else
          {
            $sql="update documents set obsoletedby=0, chindate=chindate where id=$myrow[0]";
            crm_run_query($sql);
          }
        }
        $sql="delete from pdf_docs where document=$doc";
        CRM_run_query($sql);
        $sql="delete from document_answers where document=$doc";
        CRM_run_query($sql);
        $sql="delete from document_part where document=$doc";
        CRM_run_query($sql);
        $sql="delete from document_associations where doc=$doc";
        CRM_run_query($sql);
      }
      $sql="delete from documents where id=$doc";
      CRM_run_query($sql);

      return($result);
    }
  }

  function doc_xform($doc,$action)
  {
    $flags=getvalue("documents","flags",$doc);
    if (!($flags & 2))
    {
      return(xform_one_doc($doc,$action));
    }
    $sql="select id, flags from documents where path=\"$doc\"";
    $result=CRM_run_query($sql);
    while ($myrow=OPT_fetch_row($result))
    {
      if ($myrow[1] & 2)
      {
        list($docs,$dirs)=doc_xform($myrow[0],$action);
        $TOTdocs+=$docs;
        $TOTdirs+=$dirs;
        list($docs,$dirs)=xform_one_doc($myrow[0],$action);
      }
      else
      {
        list($docs,$dirs)=xform_one_doc($myrow[0],$action);
      }
      $TOTdocs+=$docs;
      $TOTdirs+=$dirs;
    }
    list($docs,$dirs)=xform_one_doc($doc,$action);
    $TOTdocs+=$docs;
    $TOTdirs+=$dirs;
    return(array($TOTdocs,$TOTdirs));
  }




/*
 * Generates a pick list allowing one to select the directory a document
 * should be placed into.  NOTE: hidden is an option when a doc is associated 
 * with a task or a request. Also, a project manager may set the project setting: "
 */
function showDirectoryPicklist($proj, $dir = -1, $allow_hidden = 0)
{        

  $allow_none_dir_setting = get_project_setting($proj, "allow_hidden_documents");

  echo('<select name="directory">');
  if ($allow_none_dir_setting && $allow_hidden)
  { 
     echo('<option value="-1">'.__("None").'</option>');
  }

  if (sizeOf($dir) && ($dir == 0))
  {
     $selected = "selected";
  }
  echo("<option value='0' $selected>".__("Project Root").'</option>');
  $sql="select id, title, path from documents where aproj=$proj 
           AND obsoletedby=0 AND type='directory' ORDER BY id DESC";
  $result=CRM_run_query($sql);
  $tasknum=0;
  while ($resarr[]=OPT_fetch_row($result)) {
      $tasknum++;
  }

  $maxlevel = 0;

  // Round 1, calc the indent levels
  for ($z=0; $z<$tasknum; $z++) {
      $asorting[$z][0]=0; // first element means position set: yes/no
      $aposition[$z]=-1; // use this loop to unset all position data
      $asorting[$z][1]=0;  // second element means indent level
      // $aposition is sorted in the final order, $asorting is sorted in the
      // original array order
      if (!$resarr[$z][2]==0) {
          // Not a top level. Go find it. Reverse recurse (up) through levels
          $curparent=$resarr[$z][2];
          while (!$curparent==0) {

              // increase indent level by one
              $asorting[$z][1]++;

              // check whether previous max indent level is below current indent level
              if ($maxlevel<$asorting[$z][1]) { $maxlevel=$asorting[$z][1]; }

              // find next parent up
              for ($znext=0; $znext<$tasknum; $znext++) {
                  if ($resarr[$znext][0]==$curparent) {
                      $curparent = $resarr[$znext][2];
                      break;
                  }
              }
          }
      } else {

          // add to top level tasks
          $topleveltasks[]=$z;
      }
  }

  // Round 2, sort the entries
  // set the starting pointer to -1 since we increase it by 1 before starting to assign values
  $curposition = -1;

  // go through each top level entry and recurse through levels
  $toplevelnum = count($topleveltasks);

  for ($z=0; $z<$toplevelnum; $z++) {

      $curposition++;
      unset($sdone);
      $curtoplevel = $topleveltasks[$z];

      // set position data: ordered array to result array number
      $aposition[$curposition] = $curtoplevel;

      // set current original element as done (position given)
      $asorting[$curtoplevel][0] = 1;

      // set the dynamic parent indicator to current top level id (not array number!!)
      $curparent =$resarr[$curtoplevel][0];

      // ok, then go on and find next child
      while (!$sdone) {

          // loop to find child, $zchild is the array number counter
          unset($nextparent);
          for ($zchild=0; $zchild<$tasknum; $zchild++) {

              // is its parent the current parent and it hasn't been set yet?
              if (($resarr[$zchild][2] == $curparent) && ($asorting[$zchild][0]==0)) {

                  // yes, find next free position and assign number
                  $curposition++;
                  $aposition[$curposition] = $zchild;
                  $asorting[$zchild][0]=1;

                  // set the next top level (i.e. next parent) as the id number of current child
                  $nextparent = $resarr[$zchild][0];
                  break;
              }
          }

          // now we have gone through all and either found a child or not
          // have we found a child and are we not yet at the max indent level (possible children of child?)
          if (($nextparent) && ($asorting[$zchild][1]<$maxlevel)) {

              // set current child as parent
              $curparent = $nextparent;
          }

          // we haven't found a child and the parent is a toplevel?
          if ((!$nextparent) && ($curparent==0)) {

              // end current recurse
              break;
          }
          if (!$nextparent) {

              // if we get here, we have not found a child and are not at the top level
              // find the next level up

              for ($znext=0; $znext<$tasknum; $znext++) {
                  $testing1=$resarr[$znext][0];
                  if ( testing1 == $curparent) {
                      $curparent=$resarr[$znext][2];
                      break;
                  }
              }

              // see if we are on top level. If yes, this recurse is over
              if ($asorting[$znext][1]==0) {
                  break;
              }
          }
          // now, if we not done with current recurse, the new parent is checked
      }
  }


  // End of loop through top levels with recurses. Now we should be sorted
  // Debug
  $checkedall=1;
  for ($z=0; $z<=$tasknum; $z++) {
      if ($asorting[$z][0]<0) {
          unset($checkedall);
          break;
      }
  }
  if (!$checkedall) {
      echo "Sorting did not work.";
      exit;
  }
  for ($z=0; $z<$tasknum; $z++) {
      $curelement = $aposition[$z];
      $curid = $resarr[$curelement][0];
      $curname = $resarr[$curelement][1];
      $curindent = $asorting[$curelement][1];
      if ($dir == $curid) {
          echo("<option value=\"$curid\" selected>");
      } else {
          echo("<option value=\"$curid\">");
      }
      for ($zspace=0; $zspace<=$curindent; $zspace++) {
          echo "&nbsp;&nbsp;";
      }
      echo ("$curname</option>\n");
  }
  unset($aposition);
  unset($asorting);
  unset($resarr);
  unset($result);
  unset($topleveltasks);

  echo('</select>');
}
?>
