<?
#
# Email search results page
#
  include "../../include/OPT_lib.php";
  auth_open();
  include "$CRM_inc/email.php";
  checkMail();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("E-mail Search Results")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../images");
  make_main_title(__("E-mail Search Results"),"../../images");
  if (! $proj) {
    OPT_error(__("Please select a project first"));
    exit;
  }
  if (! crm_perm("projects",$proj)) {
    OPT_error(__("Classified"));
    exit;
  }

// Save the query they just made for when they search this project next
include "$CRM_path/e-mails/email_search/save_query_values.inc";

// If this was a "Quick Search" then generate the SQL filter statement ($filter)
if ($quick_search)
{
    include "$CRM_path/e-mails/email_search/quick_search_filter.inc";
    $filter = get_quick_search_filter($quick_search_type, trim($quick_search_title));
} 
else if ($full_search)
{
    include "$CRM_path/e-mails/email_search/full_search_filter.inc";
}
else if ($saved_search)
{   
    if (!abs($saved_search_id))
    {
        OPT_error("Sorry.  You must specify a valid saved search to run...");
        exit(); 
    }   
 
    // Wants to run a saved search right away so go get field variables
    $sql="select name, value from search_fields where search = $saved_search_id";
    $result = CRM_run_query($sql);
    while ($row = OPT_fetch_row($result))
    {
        $$row[0] = $row[1];  // setting variable of name equal to value
     }
    include "$CRM_path/e-mails/email_search/full_search_filter.inc";  // Now run the full search...
}
else
{
    OPT_error("Bad search request.  Please try again.  Contact OPT Administrator if this repeats.");
}

if (!$filter)
{
  OPT_error("Please specify some criteria for your search.");
  exit();
}
        
  // Go get all the emails to display
  $cat_order=OPT_parse_order_string($order);
  $result=crm_elements("email","$filter order by date");

  //echo("Filter: $filter<br />");
  startTables(); // start of email listing
?>


<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="center" colspan="3">
    <strong>Subject</strong></td>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="center">
    <strong>From</strong></td>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="center">
    <strong>Date</strong></td>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="center">
    <strong>Size</strong></td>
</tr>
<?
if (OPT_num_rows($result))
{

  while ($myrow=OPT_fetch_array($result))
  {
    echo("<tr>\n");
    if ($bg=="$OPT_col_lt")
    {
      $bg="$OPT_col_md";
    }
    else
    {
      $bg="$OPT_col_lt";
    }

    // -- New?
    echo("    <TD class=\"regular\" align=\"center\" bgcolor=\"$bg\">");
    if (!$CRM_guest)
    {
      $sql="select
              email.id
            from
              email, people
            where
              email.date>people.prevlog and
              people.id=$CRM_user and
              email.id=".$myrow["id"];
      $result2=crm_run_query($sql);
      if (OPT_num_rows($result2))
      {
        echo("<img src=\"../../images/$OPT_icon_new\" alt=\"New Document!\">");
      }
      else
      {
        echo("&nbsp;");
      }
    }
    else
    {
      echo("&nbsp;");
    }
    echo("</TD>\n");

    // -- Attachments?
    $email=$myrow["id"];
    $sql="select sum(size) from e_attach where e_mail=$email";
    $result2=CRM_run_query($sql);
    list($asize)=OPT_fetch_row($result2);
    echo("  <td class=\"regular\" align=\"center\" bgcolor=\"$bg\">\n    ");
    if ($asize)
    {
      echo("<img src=\"../../images/$OPT_icon_att\">");
    }
    else
    {
      echo("&nbsp;");
    }
    echo("  </td>\n");

    // -- Subject line
    $subject=$myrow["title"];
    if (!$subject)
    {
      $subject="[no title]";
    }
    echo("  <td class=\"regular\" bgcolor=\"$bg\">\n    <a class=\"regular\" href=\"../email_view/?email=$email\">$subject</a>\n  </td>\n");

    // -- From
    if ($from_id=$myrow["src"])
    {
      $sender_name=getvalue("people","CONCAT(fname,' ',lname)",$from_id);
      if (crm_perm("people",$myrow["src"]))
      {
        $a[0]="<A class=\"regular\" href=\"../../people/admin/?action=display&id=".$myrow["src"]."\">";
        $a[1]="</A>";
      }
      else
      {
        $a[0]="";
        $a[1]="";
        $sender_name="n/a";
      }
    }
    elseif ($sender=$myrow["emailSrc"])
    {
      if ($sender)
      {
        $a[0]="<A class=\"regular\" href=\"mailto:$sender\">";
        $a[1]="</A>";
        $sender_name="&lt;$sender&gt;";
      }
    }
    else
    {
      $a[0]="";
      $a[1]="";
      $sender_name="<b>n/a</b>";
    }
    echo("  <td class=\"regular\" align='center' bgcolor=\"$bg\">\n    $a[0]$sender_name$a[1]\n  </td>\n");

    // -- Date
    $date=niceDate("email","date",$myrow["id"]);
    echo("  <td class=\"regular\" bgcolor=\"$bg\">\n    $date\n  </td>\n");

    // -- Size
    echo("  <td class=\"regular\" bgcolor=\"$bg\">\n    ".niceSize(strlen($myrow["body"])+$asize)."\n  </td>\n");
    echo("</tr>\n");
  }
} // End of "if rows"
else
{
?>
<tr>
  <td bgcolor="<? echo $OPT_col_lt; ?>" colspan="6" class="attention" align="center">
  No results found matching your search criteria.</td>
</tr>
<?
}
?>

<tr>
  <td bgcolor="<? echo $OPT_col_dk; ?>" colspan="6" class="small">&nbsp;</td>
</tr>


<?
  endTables();
  auth_close();
?>
</BODY>
</HTML>
