<?
#
# The Forums Library
#
# Bogdan Stancescu <bogdan@lanifex.com>, February 2002
# Revision 1.0

  // Emulating include_once() using this method:
  if ($forum_lib_loaded) {
    return(true);
  }
  $forum_lib_loaded=true;

  // Used by forum_info() below
  function forum_counts($msg,$current,$underCurrent,$newDate,$msg_data)
  {
    $sql="select (forums.date>$newDate) from forums where id=$msg";
    list($isnew)=OPT_fetch_row(CRM_run_query($sql));
    if ($msg==$current)
    {
      $underCurrent=true;
      $msg_data[5]+=$isnew;
    }
    $sql="select id from forums where parent=$msg";
    $result=CRM_run_query($sql);
    while ($myrow=OPT_fetch_row($result))
    {
      $msg_data=forum_counts($myrow[0],$current,$underCurrent,$newDate,$msg_data);
    }
    $msg_data[1]++;
    $msg_data[3]+=$isnew;
    if ($underCurrent)
    {
      $msg_data[2]++;
      $msg_data[4]+=$isnew;
    }
    return($msg_data);
  }

  // Retrieving data on forum messages
  // Returns an array containing:
  // [0] - the top message id
  // [1] - the number of messages in this thread
  // [2] - the number of messages under this message
  // [3] - how many "new" messages in this thread
  // [4] - how many "new" messages under this message
  // [5] - is *this* message new
  function forum_info($msg)
  {
    global $CRM_user, $CRM_guest;

    $top=$msg;
    $oldtop=$msg;
    $path[]=$top;
    while ($top=getvalue("forums","parent",$top))
    {
      $oldtop=$top;
      $path[]=$top;
    }
    $top=$oldtop;
    $msg_data=array($top,0,0,0,0,0);
    if (!$CRM_guest) {
      $newDate=getvalue("people","prevlog",$CRM_user);
    } else {
      $newDate=gmdate("Ymd000000");
    }
    return(forum_counts($top,$msg,$underMe,$newDate,$msg_data));
  }

  // Almost identical to forum_info() above, except that
  // the parameter is not a message ID but a pair of att_type
  // and att_id instead. Returns a simpler array with two elements:
  // total number of messages and "new" messages. Indexes 0 and 1.
  function forum_stats($att_type, $att_id) {
    global $CRM_user, $CRM_guest;

    $stats=array(0,0);
    $Satt_type=OPT_gpc_slashes($att_type);
    $Satt_id=abs($att_id);
    $sql="select id from forums where att_type='$Satt_type' and att_id='$att_id'";
    $result=OPT_run_query($sql);

    $stats[0]=OPT_num_rows($result);
    if (!$CRM_guest) {
      $newDate=getvalue("people","prevlog",$CRM_user);
    } else {
      $newDate=gmdate("Ymd000000");
    }
    while(list($id)=OPT_fetch_row($result)) {
      $sql="select (forums.date>$newDate) from forums where id=$id";
      list($isnew)=OPT_fetch_row(OPT_run_query($sql));
      $stats[1]+=$isnew;
    }
    return($stats);
  }

  // Returns a formatted string with the results from forum_stats()
  // above. The string is formatted this way: "[total msg #|<B>"new" #</B>]"
  function nice_forum_stats($att_type, $att_id) {
    $data=forum_stats($att_type, $att_id);
    return("[$data[0]|<B>$data[1]</B>]");
  }

  // This function returns the link to be posted on leftMenu
  function forum_link($att_type, $att_id, $link_text) {
    global $CRM_URL;
    $stats=nice_forum_stats($att_type,$att_id);
    return("<a class='regular' href='$CRM_URL/forums/Msg_List/?att_type=$att_type&att_id=$att_id' target='mainFrame'>$link_text</a> $stats<br>\n");
  }

  // This performs the actual forum notifications.
  // Take a look at forum_notifications() below for details on how it all works.
  function do_forum_notify($people, $thread, $new_post,$inhibit_confirmation=false)
  {
    global $CRM_system_email, $CRM_URL, $SERVER_NAME, $CRM_user;

    $title=getvalue("forums","title",$thread);
    $p_query[]="email";
    $p_query[]="sal";
    $p_query[]="fname";
    $p_query[]="lname";
    $s_data=getvalue("people",$p_query,$CRM_user); // Source person data (the poster - who is the current user)
    $i=0;
    while ($people[$i])
    {
      $d_data=getvalue("people",$p_query,$people[$i]); // Destination person data
      if ($people[$i]!=$CRM_user) // You shouldn't notify yourself, should you?
      {
        OPT_notify($people[$i],"OPT: New post on forum \"$title\"",
          "Dear $d_data[1] $d_data[3],\n".
          "$s_data[1] $s_data[2] $s_data[3] posted a new message in the \"$title\" forum ".
          "you monitor on the OPT server.\n".
          "The NEW POST follows:\n".
          "------------------------------------------------------------------------\n".
          getvalue("forums","content",$new_post)."\n".
          "------------------------------------------------------------------------\n".
          "You may use the URL below in order to retrieve this comment and post a reply:\n".
          "http://$SERVER_NAME$CRM_URL?URL=".
          rawurlencode("forums/Msg_List/?parent=$new_post"),
          "You can also reply to this posting by replying to this e-mail. If you do so, please ".
          "be aware that the title of your e-mail will be the title of the newly posted e-mail and ".
          "that if you quote the original message, the quoted text will also get posted on the ".
          "system along with your reply!",
          "OPT forum #$new_post <$CRM_system_email>",$inhibit_confirmation);
      }
      $i++;
    }
  }

  // Checks who should receive notifications - called by forum_notifications()
  // Returns an array of people ID's to be notified. Typically called on a top
  // level message in order to correctly assess "on thread" type notifications.
  function forum_to_notify($msg,$new_post,$path,$people)
  {
    // First we check children of this message recursively
    $sql="select id from forums where parent=$msg";
    $result=CRM_run_query($sql);
    while ($myrow=OPT_fetch_row($result))
    {
      $people=forum_to_notify($myrow[0],$new_post,$path,$people);
    }

    // Next, we check if we should notify the person who posted this message
    $data[]="notify";
    $data[]="src";
    $data=getvalue("forums",$data,$msg);
    $notif_type=$data[0];
    $person=$data[1];
    if (
         ((!@in_array($person,$people)) && ($notif_type))                       // Only makes sense to test further if the user is not already
         &&                                                                     // in the list and if there is _some kind_ of notification set
         (                                                                      // Ok, let's test. We'll only add him in these cases:
           ($notif_type & 4) ||                                                 // Notify on thread
           (($notif_type & 2) && (@in_array($msg,$path))) ||                    // Notify under message
           (($notif_type & 1) && (getvalue("forums","parent",$msg)==$new_post)) // Notify on direct reply
         )
       )
    {
      $people[]=$person;
    }

    // And finally, we check for subscriptions on this message - same code as above
    unset($data);
    $data[]="notify";
    $data[]="src";
    $data=getvalue("forum_subscriptions",$data,$msg);
    $notif_type=$data[0];
    $person=$data[1];
    if (
         ((!@in_array($person,$people)) && ($notif_type))                       // Only makes sense to test further if the user is not already
         &&                                                                     // in the list and if there is _some kind_ of notification set
         (                                                                      // Ok, let's test. We'll only add him in these cases:
           ($notif_type & 4) ||                                                 // Notify on thread
           (($notif_type & 2) && (@in_array($msg,$path))) ||                    // Notify under message
           (($notif_type & 1) && (getvalue("forums","parent",$msg)==$new_post)) // Notify on direct reply
         )
       )
    {
      $people[]=$person;
    }

    return($people);
  }

  // First looks up to the top message and then calls do_forum_notify() on
  // the top message.
  // Then calls forum_to_notify() in order to find out who to notify.
  // Then calls do_forum_notify() which actually notifies the users.
  // Should ONLY be called for new messages on the system!
  function forum_notifications($msg,$inhibit_confirmation=false)
  {
    $top=$msg;
    $oldtop=$msg;
    while ($top=getvalue("forums","parent",$top))
    {
      $oldtop=$top;
      $path[]=$top;
    }
    $top=$oldtop;
    $to_notify=forum_to_notify($top,$msg,$path,"");
    do_forum_notify($to_notify,$top,$msg,$inhibit_confirmation);
  }

  function show_msg($msg,$level,$levels,$commentlevels=1)
  {
    global $OPT_icon_new;

    $perm=forum_perm($msg);
    if ((!($perm & 1)) || (($levels) && ($level>=$levels)))
    {
      return(false);
    }
    $msg_data=forum_info($msg);
    if ($level==0)
    {
      if ($msg_data[0]==$msg)
      {
        $info="<span class=\"small\">[$msg_data[1] total; $msg_data[3] new]</span>";
      }
      else
      {
        $info="<span class=\"small\">[$msg_data[2]/$msg_data[1] total; $msg_data[4]/$msg_data[3] new]</span>";
      }
    }
    if ($msg_data[5])
    {
      $new="<img src=\"../../images/$OPT_icon_new\"> ";
    }
    for ($i=0;$i<=$level;$i++) //>
    {
      $indent.="&nbsp;&nbsp;&nbsp;";
    }
    if (($level<$commentlevels) || ((is_string($commentlevels)) && ($commentlevels=="all"))) //>
    {
      global $OPT_col_dk_dk, $CRM_admin;
      if ($perm & 2)
      {
        $rep=" <a class=\"regular\" href=\"../Msg_Add/?msg=$msg\">[Reply]</a>";
      }
      if ($perm & 4)
      {
        $rep.=" <a class=\"regular\" href=\"../Msg_Del/?msg=$msg\">[Delete]</a>";
      }
      if ($perm & 32)
      {
        global $show;
        $sub.="<span class=\"small\">Subscribe [<a class=\"small\" href=\"../Msg_List/?parent=$msg&sub=1&show=$show\">Direct</a> |
               <a class=\"small\" href=\"../Msg_List/?parent=$msg&sub=2&show=$show\">Message</a> |
               <a class=\"small\" href=\"../Msg_List/?parent=$msg&sub=4&show=$show\">Thread</a>]</span>";
      }
      $comment="<table border=\"0\" width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
      $comment.="<tr>\n";
      $comment.="<td class=\"regular\" rowspan=\"2\">";
      $comment.=$indent;
      $comment.="</td>\n";
      $comment.="<td class=\"regular\" bgcolor=\"$OPT_col_dk_dk\">";
      $comment.="<img src=\"../../images/spacer.gif\">";
      $comment.="</td>\n";
      $comment.="</tr>\n";
      $comment.="<tr>\n";
      $comment.="<td class=\"regular\" width=\"100%\">\n";
      $comment.=nl2br(htmlspecialchars(getvalue("forums","content",$msg)));
      $comment.="</td>\n";
      $comment.="</tr>\n";
      $comment.="</table>\n";
      $class="ah4";
      //echo("<br>");
    }
    else
    {
      $class="regular";
    }
    echo($indent.$new."<a class=\"$class\" href=\"../Msg_List/?parent=$msg\"><b>".
      htmlspecialchars(getvalue("forums","title",$msg)).
      "</b></a>$rep $info\n<br>".($sub?"$indent$sub\n<br>":"")."$indent<span class=\"small\">Posted ");
    if ($perm & 8)
    {
      $src=getvalue("forums","src",$msg);
      $name[]="fname";
      $name[]="lname";
      $name=getvalue("people",$name,$src);
      echo("by <a class=\"small\" href=\"../../people/admin/?action=display&id=$src\">$name[0] $name[1]</a> ");
    }
    $date=niceDate("forums","date",$msg);
    echo("on $date</span>\n");
    echo($comment);
    echo("<br>\n");
    $sql="select id from forums where parent=$msg order by date";
    $result=crm_run_query($sql);
    while ($myrow=OPT_fetch_row($result))
    {
      show_msg($myrow[0],$level+1,$levels,$commentlevels);
    }
  }
?>
