<?
#
# HTTP library
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  // This function logs the knowledge transfer
  function OPT_know_log($datasize,$who,$inout)
  {
    $interval=get_setting("know_log_interval");
    if (!$interval)
    {
      return(false);
    }
    $sql="select id from know_log where entry_type='$who'";
    switch(strtolower($interval))
    {
      case "d":
        $sql.=" and dayofyear(now())=dayofyear(date)";
        break;
      case "w":
        $sql.=" and week(now())=week(date)";
        break;
      case "m":
        $sql.=" and month(now())=month(date)";
        break;
    }
    $sql.=" and year(now())=year(date)";
    $result=crm_run_query($sql);
    if (OPT_num_rows($result))
    {
      list($id)=OPT_fetch_row($result);
      $size=getvalue("know_log","data".$inout,$id);
      $count=getvalue("know_log","data".$inout."count",$id);
    }
    else
    {
      $id=OPT_get_ID("know_log");
      crm_run_query("insert into know_log set id=$id, entry_type='$who'");
      $size=0;
      $count=0;
    }
    $count++;
    $size+=$datasize;
    crm_run_query("update know_log set date=date, data$inout='$size', data".$inout."count='$count', intrvl='$interval' where id='$id'");
  }

  // This function parses a list of variables and values in a single
  // url encoded string.
  // This is useful when you want to send a HTTP POST request
  // (or a HTTP GET request for that matter)
  // The variables and values should NOT be previously slashed
  // unless that's the expected result at the other end.
  // In fact this is the complement of PHP's parse_str()
  function requestContent($vars)
  {
    $parsed="";
    for ($i=0;$i<sizeOf($vars);$i++) // >
    {
      $parsed.=rawurlencode($vars[$i][0])."=".rawurlencode($vars[$i][1])."&";
    }
    $parsed=substr($parsed,0,-1); // Removing the last "&"
    return($parsed);
  }

  // This function sends a response to the request tipically sent by
  // sendRequest(). As opposed to sendRequest, this function doesn't
  // have to write to a port - instead it just has to echo like regular
  // PHP's do. Obviously, we'll also send a couple of headers in order
  // to create a proper HTTP response.
  function sendResponse($vars,$who)
  {
    Header("Content-type: application/x-www-form-urlencoded");
    $content=requestContent($vars);
    Header("Content-length: ".strlen($content));
    Header("Connection: close");
    echo($content);
    // We add 150 to the content size in order to approximate for
    // the headers (we've sent about 85 bytes worth of headers
    // explicitly, but the server usually sends some extra - the
    // final figure doesn't have to be exact to the byte, we just
    // want to give the administrators a good idea about the transfer
    // and a couple of bytes plus or minus won't make a real difference)
    OPT_know_log(strlen($content)+150,$who,"out");
  }

  // This function parses the result of a sendResponse() and returns
  // an array similar to $HTTP_POST_VARS or false on error.
  // By default we also make the resulted values global variables,
  // just as PHP does with track_vars on. But if you don't want that
  // just set the third parameter to 0.
  function parseResponse($the_response, $who, $global=1)
  {
    // All incoming data goes through parseResponse so it would be a
    // good idea to also log it here.
    OPT_know_log(strlen($the_response),$who,"in");

    // Let's first split the response we've got into header/content
    $message=explode("\r\n\r\n",$the_response);

    $header=$message[0];
    $content=$message[1];

    // Now let's make sure we got it right
    if (sizeOf($message)!=2)
    {
      if (sizeOf($message)==1)
      {
        return(false);
      }
      for ($i=2;$i<sizeOf($message);$i++) // >
      {
        $content.=$message[$i];
      }
    }

    // Ok, let's see... What headers do we have here...
    $headers=explode("\r\n",$header);

    // Typically "HTTP/1.x 200 OK", but we're only interested in the 200
    // because we don't get redirected or do other stuff
    $status=explode(" ",$headers[0]);
    if ($status[1]!=200)
    {
      return(false);
    }

    // We are going to search for proper headers now.
    // We need Content-type and Content-length to have proper values.
    // We'll start with a null byte and flag the least representative
    // couple of bits to mark these two. If we end up with a value of 3
    // we're happy. Otherwise we're not. Did it this way in order to support
    // future development.
    $hdrFlags=0;
    for ($i=1;$i<sizeOf($headers);$i++) // >
    {
      if (!($limit=strpos($headers[$i],":")))
      {
        // Oopsie! Wrong header!
        return(false);
      }
      $field_name=strtolower(substr($headers[$i],0,$limit));
      $field_value=strtolower(trim(substr($headers[$i],$limit+1)));

      if ($field_name=="content-length")
      {
        if ($field_value!=strlen($content))
        {
          return(false);
        }
        $hdrFlags |= 1;
      }

      if ($field_name=="content-type")
      {
        if ($field_value!="application/x-www-form-urlencoded")
        {
          return(false);
        }
        $hdrFlags |= 2;
      }
    }
    if ($hdrFlags!=3)
    {
      return(false);
    }

    // Ok, now we have to parse the actual variables passed in the content.
    // This is a little tricky because we want this to be PHP 3 compatible, but
    // PHP older than 4.0.3 doesn't parse_str in arrays. So we'll have separate code for
    // PHP older than 4.

    // So basically we have to rewrite parse_str for older PHP versions.

    if (isphpver(4))
    {
      parse_str($content,$parsed);
    }
    else
    {
      unset($parsed);
      $parsed_pairs=explode("&",$content);
      for ($i=0;$i<sizeOf($parsed_pairs);$i++) // >
      {
        $tmp=explode("=",$parsed_pairs[$i]);
        $tmp[0]=rawurldecode($tmp[0]);
        $tmp[1]=rawurldecode($tmp[1]);
        $parsed[$tmp[0]]=$tmp[1];
      }
    }

    // On the other hand, since some of the pages using this function aren't
    // protected at all we have to make sure no critical variables are passed by
    // twisted evil psycho hackers.

    while (list($var, $val)=each($parsed))
    {
      $newvar=OPT_gpc_unslash($var);
      $newval=OPT_gpc_unslash($val);
      if (!strpos(strtolower($newvar),"crm"))
      {
        $parsed_slashed[$newvar]=$newval;
        // We're gonna be real nice and make these global so people
        // won't have to write this stuff on all their pages
        if ($global)
        {
          global $$newvar;
          $$newvar=$newval;
        }
      }
    }
    // On the other hand, we also return the parsed array
    return($parsed_slashed);
  }

  // This function sends the actual request which is a fully-qualified
  // HTTP POST request.
  // This function only sends variables - i.e. it doesn't manage file uploads.
  function sendRequest($URL, $vars, $who)
  {
    // First we parse all the incoming variables into
    // a variable so we can send a valid Content-Length header
    $parsed=requestContent($vars);
    $len=strlen($parsed);

    // Let's make sure we have at least one slash trailing the URL - otherwise
    // the request is not valid. But since we may have an URL of the form
    // "http://www.linux.com" which does not have the correct trailing but does
    // contain slashes we must first get rid of those double slashes upon testing:
    if (!strpos(str_replace("//","**",$URL),"/"))
    {
      $URL.="/";
    }

    // Ok, now let's also make sure we have some sort of scheme (like "http://")
    // prepending the URL. Please note that only http is supported so if you
    // try "ftp://www.linux.com/" this will be in fact converted to
    // "http://www.linux.com" because we're connecting to port 80 regardless
    // of the scheme in the URI.
    if (!strpos($URL,"//"))
    {
      $URL="http://".$URL;
    }
    // Let's see what the host is and what the path is in the incoming URI and
    // returning error if the incoming URI was invalid after all. Using
    // the scheme array element to trigger the error because it is always set
    // by parse_url unless the incoming URL was invalid (i.e. not fit for our purpose).
    if (! (($split_URL=parse_URL($URL)) && ($split_URL["scheme"])))
    {
      return(false);
    }
    else
    {
      $host=$split_URL["host"];
      $path=$split_URL["path"];

      // Let's see if we should use a proxy here
      if ($connect_host=get_setting("proxy_host"))
      {
        $port=get_setting("proxy_port");
        if (!$port)
        {
          $port=8080;
        }
        $request_path="http://$host$path";
      }
      else
      {
        $port=80;
        $request_path=$path;
        $connect_host=$host;
      }

      // Parsing the whole request, including the actual request content
      $request="POST $request_path HTTP/1.0\r\n".
              "Content-Type: application/x-www-form-urlencoded\r\n".
              "User-Agent: OPT\r\n".
              "Host: $host\r\n".
              "Content-Length: $len\r\n".
              "Connection: Keep-Alive\r\n".
              "\r\n".                  // This separates the header from the content
              $parsed;

      // Now let's try connecting:
      // echo("Connecting to HOST: $connect_host; PORT: $port<br>\n");
      $fp=@fsockopen($connect_host, $port, $errno, $errstr, 30);

      // Let's see if we made it
      if (!$fp)
      {
        // OPT_error("FAILED CONNECTING!");
        return(false);
      }
      else
      {
        // If we made it, let's send the request:
        fputs($fp, $request);
        if ($who) // We only log if we know who done it
        {
          OPT_know_log(strlen($request),$who,"out");
        }
        while (!feof($fp))
        {
          $response.=fgets($fp, 128);
        }
        fclose($fp);
        return($response);
      }
    }
  }

  // This function makes a request to the currently active OPT node.
  // The parameters are:
  // 1. The request variable (array of arrays of variables and values to
  // be passed in the request - this should be built like this:
  // $var[]=array("var1","val1"); $var[]=array("var2","val2") etc;
  // 2. The expected primary response;
  // 3. The expected extended response.
  // The function returns a linear array with these indexes:
  // 0. true or false -- success or failure to both connect and get the desired
  //    responses;
  // 1. error message in case of failure - you should show this to the user;
  // 2. The node server name - you may want to include this in success messages.
  //    It's set to null if that was the error.
  function request_to_node($request, $expect1, $expect2, $who="server")
  {
    global $REQUEST_URI, $response, $extended, $CRM_ver, $SERVER_NAME;
    // Setting some defaults in case we miss something
    $answer[0]=false;
    $answer[1]="<b>FAILED</b> Undetermined error in $REQUEST_URI";
    $answer[2]="";

    // We have to have these two for all requests
    if (!($node_url=get_setting("know_node")))
    {
      $answer[1]="<b>FAILED</b>: Couldn't find the 'know_node' setting in the global settings. Aborting.";
      return($answer);
    }

    if (!$CRM_ver)
    {
      $answer[1]="<b>FAILED</b>: Couldn't determine the OPT version you're running. Aborting.";
      return($answer);
    }

    if (($request=="addMe") && (!($my_name=get_setting("know_server_name"))))
    {
      $answer[1]="<b>FAILED</b>: Couldn't find the 'know_server_name' setting in the global settings. Aborting.";
      return($answer);
    }

    list($node_host)=explode("/",$node_url);
    $answer[2]=$node_host;

    list($cpath)=explode("?",$REQUEST_URI);
    $cpath_x=explode("/",$cpath);
    $i=sizeOf($cpath_x)-2;
    if (($cpath_x[$i]!="know_client") || ($cpath_x[$i-1]!="know"))
    {
      $answer[1]="<b>FAILED</b>: Couldn't determine the current directory structure.
        Please edit <b>HTTP_lib.inc</b> - search for 'REQUEST_URI'";
      return($answer);
    }

    $my_url="/";
    for($i=1;$i<sizeOf($cpath_x)-3;$i++) // >
    {
      $my_url.=$cpath_x[$i]."/";

    }
    $my_url=$SERVER_NAME.$my_url;

    $vars[]=array("request",$request);
    $vars[]=array("url",$my_url);
    $vars[]=array("name",$my_name);
    $vars[]=array("OPT_ver",$CRM_ver);
    $vars[]=array("home",get_setting("home_page"));

    if (!($response=@sendRequest($node_url,$vars,"server")))
    {
      $answer[1]="<b>FAILED</b>: Couldn't connect to $node_host";
      return($answer);
    }

    // Useful for debugging...
    // echo(nl2br($response));

    if (!parseResponse($response,$who))
    {
      $answer[1]="<b>FAILED</b>: $node_host didn't return a valid response";
      return($answer);
    }
    if ($response!=$expect1)
    {
      $answer[1]="<b>FAILED</b>: $node_host said<br><b>&quot;$response ($extended)&quot;</b>";
      return($answer);
    }
    if ($extended!=$expect2)
    {
      $answer[1]="<b>CONNECTED OK</b> but $node_host said<br><b>&quot;$extended&quot;</b>";
      return($answer);
    }

    $answer[0]=true;
    $answer[1]=false;

    return($answer);
  }

  // Almost the same as above for connecting other servers
  function request_to_server($server, $request, $uid=0, $who="client")
  {
    global $REQUEST_URI, $response, $extended, $CRM_ver, $SERVER_NAME;
    // Setting some defaults in case we miss something
    $answer[0]=false;
    $answer[1]="<b>FAILED</b> Undetermined error in $REQUEST_URI";
    $answer[2]=$server;

    list($server_host)=explode("/",$server);

    if (!get_setting("know_allow_external"))
    {
      $answer[1]="<b>FAILED</b>: This is a bug in OPT - please notify Lanifex. Your settings don't allow you to connect to external servers, yet you got this far.";
      return($answer);
    }

    if (!$CRM_ver)
    {
      $answer[1]="<b>FAILED</b>: Somehow your server doesn't know its version. Please check opt/include/OPT_lib.php";
      return($answer);
    }

    list($cpath)=explode("?",$REQUEST_URI);
    $cpath_x=explode("/",$cpath);
    $i=sizeOf($cpath_x)-2;
    if ($cpath_x[$i-1]!="know")
    {
      $answer[1]="<b>FAILED</b>: Couldn't determine the current directory structure.
        Please edit <b>HTTP_lib.inc</b> - search for 'REQUEST_URI'";
      return($answer);
    }

    $my_url="/";
    for($i=1;$i<sizeOf($cpath_x)-3;$i++) // >
    {
      $my_url.=$cpath_x[$i]."/";

    }
    $my_url=$SERVER_NAME.$my_url;

    $vars[]=array("request",$request);
    $vars[]=array("url",$my_url);
    $vars[]=array("name",$my_name);
    $vars[]=array("OPT_ver",$CRM_ver);

    switch($request)
    {
      case "Search":
        global $query, $thorough;
        $vars[]=array("query",$query);
        $vars[]=array("thorough",$thorough);
        break;
      case "Retrieve":
        $vars[]=array("uid",$uid);
        break;
      case "FullRetrieve":
        $vars[]=array("uid",$uid);
        break;
      case "Import":
        $vars[]=array("uid",$uid);
        break;
      case "RetrieveComments":
        $vars[]=array("uid",$uid);
        break;
      case "RetrieveFullComment":
        $vars[]=array("uid",$uid);
        break;
      case "ImportComment":
        $vars[]=array("uid",$uid);
        break;
      case "Status":
        break;
      default:
        $answer[1]="<b>FAILED</b>: Unknown request (by localhost)";
        return($answer);
        break;
    }

    if (!($response=@sendRequest($server,$vars,$who)))
    {
      $answer[1]="<b>FAILED</b>: Couldn't connect to $server_host";
      return($answer);
    }

    // Useful for debugging...
    // echo(nl2br($response));

    if (!parseResponse($response,$who))
    {
      $answer[1]="<b>FAILED</b>: $server_host didn't return a valid response";
      return($answer);
    }

    $answer[0]=true;
    return($answer);
  }

  // Send feedback to the Lanifex server
  function SendFeedback($ver=0)
  {
    global $SERVER_NAME, $CRM_path, $CRM_ver;
    $data[]=array("serverID",md5($SERVER_NAME.$CRM_path));
    $data[]=array("serverVersion",$CRM_ver);
    $sendType=" ".get_setting("feedback_type");
    if (strpos($sendType,"s"))
    {
      $data[]=array("servername",get_setting("know_server_name"));
      $data[]=array("serverurl",get_setting("home_page"));
    }
    else
    {
      $data[]=array("servername","-1");
      $data[]=array("serverurl","-1");
    }
    if (strpos($sendType,"u"))
    {
      list($usercount)=OPT_fetch_row(crm_run_query("select count(*) from people"));
      $data[]=array("users",$usercount);
      list($ausercount)=OPT_fetch_row(crm_run_query("select count(*) from people where (status & 1)=1"));
      $data[]=array("ausers",$ausercount);

      list($companycount)=OPT_fetch_row(crm_run_query("select count(*) from companies"));
      $data[]=array("company",$companycount);
      list($acompanycount)=OPT_fetch_row(crm_run_query("select count(*) from companies where status=1"));
      $data[]=array("acompany",$acompanycount);
    }
    else
    {
      $data[]=array("users","-1");
      $data[]=array("ausers","-1");

      $data[]=array("company","-1");
      $data[]=array("acompany","-1");
    }
    if (strpos($sendType,"p"))
    {
      list($projects)=OPT_fetch_row(crm_run_query("select count(*) from projects"));
      $data[]=array("projects",$projects);
      list($aprojects)=OPT_fetch_row(crm_run_query("select count(*) from projects where active=1"));
      $data[]=array("aprojects",$aprojects);

      list($requests)=OPT_fetch_row(crm_run_query("select count(*) from requests"));
      $data[]=array("requests",$requests);
      list($req_comments)=OPT_fetch_row(crm_run_query("select count(*) from request_answers"));
      $data[]=array("req_comments",$req_comments);

      list($tasks)=OPT_fetch_row(crm_run_query("select count(*) from task"));
      $data[]=array("tasks",$tasks);
      list($task_comments)=OPT_fetch_row(crm_run_query("select count(*) from task_history"));
      $data[]=array("task_comments",$task_comments);

      list($email)=OPT_fetch_row(crm_run_query("select count(*) from email"));
      $data[]=array("email",$email);

      list($documents)=OPT_fetch_row(crm_run_query("select count(*) from documents"));
      $data[]=array("documents",$documents);
      list($doc_comments)=OPT_fetch_row(crm_run_query("select count(*) from document_answers"));
      $data[]=array("doc_comments",$doc_comments);
    }
    else
    {
      $data[]=array("projects","-1");
      $data[]=array("aprojects","-1");

      $data[]=array("requests","-1");
      $data[]=array("req_comments","-1");

      $data[]=array("tasks","-1");
      $data[]=array("task_comments","-1");

      $data[]=array("email","-1");

      $data[]=array("documents","-1");
      $data[]=array("doc_comments","-1");
    }
    if (strpos($sendType,"n"))
    {
      list($news)=OPT_fetch_row(crm_run_query("select count(*) from news"));
      $data[]=array("news",$news);
      list($new_comments)=OPT_fetch_row(crm_run_query("select count(*) from news_answers"));
      $data[]=array("new_comments",$new_comments);

      list($know)=OPT_fetch_row(crm_run_query("select count(*) from know"));
      $data[]=array("know",$know);
      list($know_comments)=OPT_fetch_row(crm_run_query("select count(*) from know_answers"));
      $data[]=array("know_comments",$know_comments);
    }
    else
    {
      $data[]=array("news","-1");
      $data[]=array("new_comments","-1");

      $data[]=array("know","-1");
      $data[]=array("know_comments","-1");
    }
    if (strpos($sendType,"l"))
    {
      list($nl_list)=OPT_fetch_row(crm_run_query("select count(*) from nl_list"));
      $data[]=array("nl_list",$nl_list);
      list($nl_issue)=OPT_fetch_row(crm_run_query("select count(*) from nl_issue"));
      $data[]=array("nl_issue",$nl_issue);
      list($nl_entries)=OPT_fetch_row(crm_run_query("select count(*) from nl_entries"));
      $data[]=array("nl_entries",$nl_entries);
    }
    else
    {
      $data[]=array("nl_list","-1");
      $data[]=array("nl_issue","-1");
      $data[]=array("nl_entries","-1");
    }
    return(sendRequest("opt.lanifex.com/feedback.php",$data,""));
  }

  // Check if we should send feedback
  function CheckFeedback()
  {
    if ($interval=get_setting("feedback_interval"))
    {
      $lastfeed=get_setting("feedback_last");
      if (!$lastfeed)
      {
        crm_run_query("delete from settings where name=\"feedback_last\"");
        crm_run_query("insert into settings set name=\"feedback_last\", value=now()");
        $lastfeed=get_setting("feedback_last");
      }
      list($dofeedback)=OPT_fetch_row(crm_run_query("select now()>date_add(\"$lastfeed\",interval $interval)"));
      if ($dofeedback)
      {
        if (SendFeedback())
        {
          crm_run_query("delete from settings where name=\"feedback_last\"");
          crm_run_query("insert into settings set name=\"feedback_last\", value=now()");
        }
      }
    }
  }
?>
