<?
#
# Authentication library
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  // These two functions run at the beginning and end of every page in OPT.
  // They run the phplib authentication.

  /*
    If you wish to change this code, please note the following:

    1. $CRM_guest should be set to evaluate true for users with guest access and
    false otherwise. This is currently done via Check_IP() but you may wish to change
    that.

    2. This should be the place to set $CRM_user and $CRM_comp.
  */

  function perform_pageopen()
  {
    global $OPT_custom_auth, $CRM_path;
    if (!$OPT_custom_auth) {
      include("$CRM_path/include/authentication/OPT_native.php");
    } else {
      include("$CRM_path/include/authentication/".$OPT_custom_auth);
    }
    custom_page_open();
  }

  function perform_pageclose()
  {
    global $_OPT, $CRM_path;
    // No need to include again
    custom_page_close();
  }

  function auth_open()
  {
    global $CRM_may_demo, $request_login, $CRM_guest, $CRM_user, $CRM_comp, $perm,
    $auth, $REQUEST_URI, $CRM_demo, $HTTP_USER_AGENT, $CRM_noheaders;

    $debug=false;
    $remote_ip=OPT_remote_IP();

    // Uncomment the following line if you want to log susceptible IP's.
    // The resulting log file will reside under /tmp and will be named as below.

    // $debug="OPT_IP_log.txt";

    $login_interval=get_setting("login_interval");
    if (($login_interval) && (!$CRM_noheaders)) {
      $login_attempts=get_setting("login_attempts");
      if (!$login_attempts) {
        $login_attempts=5;
      }
      crm_run_query("delete from failed_login where now()>date_add(date, interval '$login_interval' minute)");
      // In case you wonder what's with the seventies date in the query below,
      // MySQL is so "smart" that it computes dates in GMT format - even though
      // nobody asked for that. So it would shift your couple of minutes or whatever
      // you've got there by your server's time offset from GMT. So, there.
      $sql="select
              id,count,
              from_unixtime(".($login_interval*60)."-(unix_timestamp(now())-unix_timestamp(date))+unix_timestamp('1970-01-01'),'%H:%i:%s')
            from failed_login
            where ip=\"$remote_ip\"";
      $result=CRM_run_query($sql);
      list($id, $count,$time)=OPT_fetch_row($result);
      if ($login_attempts>$count) {
        crm_run_query("delete from failed_login where id='$id'");
        $count++;
        if (($debug) && ($count>1)) {
          $logging="\n---1---\n";
          $logging.="Date: ".date("d M y H:i:s")."\n";
          $logging.="IP: $remote_ip\n";
          $logging.="URL: $REQUEST_URI\n";
          $logging.="Agent: $HTTP_USER_AGENT\n";
          $logging.="Count: $count";
          exec("echo \"$logging\" >> /tmp/$debug");
        }
        crm_run_query("insert into failed_login set ip='$remote_ip', count=$count");
      } else {
        echo("<table border=\"0\" width=\"100%\" height=\"100%\"><tr><td align=\"center\" valign=\"middle\">\n");
        echo("<h1>Blocked!</h1><hr>You've failed logging in too many times in a row.<br>
          Please wait for $time before trying again.<hr><h1>&nbsp;</h1></td></tr></table>");
        exit;
      }
    }

    perform_pageopen();

    crm_run_query("delete from failed_login where ip='$remote_ip'");
    if (($debug) && ($count>1)) {
      $logging="\n---2---\n";
      $logging.="Date: ".date("d M y H:i:s")."\n";
      $logging.="IP: $remote_ip\n";
      $logging.="URL: $REQUEST_URI\n";
      $logging.="Agent: $HTTP_USER_AGENT\n";
      $logging.="Deleted this entry from the database";
      exec("echo \"$logging\" >> /tmp/$debug");
    }

    // $justlogged is defined in crm_login.ihtml
    // So it's only set if this file is included in the very first page after the login!
    // Please note that if crm_lib or auth.php is not included in the first page after the
    // login then this code never gets to run!

    // Obviously this code is intended to update the last login date in the database
    // for the current user. Please make sure it gets to run in any situation!

    global $justlogged;
    if ($justlogged && !$CRM_guest) {
      OPT_run_query("update people set prevlog=lastlog, lastlog=NULL where id=$CRM_user");
      global $tz, $lang;
      write_Xtra("people",$CRM_user,"OPT_user","TZ",$tz);
      if ($lang) {
        $Slang=OPT_gpc_slashes($lang);
        OPT_run_query("update people set prevlog=prevlog, lastlog=lastlog, preflang='$Slang' where id=$CRM_user");
      }
    }

    // Demo users use a different database so they don't mess your regular
    // user's data. You may want to set up demo accounts so possible clients
    // of your solution can take a look at what you're offering.

    // So, this is how this works:
    // The first two users in your REGULAR database are the demo users. When
    // they log in using the regular login form they are shifted to demo state
    // and the demo database is used for them instead of the regular one for the
    // rest of the OPT operation. However, they use the same code as the regular
    // users, which is one more benefit if you're a developer.

    // You may change their login username and password as an adminstrator from
    // within the regular interface.

    // If they change their username and password from their login, this doesn't
    // affect other demo users because they use the regular database for login anyway.

    // Users 1 through 5 are reserved for demo purposes.
    // User 1 is admin
    // User 2-5 are regular

    if (($CRM_user > 0) && ($CRM_user <= 5))
    {
      if ($CRM_may_demo)
      {
        $prev=getvalue("people","prevlog",$CRM_user);
        $CRM_demo=1;
        $CRM_comp=getvalue("people","company",$CRM_user);
        if ($justlogged)
        {
          $sql="update people set prevlog='$prev', lastlog=NULL where id=$CRM_user";
          crm_run_query($sql);
        }
      }
      else
      {
        echo("<h4>This OPT server does not provide demo user access.</h4>");
        exit;
      }
    }
    elseif ($CRM_user=="nobody")
    {
      $CRM_comp="nobody";
    }
    else
    {
      $CRM_comp=getvalue("people","company",$CRM_user);
    }

    global $CRM_admin;

    if ($CRM_comp==1)
    {
      $CRM_admin["system"]=1;
      $CRM_admin["forums"]=1;
    }
    else
    {
      $CRM_admin["system"]=0;
      $CRM_admin["forums"]=0;
    }

    // Also setting the locales here
    // Doing it here because this is where we find out who this user is,
    // hence we can find out his/her preferred language.
    OPT_locale();
    global $_OPT, $CRM_noheaders;
    if (!$CRM_noheaders) {
      // $_OPT["local"]["force_encoding"] is used by the translation module
      // to force using a specific encoding regardless of the current user's
      // language setting for general use.
      if ($_OPT["local"]["force_encoding"]) {
        header("Content-Type: text/html; charset=".$_OPT["local"]["force_encoding"]);
      } else {
        header("Content-Type: text/html; charset=".$_OPT["local"]["encoding"]);
      }
    }

    // Also taking the opportunity to compute the difference between
    // the remote user's timezone and ours
    global $OPT_tz_diff;
    $remote_tz=read_Xtra("people",$CRM_user,"OPT_user","TZ");
    $remote_tz=OPT_tz_to_sec($remote_tz);
    $local_tz=date('Z');
    $OPT_tz_diff=$remote_tz-$local_tz;

  }

  function auth_close()
  {
    perform_pageclose();
  }

  // This function masks an IP made of four separate bytes according to the
  // mask and returns an array of four bytes.

  // This also ensures no values bigger than 255 are passed.

  // But you have to make sure $mask is not larger than 32 in order to have
  // a fully valid netmask specification.

  function mask_it($ip1,$ip2,$ip3,$ip4,$mask)
  {
    for ($i=1;$i<5;$i++) { //>
      $maskVar="mask$i";
      if ($mask>=8) {
        $$maskVar=0xff;
      } else {
        $$maskVar=(0x100-(1 << (8-$mask))) & 0xff;
      }
      $mask-=8;
    }

    $masked[]=$ip1 & $mask1;
    $masked[]=$ip2 & $mask2;
    $masked[]=$ip3 & $mask3;
    $masked[]=$ip4 & $mask4;

    return $masked;
  }

  function Check_IP()
  {
    $remote_ip=OPT_remote_IP();

    $IP_ok=false;

    $ip=explode(".",$remote_ip);

    $sql="select id from ip where
            (($ip[0] << 24) + ($ip[1] << 16) + ($ip[2] << 8) + $ip[3])
            &
            (0xffffffff - ((1<<(32-mask_bits))-1))
            =
            ((ip1 << 24) + (ip2 << 16) + (ip3 << 8) + ip4)"; // >
    $result=crm_run_query($sql);
    if (OPT_num_rows($result))
    {
      $IP_ok=1;
    }
    return($IP_ok);
  }
?>
