<?
#
# Database functions - MySQL
#
# Core OPT functions related to database stuff.
# This is the MySQL library - included by include/OPT_lib.php
#
# Bogdan Stancescu <bogdan@lanifex.com>, June 2002
# Revision 1.0

  // Define a function for CRM database handling
  // Takes as a parameter the SQL queries and returns the result.
  // If there is an error, print a message and die

  // Old note:
  // Using a global database link identifier so we don't connect
  // to the server again and again in the same page - PHP
  // kills both the global variable and the connection when
  // the page ends, so no problems there.

  // New note:
  // Actually, there are BIG problems there, so don't try it:
  // we often use the database before setting $CRM_demo - and
  // if we use a global link identifier then we'll keep using the
  // regular database for demo users too - which is obviously wrong.

  // This function was not created by me (BS) - but the copyright
  // notice got lost somewhere on the way - if anyone knows who
  // created this, please drop a line. (It would have been idiotic
  // to recreate this function without looking at the source and
  // copyright the result, since what we actually used was the idea)

  function CRM_run_query ($sql,$process_errors=1)
  {
    global $CRM_demo, $CRM_db_host, $CRM_db_db, $CRM_db_demo_db,
          $CRM_db_uname, $CRM_db_pwd, $DBCounter, $OPT_db_lock;

    $DBCounter++;

    while (file_exists($OPT_db_lock)) {
      if ($lock_wait_count>15) {
        CRM_query_error("Database locked too long!");
        exit;
      }
      $lock_wait_count++;
      echo(" ");
      flush();
      sleep(2);
    }

    if ($process_errors && !$sql) {
      CRM_query_error("You forgot to specify an SQL statement.");
      exit;
    }
    if ($CRM_demo) {
      $database = $CRM_db_demo_db;
    } else {
      $database = $CRM_db_db;
    }
    $db_link = pg_connect("host=$CRM_db_host dbname=$CRM_db_db user=$CRM_db_uname password=$CRM_db_pwd");
    echo("Running query <b>$sql</b><br>\n");
    $result = pg_exec($sql);
    if (($process_errors) && (!$result))
    {
      CRM_query_error("The following query failed:\n$sql\n".pg_error());
      exit;
    }
    return $result;
  }

  // Gets the next id for a table. The second optional parameter is the
  // field name to look for - "id" by default.
  // This is an ugly method to avoid using mysql_insert_id() because
  // other database systems don't have that.
  function OPT_get_ID($table, $field="id") {
    $sql="select max($field) from $table";
    $result=OPT_run_query($sql);
    list($id)=OPT_fetch_row($result);
    return($id+1);
  }

  function OPT_num_rows($result)
  {
    return(pg_numrows($result));
  }

  function OPT_fetch_row($result)
  {
    global $OPT_rows;
    if (!isset($OPT_rows[$result])) {
      $OPT_rows[$result]=-1;
    }
    $OPT_rows[$result]++;
    return(pg_fetch_row($result,$OPT_rows[$result]));
  }

  function OPT_fetch_array($result)
  {
    return(pg_fetch_array($result));
  }

  function OPT_result($result, $row, $name)
  {
    return(pg_result($result, $row, $name));
  }

  function OPT_run_query($sql,$process_errors=true)
  {
    return(CRM_run_query($sql,$process_errors));
  }

  function OPT_num_fields($result) {
    return(pg_numfields($result));
  }

  function OPT_fieldname($result,$id) {
    return(pg_fieldname($result,$id));
  }
?>
