<?
#
# The e-mail library.
#
# All functions by Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Added new request via e-mail feature, Barry Roberts, February 2002
# Revision 1.0

  // The main function here is checkMail() at the end of the file

  // This section defines the functions to be run in order to add
  // documents in the e-mail archive.

  // Ok, this is the function which actually does all the work.
  // The other bastards just checked some stuff and now this poor
  // thing has to actually upload the data in the database.

  // function testMail($tobj,$sender,$email,$stream,$title)
  function testMail($mailfile, $head, $sender, $dest="")
  {
    global $CRM_user, $temp_CRM_dir, $CRM_path, $CRM_limit, $CRM_email, $CRM_system_email;

    // First we'll retrieve the date when this e-mail was received by the server
    // (this is unix timestamp format).
    $thedate=filectime("$temp_CRM_dir/$mailfile");
    $thedate="date=from_unixtime($thedate)";

    // Now let's find out who this e-mail is really addressed to
    // (i.e. to which project). We'll start by reading the "personal"
    // field of the destination address. The personal field is the
    // human-readable string in front of the e-mail address - you know,
    // the "John Doe" in "John Doe <j.doe@ibm.co.uk>"
    //echo("Dest on initial if is $dest<br>");
    if ($dest)
    {
      $dest_mail=$dest; // Yeah, ugly, but $dest has been messed up in early versions
      if (strpos($dest,"<")) //>
      {
        $dest=trim(substr($dest,0,strrpos($dest,"<"))); //>
      }
      while ((substr($dest,0,1)=='"') || (substr($dest,0,1)=="'"))
      {
        $dest=substr($dest,1);
      }
      //echo("dest_mail: $dest_mail<br>\n");

      // The format for an e-mail that has to end up in the e-mail archive
      // is "OPT archive [something readable] #i", where:
      // "OPT archive" is a string which testifies the user intended the e-mail
      //   to reach the OPT e-mail archive system;
      // "[something readable]" is any string the user can easily identify the
      //   project by in his/her address book in case s/he's working at more
      //   than one project at a time;
      // "#" is a separator
      // "i" is the id of the project this e-mail is referring to.
      // So now we'll parse the "personal" string

      // First we find out where the separator is
      $projpoz=strrpos($dest,"#");

      // Then we find out what the project id we're talking about
      $proj=(substr($dest,$projpoz+1))+0;

      //echo("Processing dest=$dest with proj=$proj<br>\n");
      $newreq=0;
      $dest_id=explode(" ",$dest);
      //echo("Switching on $dest_id[1]<br />");
      switch (strtolower($dest_id[1]))
      {
        case "archive":
          $thetable="email";
          break;
        case "request":
          $thetable="requests";
          break;
        case "task":
          $thetable="task";
          break;
        case "newrequest":
          $thetable="requests";
          $newreq=1;
          break;
        case "document":
          $thetable="documents";
          break;
        case "forum":
          $thetable="forums";
          break;
        case "events":
          $thetable="events";
          break;
        default:
          // Let's check if this is an alias or a mailing list
          //echo("dest_mail before is: ".htmlspecialchars($dest_mail)."<br>");
          $m_start=strpos($dest_mail,"<");
          if (is_integer($m_start))
          {
            $dest_mail=substr($dest_mail,$m_start+1);
            $m_end=strpos($dest_mail,">");
            $dest_mail=substr($dest_mail,0,$m_end);
          }
          //echo("dest_mail after is: ".htmlspecialchars($dest_mail)."<br>");
          $Sdest_mail=addslashes($dest_mail);
          $sql_query="select project, entry_type from mail_repository where email like 
                      '%$Sdest_mail%' and entry_type in (1,2)";
          //echo(htmlspecialchars($sql_query)."<br />");
          $addr_result=CRM_run_query($sql_query);
          if (OPT_num_rows($addr_result) == 1)
          {
             $addr_row=OPT_fetch_row($addr_result);
             $proj = $addr_row[0];
             if ($addr_row[1] == 2)
             {  // This is a mailing list so save who really sent it, even if they not an OPT user
                if (strpos($head["from"][0],"<")) 
                {
                    $dest_mail=substr($head["from"][0],strrpos($head["from"][0],"<")+1); 
                    $dest_mail=substr($dest_mail,0,strrpos($dest_mail,">"));
                }
                else
                {
                    $dest_mail=$head["from"][0];
                }
             }
             //echo("Found project $addr_row[0] with ".$head["from"][0]."<br>");
          }              
          if (!$proj) {
            return(0);
          }
          $thetable="email";
          $dest="";
      }
    }
    else
    {
      $thetable="email";
      $sender=OPT_gpc_slashes($sender);
      list($proj)=OPT_fetch_row(CRM_run_query("select project from mail_repository where email like '%$sender%' and (entry_type & 1)=0"));
      if (!$proj) {
        return(0);
      }
    }
    //echo("Using table: $thetable<br>\n");

    // Now, let's check if:
    // 1. The project/request number is valid (i.e. not null)
    // 2. The string starts with the proper substring
    // 3. The user has got permissions in this project/request
    if (
        (!$dest)
        ||
        (
          ($proj)
          &&
          (
            (
              (
                (strtolower($dest_id[1])=="archive") ||
                (strtolower($dest_id[1])=="newrequest")
              )
              &&
              (crm_perm("projects",$aproj=$proj))
            )
            ||
            (
              (strtolower($dest_id[1])=="request")
              &&
              (crm_perm("requests",$aproj=$proj))
            )
            ||
            (
              (strtolower($dest_id[1])=="task")
              &&
              (crm_perm("task",$aproj=$proj))
            )
            ||
            (
              (strtolower($dest_id[1])=="document")
              &&
              (crm_perm("documents",$aproj=$proj))
            )
            ||
            (
              (strtolower($dest_id[1])=="forum")
              &&
              (forum_perm($proj) & 2)
            )
          )
        )
      )
      {
        //echo(getvalue("people","fname",$CRM_user)." has got permissions in project '".getvalue("projects","name",$aproj)."'!<br>\n");
        // Now that everything's ok, we "just" have to parse the e-mail and upload
        // it into the database.
        $fname="$temp_CRM_dir/$mailfile";
        $file=fread(fopen($fname,"r"),filesize($fname));
        $fpos=strpos($file,"\n\n");
        $file=substr($file,$fpos+2);

        $title=$head["subject"][0];

        // Ok, let's start with the rest of the message.
        // But before that, we have to skip to the first attachment in case
        // of mixed type:
        if (strtolower(substr($head["content-type"][0],0,15))=="multipart/mixed")
        {
          $c_type=$head["content-type"][0];
          $boundary=trim(substr($c_type,strpos($c_type,"boundary=")+9));
          if ($boundary[0]=="\"")
          {
            $boundary=substr($boundary,1);
            $boundary=substr($boundary,0,strpos($boundary,"\""));
          }
          $bPos=strpos($file,"--$boundary");
          $file=substr($file,$bPos+strlen($boundary)+2);
          // echo("Multipart");
        }
        else
        {
          // echo("Simple");
        }

        $i=0;
        while (
                ((!$boundary) && ($file)) ||
                (($bPos=strpos($file,"--$boundary")) && (substr($file,0,2)!="--"))
              )
        {
          // echo("Message part: ".nl2br($buffer));
          // echo("Message rest: ".nl2br($file)."<hr>\n");
          $eoa=false;
          if ($boundary)
          {
            $buffer=substr($file,0,$bPos);
            $file=substr($file,$bPos+strlen($boundary)+2);
            // echo("<hr>AFTER Message part: ".nl2br($buffer));
            // echo("AFTER Message rest: ".nl2br($file)."<hr>\n");
            $att_head=OPT_headerinfo($buffer);
            $buffer=substr($buffer,strpos($buffer,"\n\n")+2);
            $mtype=$att_head["content-type"][0];

            // Just for Apple users...
            if (strtolower(substr($mtype,0,21))=="multipart/appledouble")
            {
              $MacBoundary=trim(substr($mtype,strpos($mtype,"boundary=")+9));
              if ($MacBoundary[0]=="\"")
              {
                $MacBoundary=substr($MacBoundary,1);
                $MacBoundary=substr($MacBoundary,0,strpos($MacBoundary,"\""));
              }
              // echo("MacBoundary = $MacBoundary");

              // Ok, we must now chop $buffer using $MacBoundary until we find some reasonable MIME type
              $bPos=strpos($buffer,"--$MacBoundary");
              $buffer2=substr($buffer,$bPos+strlen($MacBoundary)+2);
              while (($bPos=strpos($buffer2,"--$MacBoundary")) && (substr($buffer2,0,2)!="--"))
              {
                // echo("<hr>GOT HERE - buffer2=".nl2br($buffer2)."<hr>");
                $buffer3=substr($buffer2,0,$bPos);
                $buffer2=substr($buffer2,$bPos+strlen($MacBoundary)+2);
                // echo("<hr>MAC Message part: ".nl2br($buffer3));
                // echo("MAC Message rest: ".nl2br($buffer2)."<hr>\n");
                $buf_head=OPT_headerinfo($buffer3);
                $buffer3=substr($buffer3,strpos($buffer3,"\n\n")+2);
                if (substr($buf_head["content-type"][0],0,21)!="application/applefile")
                {
                  $buffer=$buffer3;
                  $att_head=$buf_head;
                  $mtype=$att_head["content-type"][0];
                  break; // Found what we were looking for, so we exit the while
                }
              }
            }

          // echo("<hr>FINAL Message part: ".nl2br($buffer));
          // echo("FINAL Message rest: ".nl2br($file)."<hr>\n");

            if (strpos($mtype,"name="))
            {
              $fname=substr($mtype,strpos($mtype,"name=")+5);
              list($mtype)=explode(";",$mtype);
              $mtype=trim($mtype);
              if($fname[0]=="\"")
              {
                $fname=substr($fname,1);
                $fname=substr($fname,0,strpos($fname,"\""));
              }
              $fname=OPT_runtime_slashes($fname);
              $mtype=OPT_runtime_slashes($mtype);
            }
            switch (strtolower($att_head["content-transfer-encoding"][0]))
            {
              case("base64"):
                $buffer=base64_decode($buffer);
                break;
              case("quoted-printable"):
                $buffer=quoted_printable_decode($buffer);
                break;
            }
            //echo("Nice part: ".nl2br($buffer));
          }
          else
          {
            $buffer=$file;
            $file="";
          }
          $i++;
          if ($i==1)
          {
            $fsize=strlen($buffer);
            // The PHP3 trim doesn't do the job thoroughly, so we'll have to do
            // it by hand...
            $buffer=trim($buffer);
            $trimmable[]="\n";
            $trimmable[]="\r";
            $trimmable[]="\t";
            $trimmable[]="\v";
            $trimmable[]="\0";
            $trimmable[]=" ";
            while (in_array(substr($buffer,0,1),$trimmable))
            {
              $buffer=substr($buffer,1);
            }
            while (in_array(substr($buffer,-1),$trimmable))
            {
              $buffer=substr($buffer,0,-1);
            }
            $buffer=OPT_runtime_slashes($buffer);
            $title=OPT_runtime_slashes($title);
            if ($thetable=="email")
            {
              $email_id=OPT_get_ID("email");
              if (intval($sender))
              {
                $sql="insert into email set id=$email_id, body=\"$buffer\", project=$proj,
                      src=$sender, title=\"$title\", $thedate";
              }
              else
              {
                $sql="insert into email set id=$email_id, body=\"$buffer\", project=$proj,
                      emailSrc=\"$dest_mail\", title=\"$title\", $thedate";
              }
              //echo("$sql<br>");
              $result=CRM_run_query($sql);
            }
            elseif ($thetable=="requests" && intval($sender))
            {
              if ($newreq==0)
              {
                $sql="insert into request_answers set comment=\"$buffer\",
                      request=$proj, src=$sender, $thedate";
                CRM_run_query($sql);

                // And we'll also do the notifications in here
                $req=$proj;
                $proj=getvalue("requests","aproj",$proj);
                $rq[]="title";
                $rq[]="request";
                $rq[]="owner";
                $rqt=getvalue("requests",$rq,$req);
                $title=$rqt[0];
                $comments=$rqt[1];
                $owner=$rqt[2];

                // We'll find out who's involved.
                $notify_src=getvalue("requests","notify_src",$req,"");
                $sql="select person from request_submitters where request = $req";
                $submitters_result=CRM_run_query($sql);
                while ($submitter_row=OPT_fetch_row($submitters_result))
                {
                   if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
                   {
                      $dst[]=$submitter_row[0];
                   }
                } 
                
                if (($owner) && ($owner!=$sender) && ($owner!=$requestor_id))
                {
                  $dst[]=$owner;
                }

                $v[]="email";
                $v[]="sal";
                $v[]="fname";
                $v[]="lname";
                $s=getvalue("people",$v,$sender);
                $p_n=getvalue("projects","name",$proj);
                $comment=stripslashes($buffer);

                for ($i=0;$i<sizeOf($dst);$i++) // >
                {
                  $d=getvalue("people",$v,$dst[$i]);
                  $name="$d[1] $d[3]";
                  OPT_notify($dst[$i],"New comment on OPT request #$req \"$title\"",
                    "Dear $name,\n".
                    "$s[1] $s[2] $s[3] posted a new comment by mail on request \"$title\" ".
                    "related to the \"$p_n\" project.\n\n".
                    "The request BODY follows:\n".
                    "------------------------------------------------------------------------\n".
                    "$comments\n".
                    "------------------------------------------------------------------------\n\n".
                    "The newly posted COMMENT follows:\n".
                    "------------------------------------------------------------------------\n".
                    "$comment\n".
                    "------------------------------------------------------------------------\n".
                    "This request is accessible on the OPT server at this URL:\n".
                    "http://$SERVER_NAME$CRM_URL?URL=".
                    rawurlencode("rt/req_view/?proj=$proj&req=$req"),
                    "You may post comments on the request by replying ".
                    "to this e-mail. Please note only the message body will be ".
                    "uploaded to OPT. You may also post comments by ".
                    "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
                    "please don't quote the original message since the quotation ".
                    "will also get unnecessarily posted on OPT.\n\nThank you!",
                    "OPT request #$req <$CRM_system_email>",1);
                }
              }
              else
              {
                $req=OPT_get_ID("requests");
                $sql="insert into requests set id=$req, title=\"$title\", aproj=\"$proj\",
                  request=\"$buffer\", notify_src=1, $thedate";
                CRM_run_query($sql);
                $sql = "insert into request_submitters (request, person) values ($req, $sender)";
                CRM_run_query($sql);

                // Notify everybody [no owner for now]
                $result=get_people_involved_with_project($proj);
                while ($myrow=OPT_fetch_row($result))
                {
                  $dst[]=$myrow[0];
                }

                // ...and make sure we confirm to the sender
                if (!@in_array($sender,$dst))
                {
                  $dst[]=$sender;
                }

                $v[]="email";
                $v[]="sal";
                $v[]="fname";
                $v[]="lname";
                $s=getvalue("people",$v,$sender);
                $p_n=getvalue("projects","name",$proj);
                $comments=stripslashes($buffer);
                $title=stripslashes($title);

                for ($i=0;$i<sizeOf($dst);$i++) // >
                {
                  $d=getvalue("people",$v,$dst[$i]);
                  $name="$d[1] $d[3]";
                  OPT_notify($dst[$i],"New OPT request #$req \"$title\"",
                    "Dear $name,\n".
                    "$s[1] $s[2] $s[3] posted a new request on OPT ".
                    "related to the \"$p_n\" project.\nThe request has been posted by mail and currently has no owner\n".
                    "The request body follows:\n".
                    "------------------------------------------------------------------------\n".
                    "$comments\n".
                    "------------------------------------------------------------------------\n".
                    "This request is accessible on the OPT server at this URL:\n".
                    "http://$SERVER_NAME$CRM_URL?URL=".
                    rawurlencode("rt/req_view/?proj=$proj&req=$req"),
                    "You may post comments on the request by replying ".
                    "to this e-mail. Please note only the message body will be ".
                    "uploaded to OPT. You may also post comments by ".
                    "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
                    "please don't quote the original message since the quoted text ".
                    "will also get unnecessarily posted on OPT.\n\nThank you!",
                    "OPT request #$req <$CRM_system_email>",1);
                }
              }
            }
            elseif ($thetable=="task" && intval($sender))
            {
                $sql="INSERT INTO task_history SET taskID=$proj, record=\"$buffer\",
                      authorID=$sender,Posted=".time();
                CRM_run_query($sql);

                // And we'll also do the notifications in here
                $tk[]="TaskName";
                $tk[]="TaskDesc";
                $tkt=getvalue("task",$tk,$proj);
                $title=$tkt[0];
                $comments=$tkt[1];

                // We'll find out who's involved with this task
                $sql="select personID from person_task where taskID = $proj";
                $involved_result=CRM_run_query($sql);
                while ($involved_row=OPT_fetch_row($involved_result))
                {
                   if (($involved_row[0] != $CRM_user) && !@in_array($involved_row[0],$dst))
                   {
                      $dst[]=$involved_row[0];
                   }
                }

                $v[]="email";
                $v[]="sal";
                $v[]="fname";
                $v[]="lname";
                $s=getvalue("people",$v,$CRM_user);
                $pn=getvalue("task", "ProjectID", $proj);
                $p_n=getvalue("projects","name",$pn);
                $title=stripslashes($title);
                $comments=stripslashes($buffer);
                for ($i=0;$i<sizeOf($dst);$i++) // >
                {
                   OPT_locale($dst[$i]);
                   $d=getvalue("people",$v,$dst[$i]);
                   $name="$d[1] $d[3]";
                   OPT_notify($dst[$i],sprintf(__("New comment on OPT task %s"),"#$proj, \"$title\""),
                      sprintf(__("Dear %s,\n".
                      "%s posted a new comment on task %s ".
                      "related to the %s project.\n\n".
                      "The task description follows:\n".
                      "------------------------------------------------------------------------\n".
                      "%s\n".
                      "------------------------------------------------------------------------\n\n".
                      "The newly posted comment follows:\n".
                      "------------------------------------------------------------------------\n".
                      "%s\n".
                      "------------------------------------------------------------------------\n".
                      "This task is accessible on the OPT server at this URL:\n"),$name,
                      "$s[1] $s[2] $s[3]","#$task, \"$title\"","\"$p_n\"",$comments,$comment).
                      "http://$SERVER_NAME$CRM_URL?URL=".
                      rawurlencode("tasks/task/?action=display&proj=$proj&task=$proj"),
                      __("You may post comments on the task by replying ".
                      "to this e-mail. Please note only the message body will be ".
                      "uploaded to OPT. You may also post comments by ".
                      "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
                      "please don't quote the original message since the quotation ".
                      "will also get unnecessarily posted on OPT.\n\nThank you!"),
                      "OPT task #$proj <$CRM_system_email>", 1);
                }
            }
            elseif ($thetable=="documents" && intval($sender))
            {
              $sql="insert into document_answers set comment=\"$buffer\",
                    document=$proj, src=$sender, $thedate";
              CRM_run_query($sql);

              // Also notify the person who uploaded it
              $doc=$proj;
              $proj=getvalue("documents","aproj",$proj);
              $dc[]="title";
              $dc[]="src";
              $dc=getvalue("documents",$dc,$doc);
              $title=$dc[0];
              $dst=$dc[1];
              $o[]="sal";
              $o[]="fname";
              $o[]="lname";
              $own=getvalue("people",$o,$sender);
              $own="$own[0] $own[1] $own[2]";

              // We'll find out who's involved.
              $v[]="email";
              $v[]="sal";
              $v[]="fname";
              $v[]="lname";

              $d=getvalue("people",$v,$dst);
              $name="$d[1] $d[3]";

              $s=getvalue("people",$v,$sender);
              $p_n=getvalue("projects","name",$proj);
              $comment=stripslashes($buffer);

              OPT_notify($dst,"New comment on OPT document \"$title\"",
                "Dear $name,\n".
                "$s[1] $s[2] $s[3] posted a new comment via e-mail on document \"$title\" ".
                "related to the \"$p_n\" project.\n\n".
                "The comment follows:\n".
                "------------------------------------------------------------------------\n".
                "$comment\n".
                "------------------------------------------------------------------------\n",
                "You may post comments on the document by replying ".
                "to this e-mail. Please note only the message body will be ".
                "uploaded to OPT. You may also post comments by ".
                "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
                "please don't quote the original message since the quoted text ".
                "will also get unnecessarily posted on OPT.\n\nThank you!",
                "OPT document #$doc <$CRM_system_email>",1);
            }
            elseif ($thetable=="forums" && intval($sender))
            {
              $msg=OPT_get_ID("forums");
              $sql="insert into forums set id=$msg, content=\"$buffer\",
                    parent=$proj, src=$sender, att_type=\"".getvalue("forums","att_type",$proj)."\",
                    att_id=\"".getvalue("forums","att_id",$proj)."\", title=\"$title\", $thedate";
              CRM_run_query($sql);

              // Notify the people who requested to get notified
              include "$CRM_path/forums/forum_lib.php";
              forum_notifications($msg,true); // The second parameter inhibits on-screen confirmations
            }
            elseif ($thetable=="events" && intval($sender))
            {
              $msg=OPT_get_ID("event_comments");
              $sql="insert into event_comments set id=$msg, comment=\"$buffer\",
                    event=$proj, src=$sender, $thedate";
              CRM_run_query($sql);
            }
          }
          elseif ($thetable=="email")
          {
            // We only upload attachments for e-mails - not for
            // request and document answers
            $fsize=strlen($buffer);
            $data_big=OPT_runtime_slashes($buffer);
            $ssize=strlen($data_big);
            $fname=OPT_runtime_slashes($fname);
            if ($ssize>=$CRM_limit)
            {
              $data_start=$CRM_limit;
              $init_data=substr($data_big,0,$CRM_limit);
              while (substr($init_data,-1)=="\\")
              {
                $init_data=substr($init_data,0,-1);
                $data_start--;
              }
              $doc=OPT_get_ID("e_attach");
              $sql="insert into e_attach set e_mail=$email_id,
                    content=\"$init_data\", size=$fsize, mtype=\"$mtype\",
                    fname=\"$fname\"";
              unset($init_data); // Freeing some memory
              $result=CRM_run_query($sql);
              $data_left=$ssize-$data_start;
              while ($data_left)
              {
                // echo("Data left: $data_left<br>\n");
                if ($data_left>$CRM_limit)
                {
                  $chunk=$CRM_limit;
                }
                else
                {
                  $chunk=$data_left;
                }
                $rest_data=substr($data_big,$data_start,$chunk);
                while ((substr($rest_data,-1)=="\\") && ($chunk!=$data_left))
                {
                  $rest_data=substr($rest_data,0,-1);
                  $chunk--;
                }
                $sql="insert into e_attach_part set e_attach=$doc, content=\"$rest_data\"";
                CRM_run_query($sql);
                $data_left-=$chunk;
                $data_start+=$chunk;
              }
            }
            else
            {
              $sql="insert into e_attach set e_mail=$email_id,
                    content=\"$data_big\", size=$fsize, mtype=\"$mtype\",
                    fname=\"$fname\"";
              CRM_run_query($sql);
            }
          }
        }
        fclose(fopen("$temp_CRM_dir/~$mailfile","w"));
        return(1);
      }
  }

  // Creates the error file and notifies the administrator
  function mailProblem($message,$comment)
  {
    global $CRM_email, $temp_CRM_dir, $SERVER_NAME, $CRM_system_email;
    fclose(fopen("$temp_CRM_dir/!$message","w"));
    OPT_mail($CRM_email,"OPT mail error",
      wordwrap("The OPT system at $SERVER_NAME received an e-mail with some problems.\n\n".
      "The e-mail has been preserved for you to check at your discretion at ".
      "$temp_CRM_dir/$message. If you choose to delete this file, make sure you also delete $temp_CRM_dir/!$message.\n\n".
      "The error message issued by the OPT mail module was:\n".
      $comment),"From: OPT <$CRM_system_email>");
  }

  // Gets the header information from the message passed.
  // Returns an array of arrays with this structure:
  // {<key, value>*}, where the value is an array of values
  // for the respective keys, or an array of one value in case
  // there's only one value.
  function OPT_headerinfo($mail)
  {
    list($head)=explode("\n\n",$mail);
    $head=explode("\n",$head);
    for($i=0;$i<sizeof($head);$i++) //>
    {
      if ((substr($val,-1)==";") || (substr($head[$i],0,1)=="\t") || (!ereg("^[a-zA-Z0-9]", substr($head[$i],0,1))))
      {
        $val.=$head[$i];
        $header[$key][sizeof($header[$key])-1]=$val;
        //echo(htmlspecialchars("Adding header: key=$key, index=". (sizeof($header[$key])-1) .", val=$val")."<br />");
      }
      else
      {
        $key=strtolower(trim(substr($head[$i],0,strpos($head[$i],":"))));
        $val=trim(substr($head[$i],strpos($head[$i],":")+1));
        // Yes, this is ugly but we have to do it this way
        // because PHP 3 and PHP 4 return different sizeof() for
        // null arrays (PHP 4 correctly returns 0 while PHP 3 returns 1)
        $cpos=sizeof($header[$key]);
        if ($cpos && !$header[$key][$cpos-1])
        {
          $cpos--;
        }
        //echo(htmlspecialchars("Adding new header: key=$key, cpos=$cpos, val=$val")."<br />");
        $header[$key][$cpos]=$val;
      }
    }
    return($header);
  }

  // Processing the incoming mail.
  // This function checks whether the senders of the e-mail messages
  // are listed in the "people" table. If they aren't, their messages
  // are simply forwarded to the OPT administrator and deleted.
  // ADDED: also checks for senders in mail_repository
  function processMail($messages)
  {
    // We need to alter these later on...
    global $CRM_user, $CRM_comp, $CRM_demo, $CRM_guest, $temp_CRM_dir;
    $real_user=$CRM_user;
    $real_comp=$CRM_comp;
    $real_demo=$CRM_demo;
    $real_guest=$CRM_guest;
    $CRM_demo=0;
    $CRM_guest=0;

    for ($i=0;$i<sizeOf($messages);$i++) // >
    {
      unset($sender);
      $fname="$temp_CRM_dir/$messages[$i]";
      $fh=fopen($fname,"r");
      $header="";
      while ((($line=fgets($fh,4096))!="\n") && (!feof($fh)))
      {
        $header.=$line;
      }
      if (feof($fh))
      {
        // Whoops! Problemo! The mail either contained no data or it's not a mail message after all
        mailProblem($messages[$i],"This is either not an e-mail message at all or it's undecently empty.");
        return(false);
      }
      fclose($fh);
      $head=OPT_headerinfo($header);
      $from=$head["from"][0];
      //echo("Processing from field: $from<br>\n");
      if (strpos($from,"<")) // >
      {
        $sender=substr($from,strrpos($from,"<")+1); // >
        $sender=substr($sender,0,strrpos($sender,">"));
      }
      else
      {
        $sender=$from;
      }
      $sql="select id from people where email='$sender'";
      $result=CRM_run_query($sql);
      //echo("Searching for $sender<br>\n");
      if (!OPT_num_rows($result)) {
        $sql="select entry_id from mail_xtra where entry_type='people' and email='$sender'";
        $result=OPT_run_query($sql);
      }
      if ($myrow=OPT_fetch_row($result))
      {
        //echo($sender." is registered<br>\n");
        $CRM_user=$myrow[0];
        $CRM_comp=getvalue("people","company",$CRM_user);

        // Ok, this is quite tedious. We'll have to see where OPT is among all
        // the possible places it can be -- it can be listed in any position
        // within the "to" list or the "cc" list.
        // We need to do this in order to find out what project the user is
        // referring to.

        // Now, testMail is the function above this one and that's actually
        // doing all the job of checking for permissions and uploading the data
        // in the database and it returns 1 on successful permission checking
        // and 0 otherwise. That's cool because we can count the number of
        // uploaded messages for logging.

        // Please note that this approach also means that if the same destination
        // is specified several times, we'll duplicate the e-mail in the database.
        // Which in turn means that if the mail daemon actually sent this e-mail
        // several times to this recipient we'll square the number of duplicates
        // in the database!

        $old_k=$k;
        
        // Scanning the "to" list
        for ($m=0;$head["to"][$m];$m++)
        {
          $to_array=explode(",",$head["to"][$m]);
          for ($n=0;$n<sizeof($to_array);$n++) //>
          {
            $to=trim($to_array[$n]);
            if ($to) {
              //echo("About to call testMail with to of: $to<br />");
              $k+=testMail($messages[$i],$head,$CRM_user, $to);
            }
          }
        }

        // Scanning the "cc" list
        for ($m=0;$head["cc"][$m];$m++)
        {
          //echo("CC is ".$head["cc"][$m]."<br />");
          $cc_array=explode(",",$head["cc"][$m]);
          for ($n=0;$n<sizeof($cc_array);$n++) //>
          {
            $cc=trim($cc_array[$n]);
            //echo("About to call testMail with cc of: $cc<br />");
            if ($cc) {
              $k+=testMail($messages[$i],$head,$CRM_user, $cc);
            }
          }
        }

        // Ok, now let's try parsing the subject as well. Might get lucky!
        if ($k==$old_k)
        {
          if ($head["subject"]) {
            //echo("About to call testMail with subject<br />");
            $k+=testMail($messages[$i],$head,$CRM_user,$head["subject"][0]);
          }
        }

        // Nope. Let's notify the admin
        if ($k==$old_k)
        {
          mailProblem($messages[$i],"Unable to correctly parse the To/Cc fields, or user doesn't have permissions:\n\nFrom: ".$head["from"][0].
            "\n\nTo and CC fields [serialized - possibly multiple destinations]\nTo: ".serialize($head["to"])."\nCc: ".serialize($head["cc"]));
        }
      }
      else
      {
        $sql="select project from mail_repository where email like \"%$sender%\" and entry_type = 0";
        $result=CRM_run_query($sql);
        if (OPT_fetch_row($result))
        {
          //echo("Trying testmail because of sender match: $sql<br>");
          $k+=testMail($messages[$i],$head,$sender);
        }
        else
        {

          // Ok, nothing else worked - we'll now check for server aliases or mailing lists.

          $old_k=$k;

          // Scanning the "to" list
          for ($m=0;$head["to"][$m];$m++)
          {
            $to_array=explode(",",$head["to"][$m]);
            for ($n=0;$n<sizeof($to_array);$n++) //>
            {
              $to=trim($to_array[$n]);
              if ($to) { 
                //echo("Trying testmail for to=$to<br>");
                $k+=testMail($messages[$i],$head,$sender,$to);
              }
            }
          }

          // Scanning the "cc" list
          for ($m=0;$head["cc"][$m];$m++)
          {
            $cc_array=explode(",",$head["cc"][$m]);
            for ($n=0;$n<sizeof($cc_array);$n++) //>
            {
              $cc=trim($cc_array[$n]);
              if ($cc) {
                //echo("Trying testmail for cc=$cc<br>");
                $k+=testMail($messages[$i],$head,$sender,$cc);
              }
            }
          }

          if ($k==$old_k) {
            // Hummm... this user isn't listed. We'll have to do something
            mailProblem($messages[$i],"Ambiguous destination for e-mail from ".$head["from"][0]);
          }
        }
      }
    }
    $CRM_user=$real_user;
    $CRM_comp=$real_comp;
    $CRM_demo=$real_demo;
    $CRM_guest=$real_guest;
  }

  // This function cleans up the mail directory.
  // Read the comments in opt/include/mail_retrieve.pl for details
  function cleanupMail()
  {
    global $temp_CRM_dir, $CRM_mail_fname;
    $read = Array();
    $dirhandle=opendir($temp_CRM_dir);
    while ($file = readdir($dirhandle)) {
      if ((strpos(" ".$file,"~".$CRM_mail_fname)==1) &&
          (!file_exists("$temp_CRM_dir/".substr($file,1)))) {
          unlink("$temp_CRM_dir/$file");
        }
      }
  }

  // This is the "main" function -- it actually only checks for new
  // e-mail messages. If any, it runs processMail();

  // Our opt mail alias executes the perl in this directory which
  // simply copies the incoming e-mail message to the $temp_CRM_dir
  // directory.

  function checkMail()
  {
    global $temp_CRM_dir, $CRM_mail_fname, $CRM_demo, $CRM_email, $CRM_system_email, $CRM_path;

    if (!get_setting("mail_interface"))
    {
      return(true);
    }
    if ($iab=ignore_user_abort())
    {
      ignore_user_abort(0);
    }
    if (!is_dir($temp_CRM_dir))
    {
      global $CRM_email, $SERVER_NAME;
      $warning[]=wordwrap("[MAIL DIRECTORY ISN'T THERE]\n\nThe OPT system at $SERVER_NAME ".
        "has been assigned to use $temp_CRM_dir as the temporary directory, but this is not ".
        "available anymore. Please be aware that the incoming messages sent to OPT may be lost ".
        "if there's a cleanup cron job which periodically deletes it.");
      if (!@mkdir($temp_CRM_dir,0777))
      {
        $error[]=wordwrap("[CAN'T CREATE MAIL DIRECTORY]\n\nOPT was unable to create the directory. Therefore *no* ".
          "incoming mail can be received by OPT.\n\nIf you don't want to use this feature, simply specify ".
          "a valid directory and remove the OPT alias from your mail server.");
      }
    }
    if ((fileperms($temp_CRM_dir) & 0777)!=0777)
    {
      $warning[].=wordwrap("[MAIL DIRECTORY PERMISSIONS]\n\nThe OPT system at $SERVER_NAME ".
        "has been assigned to use $temp_CRM_dir as the temporary directory, but this directory doesn't have full ".
        "write permissions, as they should be for the system to work properly. Both your mail server and your web ".
        "server have to be able to write in this directory, so this can't be solved with ownership. Therefore, ".
        "the best solution is setting this in a temporary location with full write access (the recommended default ".
        "is /tmp/OPT).\n\nYou can provide full write access to this directory by issuing the following from a ".
        "console, running as root:\nchmod -R 777 $temp_CRM_dir");
    }
    if ((sizeOf($warning)) || (sizeOf($error)))
    {
      $warncount=sizeOf($warning);
      $errorcount=sizeOf($error);
      if ($warncount)
      {
        $msg.="The OPT system has issued $warncount warning(s):\n\n";
        for ($i=0;$i<$warncount;$i++) //>
        {
          $msg.="Warning #".($i+1)."\n----------------\n".$warning[$i]."\n----------------\n\n";
        }
      }
      if ($errorcount)
      {
        $msg.="Additionally, the OPT system has issued $errorcount error(s):\n\n";
        for ($i=0;$i<$errorcount;$i++) //>
        {
          $msg.="Error #".($i+1)."\n----------------\n".$error[$i]."\n----------------\n\n";
        }
      }
      $msg.=wordwrap("[ADDITIONAL DATA]\n\nYou may change the temporary directory by specifying ".
        "a different directory for OPT to use in both $CRM_path/include/mail_retrieve.pl and $CRM_path/include/OPT_lib.php - ".
        "look for the line defining \$temp_CRM_dir.");
      if (!OPT_mail($CRM_email,"OPT e-mail problems",$msg,"From: OPT <$CRM_system_email>"))
      {
        OPT_error("[MAIL SYSTEM PROBLEMS]<br>This message should have been sent via e-mail but that failed,
          so please forward this error message to the administrator of this system! Thank you and we apologize
          for the inconvenience.\n<p>".nl2br($msg));
      }
      if ($errorcount)
      {
        return(false);
      }
    }
    $CDMO=$CRM_demo;
    $CRM_demo=0;
    cleanupMail();
    $tot_messages = Array();
    $dirhandle=opendir($temp_CRM_dir);
    while ($file = readdir($dirhandle)) {
      if ((strpos(" ".$file,$CRM_mail_fname)==1) &&
          (!file_exists("$temp_CRM_dir/~$file")) &&
          (!file_exists("$temp_CRM_dir/!$file"))) {
        $messages[] = $file;
      }
    }

    if ($messages)
    {
      global $OPT_col_lt;
      if (is_admin())
      {
        echo("<SCRIPT LANGUAGE='JavaScript1.1' type='text/javascript'><!--\n");
        echo("var emailWin;\nemailWin=window.open('','_blank','width=300,height=100,status=no,toolbar=no,menubar=no,location=no,resizable=no,titlebar=no,scrollbars=no,fullscreen=no,top=2,left=2');\n");
        echo("emailWin.document.write('<HEAD><TITLE>OPT Message window</TITLE>".$_OPT["head_xtra"]."</HEAD>');\n");
        echo("emailWin.document.write('<HTML><BODY bgcolor=\"$OPT_col_lt\"><CENTER><BIG><B>Parsing ".sizeOf($messages)." e-mail message(s)</B></BIG></CENTER></BODY></HTML>');\n");
        echo("function closeEmailWin() {\n emailWin.close();\n}\n");
        echo("//--></script>\n");
        flush();
      }
      processMail($messages);
      if (is_admin())
      {
        echo("<SCRIPT LANGUAGE='JavaScript1.1' type='text/javascript'><!--\n");
        echo("timer=setTimeout('closeEmailWin()',1);\n");
        echo("//--></script>\n");
      }
    }
    
    $CRM_demo=$CDMO;
    ignore_user_abort($iab);
    return(true);
  }
?>
