<?
#
# General use library
#
# All functions
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# unless speficied otherwise
# Revision 1.0

  // System colors
  $OPT_col_lt="#eeeefc";
  $OPT_col_md="#e0e0f1";
  $OPT_col_dk="#cacade";
  $OPT_col_dk_dk="#c0c0d5";
  $OPT_col_attention="#ff0000";
  $OPT_col_dimmed="#606070";
  $OPT_col_bg="#ffffff";

  // System icons
  $OPT_icon_new="new.gif";
  $OPT_icon_att="attachment.gif";
  $OPT_icon_plus="plus.jpg";
  $OPT_icons["header"]["arrow_up"]="header_icons/arrow_up.png";
  $OPT_icons["header"]["arrow_down"]="header_icons/arrow_down.png";
  $OPT_icons["header"]["plus"]="header_icons/plus.png";
  $OPT_icons["header"]["minus"]="header_icons/minus.png";
  $OPT_icons["header"]["figures"][1]="header_icons/1.png";
  $OPT_icons["header"]["figures"][2]="header_icons/2.png";
  $OPT_icons["header"]["figures"][3]="header_icons/3.png";
  $OPT_icons["header"]["figures"][4]="header_icons/4.png";
  $OPT_icons["header"]["figures"][5]="header_icons/5.png";
  $OPT_icons["header"]["figures"][6]="header_icons/6.png";

  // Printer-friendly settings
  if ($pf) {
    $OPT_col_lt="#ffffff";
    $OPT_col_md="#ffffff";
    $OPT_col_dk="#ffffff";
    $OPT_col_dk_dk="#000000";
    $OPT_col_attention="#000000";
    $OPT_col_dimmed="#000000";
    $OPT_col_bg="#ffffff";

    $OPT_icon_new="new_p.gif";
  }

  function get_site_name()
  {
    global $OPT_sitename;

    $OPT_sitename=get_setting("opt_sitename");
    if (!$OPT_sitename) {
      $OPT_sitename="Outreach Project Tool";
    }
  }

  // Echoes the confirmation messages (such as "Request successfully created")
  function OPT_confirm($message) {
    echo("<div class=\"small\" align=\"center\"><b>$message</b></div>\n");
  }

  // Echoes error messages (such as "Unable to send e-mail")
  function OPT_error($message) {
    echo("<div class=\"attention\" align=\"center\"><b>$message</b></div>\n");
  }

  // Echoes typical messages (such as "No documents in this project")
  function OPT_message($message) {
    echo("<div class=\"regular\" align=\"center\"><i>$message</i></div>\n");
  }

  // Output a nicely formatted time  
  function makeNiceTime($time)
  {
    if ($time=="")
    {
      $time="00:00:00";
    }
    $timex=explode(":",$time);
    $time=$timex[0].":".$timex[1];
    return($time);
  }

  // Used by niceDate() - this function generates the SQL query for niceDate()
  function niceDateSQL($field,$notime) {
    global $pf, $OPT_tz_diff;
    if ($OPT_tz_diff) {
      $TZfield="if($field=0,0,if($field IS NULL, NULL, DATE_ADD($field,INTERVAL $OPT_tz_diff SECOND)))";
    }

    if ($notime) {
      if (!$pf) {
        return("
          if (year($field)!=year(now()),
            date_format($field,\"%b %d %Y\"),
            if (dayofyear($field)=dayofyear(now()),
              \"Today\",
              date_format($field,\"%b %d\")
            )
          )
        ");
      } else {
        return("date_format($field,\"%b %d %Y\")");
      }
    } else {
      if (!$pf) {
        return("
          if (year($field)!=year(now()),
            date_format($field,\"%b %d %Y\"),
            if (dayofyear($field)=dayofyear(now()),
              date_format($field,\"%H:%i\"),
              date_format($field,\"%b %d, %H:%i\")
            )
          )
        ");
      } else {
        return("date_format($field,\"%b %d %Y, %H:%i\")");
      }
    }
  }

  // Returns a nicely formatted date. works the same as getvalue, but
  // it expects the field (list) to be of type timestamp.
  // If the fourth parameter is specified, it won't return the time
  // component of the date - useful for deadline reports
  function niceDate($table,$value,$id,$notime=0,$ifnull="n/a") {
    if (is_array($value)) {
      for ($i=0;$i<(sizeof($value)-1);$i++) { //>
        $values[]=niceDateSQL($value[$i],$notime);
      }
    } else {
      $values=niceDateSQL($value,$notime);
    }
    return(getvalue($table,$values,$id,$ifnull));
  }

  // Convert a number of bytes in a human-friendly size
  // If the second parameter is set, the function will return
  // "0 bytes" if $asize is undefined. Otherwise it returns "&nbsp;"
  function niceSize($asize,$force=0) {
    if (!$asize) {
      if ($force) {
        $asize=0;
      } else {
        return("&nbsp;");
      }
    }
    $atype="bytes";
    if ($asize>1024) {
      $asize=$asize/1024;
      $atype="KB";
    }
    if ($asize>1024) {
      $asize=$asize/1024;
      $atype="MB";
    }
    if ($asize>1024) {
      $asize=$asize/1024;
      $atype="GB";
    }
    if ($asize>1024) {
      $asize=$asize/1024;
      $atype="TB";
    }
    if ($atype!="bytes") {
      $asize=round($asize*100)/100;
    }
    elseif ($asize==1) {
      $atype="byte";
    }
    return("$asize $atype");
  }

  function build_number_options($start, $end, $name, $checked_val="x", $addempty=0)
  {
    if ($end>=$start) {
      echo  "<SELECT NAME=\"".$name. "\">\n";
      if ($checked_val!="x") {
        $selected="";
      } else {
        $selected="selected";
      }
      if ($addempty) {
        echo  "<OPTION NAME=\"empty\" VALUE=\"\" $selected></OPTION>\n";
      }
      for ($i=$start;$i<=$end;$i++) { // >
        if ($i==$checked_val) {
          $selected="SELECTED";
        } else {
          $selected="";
        }
        echo("<OPTION VALUE=\"$i\" $selected>$i</OPTION>\n");
      }
      echo("</SELECT>\n");
    }
  }

  // This function was inserted here by Irina Nikitina <irina@lanifex.com> but I don't
  // know if she wrote it.
  function build_select_box ($result, $name, $checked_val= "xzxz")
  {
    /*
      Takes a result set, with the first column being the "id" or value
      and the second column being the text you want displayed

      The second parameter is the name you want assigned to this form element

      The third parameter is optional. Pass the value of the item that should be checked
    */

    $rows=OPT_num_rows($result);
    echo("<SELECT NAME=\"$name\">");
    for ($i=0; $i<$rows; $i++) { //>
      echo("\n  <OPTION VALUE=\"".OPT_result($result,$i,0)."\""); //>
      if (OPT_result($result,$i,0) == $checked_val) {
        echo(" SELECTED");
      }
      echo(">".OPT_result($result,$i,1)."</OPTION>");
    }
    echo("\n</SELECT>\n");
  }

  // This function was inserted here by Irina Nikitina <irina@lanifex.com> but I don't
  // know if she wrote it.
  function build_empty_select_box ($result, $name, $checked_val= "xzxz",$size="auto") {
    /*
      Takes a result set, with the first column being the "id" or value
      and the second column being the text you want displayed

      The second parameter is the name you want assigned to this form element

      The third parameter is optional. Pass the value of the item that should be checked
    */

    $rows=OPT_num_rows($result);
    echo("<SELECT NAME=\"".$name."\""); //>
    if ($size !="auto") {
      echo("style=\"width: $size mm\"");
    }
    echo(">\n");
    if ($checked_val!="xzxz") {
      $selected="";
    } else {
      $selected="selected";
    }
    echo("  <OPTION NAME=\"empty\" VALUE=\"\" $selected></OPTION>\n"); //>
    for ($i=0; $i<$rows; $i++) { //>
      echo("  <OPTION VALUE=\"".OPT_result($result,$i,0). "\""); // >
      if (OPT_result($result,$i,0) == $checked_val) {
        echo(" SELECTED");
      }
      echo(">".OPT_result($result,$i,1)."</OPTION>\n");
    }
    echo("\n</SELECT>\n");
  }

  // This function was inserted here by Irina Nikitina <irina@lanifex.com> but I don't
  // know if she wrote it.
  function create_options($table, $field, $selected="") {
    $sql="select $field, id from $table order by $field";
    $result=crm_run_query($sql);
    while ($myrow=OPT_fetch_row($result)) {
      echo "<option "; // >
      if ($myrow[1]==$selected) {
        echo "selected ";
      }
      echo "value='$myrow[1]'>".$myrow[0]."</option>";
    }
  }

  // This function echoes the BODY HTML tag for the main window
  // I requested the images path to be passed for future development - it's of no use right now.
  // onLoadJSCode = JS code that will be put in the onLoad attribute of the BODY tag, if present
  function mainBody($images_path,$onLoadJSCode="") {
    global $OPT_col_bg, $pf;
    if ($pf)
    {     
        $onLoadJSCode="javascript:window.print();".$onLoadJSCode;
    }
    echo("<BODY bgcolor=\"$OPT_col_bg\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\" ".($onLoadJSCode?"onLoad=\"$onLoadJSCode\"":"").">\n");
    if ($pf) {
      global $CRM_ver, $CRM_subver, $proj;
      if ($proj) {
        $prj=" while working on project &quot;".getvalue("projects","name",$proj)."&quot;";
      }
      echo("<div class='small' align='center'>\n");
      list($now)=OPT_fetch_row(crm_run_query("select ".niceDateSQL("now()",0)));
      echo("Generated by OPT $CRM_ver $CRM_subver on $now$prj.\n");
      echo("</div>\n");
    }
  }

  // This function echoes the title bar for the main window
  function make_main_title($title,$images_path,$subtitle="",$subtitle_height=0) {
    global $pf, $CRM_URL, $SERVER_NAME;
    if (!$pf) {
      echo("<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n");
      echo("<tr>\n");
      echo("<td background=\"$images_path/left_title_bg.gif\" align='center' noWrap>");
      ?><script language='JavaScript'>
      if (parent.frames.length>1) {
        document.write("<a href='http://<? echo $SERVER_NAME.$CRM_URL; ?>?URL="+escape(location.href)+"' target='_blank'>");
        document.write("<img src='<? echo $images_path; ?>/Local_URL.gif' height='33' border='0'></a>");
      } else {
        document.write("<img src='<? echo $images_path; ?>/spacer.gif' height='33'>");
      }
      </script><?
      echo("</td>\n");
      echo("<td width=\"100%\" class=\"ah2\" background=\"$images_path/left_title_bg.gif\" align=\"center\" valign=\"middle\" noWrap>$title</td>\n");
      if (!$subtitle_height) {
        echo("<td rowspan=\"2\" noWrap><img src=\"$images_path/main_title_end.gif\" height=\"53\"></td>\n");
        echo("</tr>\n");
        echo("<tr>\n");
        echo("<td background=\"$images_path/main_under_title_bg.gif\" noWrap><img src=\"$images_path/spacer.gif\"></td>\n");
        echo("<td background=\"$images_path/main_under_title_bg.gif\" noWrap><img src=\"$images_path/spacer.gif\" height=\"20\"></td>\n");
        echo("</tr></table>\n");
      }
    } else {
      echo("<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n");
      echo("<tr>\n");
      echo("<td><img src=\"$images_path/spacer.gif\" height=\"10\"></td>\n");
      echo("</tr>\n");
      echo("<tr>\n");
      echo("<td width=\"100%\" class=\"ph2\" align=\"center\" valign=\"middle\" noWrap>$title</td>\n");
      if (!$subtitle_height) {
        echo("</tr>\n");
        echo("<tr>\n");
        echo("<td><img src=\"$images_path/spacer.gif\" height=\"20\"></td>\n");
        echo("</tr></table>\n");
      }
    }
  }

  // This function echoes the BODY HTML tag for the menu window
  function leftBody($images_path) {
    echo("<BODY background=\"$images_path/left_bg.gif\" leftmargin=\"0\" topmargin=\"0\" marginwidth=\"0\" marginheight=\"0\">\n");
  }

  // This function echoes the title bar for the menu window
  function make_left_title($title,$images_path,$subtitle="",$subtitle_height=0) {
    global $pf;
    if (!$pf) {
      echo("<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n");
      echo("<tr>\n");
      echo("<td background=\"$images_path/left_title_bg.gif\"><img src=\"$images_path/spacer.gif\" height=\"33\"></td>\n");
      echo("<td class=\"ah4\" background=\"$images_path/left_title_bg.gif\" align=\"center\" valign=\"middle\" width=\"100%\" noWrap>$title</td>\n");
      echo("<td background=\"$images_path/left_title_bg.gif\"><img src=\"$images_path/spacer.gif\" height=\"33\"></td>\n");
      echo("</tr>\n");
      if (!$subtitle_height) {
        echo("<tr>\n");
        echo("<td colspan=\"3\" background=\"$images_path/left_under_title_bg.gif\"><img src=\"$images_path/spacer.gif\" height=\"20\"></td>\n");
        echo("</tr></table>\n");
      }
    } else {
      echo("<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\">\n");
      echo("<tr>\n");
      echo("<td><img src=\"$images_path/spacer.gif\" height=\"10\"></td>\n");
      echo("</tr>\n");
      echo("<tr>\n");
      echo("<td class=\"ph4\" align=\"center\" valign=\"middle\" width=\"100%\" noWrap>$title</td>\n");
      echo("</tr>\n");
      if (!$subtitle_height) {
        echo("<tr>\n");
        echo("<td><img src=\"$images_path/spacer.gif\" height=\"20\"></td>\n");
        echo("</tr></table>\n");
      }
    }
  }

  // So, it finally happened! You grew so tired of me that you started searching
  // for me in the whole system. Ok, here I am. Go on, don't be ashamed,
  // delete a poor harmless function in the prime of its life!
  function cancelDel() {
    srand((double) microtime() * 1000000);
    if (rand(0,100)>10) {
      return(false);
    }
    $line[]="Whew! That was close!";
    $line[]="Should've done it!";
    $line[]="Undecided...?";
    $line[]="Don't let it go next time!";
    $line[]="Was that the important report you worked all night for?";
    echo($line[rand(0,sizeOf($line)-1)]."<br>\n");
  }

  // Ok, if you wonder why we need so many tables, the answer is "simple":
  // We need two tables because we want to achieve the nice plain border with
  // a controllable color, as opposite to HTML's default ugly border thing.
  // So we embed the actual table into another "background" table which sets
  // the border color we see through the gaps between the table's cells. These
  // are the two inner tables (the second and third defined here - notice the
  // "cellspacing=1" in the third table).
  // The third, external table is needed by Netscape 4.x which is unpredictable with
  // tables on pixel-level when we set the outer table's width to a percentage value
  // (90% in our case). So we had to add another "wrapper" table (the first defined
  // here) which only sets the width for rendering the inner ones.
  function startTables($width="96%") {
    global $OPT_col_dk_dk, $pf;
    echo("<div class='regular' align='center'>\n");
    echo("<table width='$width' border='0' cellspacing='0' cellpadding='0'><tr><td>\n");
    echo("<table width='100%' border='0' cellspacing='0' cellpadding='0' bgcolor='$OPT_col_dk_dk'><tr><td>\n");
    if (!$pf) {
      echo("<table width='100%' border='0' cellspacing='1' cellpadding='2'>\n");
    } else {
      // This isn't nice but it seems that IE doesn't render the gaps for print so...
      echo("<table width='100%' border='1' cellspacing='0' cellpadding='2'>\n");
    }
  }

  function endTables() {
    echo("</table>\n");
    echo("</td></tr></table>\n");
    echo("</td></tr></table>\n");
    echo("</div>\n");
  }

?>
