<?php
/*
 * $Horde: chora/config/cvsroots.php.dist,v 1.4.2.3 2002/06/23 13:45:32 jan Exp $
 *
 * This file contains all the configuration information for the various
 * CVS repositories that you wish to display.  You should have a minimum of
 * one entry here!  The following fields are allowed in the description,
 * and those with a [M] are Mandatory, and should not be left out.
 *
 * 'name'     [M] : Short name for the repository
 *
 * 'location' [M] : Location on the filesystem of the CVSROOT
 * 
 * 'title'    [M] : Long title for the repository
 *
 * 'default'      : To make that repository the default one to show
 *
 * 'intro'        : File which contains some introductory text to show
 *                  on the front page of this repository.  This file is
 *                  located in the config/ directory.
 *
 * 'cvsusers'     : A list of all committers with real names and email
 *                  addresses, that normally sits in the CVSROOT/cvsusers
 *                  file.  If it is found, then more useful information
 *                  will be shown.
 *
 * 'restrictions' : Array of perl-style regular expressions for those files
 *                  whose contents should be protected and not displayed.
 * 
 * 'root_dir'     : Typically '/', but can specify access is allowed only 
 *                  to particular sub-trees. 
 */



// This file is generated dynamically on a per project basis by OPT now
// User only specifies a single CVSROOT to work with at a time.
if ($rep && $proj)
{
    $sql = "select name, title, location, cvsusers, root_dir, restrictions from code_repositories
        where project = $proj and id = $rep";
    $result = crm_run_query($sql);
    if (OPT_num_rows($result) == 1)
    {
        $row = OPT_fetch_row($result);
        $cvsroot = array(
            'name' => $row[0],
            'title' => $row[1],
            'location' => $row[2],
            'root_dir' => $row[4]);
    }
    
    // Add cvsusers field if provided
    if (strlen($row[3]))
    {
        $cvsroot['cvsusers'] = $row[3];
    }

    // Add restrictions field if provided
    if (strlen($row[5]))
    {
        $cvsroot['restrictions'] = array($row[5]);
    }
    $cvsroots[$row[0]] = $cvsroot;
}

//print_r($cvsroots);