<?php
/*
* Session Management for PHP3
*
* Copyright (c) 1998,1999 SH Online Dienst GmbH
*                    Boris Erdmann, Kristian Koehntopp
*
* $Id: local.inc,v 1.1.1.1 2002/08/15 20:42:12 b_stancescu Exp $
*
*/

class DB_OPT extends OPTDB_Sql {
  var $Host;
  var $Database;
  var $User;
  var $Password;

  function DB_OPT()
  {
    global $CRM_db_host, $CRM_db_db, $CRM_db_uname, $CRM_db_pwd;
    $this->Host     = $CRM_db_host;
    $this->Database = $CRM_db_db;
    $this->User     = $CRM_db_uname;
    $this->Password = $CRM_db_pwd;
  }
}

class OPT_CT_Sql extends OPTCT_Sql {
  var $database_class = "DB_OPT";          ## Which database to connect...
  var $database_table = "active_sessions"; ## and find our session data in this table.
}

class OPT_Session extends OPTSession {
  var $classname = "OPT_Session";

  var $cookiename     = "";                ## defaults to classname
  var $magic          = "Hocuspocus";      ## ID seed
  var $mode           = "cookie";          ## We propagate session IDs with cookies
  var $fallback_mode  = "get";
  var $lifetime       = 0;                 ## 0 = do session cookies, else minutes
  var $that_class     = "OPT_CT_Sql"; ## name of data storage container
  var $gc_probability = 5;
}

class OPT_User extends OPTUser {
  var $classname = "OPT_User";

  var $magic          = "Abracadabra";     ## ID seed
  var $that_class     = "OPT_CT_Sql"; ## data storage container
}

class OPT_Auth extends OPTAuth {
  var $classname      = "OPT_Auth";

  var $nobody = true;

  var $lifetime       =  15;

  var $database_class = "DB_OPT";
  var $database_table = "people";

  function auth_loginform() {
    global $sess;
    global $_PHPOPTLIB;

    include($_PHPOPTLIB["libdir"] . "crm_login.ihtml");
  }

  function auth_validatelogin() {
    global $username, $password;

    if(isset($username)) {
      $this->auth["uname"]=$username;        ## This provides access for "crm_login.ihtml"
    }


    $uid = false;
    // First bit of status is "active";
    // Secong bit of status is "*not* allowed to log in".
    $this->db->query(sprintf("select id, 'admin' as perms, company".
                            "        from %s ".
                            "       where uname = \"%s\" ".
                            "         and pwd = \"%s\" ".
                            "         and (status & 1) = 1".
                            "         and (status & 2) = 0",
                          $this->database_table,
                          OPT_gpc_slashes($username),
                          md5(OPT_gpc_slashes($password))));

    while($this->db->next_record()) {
      $uid = $this->db->f("id");
      $this->auth["perm"] = $this->db->f("perms");
    }
    return $uid;
  }
}

class OPT_Perm extends OPTPerm {
  var $classname = "OPT_Perm";

  var $permissions = array(
                            "user"       => 1,
                            "author"     => 2,
                            "editor"     => 4,
                            "supervisor" => 8,
                            "admin"      => 16
                          );

  function perm_invalid($does_have, $must_have) {
    global $perm, $auth, $sess;
    global $_PHPOPTLIB;

    include($_PHPOPTLIB["libdir"] . "crm_perminvalid.ihtml");
  }
}

?>
