<?
#
# Knowledge server - the code for nodes
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  include("../../include/OPT_lib.php");
  include("$CRM_inc/HTTP_lib.php");

  /*
  A few clarifications:

  The status field in the is made of three characters. The first is the action the
  node is requesting other servers to perform on that server. The second is
  the last known status of the server. The third is the originator of the current setting.

  Their possible values and meanings are listed below:

  ACTION
  ------
  A - Add this server to your database
      This means your server should add this as a server that may be searched for
      knowledge entries whenever a user asks for an external search.
  D - Delete this server from your database
      This server is no longer active. Delete it and don't try searching for it
      in the future.
  I - Ignore entries from this server, but let it search on yours. This will
      occur on servers installed by prankers who try to add stupid entries.
  F - Forbid access to this server
      This is rather drastic. Your server should not even allow access to this
      server for search. This will probably be very rare, but might happen
      if someone repeatedly bothers people

  STATUS
  ------
  U - This server is known to be Up and running
  D - This server was Down on the last check
  K - This server was down for so long it might've been Killed

  ORIGINATOR
  ----------
  N - The knowledge Node exported this value
  L - The Local server set this value

  */

  function test_result()
  {
    if (mysql_errno())
    {
      global $sql, $url, $CRM_system_email;
      $sent=OPT_mail($CRM_email, "OPT Node Error!",
        wordwrap("There was an error while trying to execute this sql statement:\n\n$sql\n\nError issued by mysql: ".mysql_error().
        "\nThe server trying to connect was $url."),"From: OPT <$CRM_system_email>");
      if ($sent)
      {
        $sent=" The node administrator has been notified about this.";
      }
      else
      {
        $sent=" Unable to notify the administrator about this.";
      }
      $vars[]=array("response","FAILED");
      $vars[]=array("extended","Internal node error.$sent Please try again later. Thank you!");
      sendResponse($vars,"node");
      exit;
    }
  }

  // We must log the incoming request
  $size=138+strlen($SERVER_NAME)+strlen($PHP_SELF); // An approximate of the incoming header size
  if (!is_array($HTTP_POST_VARS))
  {
    echo("You have to specify a request!\n");
    exit;
  }
  while (list($key,$val)=each($HTTP_POST_VARS))
  {
    $size+=strlen($key)+strlen($val)+2;
  }
  OPT_know_log($size,"node","in");

  // First, let's see if we're allowed to talk
  if (!get_setting("know_allow_node"))
  {
    $vars[]=array("response","NO_NODE");
    $vars[]=array("extended","I'm not a node. Sorry!");
    sendResponse($vars,"node");
    exit;
  }

  // Note the "0" at the end of crm_run_query() - preventing crm_run_query from managing errors
  if ($request=="addMe")
  {
    $url=addslashes($url);
    // Is this server already signed up?
    $sql="select id, status from know_node where url=\"$url\"";
    $result=crm_run_query($sql,0);
    test_result();
    $name=addslashes($name);
    $home=addslashes($home);
    $add_sql="insert into know_node set status='AUN', url=\"$url\", name=\"$name\", home=\"$home\"";
    $sql_update=false;
    if ($myrow=OPT_fetch_row($result))
    {
      if ($myrow[1][0]=="D")
      {
        $add_sql="update know_node set status='AUN', name='$name', home='$home' where id=$myrow[0]";
        $sql_update=true;
      }
      else
      {
        $vars[]=array("response","OK");
        $vars[]=array("extended","You are already signed up");
        sendResponse($vars,"node");
        exit;
      }
    }

    // Is this name already used?
    $sql="select id from know_servers where name=\"$name\"";
    $result=crm_run_query($sql,0);
    test_result();
    if ($name && (OPT_num_rows($result)) && !$sql_update)
    {
      $vars[]=array("response","NAME_USED");
      $vars[]=array("extended","The name $name is already in use. Please try another one.");
      sendResponse($vars,"node");
      exit;
    }

    // Ok, now let's see if this server is actually running as a server
    $req=request_to_server($url."know/know_server/server.php","Status",0,"node");
    // First we check that upon connecting it returns a valid response...
    if (!$req[0])
    {
      $url_server=$url;
      if (strpos($url,"//"))
      {
        list($dump,$url_server)=explode("//",$url_server);
      }
      list($url_server)=explode("/",$url_server);
      //echo($req[1]);
      $vars[]=array("response","NOT_WORKING");
      $vars[]=array("extended","Can't connect to $url_server. You might have an error there. Not adding it.");
      sendResponse($vars,"node");
      exit;
    }
    // ...then we check if it's running as a server
    if (!$know_public)
    {
      $url_server=$url;
      if (strpos($url,"//"))
      {
        list($dump,$url_server)=explode("//",$url_server);
      }
      list($url_server)=explode("/",$url_server);
      $vars[]=array("response","NOT_SERVER");
      $vars[]=array("extended","Machine $url_server is not running as a knowledge server. Check global setting know_public. Not adding it.");
      sendResponse($vars,"node");
      exit;
    }

    // Everything seems ok, let's add this server.
    $result=crm_run_query($add_sql,0);
    test_result();
    $vars[]=array("response","OK");
    $vars[]=array("extended","Added");
    sendResponse($vars,"node");
  }
  elseif ($request=="deleteMe")
  {
    $url=addslashes($url);
    // First, let's see it this server is here
    $sql="select id from know_node where url=\"$url\"";
    $result=crm_run_query($sql,0);
    test_result();
    if (!(list($delete)=OPT_fetch_row($result)))
    {
      $vars[]=array("response","FAILED");
      $vars[]=array("extended","You don't exist in my database");
      sendResponse($vars,"node");
      exit;
    }

    // Ok, now we know the id. Let's see its status
    $sql="select status from know_node where id=$delete";
    $result=crm_run_query($sql,0);
    test_result();
    $myrow=OPT_fetch_row($result);
    $status=$myrow[0];
    if ($status[0]=="D")
    {
      $vars[]=array("response","OK");
      $vars[]=array("extended","You were already deleted");
      sendResponse($vars,"node");
      exit;
    }

    // The request is valid, so let's change the status to delete
    $sql="update know_node set status='DKN' where id=$delete";
    $result=crm_run_query($sql,0);
    test_result();
    $vars[]=array("response","OK");
    $vars[]=array("extended","Deleted");
    sendResponse($vars,"node");
  }
  elseif ($request=="getServers")
  {
    $url=addslashes($url);
    $sql="select name, url, status, home from know_node where url!=\"$url\"";
    $result=crm_run_query($sql,0);
    test_result();
    $count=0;
    while($myrow=OPT_fetch_row($result))
    {
      $vars[]=array("names$count",$myrow[0]);
      $vars[]=array("urls$count",$myrow[1]);
      $vars[]=array("statuses$count",$myrow[2]);
      $vars[]=array("homes$count",$myrow[3]);
      $count++;
    }
    $vars[]=array("count",$count);
    $vars[]=array("response","OK");
    $vars[]=array("extended","Sent");
    sendResponse($vars,"node");
  }
  else
  {
    $vars[]=array("response","FAILED");
    $vars[]=array("extended","I don't understand your request (&quot;$request&quot;)");
    sendResponse($vars,"node");
  }
?>
