<?
#
# Knowledge server - the code for serving knowledge entries
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  include("../../include/OPT_lib.php");
  include("$CRM_inc/HTTP_lib.php");

  /*
  A few clarifications:

  The status field in the is made of three characters. The first is the action the
  node is requesting other servers to perform on that server. The second is
  the last known status of the server. The third is the originator of the current setting.

  Their possible values and meanings are listed below:

  ACTION
  ------
  A - Add this server to your database
      This means your server should add this as a server that may be searched for
      knowledge entries whenever a user asks for an external search.
  D - Delete this server from your database
      This server is no longer active. Delete it and don't try searching for it
      in the future.
  I - Ignore entries from this server, but let it search on yours. This will
      occur on servers installed by prankers who want to add stupid entries.
  F - Forbid access to this server
      This is rather drastic. Your server should not even allow access to this
      server for search. This will probably be very rare, but might happen
      if someone repeatedly bothers people

  STATUS
  ------
  U - This server is known to be Up and running
  D - This server was Down on the last check
  K - This server was down for so long it might've been Killed

  ORIGINATOR
  ----------
  N - The knowledge Node exported this value
  L - The Local server set this value

  */

  function test_result()
  {
    if (mysql_errno())
    {
      global $sql, $url, $CRM_system_email;
      $sent=OPT_mail($CRM_email, "OPT Node Error!",
        wordwrap("There was an error while trying to execute this sql statement:\n\n$sql\n\nError issued by mysql: ".mysql_error().
        "\nThe server trying to connect was $url."),"From: OPT <$CRM_system_email>");
      if ($sent)
      {
        $sent=" The node administrator has been notified about this.";
      }
      else
      {
        $sent=" Was unable to notify the administrator about this.";
      }
      $vars[]=array("response","FAILED");
      $vars[]=array("extended","Internal node error.$sent Please try again later. Thank you!");
      sendResponse($vars,"server");
      exit;
    }
  }

  // We must log the incoming request
  $size=138+strlen($SERVER_NAME)+strlen($PHP_SELF); // An approximate of the incoming header size
  while (list($key,$val)=each($HTTP_POST_VARS))
  {
    $size+=strlen($key)+strlen($val)+2;
  }
  OPT_know_log($size,"server","in");

  // First, let's see if we're allowed to talk
  if (!get_setting("know_public"))
  {
    $vars[]=array("response","NOT_ALLOWED");
    $vars[]=array("extended","I'm not allowed to talk. Sorry!");
    sendResponse($vars,"server");
    exit;
  }

  // Now let's see if we're allowed to talk to this guy
  // Should be checked better - this is just a temporary solution
  $sql="select id,url,status from know_servers";
  $result=crm_run_query($sql);
  $allow_access=2;
  while (($myrow=OPT_fetch_row($result)) && ($allow_access==2))
  {
    $server_url=$myrow[1];
    if (strpos($sever_url,"//"))
    {
      list($dump,$server_url)=explode("//",$server_url);
    }
    list($server_url)=explode("/",$server_url);
    if (gethostbyaddr($REMOTE_ADDR)==$server_url)
    {
      if ($status[0]=="F")
      {
        $allow_access=0;
      }
      else
      {
        $allow_access=1;
      }
    }
  }
  if (($allow_access==2) && (get_setting("know_forbid_unknown")))
  {
    $allow_access=0;
  }
  if (!$allow_access)
  {
    $vars[]=array("response","NOT_ALLOWED");
    $vars[]=array("extended","I'm not allowed to talk to you. Sorry!");
    sendResponse($vars,"server");
    exit;
  }

  // Now we get to do the real job, based on the request:
  if ($request=="Search")
  {
    if ($thorough=="thorough")
    {
      $what="concat(entry,title,keywords)";
    }
    else
    {
      $what="keywords";
    }

    $query_array=explode(" ",OPT_gpc_slashes($query));
    $where="(";
    for ($i=0;$i<sizeOf($query_array);$i++) //>
    {
      $where.="$what like \"%$query_array[$i]%\" and ";
    }
    $where=substr($where,0,-4).")";

    $sql="select * from know where (flags & 1)=1 and $where";
    // Ok, now read the $sql definition above: "select * from nowhere [bla-bla]" :-)
    $result=crm_run_query($sql,0);
    test_result();
    $count=0;
    if ($myrow["server"])
    {
      $original=0;
    }
    else
    {
      $original=1;
    }
    while ($myrow=OPT_fetch_array($result))
    {
      $vars[]=array("uid$count",$myrow["uid"]);
      $vars[]=array("original$count",$original);
      $count++;
    }
    $vars[]=array("count",$count);
    $vars[]=array("response","OK");
    $vars[]=array("extended","You've been sent the results");
    sendResponse($vars,"server");
  }
  elseif (($request=="Retrieve") || ($request=="FullRetrieve") || ($request=="Import"))
  {
    $sql="select * from know where uid='$uid' and (flags & 1)=1";
    $result=crm_run_query($sql,0);
    $myrow=OPT_fetch_array($result);
    test_result();
    if (!$myrow)
    {
      $vars[]=array("response","FAILED");
      $vars[]=array("extended","Entry $uid not found");
      sendResponse($vars,"server");
      exit;
    }
    if ($myrow["src"])
    {
      $src[]="fname";
      $src[]="lname";
      $src[]="email";
      $author=getvalue("people",$src,$myrow["src"]);
      $authorname="$author[0] $author[1]";
      $authormail=$author[2];
      $original=1;
    }
    else
    {
      $authorname=$myrow["authorname"];
      $authormail=$myrow["authormail"];
      $original=0;
    }
    $vars[]=array("authorname",$authorname);
    $vars[]=array("authormail",$authormail);
    $vars[]=array("title",$myrow["title"]);
    $vars[]=array("date",$myrow["date"]);
    $vars[]=array("original",$original);
    if (($request=="FullRetrieve") || ($request=="Import"))
    {
      $vars[]=array("entry",$myrow["entry"]);
      $vars[]=array("keywords",$myrow["keywords"]);
    }
    $vars[]=array("response","OK");
    $vars[]=array("extended","You've been sent the results");
    sendResponse($vars,"server");
    if ($request=="Import")
    {
      $sql="update know set date=date, imported=imported+1 where id=".$myrow["id"];
      crm_run_query($sql);
    }
  }
  elseif ($request=="RetrieveComments")
  {
    $sql="select * from know where uid='$uid' and (flags & 1)=1";
    $result=crm_run_query($sql,0);
    $myrow=OPT_fetch_array($result);
    test_result();
    if (!$myrow)
    {
      $vars[]=array("response","FAILED");
      $vars[]=array("extended","Entry $uid not found");
      sendResponse($vars,"server");
      exit;
    }
    $know=$myrow["id"];
    $sql="select * from know_answers where know=$know and (flags & 1)=1";
    $result=crm_run_query($sql,0);
    $count=0;
    if ($myrow["server"])
    {
      $original=0;
    }
    else
    {
      $original=1;
    }
    while ($myrow=OPT_fetch_array($result))
    {
      $vars[]=array("uid$count",$myrow["uid"]);
      $vars[]=array("original$count",$original);
      $count++;
    }
    $vars[]=array("count",$count);
    $vars[]=array("response","OK");
    $vars[]=array("extended","You've been sent the results");
    sendResponse($vars,"server");
  }
  elseif (($request=="RetrieveFullComment") || ($request=="ImportComment"))
  {
    $sql="select * from know_answers where uid='$uid' and (flags & 1)=1";
    $result=crm_run_query($sql,0);
    $myrow=OPT_fetch_array($result);
    test_result();
    if (!$myrow)
    {
      $vars[]=array("response","FAILED");
      $vars[]=array("extended","Comment $uid not found");
      sendResponse($vars,"server");
      exit;
    }
    if ($myrow["src"])
    {
      $src[]="fname";
      $src[]="lname";
      $src[]="email";
      $author=getvalue("people",$src,$myrow["src"]);
      $authorname="$author[0] $author[1]";
      $authormail=$author[2];
    }
    else
    {
      $authorname=$myrow["authorname"];
      $authormail=$myrow["authormail"];
    }
    $vars[]=array("authorname",$authorname);
    $vars[]=array("authormail",$authormail);
    $vars[]=array("comment",$myrow["comment"]);
    $vars[]=array("date",$myrow["date"]);
    $vars[]=array("response","OK");
    $vars[]=array("extended","You've been sent the results");
    sendResponse($vars,"server");
    if ($request=="ImportComment")
    {
      $sql="update know_answers set date=date, imported=imported+1 where id=".$myrow["id"];
      crm_run_query($sql);
    }
  }
  elseif ($request=="Status")
  {
    $vars[]=array("response","OK");
    $vars[]=array("extended","Running as a public server");
    $vars[]=array("know_allow_node",get_setting("know_allow_node"));
    $vars[]=array("know_public",get_setting("know_public"));
    $vars[]=array("know_allow_external",get_setting("know_allow_external"));
    $vars[]=array("know_server_name",get_setting("know_setver_name"));
    sendResponse($vars,"server");
  }
  else
  {
    $vars[]=array("response","FAILED");
    $vars[]=array("extended","I don't understand your request (&quot;$request&quot;)");
    sendResponse($vars,"server");
  }
?>
