<?
  // about this id:
  // when installing the meeting module, there is an insert that gets executed in the companies table
  // with the "Guest" company
  // the install (OPTUM) should get the inserted_id and store it in this file
  // for it is necessary in order to add users on the fly, while in the meeting
  $OPT_meeting_guest_company_id=get_setting("guest_comp");

  // So it's critical that we check if this has been properly initialized:
  if ((!$OPT_meeting_guest_company_id) && (basename($PHP_SELF)!="leftMenu.php")) {
    if ($guest_id) {
      if ($guest_id=="NEW") {
        $guest_id=OPT_get_ID("companies");
        OPT_run_query("insert into companies set id=$guest_id, shortname=\"Guest\", name=\"Guest Company\", status=1");
      }
      OPT_run_query("delete from settings where name=\"guest_comp\"");
      OPT_run_query("insert into settings set name=\"guest_comp\", value=\"$guest_id\", default_val=\"$guest_id\"");
    } else {
      ?>
      <!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
      <HTML>
      <HEAD>
      <TITLE>No Guest Company</TITLE>
      <LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
      <? echo $_OPT["head_xtra"]; ?>
      </HEAD>
      <?
      mainBody("../images");
      make_main_title("Guest Company Setting Problem","../images");
      OPT_message("Your OPT system misses the guest company setting.");
      OPT_message("This is where temporary users are stored. Please select one of the ".
        "companies below for this purpose or click on \"Create New\" below in order to ".
        "create a new one:");
      $sql="select id, shortname from companies";
      $result=OPT_run_query($sql);
      while ($myrow=OPT_fetch_row($result)) {
        $id=$myrow[0];
        $name=$myrow[1];
        OPT_message("<a href=\"$PHP_SELF?guest_id=$id\">$name</a>");
      }
      OPT_message("<a href=\"$PHP_SELF?guest_id=NEW\"><b>Create New</b></a>");
      exit;
    }
  }

  $OPT_meeting_max_option_length=20;

  //transforms "DD/MM/(YY)YY" to "(YY)YY-MM-DD"
  // parameter: the date as string
  function dateFrench2Mysql($date){
    $ret=preg_replace("/^(\d{2})\/(\d{2})\/(19|20)(\d{2})$/","\\3\\4-\\2-\\1",$date);
    return $ret;
  }

  // creates unique initials (i.e. not found in @others array) from $firstname and $lastname
  function createInitials($firstname,$lastname,$others){
    $i=1;$j=1;
    $minlen=min(strlen($firstname),strlen($lastname));
    while ((in_array(substr($firstname,0,$j).substr($lastname,0,$i),$others))&&($i<$minlen)){
      if ($i>$j){ $j++;}
         else{ $i++; };

    }
    return substr($firstname,0,$j).substr($lastname,0,$i);
  }

  // if $string is longer than a $size, adds '...' after it, and chops it to the good size
  function chopString($string,$size)
  {
    $string=chop($string);
    if (strlen($string)<=$size) return $string;
       else return substr($string,0,$size-3)."...";
  }


  // creates option list with sections of $meeting (truncated after $textLength chars)
  // with section names as text and sections id's as values
  // and with $selected section select
  function createSectionsOptions($meeting,$selected,$textLength){
    $ret="";

    $prevSection=0;
    $moreSections=1;

    while ($moreSections){
      $sql="select id, title from meetingsection where meeting=$meeting and after=$prevSection";
      $result=crm_run_query($sql);
      if (OPT_num_rows($result)){
        // found a section.
        // Displaying it
        list($id,$title)=OPT_fetch_row($result);
        $ret.="<option value='$id' ".(($id==$selected)?"selected":"").">".chopString($title,$textLength)."</option>";
        $prevSection=$id;
      }else{
        $moreSections=0;
      }
    }
    return $ret;
  }

  // function that retrieves all present serializers in seralizers/ dir.
  // thse serializers must be named "*seralizer.class.php" (case is important)
  function getSerializers(){
    $temp=array();
    $d=dir("serializers/");
    while ($entry=$d->read()){
      if ($pos=strpos($entry,"serializer.class.php")){
        $temp[]=substr($entry,0,$pos);
      }
    }
    return $temp;
  }
?>
