<?
  include ("$CRM_path/meeting/fpdf/fpdf.php");

  include ("$CRM_path/meeting/serializers/Serializer.class.php");
  class PDFserializer extends MeetingSerializer{
    var $fpdf;

    function PDFserializer(){
      //constructor
      $this->fpdf=new FPDF();
      $this->fpdf->Open();
      $this->fpdf->SetFont('Arial','B',18);
      $this->fpdf->SetMargins(20,20);      //2 cm margins
      $this->fpdf->AddPage();
    }

    function mime(){
      // must return mime type of the document
      return "application/pdf";
    }

    function extension(){
      // must return default extension of the document
      return "pdf";
    }

    function documentStart($topic){
      // produces the header of the serialized document
      // date - the date of the meeting
      $this->fpdf->Cell(170,9,"$topic",0,1,'L');
      $this->fpdf->Line(20,$this->fpdf->GetY(),190,$this->fpdf->GetY());
      $this->fpdf->Ln(5);
    }

      function personsBody($personStruct, $date){
        // produces the part of the document that describes the persons
        // personStruct - array of array["shortname","name"] of all the participants
        $this->fpdf->SetFontSize(14);
        $this->fpdf->Cell(170,7,"Persons involved                                                               Held: $date",0,1,'L');
        $this->fpdf->SetFont('Arial','',11);
        $startY=$this->fpdf->GetY();
        for ($i=0;$i<count($personStruct)/2;$i++){
          $this->fpdf->Cell(15,5,$personStruct[$i]["shortname"],0,0,'L');
          $this->fpdf->Cell(70,5,$personStruct[$i]["name"],0,1,'L');
        }
        $endY=$this->fpdf->GetY();
        $this->fpdf->SetY($startY);

        for (;$i<count($personStruct);$i++){
          $this->fpdf->Cell(85);
          $this->fpdf->Cell(15,5,$personStruct[$i]["shortname"],0,0,'L');
          $this->fpdf->Cell(70,5,$personStruct[$i]["name"],0,1,'L');
        }
        $this->fpdf->SetY($endY+5); // space left out
      }

      function sectionStart($sectionTitle){
        // starting a section
        // sectionTitle - title of the section
        $this->fpdf->SetFont('Arial','B',14);
        $this->fpdf->Cell(170,6,$sectionTitle,0,1,'L');
        $this->fpdf->Line(20,$this->fpdf->GetY(),190,$this->fpdf->GetY());
        $this->fpdf->Ln(3);
      }

        function paragraphStart($paragraphTitle){
          // starting a paragraph
          // paragraphTitle - title of the paragraph
          $this->fpdf->SetFont('Arial','B',12);
          $this->fpdf->Cell(170,6,$paragraphTitle,0,1,'L');
        }

          function paragraphBody($paragraphText){
            // body of a paragraph
            // paragraphText - text of the paragraph
            $this->fpdf->SetFont('Arial','',10);
            $this->fpdf->MultiCell(170,6,$paragraphText);
          }

          function taskStart(){
            // starting a task section
            $this->fpdf->Ln(3);
            $this->fpdf->SetFont('Arial','B',10);
            $this->fpdf->Cell(5);
            $this->fpdf->Cell(60,5,"Task",1,0,'C');
            $this->fpdf->Cell(50,5,"Members",1,0,'C');
            $this->fpdf->Cell(35,5,"Date",1,0,'C');
            $this->fpdf->Cell(20,5,"Status",1,1,'C');
          }

          function taskBody($taskStruct){
            // produces the part of the document that describes the persons
            // taskStruct - array of array["name","members","date","complete"] of all the tasks of this paragraph
            for ($i=0;$i<count($taskStruct);$i++){
              $startY=$this->fpdf->GetY();
              $this->fpdf->Cell(5);
              $this->fpdf->MultiCell(60,5,$taskStruct[$i]["name"],0,'L');
              $endY=$this->fpdf->GetY();
              $this->fpdf->SetY($startY);
              $this->fpdf->SetX(20+65);   // 20 for the margin
              $this->fpdf->MultiCell(50,5,$taskStruct[$i]["members"],0,'L');
              if ($this->fpdf->GetY()>$endY){
                $endY=$this->fpdf->GetY();
              }
              $this->fpdf->SetY($startY);
              $this->fpdf->SetX(20+115);
              $this->fpdf->Cell(35,5,$taskStruct[$i]["date"],0,'C');
              $this->fpdf->SetY($startY);
              $this->fpdf->SetX(20+150);
              $this->fpdf->Cell(20,5,$taskStruct[$i]["complete"],0,'C');
              $this->fpdf->SetX(20);
              $this->fpdf->Cell(5);
              $this->fpdf->Cell(60,$endY-$startY," ",1,0,'C');
              $this->fpdf->Cell(50,$endY-$startY," ",1,0,'C');
              $this->fpdf->Cell(35,$endY-$startY," ",1,0,'C');
              $this->fpdf->Cell(20,$endY-$startY," ",1,1,'C');
            }
          }

          function taskEnd(){
            // produces the footer of a task section
          }

        function paragraphEnd(){
          // produces the footer of a paragraph
          $this->fpdf->Ln(3);
        }

      function sectionEnd(){
        // produces the footer of a section
        $this->fpdf->Ln(3);
      }

    function documentEnd(){
      // produces the footer of the serialized document
      list($now)=OPT_fetch_row(crm_run_query("select ".niceDateSQL("now()",0)));

      $this->fpdf->SetFontSize(10);
      $this->fpdf->Line(20,$this->fpdf->GetY(),190,$this->fpdf->GetY());
      $this->fpdf->Cell(170,8,"Created on $now by OPT ".$GLOBALS["CRM_ver"].' '.$GLOBALS["CRM_subver"],0,1,'L');
      $this->fpdf->Close();
    }

    function fetch(){
      // returns the serialized document as string
      return $this->fpdf->Output('',false,true);
    }

    function display(){
      // sends the serialized document to the browser
      $this->fpdf->Output();
    }

  }
?>
