<?
  // generic stub serializer for meetings
  class MeetingSerializer {
    // a subclass will have to implement these functions

    function mime(){
      // must return mime type of the document
    }

    function extension(){
      // must return default extension of the document
    }

    function documentStart($date){
      // produces the header of the serialized document
      // date - the date of the meeting
    }

      function personsBody($personStruct){
        // produces the part of the document that describes the persons
        // personStruct - array of array["shortname","name"] of all the participants
      }

      function sectionStart($sectionTitle){
        // starting a section
        // sectionTitle - title of the section
      }

        function paragraphStart($paragraphTitle){
          // starting a paragraph
          // paragraphTitle - title of the paragraph
        }

          function paragraphBody($paragraphText){
            // body of a paragraph
            // paragraphText - text of the paragraph
          }

          function taskStart(){
            // starting a task section
          }

          function taskBody($taskStruct){
            // produces the part of the document that describes the persons
            // taskStruct - array of array["name","members","date","complete"] of all the tasks of this paragraph
          }

          function taskEnd(){
            // produces the footer of a task section
          }

        function paragraphEnd(){
          // produces the footer of a paragraph
        }

      function sectionEnd(){
        // produces the footer of a section
      }

    function documentEnd(){
      // produces the footer of the serialized document
    }

    function fetch(){
      // returns the serialized document as string
    }

    function display(){
      // sends the serialized document to the browser
    }

/*
    the serializer class will be used as follows:

    (please don't use foreach -- use list($something)=each()
    instead for PHP3 compliancy

      documentStart();
      personsBody($personStruct);
      while (each(section)){
        sectionStart($sectionTitle);
        while (each(paragraph)){
          paragraphStart($paragraphTitle);
          paragraphBody($paragraphText);
          taskStart();
          taskBody($taskStruct);
          paragraphEnd();
        }
        sectionEnd();
      }
      documentEnd();

      display() or fetch()
*/
  }
?>
