<?
#
# Newsletter distribution engine
#
# Normally triggered by the OPT entry in crontab at 00:01 every day
# Does a few other jobs too - sends feedback and
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  include("../../include/OPT_lib.php");

  // Since we execute this code daily, why don't we send some feedback on the
  // same occasion?
  include("$CRM_inc/HTTP_lib.php");
  CheckFeedback();
  echo(" ");
  flush();
  set_time_limit(30);

  // Let's also check for feedback if allowed to
  if (!get_setting("disable_upgrade_search"))
  {
    include("$CRM_path/UpgradeManager/upg_lib.php");
    include("$CRM_path/UpgradeManager/xml_lib.php");
    if (($upgrade=FindUpgrades()) && (get_setting("UM_notified")<$upgrade)) //>
    {
      OPT_mail($CRM_email,"OPT Upgrade Available!",wordwrap("The OPT server at http://$SERVER_NAME$CRM_URL ".
      "has version $CRM_ver. A new version of OPT was found, with version $upgrade. You may upgrade OPT ".
      "by logging in via the Admin/Upgrade menu or by using the link below:\n".
      "http://$SERVER_NAME$CRM_URL?URL=UpgradeManager%2F%3Fforceremote%3D1\n\nThe upgrade search is performed once a day, ".
      "triggered by the newsletter distribution cron job. If you want to disable upgrade searching altogether, ".
      "log into OPT and from the Admin/Settings page set the variable disable_upgrade_search to 1."),
      "From: OPT <$CRM_system_email>");
      crm_run_query("delete from settings where name=\"UM_notified\"");
      crm_run_query("insert into settings set name=\"UM_notified\", value=\"$upgrade\"");
    }
  }

  function distribute_newsletter($nl_id)
  {
    // Retrieving the people to send the newsletter to
    $sql="select own_type, owner from nl_list where id=$nl_id";
    $result=crm_run_query($sql);
    if (!$myrow=OPT_fetch_row($result))
    {
      return(false);
    }
    if ($myrow[0]=="company")
    {
      $sql="select fname, lname, email from people where company=$myrow[1]";
      $why="are listed as working for ".getvalue("companies","shortname",$myrow[1]);
    }
    elseif ($myrow[0]=="project")
    {
      $sql="select fname, lname, email from people, people_proj
            where people.id=people_proj.person and people_proj.project=$myrow[1]";
      $why="are involved in the project ".getvalue("projects","name",$myrow[1]);
    }
    $result=crm_run_query($sql);
    while ($myrow=OPT_fetch_row($result))
    {
      $dest[]=array($myrow[0]." ".$myrow[1],$myrow[2]);
    }

    // Finding out what the current issue's number is
    $sql="select max(issue) from nl_issue where nl=$nl_id";
    $result=crm_run_query($sql);
    if ($myrow=OPT_fetch_row($result))
    {
      $issue_no=$myrow[0]+1;
    }
    else
    {
      $issue_no=1;
    }

    // Creating the issue entry in the database
    $issue=OPT_get_ID("nl_issue");
    $sql="insert into nl_issue set id=$issue, nl=$nl_id, issue=$issue_no";
    crm_run_query($sql);

    // Retrieving the articles in the newsletter
    $sql="select title, src, entry, id from nl_entries where nl=$nl_id and sent=0";
    $result=crm_run_query($sql);
    if (!OPT_num_rows($result))
    {
      crm_run_query("delete from nl_issue where id=$issue");
      return(true);
    }
    while ($myrow=OPT_fetch_row($result))
    {
      $titles[]=$myrow[0];
      $entries[]=$myrow[2];
      $person=getvalue("people", array("fname","lname","email"),$myrow[1]);
      $authors[]=$person[0]." ".$person[1];
      $authormails[]="<".$person[2].">";
      crm_run_query("update nl_entries set sent=$issue, date=date where id=$myrow[3]");
    }

    // Creating the newsletter heading
    $nl_name=getvalue("nl_list","name",$nl_id);
    $underline="";
    for ($i=0;$i<strlen("$nl_name");$i++) //>
    {
      $underline.="=";
    }
    $newsletter="\n  $underline\n  $nl_name\n  $underline\n  Issue #$issue_no\n\n";
    global $SERVER_NAME;
    $newsletter.="  Automatically distributed by the OPT system at $SERVER_NAME\n\n";

    // Creating the newsletter contents

    $newsletter.="________________________________ CONTENTS _________________________________\n\n";
    for ($i=0;$i<sizeOf($titles);$i++) // >
    {
      if ($i<9) // >
      {
        $sp="  ";
      }
      elseif ($i<99) // >
      {
        $sp=" ";
      }
      else
      {
        $sp="";
      }
      $newsletter.=$sp.($i+1).". $titles[$i]\n";
    }

    $newsletter.="\n\n";

    // Creating the bulk of the newsletter
    $underline="__________________________________________________________________________";
    for ($i=0;$i<sizeOf($titles);$i++) // >
    {
      // Article no.
      $under_no=substr($underline,0,-1*strlen($i+1));
      $newsletter.="$under_no ".($i+1)."\n\n";

      // Title
      $newsletter.="$titles[$i]\n";
      $newsletter.="by $authors[$i] $authormails[$i]\n\n";
      $newsletter.=wordwrap($entries[$i])."\n\n\n";
    }

    global $CRM_email, $CRM_system_email;
    $newsletter.="***************************************************************************\n\n".
                 wordwrap("This newsletter is automatically generated by the OPT system ".
                 "at $SERVER_NAME. You receive this newsletter because you $why in the OPT system. ".
                 "If you do not wish to receive this newsletter anymore please contact the OPT ".
                 "system administrator at <$CRM_email> and let him/her know of this inconvenience.\n".
                 "Since this is an automated message there's no use replying to this e-mail.")."\n";

    // Finished. Uncomment the following line if you want to see the result in a browser.
    // echo(nl2br(htmlspecialchars($newsletter)));

    // Finally, distributing the newsletter
    $evermadeit=false;
    for ($i=0;$i<sizeOf($dest);$i++) //>
    {
      $madeit=OPT_mail($dest[$i][0]." <".$dest[$i][1].">","$nl_name Newsletter -- Issue #$issue_no",$newsletter,"From: OPT <$CRM_system_email>");
      if ($madeit)
      {
        $evermadeit=true;
      }
    }

    if ($evermadeit)
    {
      crm_run_query("update nl_list set lastsent=now() where id=$nl_id");
    }
    return($evermadeit);
  } // function distribute_newsletter()

  $sql="select id, name, send_type, send_interval, if (lastsent,TO_DAYS(now())-TO_DAYS(lastsent),TO_DAYS(now())-TO_DAYS(date)) from nl_list where active>0";
  $main_result=crm_run_query($sql);
  while ($send_data=OPT_fetch_row($main_result))
  {
    $madeit=true;
    if ($send_data[2]=="entries")
    {
      $sql="select count(*) from nl_entries where nl=$send_data[0] and sent=0";
      $result=crm_run_query($sql);
      list($entry_count)=OPT_fetch_array($result);
      if ($entry_count>=$send_data[3])
      {
        $madeit=distribute_newsletter($send_data[0]);
      }
    }
    elseif ($send_data[2]=="days")
    {
      if ($send_data[4]>=$send_data[3])
      {
        $madeit=distribute_newsletter($send_data[0]);
      }
    }
    else
    {
      crm_run_query("insert into log set entry='Unable to determine when to send newsletter #$send_data[0] ($send_data[1])'");
    }
    if (!$madeit)
    {
      crm_run_query("insert into log set entry='Unable to distribute newsletter #$send_data[0] ($send_data[1])'");
    }
  }
?>
