<?
/*
 * Displays a listing of unresolved or recent requests submitted by a user 
 */ 

include "$CRM_path/tasks/task/task_lib.php";
include "$CRM_path/tasks/calculate_status.inc";

// Just get requests which have tasks due this (or last) week
$sql="select distinct(requests.id), title, priority, status, deadline, aproj, TIME_TO_SEC(initial_estimate)/3600
      from requests, request_submitters where (status <> 2 || resolved_date > (now() - INTERVAL 7 DAY)) and 
      request_submitters.person = $person and request_submitters.request = requests.id
      order by priority asc";
    $result=CRM_run_query($sql);
?>

<?
startTables();
?>

<tr>
<td class="regular" bgcolor="<?echo($OPT_col_md);?>" align="center" colspan="6">
<b>Recent requests you've submitted.</b></td>
</tr>
<tr>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center"><b>ID</b></td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center"><b>Title</b></td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center"><b>Priority</b></td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center"><b>Status</b></td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center"><b>Deadline</b></td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center" nowrap><b>Hours Left</b></td>
</tr>
<? 
$req_counter=0;
while ($req_row=OPT_fetch_row($result))
{
   // Need to get settings from the project for this request
   $proj=$req_row[5];
   $statii=get_project_setting($proj, "request_status_options");
   $extra_statuses=explode("|", $statii); 
   $priorities = get_project_setting($proj, "request_priority");
   if (!$priorities) {
      $priorities=array();
   }
   $priorities = explode("|",$priorities);
?>

<tr>
<td class="regular" bgcolor="<?echo($OPT_col_md);?>" align="center">
<a class="regular" href="<?echo($level);?>/rt/req_view/?proj=<?echo($proj)?>&req=<?echo($req_row[0])?>"><?echo($req_row[0])?></a></td>
<td class="regular" bgcolor="<?echo($OPT_col_md);?>" align="left">
<a class="regular" href="<?echo($level);?>/rt/req_view/?proj=<?echo($proj)?>&req=<?echo($req_row[0])?>"><?echo(stripslashes($req_row[1]))?></a></td>

<td class="regular" align="center" bgcolor="<?echo($OPT_col_md);?>"><?echo($priorities[$req_row[2]])?></td>

<td class="regular" bgcolor="<?echo($OPT_col_md);?>" align="center">
<?
  switch ($req_row[3])
  {
    case 1: echo("Open"); break;
    case 2: echo("<font color='green'>Resolved</font>"); break;
    default: echo($extra_statuses[$req_row[3]-3]);
  }
?>
</td>
<? 
    // Deadline
    $deadline=niceDate("requests","deadline",$req_row[0],1);
    if (!$deadline) {
      $deadline="&nbsp;";
    }
    unset($bold);
    if (getvalue("requests","(deadline<now()) and (status!=2)",$req_row[0])) {
      $bold[]="<strong><font color=\"$OPT_col_attention\">";
      $bold[]="</font></strong>";
    } else {
      $bold[]="";
      $bold[]="";
    }
    echo("  <td class=\"regular\" align=\"center\" bgcolor=\"$OPT_col_md\">$bold[0]$deadline$bold[1]</td>\n");
?>

<?
    // Hours remaining on this request
    $hrs_remaining=$req_row[6];
    if (intval($hrs_remaining) == 0)
    {
        $hrs_remaining="";  // Will be empty string if no tasks and no initial estimate
    }
    else
    {
        $hrs_remaining=sprintf("%.0f", $hrs_remaining);
    }
    $sql="select count(*), sum(TIME_TO_SEC(estimated)/3600 * (100-PercentComplete)/100) from
          task, request2task where request2task.request = $req_row[0] and request2task.task = task.id";
    $task_hrs_res=CRM_run_query($sql);
    $task_hrs_row=OPT_fetch_row($task_hrs_res);
    if ($task_hrs_row[0] > 0)
    {   // This request has tasks associated with it, so use the sum of their time remaining
        $hrs_remaining="<b>".sprintf("%.0f",$task_hrs_row[1])."</b>"; 
        $total_hours+=$task_hrs_row[1];  // add task sum onto total
    }
    else
    {
        $total_hours+=$hrs_remaining;    // add request estimate onto total 
    }
    echo("<td class=\"regular\" bgcolor=$OPT_col_md align='center'>$hrs_remaining</td>\n");
?>

</td>
</tr>
<?
   $req_counter += 1;
}  // end of while loop for requests
?>

<tr>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center">&nbsp;</td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="left"><b>Effort Remaining</b> (Total Hours)</td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center">&nbsp;</td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center">&nbsp;</td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center">&nbsp;</td>
<td class="regular" bgcolor="<?echo($OPT_col_dk);?>" align="center">
<b><?echo(sprintf("%.0f", $total_hours))?></b></td>
</tr>
<?
endTables();
?>
