<?
  if (!(system_perm("people") & 2))
  {
    $contact=getvalue("people","iscontact",$CRM_user);
    if (!$contact)
    {
      make_main_title("Can't create user","../../images");
      OPT_error("Sorry, you don't have permissions to create people!");
      exit;
    }
  }

  if ($CRM_demo)
  {
    make_main_title("Unable to complete", "../../images");
    OPT_error("Sorry, other users can not be created while working in demo mode. You get the idea though...");
    exit;
  }

  // So we slash everything
  $fname=OPT_gpc_slashes($fname);
  $lname=OPT_gpc_slashes($lname);
  $uname=OPT_gpc_slashes($uname);
  if (!$contact)
  {
    $company=OPT_gpc_slashes($company);
  }
  else
  {
    $company=$CRM_comp;
    $iscontact=0; // If you're just a company contact you can't set another person to be the primary contact
  }
  $position=OPT_gpc_slashes($position);
  $sal=OPT_gpc_slashes($sal);
  $email=OPT_gpc_slashes($email);
  $notes=OPT_gpc_slashes($notes);

  // only authorised users are allowed to give logins, 
  if ( !(system_perm("login") & 2)){
  	$allowlogin = 0;
    $uname = "";
    $pwd = "";
    $pwd1 = "";
  }

  if ($allowlogin)
  {
    $unametest=" || (uname=\"$uname\")";    
  }
  else
  {
    $unamelogin="";
  }

  // We check to see the record is unique
  $sql="select id, (status & 1) from people where
    ((fname=\"$fname\") && (lname=\"$lname\")) ||
    (email=\"$email\") $unametest";
  $result=crm_run_query($sql);
  if ($myrow=OPT_fetch_row($result))
  {
    $error=1;
    if ($myrow[1])
    {
      $error_type="dupliname";
    }
    else
    {
      $error_type="dupliname_inactive";
      $inactive_id=$myrow[0];
    }
  }

  // We check to see we have non-null fname, lname, email, uname, pass, company,
  // and that pass1==pass2
  if (
       (!$fname) ||
       (!$lname) ||
       (!$sal) ||
       (
         ($allowlogin) &&
         (
           (!$uname) ||
           (!$pwd) ||
           ($pwd!=$pwd1)
         )
       )
     )
  {
    $error=1;
    $error_type='empty';
  }

  // If the user is assigned to an inactive company, we
  // set their status to inctive, too
  $comp_status=getvalue(companies, status, $company);
  if ($comp_status==0)
  {
    $status=0;
  }

  // An inactive person cannot be set contact for an active company
  if (($comp_status==1) && ($iscontact==1) && ($status==0))
  {
    $error=1;
    $error_type="inactive_contact";
  }

  if ($error)
  {
    if ($error_type=='dupliname')
    {
      make_main_title("User Creation Error","../../images");
      opt_error("Error creating user $fname $lname<br>
          An active user with the same first name and last name,
          the same email or username exists in the system!");
    }
    elseif ($error_type=='empty')
    {
      make_main_title("User Creation Error","../../images");
      opt_error("You have left some fields empty, or you have typed the password
          incorrectly. Please hit your browser's 'Back' button, complete
          the fields and submit again.");
    }
    elseif ($error_type=='dupliname_inactive')
    {
      make_main_title("User Creation Error","../../images");
      opt_error("Error creating user $fname $lname<br>
          A user with the same first name and last name,
          the same email or username exists in the system, but their status is
          set to 'Inactive'. <br>Please click
          <a href='../admin/?action=edit&id=".$inactive_id."'>here</a>
          to edit that person and change their status to 'Active'.");
    }
    elseif ($error_type=='inactive_contact')
    {
      make_main_title("User Creation Error","../../images");
      opt_error("An inactive person cannot be set contact for an active company.<br>
            Please hit your browser's 'Back' button and review your information.");
    }
    exit;
  }
  else
  {
    // There is no error so we (get ready to) insert the new user

    // If another person was set as contact we replace them
    if ($iscontact==1)
    {
        if (!$CRM_demo)
        {
            $demo_sql = "and people.id > 5";
        }
        $sql2="select * from people where company='$company' $demo_sql";
        $result2=crm_run_query($sql2);
        while ($myrow2=OPT_fetch_row($result2))
        {
            if ($myrow2[19]==1)
            {
                // There was a contact set for this company
                $exists_contact=$myrow2[0];
                $sql3="update people set iscontact='0', lastlog=lastlog, prevlog=prevlog where id='$exists_contact'";
                $result3=crm_run_query($sql3);
            }
        }
    }
    $md5pwd=md5($pwd);
    if ($allowlogin)
    {
      $allowlogin=1;      
    }
    else
    {
      $allowlogin=0;
    }
    if ($projadmin)
    {
      $projadmin=1;
      // only people of the root company may be admins in axelogis mode
      if ($secuLevel == AXELOGIS && $company != 1){
		    $projadmin=0;
        opt_confirm("This user doesn't have the rights to be set up as an admin. 
                     This functionnality has been disabled");
	    }
    }
    else
    {
      $projadmin=0;
    }
    if ($notif)
    {
      $notif=1;
    }
    else
    {
      $notif=0;
    }
    $stat="'$status'+2*(1-$allowlogin)+4*(1-$projadmin)+8*(1-$notif)";
    $sql="insert into people set fname='$fname', lname='$lname', uname='$uname',
          pwd='$md5pwd', mphone='$mphone', fax='$fax', wphone='$wphone',
          hphone='$hphone', email='$email', company='$company',
          iscontact='$iscontact', position='$position', sal='$sal', status=$stat,
          prevlog=0, lastlog=0, preflang='$lang', notes='$notes'";
    $result=CRM_run_query($sql);

    make_main_title("User Created","../../images");

    if (($comp_status==0) && (($status & 1)==1))
    {
      $comp_name=getvalue(companies, shortname, $company);
      opt_confirm("Company <a class='regular' href='../../companies/admin/?action=edit_form&id=$company'>".
        $comp_name."</a>; to which you have assigned this user, is inactive.<br>
      The user will not be able to log into the system.");
    }

    if (($comp_status==1) && (($status & 1)==0))
    {
      $sql="select id from people where fname='$fname' and lname='$lname'";
      $result=crm_run_query($sql);
      $myrow=OPT_fetch_row($result);
      $id=$myrow[0];
      opt_confirm("The user was created, and their status was set to inactive.
          This prevents them from logging into the system.<br>
          Click <a class='regular' href='./?action=edit&id=$id'>here</a> if you
          want to edit the user.");
    }
    if ($exists_contact)
    {
      $f_old=getvalue(people, fname, $exists_contact);
      $l_old=getvalue(people, lname, $exists_contact);
      $comp_name=getvalue(companies, shortname, $company);
      opt_confirm("<b>Warning:</b>&nbsp;The user you created replaced ".$f_old." ".$l_old."&nbsp;as contact
      for company <a class='regular'
      href='../../companies/admin/?action=edit_form&id=".$company."'>".$comp_name."</a>.<br>
      Click the company link if you wish to review this change.");
    }
  }
  startTables();
  if ($allowlogin)
  {
    $uname_pwd_message="Your username for logging in is $uname and the password is $pwd.\n\n".
      "Since this is an unencrypted message, please consider changing your password as soon as possible!\n\n";
  }
  else
  {
    $uname_pwd_message="";
  }
?>
<form method="post" action="./">
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_dk ?>" align="center">
      You may use the form below to send a welcome message to the newly created user
      <div class="attention">Please be aware that the default message contains the unencrypted username and password for this user!</div>
    </td>
  </tr>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md ?>" align="center">
      <b>Message title</b>
    </td>
  </tr>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_lt ?>" align="center">
      <input type="text" name="mail_title" value="Welcome to OPT!" size="40">
    </td>
  </tr>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_md ?>" align="center">
      <b>Message to be sent out</b>
    </td>
  </tr>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_lt ?>" align="center">
      <textarea name="mail_content" wrap="VIRTUAL" cols="40" rows="20"><?
      echo("Dear $sal $lname,\n\n".
        "A new user has been created for you on the OPT system at $SERVER_NAME.\n\n".
        "In order to access the system, please use the following URL:\nhttp://".
        "$SERVER_NAME$CRM_URL\n\n".
        $uname_pwd_message.
        "Thank you and welcome!");
      ?></textarea>
    </td>
  </tr>
  <tr>
    <td class="regular" bgcolor="<? echo $OPT_col_lt ?>" align="center">
      <input type="hidden" name="email" value="<? echo htmlspecialchars($email); ?>">
      <input type="submit" name="action" value="Send Notification">&nbsp;&nbsp;
      <input type="submit" name="action" value="No Notification">
    </td>
  </tr>
</form>
<?
  endTables();
?>
