<?
#
# Project details page
#
# Also creates and edits projects
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.01
  include "../../include/OPT_lib.php";
  auth_open();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Project Details")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../images");
  make_main_title(__("Project Details"),"../../images");
  $proj=abs($proj);
  if ((!$proj) && (!$Submit) && (!isset($setactive)) && (!$edit)) {
    OPT_error(__("Please select a project first"));
    exit;
  }

  // Admins or primary group contacts are allowed to create new projects! (No guests!)
  if (($proj) && (!crm_perm("projects",$proj, VIEW))) 
  {
    OPT_error(__("Classified"));
    exit;
  }

  // Activating/deactivating project
  if (isset($setactive) && (!$CRM_guest) && crm_perm("projects",$proj, EDIT) )
  {
    $sql="update projects set active=$setactive where id=$proj";
    CRM_run_query($sql);
    if ($setactive) {
      OPT_confirm(__("Successfully activated the project"));
    } else {
      OPT_confirm(__("Successfully deactivated the project"));
    }
  }

  // Creating a project (admin or primary group contact)
  if ($Submit && (is_admin() || getvalue("people", "iscontact", $CRM_user)) && (!$CRM_guest))
  {
    if (!$name || !$manager)
    {
      OPT_error(__("Sorry, you missed some fields (most probably the name). Please hit ".
        "your browser's 'Back' button and fill them out. Thank you."));
      auth_close();
      echo("</BODY>\n</HTML>");
      exit;
    }
    $sname=OPT_gpc_slashes($name);
    $sdescription=OPT_gpc_slashes($description);
    if (strlen($cost_code))
    { 
        $s_cost_code=OPT_gpc_slashes(trim($cost_code));
    }
    else
    {
        $s_cost_code=OPT_gpc_slashes(trim($name));
    }
    $proj=OPT_get_ID("projects");
    $sql="insert into projects set id=$proj, name='$sname', description='$sdescription',
          cost_code='$s_cost_code', active=$active";
    CRM_run_query($sql);
    $manager=abs($manager);
    $sql="insert into project_managers (project, manager) values ($proj, $manager)";
    CRM_run_query($sql);  // add the first project manager
   
    // Set up a default set of project settings (defaults are from fake project 0)
    $sql="select name, value, default_val from project_settings where project = 0";
    $result=CRM_run_query($sql);
    while ($myrow=OPT_fetch_row($result))
    {
        $sql="insert into project_settings (project, name, value, default_val) "
             ."VALUES ($proj,'$myrow[0]','$myrow[1]','$myrow[2]')";
        CRM_run_query($sql);
    }
  
    // Notify the manager of their new project    
    $v[]="email";
    $v[]="sal";
    $v[]="fname";
    $v[]="lname";
    OPT_locale($manager);
    $d=getvalue("people",$v,$manager);
    $name="$d[1] $d[3]";
    OPT_notify($manager,
               sprintf(__("New OPT project created: %s"), $sname),
               sprintf(__("Dear %s,\n".
                          "You have been made the project manager of a new OPT project:\n\n\t%s\n\n".
                          "Please set the access permissions for the project as soon as possible.\n".
                          "You can configure this project on the OPT server at this URL:\n"),$name,$sname).
               "http://$SERVER_NAME$CRM_URL?URL=". rawurlencode("projects/Proj_Edit/?proj=$proj"),
               __("This is automated message.  Please do not send a response to it."),
               "OPT project #$proj <$CRM_system_email>");
    OPT_locale();


    OPT_confirm(__("Project successfully created"));
  }

  // Editing a project
  if (($edit==__("Save")) && crm_perm("projects",$proj, EDIT))
  {
      if (!$name)
    {
      OPT_error(__("Sorry, you missed some fields (most probably the name). Please hit ".
        "your browser's 'Back' button and fill them out. Thank you."));
      auth_close();
      echo("</BODY>\n</HTML>");
      exit;
    }
     if (strlen($cost_code))
    { 
        $s_cost_code=OPT_gpc_slashes(trim($cost_code));
    }
    else
    {
        $s_cost_code=OPT_gpc_slashes(trim($name));
    }
    $sql="update projects set name='$name', description=\"$description\",
          cost_code='$s_cost_code', active=$active where id=$proj";
    CRM_run_query($sql);
    
    // First we delete any previous managers for this project
    CRM_run_query("delete from project_managers where project=$proj");

    // Now add all the people who will be managing this project
    for ($i=0; $i<sizeOf($managers); $i++)
    {
        $sql="insert into project_managers (project, manager) values ($proj, $managers[$i])";
        CRM_run_query($sql);
    }

    OPT_confirm(__("Project details successfully edited"));
  }
?>
<script language="javascript">
<!--
  parent.leftFrame.location='../leftMenu/?proj=<? echo $proj; ?>';
<?
  if (!$noupd)
  {
    ?>
      parent.topFrame.location='../../main_menu/?m1=Projects&m2=Project%20Management<? if ($proj) echo("&proj=".$proj); ?>&noupd=1';
    <?
  }
?>
  // -->
</script>
<?
  startTables();
  $sql="select * from projects where id=$proj";
  $result=CRM_run_query($sql);
  $myrow=OPT_fetch_array($result);
  echo("  <tr>\n");
  echo("    <td class=\"ah4\" bgcolor=\"$OPT_col_dk\" align=\"center\" colspan=\"2\">".htmlspecialchars($myrow["name"])."</td>\n");
  echo("  </tr>\n");

  echo("  <tr>\n");
  echo("    <td class=\"small\" bgcolor=\"$OPT_col_lt\" align=\"center\" colspan=\"2\">");
  if ($myrow["active"])
  {
    echo(__("This project is currently active. "));
  }
  else
  {
    echo("<font color='$OPT_col_attention'>".__("This project is currently inactive. ")."</font>");
  }
  if (strlen($myrow["cost_code"]))
  {
    echo(__("Time worked is recorded under the '" .$myrow["cost_code"]. "' cost code. "));
  }
  else
  {
    echo("<font color='$OPT_col_attention'>".__("No cost code is set!  Please set one or timesheet exports won't work!")."</font>");
  }
  echo("</td>\n");
  echo("  </tr>\n");

  echo("  <tr>\n");
  echo("    <td class=\"regular\" valign=\"top\" bgcolor=\"$OPT_col_md\" align=\"center\" colspan=\"2\"><b>".__("Description")."</b></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\" colspan=\"2\">".$myrow["description"]."</td>\n");
  echo("  </tr>\n");

  echo("  <tr>\n");
  echo("    <td class=\"regular\" bgcolor=\"$OPT_col_md\" align=\"center\" width=\"50%\"><b>".__("Project Manager(s)")."</b></td>\n");
  echo("    <td class=\"regular\" bgcolor=\"$OPT_col_md\" align=\"center\" width=\"50%\"><b>".__("Project Stats")."</b></td>\n");
  echo("  </tr>\n");
  echo("  <tr>\n");
  echo("    <td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\">");
  $sql="select people.id, CONCAT(fname,' ', lname) from project_managers, people where project = $proj 
        and project_managers.manager = people.id";
  $manager_result=CRM_run_query($sql);
  while ($manager_row=OPT_fetch_row($manager_result))
  {
      if (crm_perm("people",$manager_row[0]))
      {
        $a[0]="<A class=\"regular\" href=\"../../people/admin/?action=display&id=".$manager_row[0]."\">";
        $a[1]="</A>";
      }
      else
      {
        $a[0]="";
        $a[1]="";
      }
      echo("$a[0]$manager_row[1]$a[1]<br />");
  }
  echo("  </td>\n");
  echo("    <td class=\"regular\" bgcolor=\"$OPT_col_lt\" valign=\"top\">\n");
   
  // Display statistics for this project 
  include "$CRM_path/projects/Proj_View/stats.inc";

  echo("    </td>\n");

  echo("  <tr>\n");
  echo("    <td class=\"regular\" align=\"center\" bgcolor=\"$OPT_col_md\"><b>".__("Project Team")."</b></td>\n");
  echo("    <td class=\"regular\" align=\"center\" bgcolor=\"$OPT_col_md\"><b>".__("Customers")."</b></td>\n");
  echo("  </tr>\n");



  echo("  <tr>\n");
  echo("    <td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\" valign=\"top\">\n");

  // Get list of developers that are in groups with access to this project
  $sql="select company from company2project, companies where project=$proj and role='Developer' and company=id  
        and status > 0";
  $comp_result=CRM_run_query($sql);
  while ($comp_row=OPT_fetch_row($comp_result))
  {
      if (!$CRM_demo)
      {
          $demo_sql = "and people.id > 5";
      }

      $sql="select id from people where company=$comp_row[0] and (status&1) = 1 $demo_sql";
      $comp_user_result=CRM_run_query($sql);
      while ($comp_user_row=OPT_fetch_row($comp_user_result))
      {
           if (!@in_array($comp_user_row[0],$people))
           {
               $people[] = $comp_user_row[0];
           }
      }
  }

// Get list of individuals with developer access to this project
$sql="select id from people_proj, people where project=$proj and person = id and role='Developer' and (status&1) = 1";
$dev_result=CRM_run_query($sql);
while ($dev_row=OPT_fetch_row($dev_result))
{
    if (!@in_array($dev_row[0],$people))
    {
        $people[] = $dev_row[0];
    }
}


// Get a sorted list of names based on the array of people's id numbers
if (sizeOf($people) > 0)
{
  $sql="select id, CONCAT(fname, ' ', lname) from people where id IN (" . implode(",", $people) . ") order by fname";
  $people_names_result=CRM_run_query($sql);
  $first_row=1;
  while ($people_names_row=OPT_fetch_row($people_names_result))
  {
      if (crm_perm("people",$people_names_row[0], VIEW))
      {
        $a[0]="<A class=\"regular\" href=\"../../people/admin/?action=display&id=".$people_names_row[0]."\">";
        $a[1]="</A>";
      }
      else
      {
        $a[0]="";
        $a[1]="";
      }
      if ($first_row) { $first_row=0; } else { echo("<br />"); }
      echo("          $a[0]$people_names_row[1]$a[1]");
  }
}

  echo("</td>\n");

  echo("<td class=\"regular\" bgcolor=\"$OPT_col_lt\" align=\"center\">"); 
  // Show all customer groups
  $sql="select company, shortname from company2project, companies where project=$proj and role='Customer' and company=id 
        and status > 0 order by shortname";
  $comp_result=CRM_run_query($sql);
  $first_row=1;
  while ($comp_row=OPT_fetch_row($comp_result))
  {
     if ($first_row) { $first_row=0; } else { echo("<br />"); }
     if (crm_perm("companies", $comp_row[0], VIEW)) 
     {
        echo("<a class=\"regular\" href=\"../../companies/admin/?action=display_details&see=1&id=".$comp_row[0]."\">$comp_row[1]</a> (Group)");
     }
     else
     {
        echo("$comp_row[1] (Group)");
     }
  }
  // Now show any individuals with customer access
  $sql="select id, CONCAT(fname, ' ', lname) from people, people_proj where people.id = people_proj.person 
        and role='Customer' and project=$proj and (status&1)=1 order by fname";
  $cust_result=CRM_run_query($sql);
  while ($cust_row=OPT_fetch_row($cust_result))
  {
      if ($first_row) { $first_row=0; } else { echo("<br />"); }
      if (crm_perm("people",$cust_row[0]))
      {
        $a[0]="<A class=\"regular\" href=\"../../people/admin/?action=display&id=".$cust_row[0]."\">";
        $a[1]="</A>";
      }
      else
      {
        $a[0]="";
        $a[1]="";
      }
      echo("$a[0]$cust_row[1]$a[1] (Individual)");
  }
  echo("</td></tr>\n");


  echo("  </tr>\n");

?>
  <tr>
    <td colspan="2" bgcolor="<? echo $OPT_col_dk; ?>" class="small">&nbsp;</td>
  </tr>
<?
  endTables();
  auth_close();
?>
</BODY>
</HTML>
