<?

// Automatic memory for previous filter settings that this user had
if ($owner_filter && sizeOf($priority_filter) && ($status_filter || $hide_status_filter)  && $category_filter)
{ // User likely caused a form submit on page with filters so let's save them
   $sql="DELETE FROM user_settings where person=$CRM_user and project=$proj and type='request_filters'";
   CRM_run_query($sql);
   $sql="INSERT INTO user_settings (person, project, type, name, value) VALUES   
         ($CRM_user, $proj, 'request_filters', 'owner_filter', '$owner_filter'),
         ($CRM_user, $proj, 'request_filters', 'priority_filter', '$priority_filter'),
         ($CRM_user, $proj, 'request_filters', 'status_filter', '$status_filter'),
         ($CRM_user, $proj, 'request_filters', 'category_filter', '$category_filter'),
         ($CRM_user, $proj, 'request_filters', 'milestone_filter', '$milestone_filter')";
   CRM_run_query($sql);
}
elseif (!$owner_filter && !$priority_filter && !$status_filter && !$category_filter)
{ // User likely just didn't specify any filters, so let's retrieve their saved settings
  $sql="SELECT name, value FROM user_settings WHERE person=$CRM_user and project=$proj and type='request_filters'";
  $settings_result=CRM_run_query($sql);
  while ($settings_row=OPT_fetch_row($settings_result))
  {
        if ($settings_row[0] == "owner_filter")
        {
           $owner_filter=intval($settings_row[1]);
        }
        else if ($settings_row[0] == "priority_filter")
        {
           $priority_filter=intval($settings_row[1]);
        }
        else if ($settings_row[0] == "status_filter")
        {
           $status_filter=intval($settings_row[1]);
        }
        else if ($settings_row[0] == "category_filter")
        {
           $category_filter=intval($settings_row[1]);
        } 
        else if ($settings_row[0] == "milestone_filter")
        {
           $milestone_filter=intval($settings_row[1]);
        }
  }
}


if (!$hide_status_filter)
{
  // Generate status filter
  switch ($status_filter) {
  case 1:
      $filter="and status = '$status_filter'";
      break;
  case -2:  // all plus recently resolved
      $filter="and (status <> 2 || resolved_date > (now() - INTERVAL 7 DAY))";
      break;
  case 2:
      $filter="and status = '$status_filter'";
      break;
  case -3:
      $filter="";
      break;
  case -1:
      $filter="and status <> 2";
      break;
  case 0:  // default (when variable is empty or 0) is 'recent'
      $filter="and (status <> 2 || resolved_date > (now() - INTERVAL 7 DAY))";
      $status_filter="-2"; break;
  default:
      $filter="and status = '$status_filter'";
      break;
  }
}

  // Append priority filter
  if (sizeOf($priority_filter) && ($priority_filter >= 0))
  {
      $filter = $filter . " and priority = '$priority_filter'";
  }
  else
  {
      $priority_filter = -1;   // Default is ALL
  }

  // Append Owner filter
  if (sizeOf($owner_filter) && ($owner_filter >= 0))
  {
      $filter = $filter . " and owner = '$owner_filter'";
  }
  else if (sizeOf($owner_filter) && ($owner_filter == -2))
  {   // Nobody selected
      $filter = $filter . " and owner = '0'";
  }  
  else
  {
      $owner_filter = -1;   // Default is ALL
  }

  // Append Category filter
  if (sizeOf($category_filter) && ($category_filter >= 0))
  {
      $filter = $filter . " and CatID= '$category_filter'";
  }
  else
  {
      $category_filter = -1;   // Default is ALL
  }

  // Append Milestone filter if they're enabled for this project
  if ($show_milestones == "1")
  {
      if (!sizeOf($milestone_filter))
      {  // nothing specified at all so we default to Next & Unset
          $milestone_filter=-2;
      }
      switch ($milestone_filter) {
      case -3: break; // 'All' so no filter to add
      case -2:   // "Next and Unset" choosen
          $next_milestone=get_next_milestone($proj);
          if ($next_milestone)
          {
              $filter= $filter . " and ((milestone=$next_milestone[0]) OR (milestone=0))";
          }
          else
          {   // Just get requests with no milestone set
              $filter=$filter . " and milestone = 0";
          }
          break;
      case -1: // "Next" milestone choose
          $next_milestone=get_next_milestone($proj);
          if ($next_milestone)
          {
              $filter= $filter . " and milestone=$next_milestone[0]";
          }
          else
          {   // asked for all requests for next milestone, but no milestone is scheduled!!
              $filter= $filter . " and 1 <> 1";
          }
          break;
      default:  // given a specific Milestone to look for (or want Not Set)
          $filter = $filter . " and milestone = '$milestone_filter'";
      }
  }
 
?>

<? startTables(); ?>
<tr>
<td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Owner<b></td>
<td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Priority<b></td>
<?
if (!$hide_status_filter)
{  // Don't show only weekly progress report
?>
<td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Status<b></td>
<?
}
?>
<td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Category<b></td>
<?
if ($show_milestones == "1")
{
?>
<td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Milestone<b></td>
<?
}
?>
</tr>

<tr>
<td align="center" bgcolor="<? echo $OPT_col_md; ?>">
<select name="owner_filter" onchange="form.submit()">
<option value="-1">All</option>
<option value="-2" <? isSel($owner_filter, "-2")?>>Nobody</option>
<?
  $owner_result=get_people_involved_with_project($proj);
  while ($owner_row=OPT_fetch_array($owner_result)) {
    if ($owner_filter==$owner_row[0]) {
      $sel=" selected";
    } else {
      $sel="";
    }
    echo("<option value=\"".$owner_row[0]."\"$sel>".$owner_row[1]." ".$owner_row[2]."</option>\n");
  }
?>
</select></td>

<td align="center" bgcolor="<? echo $OPT_col_md; ?>">
<select name="priority_filter" onchange="form.submit()">
<option value="-1">All</option>
<?
  $priority=getvalue("requests","priority",$req, get_project_setting($proj, "default_priority_level"));
  $priorities = preg_split('/\|/', get_project_setting($proj, "request_priority"));
  for($priorityval=0; $priorityval < sizeof($priorities); $priorityval++) {
      if ($priorityval == $priority_filter)
      {
          $sel="selected";
      }
      else
      {
          $sel="";
      }
      print "<option value=\"$priorityval\" $sel>".__($priorities[$priorityval])."</option>\n";
  }
?>
</select></td>

<?
if (!$hide_status_filter)
{  // Don't show only weekly progress report
?>
<td align="center" bgcolor="<? echo $OPT_col_md; ?>">
<select name="status_filter" onchange="form.submit()">
<option value="-3">All</option>
<option value="-2" <? isSel($status_filter, "-2")?>>Recent</option>
<option value="1" <? isSel($status_filter, "1")?>>Open</option>
<?  // list out the other possible statii provided by the project manager
for ($i=0; $i<sizeOf($extra_statuses); $i++)
{
    unset($selected);
    if (($i+3) == $status_filter)
    {
        $selected='selected';
    }
    echo("<option value='".($i+3)."' $selected>".$extra_statuses[$i]."</option>");
}
?>
<option value="2" <? isSel($status_filter, "2")?>>Resolved</option>
<option value="-1" <? isSel($status_filter, "-1")?>>Unresolved</option>
</select></td>
<?
}
?>

<td align="center" bgcolor="<? echo $OPT_col_md; ?>">
<select name="category_filter" onchange="form.submit()">
<option value="-1">All</option>
<?
  $cat_sql="select id, cat_name from project_categories where project = $proj order by cat_name";
  $cat_result=crm_run_query($cat_sql);
  while ($cat_row=OPT_fetch_array($cat_result)) {
    if ($category_filter==$cat_row[0]) {
      $sel=" selected";
    } else {
      $sel="";
    }
    echo("<option value=\"".$cat_row[0]."\"$sel>".$cat_row[1]." ".$cat_row[2]."</option>\n");
  }
?>
</select></td>

<?
if ($show_milestones == "1")
{
?>
<td align="center" bgcolor="<? echo $OPT_col_md; ?>">
<select name="milestone_filter" onchange="form.submit()">
<option value="-3" <? isSel($milestone_filter, "-3")?>>All</option>
<option value="-2" <? isSel($milestone_filter, "-2")?>>Next &amp; Unset</option>
<option value="-1" <? isSel($milestone_filter, "-1")?>>Next</option>
<?
  $milestone_sql="select id, name from project_milestones where project = $proj  and due_date >= now() order by due_date";
  $milestone_result=crm_run_query($milestone_sql);
  while ($milestone_row=OPT_fetch_array($milestone_result)) {
    if ($milestone_filter==$milestone_row[0]) {
      $sel=" selected";
    } else {
      $sel="";
    }
    echo("<option value=\"".$milestone_row[0]."\"$sel>".$milestone_row[1]." ".$milestone_row[2]."</option>\n");
  }
?>
<option value="0" <? isSel($milestone_filter, "0")?>>Unset</option>
</select> 
</td>
<?
} // end of if ($show_milestones)
?>
</tr>

<?
endTables();  // end of filter controls

?>
