<?php
if ($_REQUEST['_jpg_csimd'] == 1)
{
    include ("../../include/OPT_lib.php");
    auth_open();
    if (!crm_perm("projects",$proj))
    {
        auth_close();
        exit;
    }
}
include ("$CRM_inc/jpgraph/jpgraph.php");
include ("$CRM_inc/jpgraph/jpgraph_gantt.php");
include ("$CRM_path/rt/reports/req_gantt_calc.inc");

// Setup Gantt graph
$graph = new GanttGraph(700,0,'auto');
$graph->SetShadow();
$graph->SetBox();

// If we didn't get all the variables we'd like, retrieve them from user_settings;
if (!$start_date || !$end_date)
{
    $sql="select name, value from user_settings where (type = 'request_gantt_chart' or type = 'request_filters')
         and project = $proj and person = $CRM_user";
    $result=CRM_run_query($sql);
    while ($row = OPT_fetch_row($result))
    {
        $$row[0] = $row[1];  // Assign value to variable name
    }
}

// If we still don't have a start and end date, then let's use some defaults
if ($start_date || $end_date)
{  
    $start_date = date("Y-m-d", mktime(0,0,0, date(m)-1, date(d),date(Y))); // One month ago 
    $end_date = date("Y-m-d", mktime(0,0,0, date(m)+1, date(d),date(Y))); // One month from now
}


// Only show part of the Gantt
$graph->SetDateRange($start_date,$end_date);

// Determine which header for dates to show
if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365)  
{   // More than two years difference
    $graph->ShowHeaders(GANTT_HYEAR);
}
else if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365*(5/12))  
{   // More than five months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH);
}
else if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365*(2/12))  
{   // More than two months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH | GANTT_HWEEK);
}
else
{   // Less than two months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH | GANTT_HDAY | GANTT_HWEEK);
}

$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
$graph->scale->week->SetFont(FF_FONT1);

$bar_index = 0;  // incremented for each bar on chart

// Get all milestones for this project that fall within this time range
$sql="select due_date, name from project_milestones where project = ".abs($proj)." 
     and due_date >= '".OPT_gpc_slashes($start_date)."' and due_date <= '".OPT_gpc_slashes($end_date)."'";
$result=CRM_run_query($sql);
while ($row = OPT_fetch_row($result))
{
   $ms = new MileStone($bar_index++,"",$row[0],date("M d",strtotime($row[0])));
   $ms->title->SetFont(FF_FONT1,FS_BOLD);
   $graph->Add($ms);  // Add the milestone
   
   $vline = new GanttVLine($row[0], $row[1], "darkred"); // add it as a line as well to really stand out
   $vline->title->SetFont(FF_FONT1,FS_BOLD,10);
   $vline->SetDayOffset(0.5);    // Center the line in the day
   $graph->Add($vline);
}

// Now get all requests that have both met the filter criteria
// Generate status filter
switch ($status_filter) {
 case 1:
     $filter="and r.status = '$status_filter'";
     break;
 case -2:  // all plus recently resolved
     $filter="and (r.status <> 2 || resolved_date > (now() - INTERVAL 7 DAY))";
     break;
 case 2:
     $filter="and r.status = '$status_filter'";
      break;
 case -3:
     $filter="";
     break;
 case -1:
     $filter="and r.status <> 2";
     break;
  case 0:  // default (when variable is empty or 0) is 'recent'
      $filter="and (r.status <> 2 || resolved_date > (now() - INTERVAL 7 DAY))";
 default:
     $filter="and r.status = '$status_filter'";
     break;
}

// Append priority filter
if (sizeOf($priority_filter) && ($priority_filter >= 0))
{
    $filter = $filter . " and priority = '$priority_filter'";
}

// Append Owner filter
if (sizeOf($owner_filter) && ($owner_filter >= 0))
{
    $filter = $filter . " and owner = '$owner_filter'";
}
else if (sizeOf($owner_filter) && ($owner_filter == -2))
{   // Nobody selected
    $filter = $filter . " and owner = '0'";
}  

// Append Category filter
if (sizeOf($category_filter) && ($category_filter >= 0))
{
    $filter = $filter . " and CatID= '$category_filter'";
}

// Append Milestone filter if they're enabled for this project
if (get_project_setting($proj, "show_milestones") == "1")
{
    if (!sizeOf($milestone_filter))
    {  // nothing specified at all so we default to Next & Unset
        $milestone_filter=-2;
    }
    switch ($milestone_filter) {
    case -3: break; // 'All' so no filter to add
    case -2:   // "Next and Unset" choosen
        $next_milestone=get_next_milestone($proj);
        if ($next_milestone)
        {
            $filter= $filter . " and ((milestone=$next_milestone[0]) OR (milestone=0))";
        }
        else
        {   // Just get requests with no milestone set
            $filter=$filter . " and milestone = 0";
        }
        break;
    case -1: // "Next" milestone choose
        $next_milestone=get_next_milestone($proj);
        if ($next_milestone)
        {
            $filter= $filter . " and milestone=$next_milestone[0]";
        }
        else
        {   // asked for all requests for next milestone, but no milestone is scheduled!!
            $filter= $filter . " and 1 <> 1";
        }
        break;
    default:  // given a specific Milestone to look for (or want Not Set)
        $filter = $filter . " and milestone = '$milestone_filter'";
    }
}

// Now get all the requests ordered by owner
$sql = "select distinct(r.id) as rid, r.title, p.fname, p.id as pid, 
           UNIX_TIMESTAMP(r.date) as date, UNIX_TIMESTAMP(r.deadline) as deadline
           from requests as r left join people as p on r.owner = p.id
           where aproj=$proj $filter            
           order by p.fname, r.priority";
$result = CRM_run_query($sql);

$last_person = 0;
while ($row = OPT_fetch_array($result))
{
    // Get an array of start, end, progress, caption from its tasks
    $details = calcRequestDetails($row["rid"], $row["date"], $row["deadline"]);
    $req_start = strtotime($details[0]);
    $req_end = strtotime($details[1]);
    $graph_start = strtotime($start_date);
    $graph_end = strtotime($end_date);

    // Only bother adding it to the graph if it will be displayed
    if (($req_start > 0 && $req_start <= $graph_end) && ($req_end >= $graph_start))
    {
        if ($last_person != intVal($row["pid"]))
        {
            // Use milestones without date to indicate a person label
            $last_person = intVal($row["pid"]);
            $ms = new MileStone($bar_index++,$row["fname"],0,"");
            $ms->title->SetFont(FF_FONT1,FS_BOLD);
            $ms->title->SetColor("black");
            $graph->Add($ms);  // Add the milestone
        }
        
        $bar = new GanttBar($bar_index++,"Request #".$row["rid"],$details[0],$details[1],$details[3]);
        
        // Set the progress amount on the bar
        $bar->SetPattern(BAND_RDIAG,"yellow");
        $bar->SetFillColor("red");
        $bar->progress->Set($details[2]);
        $bar->progress->SetPattern(GANTT_SOLID,"darkgreen");
        
        // Now add a Client side image map to link directly to task with hovering title
        $bar ->SetCSIMTarget ("../req_view/index.php?proj=$proj&req=".$row["rid"]);
        $bar->SetCSIMAlt(str_replace("\"", "'", $row["title"]));
        $bar->title-> SetCSIMTarget("../req_view/index.php?proj=$proj&req=".$row["rid"]);
        $bar->title-> SetCSIMAlt("Click to view details");
        
        $graph->Add($bar);
    }
}

$graph->StrokeCSIM('gantt_image.php');
if ($_REQUEST['_jpg_csimd'] == 1)
{
    auth_close();
}


?>
