<?
#
# Tabular report showing weekly progress on requests.
# PMs will be able to change priorities on this screen
# which will notify owners by email.
#

  include "../../../include/OPT_lib.php";
  auth_open();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Weekly Progress Report")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../../images");
?>
<script language="JavaScript" src="./ts_picker.js"></script>
<?
  make_main_title(__("Weekly Progress Report"),"../../../images");
  if (! $proj) {
    OPT_error(__("Please select a project first"));
    exit;
  }
  if (! crm_perm("projects",$proj)) {
    OPT_error(__("Classified"));
    exit;
  }

  $req=abs($req);
 
  // Get project settings once
  $show_milestones = get_project_setting($proj, "display_milestones_for_requests");
  $show_req_ids = get_setting("show_request_ids");
  // How many columns do we have
  if ($show_req_ids == "1")  // Optionally display request ID numbers
  {
      $table_cols=10;
  }
  else
  {
      $table_cols=9;
  }
 
  // Get the additional status values this PM has set.
  $statii=get_project_setting($proj, "request_status_options");
  $extra_statuses=explode("|", $statii);

  // We have to update request priorities
  if (($update == "Update Request Priorities") && (is_project_manager($proj)))
  {
      for ($i=0; $i<sizeOf($priorities); $i++)
      {
          $req=$request_ids[$i]; 
          $new_priority=$priorities[$i];
          $old_priority=getvalue("requests","priority",$req);
          if (intVal($new_priority) != $old_priority)
          {
             notify_priority_change($proj, $req, $new_priority, $CRM_user, $CRM_system_email);
          }
      }
      OPT_confirm("Request priorities updated.  Notifications sent to request owners and submitters.");
  } // end of notification of priority changes
?>

<form name="priorities" action="." method="POST" style="margin:0;">
<input type="hidden" name="proj" value="<? echo($proj); ?>" />
<?
startTables();

// Default today as current date
if (!$end_date)
{
    $end_date=date("Y-m-d");
}
?>
<tr>
<td class="regular" align="center" bgcolor="<?echo($OPT_col_lt)?>">
<b>Last Week: <span id="hours_last_week"></span></b></td>
<td class="regular" align="center" bgcolor="<?echo($OPT_col_lt)?>">
<b>This Week: <span id="hours_this_week"></span></b></td>
<td class="regular" align="center" bgcolor="<?echo($OPT_col_lt)?>">
<b>Progress: <span id="progress"></span></b></td>
</td>
<td class="regular" align="right" bgcolor="<?echo($OPT_col_lt)?>" valign="middle" nowrap>
<b>Week Ending</b>: <input type="text" name="end_date" size="12" value="<?echo($end_date)?>">
<a href="javascript:show_calendar('document.priorities.end_date', document.priorities.end_date.value);">
<img src="../../../images/cal.gif" width="16" height="16" border="0" alt="Click Here to Pick an End Date"></a>
<input type="submit" name="refresh" value="Refresh" />
</td>
</tr>
<?
  endTables(); // From the header instructions and date selector

  $hide_status_filter=1; // Progress report doesn't include RECENT status
  include "$CRM_path/rt/filters.inc";  // bring in all the filters 
  $sql="select requests.*, cat_name from requests left join project_categories 
        on requests.CatID = project_categories.id where aproj = $proj $filter
        and (status != 2 OR (resolved_date > DATE_SUB('$end_date', INTERVAL 7 DAY)))     
        ORDER BY priority, cat_name";
  $result=CRM_run_query($sql);                    
  startTables(); // start of request listing
?>

<tr>
<?
  if ($show_req_ids == "1")  // Optionally display request ID numbers
  {
      echo("<td class=\"regular\" align=\"center\" bgcolor=\"$OPT_col_dk\"><strong>".__("ID")."</strong></td>\n");
  }
?>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">Title</th>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">Priority</th>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">Effort</th>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">+/-</th>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">Status</th>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">Owner</th>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">Deadline</t>
  <th class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">Worked</th>
</tr>
<?
  $col="'$OPT_col_md'";
  if (OPT_num_rows($result) == 0)
  {
 ?>
<tr><td colspan="<?echo($table_cols);?>" class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" valign="middle">
<i>No requests found matching your criteria.</i>
</td></tr>
<?
  }
  
  $priorities = preg_split('/\|/', get_project_setting($proj, "request_priority"));

  // The display loop
  $prev_priority = -1;
  $cat = -1;
  $cat_row_num=0;
  while ($myrow=OPT_fetch_array($result)) {

    if ($col=="'$OPT_col_md'") {
      $col="'$OPT_col_lt'";
    } else {
      $col="'$OPT_col_md'";
    }

    $priority=$myrow["priority"];
    
    // Different priority/category combo?
    if ((($myrow["CatID"]) && ($cat!=$myrow["CatID"])) || ($priority!=$prev_priority))
    {
      $cat_row_num = $cat_row_num + 1;
      $cat=$myrow["CatID"];
      $prev_priority=$priority;
      echo "<tr>\n<td class='regular' colspan='$table_cols' align='left' bgcolor=\"$OPT_col_md\">";
      echo "<b>".$myrow["cat_name"] ." (". __($priorities[$priority]) .")</b>";
      echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<span id=\"cat_stat$cat_row_num\"></span></td></tr>\n";
      $col=$OPT_col_lt;
    }

    echo("<tr>");

    $id=$myrow["id"];

    // Request ID number
    if ($show_req_ids == "1")
    {
      echo("<td class=\"regular\" align=\"center\" bgcolor=$col><A class=\"regular\" 
              href=\"../../req_view/?proj=$proj&req=".$myrow["id"]."\">$id</a></td>\n");
    }
    
    // Title
    $title=htmlspecialchars(stripslashes($myrow["title"]));
    echo("<td class=\"regular\" bgcolor=$col align='left' width='45%' >");
    echo("<input type='hidden' name='request_ids[]' value='$id' />");
    echo("<a class=\"regular\" href=\"../../req_view/?proj=$proj&req=".$myrow["id"]."\">$title</a></td>\n");

    // Priority
    echo("<td class=\"regular\" align=\"center\" bgcolor=$col>");
    if (!$pf && is_project_manager($proj))
    {
        echo("<select name=\"priorities[]\">\n");
        for ($i=0;$i<sizeOf($priorities);$i++) {
            unset($selected);
            if ($i==$myrow["priority"]) {
                $selected="selected";
            }
            echo("<option value=\"$i\" $selected>".__("$priorities[$i]")."</option>\n");
        }
        echo("</select>\n");
    }
    else
    {
        echo(__($priorities[$myrow["priority"]]));
    }
    echo("</td>\n");

    // Request progress in last week (Effort)
    $progress = calculate_weekly_request_progress($id, $end_date);
    $total_this_week += $progress[0];
    $total_last_week += $progress[1];
    echo("<td class=\"regular\" align=\"center\" bgcolor=$col nowrap>");
    if ($progress[4] == "0")
    {   // number is based on task breakdown so more accurate (highlight it)
        echo("<b>$progress[0]</b>");
    }
    else
    {
        echo("$progress[0]");
    }
    if ($progress[3] == "0")
    {   // number is based on task breakdown so more accurate (highlight it)
        echo(" (<b>$progress[1]</b>)");
    }
    else
    {
        echo(" ($progress[1])");
    }
    echo("</td><td class=\"regular\" align=\"center\" bgcolor=$col>$progress[2]</td>\n");
    $cat_last_totals[$cat_row_num] += $progress[1];
    $cat_this_totals[$cat_row_num] += $progress[0];
    
    // Status 
    echo("  <td class=\"regular\" bgcolor=$col align='center'>\n");
    switch ($myrow["status"])
    {
    case 1: echo("Open"); break;
    case 2: echo("<font color='green'>Resolved</font>"); break;
    default: echo($extra_statuses[$myrow["status"]-3]);
    }
    echo("  </td>\n");

    // Owner
    $src[]="fname";
    $src[]="lname";
    if ($myrow["owner"]) {
      if (crm_perm("people",$myrow["owner"])) {
        $a[0]="<A class=\"regular\" href=\"../../../people/admin/?action=display&id=".$myrow["owner"]."\">";
        $a[1]="</A>";
      } else {
        $a[0]="";
        $a[1]="";
      }
      $src_name=getvalue("people",$src,$myrow["owner"]);
      $src_name=$a[0].$src_name[0]." ".$src_name[1].$a[1];
    } else {
      $src_name=__("Nobody");
    }
    echo("  <td class=\"regular\" align=\"center\" bgcolor=$col>$src_name</td>\n");


    // Deadline
    $deadline=niceDate("requests","deadline",$myrow["id"],1);
    if (!$deadline) {
      $deadline="&nbsp;";
    }
    unset($bold);
    if (getvalue("requests","(deadline<now()) and (status!=\"resolved\")",$myrow["id"])) {
      $bold[]="<strong><font color=\"$OPT_col_attention\">";
      $bold[]="</font></strong>";
    } else {
      $bold[]="";
      $bold[]="";
    }
    echo("  <td class=\"regular\" align=\"center\" bgcolor=$col>$bold[0]$deadline$bold[1]</td>\n");

    // Total hours worked
    $hrs_worked = calculate_weekly_request_worked($id, $end_date);
    echo("<td class=\"regular\" align=\"center\" bgcolor=$col>");
    echo(sprintf("%.0f", $hrs_worked[1]));
    echo(" (".sprintf("%.0f",$hrs_worked[0]).")</td>\n");
    echo("</tr>\n");
  }


  if (!$pf && is_project_manager($proj) && (OPT_num_rows($result) > 0))
  {
?>
    <tr> 
   <td class="small" align="center" bgcolor="<? echo $OPT_col_dk; ?>" colspan="<?echo($table_cols);?>">
         <input type="submit" name="update" value="Update Request Priorities" /></td></tr>
<?
  }
?>

   <tr> 
   <td class="small" align="left" bgcolor="<? echo $OPT_col_md; ?>" colspan="<?echo($table_cols);?>">
    <? echo(__("You may select any of the requests for details by clicking on the request title.  The effort column shows the hours remaining for each request, with the hours remaining exactly one week ago shown  in brackets for comparison.  Hours in the effort column in bold text indicate the estimate is based on a breakdown of tasks, rather than a single estimate on the whole request and therefore more accurate.  The worked column shows the total number of hours worked on the request with the total worked the previous week in brackets for comparsion.")); ?>
    </td></tr>

  </td>
</tr>

</form>

<script language="JavaScript" type="text/javascript">
<!--
    // These are calculated after we've drawn the table so use Javascript to shown them up top
    last_week=window.document.getElementById('hours_last_week');
    last_week.innerHTML="<? echo(intval($total_last_week))?> hrs";
    this_week=window.document.getElementById('hours_this_week');
    this_week.innerHTML="<? echo(intval($total_this_week))?> hrs";
<?
    $progress_this_week=intval($total_this_week)-intval($total_last_week);
    if ($progress_this_week > 0)
    {
        $prog_font_color="red";
    }
    else if ($progress_this_week < 0)
    {
        $prog_font_color="green";
    }
    else
    {
        $prog_font_color="black";
    }
?>
    progress_field=window.document.getElementById('progress');
    progress_field.innerHTML="<font color='<?echo($prog_font_color)?>'><? echo(intval($progress_this_week))?> hrs</font>";


<?  // Now fill in the sub-totals for each category/priority heading
for ($i=1; $i<=$cat_row_num; $i++)
{
    $this_week=$cat_this_totals[$i];
    $last_week=$cat_last_totals[$i];
    $change=$this_week-$last_week;
    if ($change > 0)
    {
        $html="$this_week hrs ($last_week hrs) --> <font color='red'>$change</font>";
    } 
    elseif ($change < 0)
    {
        $html="$this_week hrs ($last_week hrs) --> <font color='green'>$change</font>";
    }
    else
    {
        $html="$this_week hrs ($last_week hrs) --> $change";
    }

    echo("cat_stat=window.document.getElementById('cat_stat".$i."');\n");
    echo("cat_stat.innerHTML=\"".$html."\";\n");
}

?>

//-->
</script>
<?
  endTables();
  auth_close();
?>
</BODY>
</HTML>




<?

// Calculates the amount of progress made on this request in a week in terms of hours worked
function calculate_weekly_request_worked($req, $end_date)
{
    // First get now and a week ago as timestamps
    $end_date=strtotime($end_date)+(60*60*24);
    $week_earlier=$end_date-(60*60*24*7);

    // Now find all tasks that are associated with this request
    $sql="select distinct(task) from request2task where request = $req"; 
    $task_result=crm_run_query($sql); 
    while ($task_row=OPT_fetch_row($task_result))
    {
       $task_ids[] = $task_row[0];
    }
    
    if ($task_ids) {
        // Now determine total hrs worked a week ago
        $sql="select sum(TIME_TO_SEC(worked)/3600) from task_progress_history where taskID IN (".implode(", ", $task_ids).
            ") and UNIX_TIMESTAMP(date) < $week_earlier";
        $result=CRM_run_query($sql);
        if (OPT_num_rows($result) == 1)
        {
            $row=OPT_fetch_row($result);
            $hrs_worked[] = $row[0];
        }
        else
        {
            $hrs_worked[] = 0;
        }
        // Now determine total hrs worked as of this week
        $sql="select sum(TIME_TO_SEC(worked)/3600) from task_progress_history where taskID IN (".implode(", ", $task_ids).
            ") and UNIX_TIMESTAMP(date) < $end_date";
        $result=CRM_run_query($sql);
        if (OPT_num_rows($result) == 1)
        {
            $row=OPT_fetch_row($result);
            $hrs_worked[] = $row[0];
        }
        else
        {
            $hrs_worked[] = 0;
        }
    }
    else
    {
        $hrs_worked[] = 0;
        $hrs_worked[] = 0;
    }
    return $hrs_worked;  // array[0] == last week worked total, array[1] == this week worked total
}



// Calculates the amount of progress made on this request in a week in terms of effort remaining
function calculate_weekly_request_progress($req, $end_date)
{
    // First get now and a week ago as timestamps
    $end_date=strtotime($end_date)+(60*60*24);
    $week_earlier=$end_date-(60*60*24*7);

    // Get the creation date of the request
    $sql="select UNIX_TIMESTAMP(date), status from requests where id = $req";
    $req_result = CRM_run_query($sql);
    if (OPT_num_rows($req_result))
    {
        $row=OPT_fetch_row($req_result);
        $created_date=$row[0];
        $status=$row[1];
    }

    // Now find all tasks that are associated with this request
    $sql="select distinct(task) from request2task where request = $req"; 
    $task_result=crm_run_query($sql); 
    while ($task_row=OPT_fetch_row($task_result))
    {
       $task_ids[] = $task_row[0];
    }       
    
    // Find the total hours remaining last week for this task
    $tasks_week_old=0;  // flag indicating this task didn't exist before this time
    // Start out with the initial estimate on the request, overridden by task estimates if found
    if ((sizeOf($task_ids) == 0) && ($week_earlier >= $created_date)  && ($status != 2))
    {
       $last_week=intVal(getvalue("requests", "TIME_TO_SEC(initial_estimate)/3600",$req));
       $using_request_estimate_for_last_week = 1;
    }  
    // Get the remaining hours for this task    
    for ($j=0; $j<sizeOf($task_ids); $j++)
    {
       $sql="select remaining from task_progress_history where unix_timestamp(date) <= '$week_earlier' 
             and taskID=$task_ids[$j]
             order by date desc, id desc limit 1";
       $rem_result=crm_run_query($sql);
       if (OPT_num_rows($rem_result) == 1)
       {
           $rem_row=OPT_fetch_row($rem_result);
           $last_week=$last_week+$rem_row[0];
           $using_request_estimate_for_last_week = 0;  // not using request estimate any more
           $tasks_week_old=1;  // set flag as this task existed a week ago
       }
    }

    // Now repeat the process to find the hours remaining as of right now
    // Start out with the initial estimate on the request, overridden by task estimates if found
    if ((sizeOf($task_ids) == 0) && ($end_date >= $created_date) && ($status != 2))
    {
        $this_week=intVal(getvalue("requests", "TIME_TO_SEC(initial_estimate)/3600",$req));
        $using_request_estimate_for_this_week = 1;  
    } 
    $tasks_now=0;    // indicates whether there are any tasks associated with this request
    // Get the remaining hours for this task    
    for ($j=0; $j<sizeOf($task_ids); $j++)
    {
        $sql="select remaining from task_progress_history where unix_timestamp(date) <= '$end_date'
              and taskID=$task_ids[$j]
              order by date desc, id desc limit 1";
	$rem_result=crm_run_query($sql);
        if (OPT_num_rows($rem_result) == 1)
        {
            $rem_row=OPT_fetch_row($rem_result);
	    $this_week=$this_week+$rem_row[0];
            $using_request_estimate_for_this_week = 0;
            $tasks_now=1;  // set flag as this request has at least one task
        }
    }

    // Now determine the type of flag to display
    if ($this_week == $last_week)
    {   // No progress at all on this task
        $flag="0";
    }
    elseif ($this_week < $last_week)
    {
        $progress=$this_week-$last_week;
        $flag="<font color='green'>".sprintf("%.0f", $progress)."</font>";
    }
    elseif ($this_week > $last_week)
    {
        $progress=$this_week-$last_week;
        $flag="<font color='red'>".sprintf("%.0f", $progress)."</font>";
    }
    
    // return a tuple describing this request's progress this week
    $result[] = sprintf("%.0f", $this_week);  
    $result[] = sprintf("%.0f", $last_week);    
    $result[] = $flag;        // the colored progress field value
    
    // Color to indicate whether the number is based on task sums or just request
    if ($using_request_estimate_for_last_week == 1)
    {
        $result[] = '1';
    }
    else
    {
        $result[] = '0';
    }

    // Color to indicate whether the number is based on task sums or just request
    if ($using_request_estimate_for_this_week == 1)
    {
        $result[] = '1';
    }
    else
    {
        $result[] = '0';
    }
    return $result;
}

// Notifies the owner and source of a request when the priority changes
function notify_priority_change($proj, $req, $new_priority, $CRM_user, $CRM_system_email)
{
    unset($dst); 
    $old_priority=getvalue("requests", "priority", $req);
    $sql="update requests set date=date, priority=\"$new_priority\" where id=$req";
    $result=CRM_run_query($sql);

    // This is where the notification takes place!
    $rq[]="title";
    $rq[]="request";
    $rq[]="owner";
    $rqt=getvalue("requests",$rq,$req);
    $title=$rqt[0];
    $comments=$rqt[1];
    $owner=$rqt[2];

    // Always notify the request owner...
    if ($owner && (!@in_array($owner,$dst))) {
      $dst[]=$owner;
    }

    // The request submitter(s) if they wish to be notified
    $notify_src=getvalue("requests","notify_src",$req,"");
    $sql="select person from request_submitters where request = $req";
    $submitters_result=CRM_run_query($sql);
    while ($submitter_row=OPT_fetch_row($submitters_result))
    {
        if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
        {
            $dst[]=$submitter_row[0];
        }
    }

    $v[]="email";
    $v[]="sal";
    $v[]="fname";
    $v[]="lname";
    $s=getvalue("people",$v,$CRM_user);
    $p_n=getvalue("projects","name",$proj);
    $priority_names=preg_split('/\|/', get_project_setting($proj, "request_priority"));
    $new_priority_name=$priority_names[$new_priority];
    $old_priority_name=$priority_names[$old_priority];
    // Notify each person in the list
    for ($i=0;$i<sizeOf($dst);$i++) { 
      OPT_locale($dst[$i]);
      $d=getvalue("people",$v,$dst[$i]);
      $name="$d[1] $d[3]";

      if ($owner) {
        $o[]="sal";
        $o[]="fname";
        $o[]="lname";
        $own=getvalue("people",$o,$owner);
        $own=sprintf(__("This request is currently owned by %s."),"$own[0] $own[1] $own[2]");
      } else {
        $own=__("This request currently has no owner.");
      }

      OPT_notify($dst[$i],sprintf(__("OPT request %s is of %s priority"),"\"$title\"",$new_priority_name),
        sprintf(__("Dear %s,\n".
        "%s changed the priority of request %s ".
        "related to the %s project to %s. %s\n\n".
        "The request body follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n".
        "This request is accessible on the OPT server at this URL:\n"),$name,"$s[1] $s[2] $s[3]",
        "\"$title\"","\"$p_n\"","\"$new_priority_name\"",$own,$comments).
        "http://$SERVER_NAME$CRM_URL?URL=".
        rawurlencode("rt/req_view/?proj=$proj&req=$req"),
        __("You may post comments on the request by replying ".
        "to this e-mail. Please note only the message body will be ".
        "uploaded to OPT. You may also post comments by ".
        "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
        "please don't quote the original message since the quoted text ".
        "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
        "OPT request #$req <$CRM_system_email>", 1);  // confirm output is hidden
    }
    OPT_locale();
    
    // Log this change
    $entry=addslashes("Priority changed from $old_priority_name to $new_priority_name.");
    CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '$entry')"); 
  }
?>