<?php
  include ("../../include/OPT_lib.php");
  include ("$CRM_inc/jpgraph/jpgraph.php");
  include ("$CRM_inc/jpgraph/jpgraph_bar.php");
  auth_open();

// Ensure we got a project
$proj=abs($proj); 
if (! $proj) {
    OPT_error(__("Please select a project first."));
    exit;
}


// Get categories
$group_names[] = "Whole\nTeam";
$group_count = 1;

// Total hours taken to resolve all requests for this project
$sql="select avg((unix_timestamp(resolved_date)-unix_timestamp(date))/3600) from requests where aproj=$proj and resolved_date > 0";
$result=crm_run_query($sql);
if ($total_row=OPT_fetch_row($result))
{
    $totals[]=$total_row[0];
}


// Gets the list of people on this project team
$result=get_people_involved_with_project($proj);
// For each category, store the name
while ($owner_row=OPT_fetch_row($result))
{
    $owner_ids[] = $owner_row[0];
    $owner_name = ($owner_row[1] . "\n" . $owner_row[2]);
    $group_names[] = $owner_name;
    $group_count++;
}

for ($i=0; $i<sizeOf($owner_ids); $i++)
{

    // Total hours taken to resolve all requests for this project category
    $sql="select avg((unix_timestamp(resolved_date)-unix_timestamp(date))/3600) from requests where aproj=$proj and owner = $owner_ids[$i] and resolved_date > 0";
    $result=crm_run_query($sql);
    if ($count_row=OPT_fetch_row($result))
    {
        $totals[]=$count_row[0];
    } 
}

$title="Average Time to Resolve Requests ";
$subtitle="Grouped by Person Assigned Request";
$project=getvalue("projects", "name", $proj);
$footer=$project . ": " . date("D M j G:i:s T Y");


# I wanted this graph code to be in an include file to avoid duplication, but it
# breaks, so I have the same chunk copied around...

# 
#  Horizontal bar graph that displays percentages for an 
#  early and a late data plot.  Expects the following:
#
#  title: title for graph
#  subtitle: subtitle for graph
#  project: project name for graph footer
#  group_count: Number of groups to display along the left side
#  group_names: Names of x-axis groups to work with
#  num_early: Array of percentages showing amount early for each group
#  num_late: Array of percentages showing amount late for each group
#

// Size of graph
$width=650;   // width is set
$height=150 + 65*$group_count;  // height must expand to meet the number of categories

// Set the basic parameters of the graph 
$graph = new Graph($width,$height,'auto');
$graph->SetScale("textlin");

// Since we swap width for height (since we rotate it 90 degrees)
// we have to adjust the margin to take into account for that
$top = 50;
$bottom = 30;
$left = 150;
$right = 20;
$adj = ($height-$width)/2;
$graph->SetMargin($top-$adj,$bottom-$adj,$right+$adj,$left+$adj);

// Set Center and rotate the graph
$graph->img->SetCenter(floor($width/2),floor($height/2));
$graph->SetAngle(90);

// Nice shadow
$graph->SetShadow();

// Setup title and footer
$graph->title->Set($title);
$graph->title->SetFont(FF_VERDANA,FS_BOLD,14);
$graph->subtitle->Set("($subtitle)");
$txt =new Text($footer);
$txt->Pos( $width/2-100,$height-25);  // footer isn't at bottom when rotated so place exactly
$graph->AddText( $txt);

// Setup X-axis
$graph->xaxis->SetTickLabels($group_names);
$graph->xaxis->SetFont(FF_VERDANA,FS_NORMAL,12);

// Some extra margin looks nicer
$graph->xaxis->SetLabelMargin(10);

// Label align for X-axis
$graph->xaxis->SetLabelAlign('right','center');

// Add some grace to y-axis so the bars doesn't go
// all the way to the end of the plot area
$graph->yaxis->scale->SetGrace(20);

// Now create a bar pot
$bplot1 = new BarPlot($totals);
$bplot1->SetFillColor("gold1");
$bplot1->SetShadow();

//You can change the width of the bars if you like
//$bplot->SetWidth(0.5);

// We want to display the value of each bar at the top
$bplot1->value->Show();
$bplot1->value->SetFont(FF_ARIAL,FS_BOLD,12);
$bplot1->value->SetAlign('left','center');
$bplot1->value->SetColor("black","darkred");
$bplot1->value->SetFormat('%.1f hrs');

// Add the bar to the graph
$graph->Add($bplot1);

// .. and stroke the graph
$graph->Stroke();

#####  END of file I would just include if I could


auth_close();
?>
