<?
#
# Request list page
#
# Also creates and updates requests
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  include "../../include/OPT_lib.php";
  auth_open();
  include "$CRM_inc/email.php";
  checkMail();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Request List")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
mainBody("../../images");
make_main_title(__("Request List"),"../../images");
if (! $proj)
{
  OPT_error(__("Please select a project first"));
  exit;
}
if (! crm_perm("projects",$proj))
{
  OPT_error(__("Classified"));
  exit;
}

$req=abs($req);

// Get project settings once
$show_milestones = get_project_setting($proj, "display_milestones_for_requests");
$show_req_ids = get_setting("show_request_ids");
$show_hours_column=get_project_setting($proj, "task_status_hours_remaining");
$pm_can_change_request_status_even_if_not_owner = get_project_setting($proj, "pm_can_change_request_status_even_if_not_owner");
$ispm = is_project_manager($proj);
$only_pm_can_set_request_priority = get_project_setting($proj, "only_pm_can_set_request_priority");
$only_pm_can_edit_requests = get_project_setting($proj, "only_pm_can_edit_requests");

// Get the additional status values this PM has set.
$statii=get_project_setting($proj, "request_status_options");
$extra_statuses=explode("|", $statii);

// Store names for people in memory to avoid hitting the database over and over
$people_result=get_people_involved_with_project($proj);
while ($people_row=OPT_fetch_array($people_result)) 
{
  $people[] = array($people_row["id"], ($people_row["fname"] . ' ' . $people_row["lname"]));
  $Last_name = $people_row["lname"];  
  $people_disp[] = array($people_row["id"], ($people_row["fname"]) . ' ' . $Last_name[0] . '.');
}

// Store this list of priorities 
$priorities = get_project_setting($proj, "request_priority");
if (!$priorities)
{
  $priorities=array();
}
$priorities = explode("|",$priorities);

// Store this list of categories
$cat_result=crm_run_query("select id, cat_name from project_categories where project = $proj order by cat_name");
$j = 1;
while ($cat_row=OPT_fetch_row($cat_result))
{
  $category_indx[$j] = $cat_row[0];
  $category_name[$j] = $cat_row[1];
  $j++;
}
$category_indx[0] = 0;
$category_name[0] = '';

if($show_milestones == "1")
{
  $i = 1;
  $mil_result=crm_run_query("select id, name from project_milestones where project = $proj");
  while($mil_row=OPT_fetch_row($mil_result))
  {
    $milestone_indx[$i] = $mil_row[0];
    $milestone_name[$i] = $mil_row[1];
    $i++;
  }
  $milestone_indx[0] = 0;
  $milestone_name[0] = '';
}

// We have to move the request to a different project (drag its tasks and documents with it!)
if (($req) && ($moveto) && (crm_perm("requests",$req, EDIT) && crm_perm("projects",$moveto, VIEW)))
{
  $default_req_priority=intval(get_project_setting($moveto, "default_priority_level"));
  // Must reset a bunch of stuff as they don't apply in the target project possibly
  $sql="update requests set aproj=$moveto, milestone=0, CatID=0, status=1, 
                     priority=$default_req_priority where id=$req";
  crm_run_query($sql);
  // Transfer any associated requests
  $sql="select task from request2task where request = $req";
  $req_result=CRM_run_query($sql);
  unset($move_req_tasks);
  while ($req_row=OPT_fetch_row($req_result))
  {
    $move_req_tasks[] = $req_row[0];
  }
  if ($move_req_tasks)
  {
    CRM_run_query("update task set ProjectID=$moveto, CatID=0 where id in (". implode(", ", $move_req_tasks) .")");
  }
}

// How many columns do we have
if ($show_req_ids == "1")  // Optionally display request ID numbers
{
  $table_cols=9;
}
else
{
  $table_cols=8;
}

// Extra column for milestones if they are used in the project
if ($show_milestones == "1")
{
  $table_cols+=1;
}

// Extra column for hours if they are important on this project
if ($show_hours_column == "1")
{
  $table_cols+=1;
}

// Project manager or owner changed the ownership of a request
if (($req) && (sizeOf($new_owner)) && (crm_perm("requests",$req, EDIT)))
{
  $sql="update requests set owner=$new_owner, date=date where id=$req";
  CRM_run_query($sql);
  OPT_confirm(__("Request owner successfully changed."));    // This is where the notification takes place!
  $rq[]="title";
  $rq[]="request";
  $rq[]="owner";
  $rqt=getvalue("requests",$rq,$req);
  $title=$rqt[0];
  $comments=$rqt[1];
  $owner=$rqt[2];
  
  // Always notify the new request owner...
  if ($new_owner && (!@in_array($new_owner,$dst)))
  {
    $dst[]=$new_owner;
  }
  
  // Always notify the previous request owner...
  if ($prev_owner && (!@in_array($prev_owner,$dst)))
  {
    $dst[]=$prev_owner;
  }
  
  // The request submitter(s) if they wish to be notified
  $notify_src=getvalue("requests","notify_src",$req,"");
  $sql="select person from request_submitters where request = $req";
  $submitters_result=CRM_run_query($sql);
  while ($submitter_row=OPT_fetch_row($submitters_result))
  {
    if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
    {
      $dst[]=$submitter_row[0];
    }
  }
  
  $v[]="email";
  $v[]="sal";
  $v[]="fname";
  $v[]="lname";
  $s=getvalue("people",$v,$CRM_user);
  $p_n=getvalue("projects","name",$proj);
  $stat=getvalue("requests", "status", $req);
  
  for ($i=0;$i<sizeOf($dst);$i++) 
  {
    OPT_locale($dst[$i]);
    switch ($stat)
    {
      case 1: $newstat="Open"; break;
      case 2: $newstat="Resolved"; break;
      default: $newstat=$extra_statuses[$stat-3];
    }
    $prev_owner_name=getvalue("people","CONCAT(fname, ' ', lname)",$prev_owner, "nobody");
    if ($new_owner)
    {
      $owner_name=getvalue("people","CONCAT(fname, ' ', lname)",$new_owner);
      $own=sprintf(__("This request is now owned by %s. It was previously owned by %s."), $owner_name, $prev_owner_name);
    }
    else
    {
      $own=__("This request currently has no owner. It was previously owned by $prev_owner_name.");
    }
      
    $d=getvalue("people",$v,$dst[$i]);
    $name="$d[1] $d[3]";
    OPT_notify($dst[$i],sprintf(__("OPT request %s ownership change"),"$reqidstr\"$title\""),
	       sprintf(__("Dear %s,\n".
			  "%s changed the ownership of request %s ".
			  "related to the %s project with status %s. %s\n\n".
			  "The request body follows:\n".
			  "------------------------------------------------------------------------\n".
			  "%s\n".
			  "------------------------------------------------------------------------\n".
			  "This request is accessible on the OPT server at this URL:\n"),$name,"$s[1] $s[2] $s[3]",
		       "$reqidstr\"$title\"","\"$p_n\"","\"$newstat\"",$own,$comments).
	       "http://$SERVER_NAME$CRM_URL?URL=".
	       rawurlencode("rt/req_view/?proj=$proj&req=$req"),
	       __("You may post comments on the request by replying ".
		  "to this e-mail. Please note only the message body will be ".
		  "uploaded to OPT. You may also post comments by ".
		  "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
		  "please don't quote the original message since the quoted text ".
		  "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
	       "OPT request #$req <$CRM_system_email>");
  }
  OPT_locale();
  unset($stat);  // clear so we don't trigger status change
  unset($priority);
  unset($milestone);
  unset($category);
  // Log the change
  $entry=addslashes("$own");
  CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '$entry')");
}

// Priority changed by PM or owner
if(($req) && (sizeof($priority)) && (crm_perm("requests",$req, EDIT)))
{
  unset($dst);       
  $stat = getvalue("requests", "status", $req);
  $sql="update requests set priority=$priority, date=date where id=$req";
  $result=CRM_run_query($sql);
  
  // This is where the notification takes place!
  $rq[]="title";
  $rq[]="request";
  $rq[]="owner";
  $rqt=getvalue("requests",$rq,$req);
  $title=$rqt[0];
  $comments=$rqt[1];
  $owner=$rqt[2];
  
  OPT_confirm(__("Request priority successfully updated"));
  
  // If whole team notify is enabled then add all team members 
  if (get_project_setting($proj, "notify_whole_team_on_new_requests") == "1")
  {
    OPT_confirm(__("Notifying project participants..."));
    $result = get_people_involved_with_project($proj, "id");
    while ($myrow=OPT_fetch_row($result))
    {
      $dst[]=$myrow[0];
    }
  }
  
  // Always notify the request owner...
  if ($owner && (!@in_array($owner,$dst)))
  {
    $dst[]=$owner;
  }
  
  // The request submitter(s) if they wish to be notified
  $notify_src=getvalue("requests","notify_src",$req,"");
  $sql="select person from request_submitters where request = $req";
  $submitters_result=CRM_run_query($sql);
  while ($submitter_row=OPT_fetch_row($submitters_result))
  {
    if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
    {
      $dst[]=$submitter_row[0];
    }
  }
  
  $v[]="email";
  $v[]="sal";
  $v[]="fname";
  $v[]="lname";
  $s=getvalue("people",$v,$CRM_user);
  $p_n=getvalue("projects","name",$proj);
  
  $priority_str=$priorities[$priority];  
  $oldpriority_str=$priorities[$oldpriority];
  
  for ($i=0;$i<sizeOf($dst);$i++) 
  {
    OPT_locale($dst[$i]);
    switch ($stat)
    {
      case 1: $newstat="Open"; break;
      case 2: $newstat="Resolved"; break;
      default: $newstat=$extra_statuses[$stat-3];
    }	  
    
    if ($owner)
    {
      $o[]="sal";
      $o[]="fname";
      $o[]="lname";
      $own=getvalue("people",$o,$owner);
      $own=sprintf(__("This request is owned by %s."),"$own[0] $own[1] $own[2]");
    }
    else
    {
      $own=__("This request currently has no owner.");
    }
    
    
    $d=getvalue("people",$v,$dst[$i]);
    $name="$d[1] $d[3]";
    OPT_notify($dst[$i],sprintf(__("OPT request %s priority change"),"$reqidstr\"$title\""),
	       sprintf(__("Dear %s,\n".
			  "%s changed the priority of request %s ".
			  "related to the %s project with status %s. ".
			  "The priority changed from %s to %s. %s\n\n".
			  "The request body follows:\n".
			  "------------------------------------------------------------------------\n".
			  "%s\n".
			  "------------------------------------------------------------------------\n".
			  "This request is accessible on the OPT server at this URL:\n"),$name,"$s[1] $s[2] $s[3]",
		       "$reqidstr\"$title\"","\"$p_n\"","\"$newstat\"","\"$oldpriority_str\"","\"$priority_str\"",$own,$comments).
	       "http://$SERVER_NAME$CRM_URL?URL=".
	       rawurlencode("rt/req_view/?proj=$proj&req=$req"),
	       __("You may post comments on the request by replying ".
		  "to this e-mail. Please note only the message body will be ".
		  "uploaded to OPT. You may also post comments by ".
		  "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
		  "please don't quote the original message since the quoted text ".
		  "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
	       "OPT request #$req <$CRM_system_email>");
  }
  OPT_locale();
  unset($stat);
  unset($milestone);
  unset($category);
  
  // Log the change
  $entry=addslashes("Priority changed from $oldpriority_str to $priority_str.");
  CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '$entry')");
}

// We have to update the request status
if (($req) && ($stat) && (crm_perm("requests",$req, EDIT)))
{
  unset($dst); 
  // If the request was marked as resolved, set the resolved_date to now
  if ($stat == 2)
  {
    $resolved_date='now()';  // MySQL now() will update to current time
  } 
  else
  { 
    $resolved_date="0"; // no longer resolved, so no resolved_date
  }
  $oldstat = getvalue("requests", "status", $req);
  $sql="update requests set status=\"$stat\", date=date, resolved_date=$resolved_date where id=$req";
  $result=CRM_run_query($sql);
  
  // This is where the notification takes place!
  $rq[]="title";
  $rq[]="request";
  $rq[]="owner";
  $rqt=getvalue("requests",$rq,$req);
  $title=$rqt[0];
  $comments=$rqt[1];
  $owner=$rqt[2];
  
  OPT_confirm(__("Request status successfully updated"));
  
  // If whole team notify is enabled then add all team members 
  if (get_project_setting($proj, "notify_whole_team_on_new_requests") == "1")
  {
    OPT_confirm(__("Notifying project participants..."));
    $result = get_people_involved_with_project($proj, "id");
    while ($myrow=OPT_fetch_row($result))
    {
      $dst[]=$myrow[0];
    }
  }
  
  // Always notify the request owner...
  if ($owner && (!@in_array($owner,$dst)))
  {
    $dst[]=$owner;
  }
  
  // The request submitter(s) if they wish to be notified
  $notify_src=getvalue("requests","notify_src",$req,"");
  $sql="select person from request_submitters where request = $req";
  $submitters_result=CRM_run_query($sql);
  while ($submitter_row=OPT_fetch_row($submitters_result))
  {
    if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
    {
      $dst[]=$submitter_row[0];
    }
  }
  
  $v[]="email";
  $v[]="sal";
  $v[]="fname";
  $v[]="lname";
  $s=getvalue("people",$v,$CRM_user);
  $p_n=getvalue("projects","name",$proj);
  
  
  switch ($oldstat)
  {
    case 1: $oldstat_str="Open"; break;
    case 2: $oldstat_str="Resolved"; break;
    default: $oldstat_str=$extra_statuses[$stat-3];
  }
  
  for ($i=0;$i<sizeOf($dst);$i++) 
  {
    OPT_locale($dst[$i]);
    
    switch ($stat)
    {
      case 1: $newstat="Open"; break;
      case 2: $newstat="Resolved"; break;
      default: $newstat=$extra_statuses[$stat-3];
    }
    if ($owner)
    {
      $o[]="sal";
      $o[]="fname";
      $o[]="lname";
      $own=getvalue("people",$o,$owner);
      $own=sprintf(__("This request is owned by %s."),"$own[0] $own[1] $own[2]");
    }
    else
    {
      $own=__("This request currently has no owner.");
    }
    
    $d=getvalue("people",$v,$dst[$i]);
    $name="$d[1] $d[3]";
    OPT_notify($dst[$i],sprintf(__("OPT request %s status change"),"$reqidstr\"$title\""),
	       sprintf(__("Dear %s,\n".
			  "%s changed the status of request %s ".
			  "related to the %s project to status %s. ".
			  "The status changed from %s to %s. %s\n\n".
			  "The request body follows:\n".
			  "------------------------------------------------------------------------\n".
			  "%s\n".
			  "------------------------------------------------------------------------\n".
			  "This request is accessible on the OPT server at this URL:\n"),$name,"$s[1] $s[2] $s[3]",
		       "$reqidstr\"$title\"","\"$p_n\"","\"$newstat\"","\"$oldstat_str\"","\"$newstat\"",$own,$comments).
	       "http://$SERVER_NAME$CRM_URL?URL=".
	       rawurlencode("rt/req_view/?proj=$proj&req=$req"),
	       __("You may post comments on the request by replying ".
		  "to this e-mail. Please note only the message body will be ".
		  "uploaded to OPT. You may also post comments by ".
		  "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
		  "please don't quote the original message since the quoted text ".
		  "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
	       "OPT request #$req <$CRM_system_email>");
  }
  OPT_locale();
  unset($milestone);
  unset($category);
  
  // Log the change
  $entry=addslashes("Status changed from $oldstat_str to $newstat.");
  CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '$entry')");
}


// Milestone changed by PM or owner
if(($req) && (sizeof($milestone)) && (crm_perm("requests",$req, EDIT)))
{
  unset($dst);       
  $stat = getvalue("requests", "status", $req);
  
  $sql="update requests set milestone=$milestone_indx[$milestone], date=date where id=$req";
  $result=CRM_run_query($sql);
  
  // This is where the notification takes place!
  $rq[]="title";
  $rq[]="request";
  $rq[]="owner";
  $rqt=getvalue("requests",$rq,$req);
  $title=$rqt[0];
  $comments=$rqt[1];
  $owner=$rqt[2];
  
  OPT_confirm(__("Request milestone successfully updated"));
  
  // If whole team notify is enabled then add all team members 
  if (get_project_setting($proj, "notify_whole_team_on_new_requests") == "1")
  {
    OPT_confirm(__("Notifying project participants..."));
    $result = get_people_involved_with_project($proj, "id");
    while ($myrow=OPT_fetch_row($result))
    {
      $dst[]=$myrow[0];
    }
  }
  
  // Always notify the request owner...
  if ($owner && (!@in_array($owner,$dst)))
  {
    $dst[]=$owner;
  }
  
  // The request submitter(s) if they wish to be notified
  $notify_src=getvalue("requests","notify_src",$req,"");
  $sql="select person from request_submitters where request = $req";
  $submitters_result=CRM_run_query($sql);
  while ($submitter_row=OPT_fetch_row($submitters_result))
  {
    if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
    {
      $dst[]=$submitter_row[0];
    }
  }
  
  $v[]="email";
  $v[]="sal";
  $v[]="fname";
  $v[]="lname";
  $s=getvalue("people",$v,$CRM_user);
  $p_n=getvalue("projects","name",$proj);
  
  $milestone_str=$milestone_name[$milestone]; 
  $oldmilestone_str=$milestone_name[$oldmilestone];
  
  for ($i=0;$i<sizeOf($dst);$i++) 
  {
    OPT_locale($dst[$i]);
    switch ($stat)
    {
      case 1: $newstat="Open"; break;
      case 2: $newstat="Resolved"; break;
      default: $newstat=$extra_statuses[$stat-3];
    }	  
    
    if ($owner)
    {
      $o[]="sal";
      $o[]="fname";
      $o[]="lname";
      $own=getvalue("people",$o,$owner);
      $own=sprintf(__("This request is owned by %s."),"$own[0] $own[1] $own[2]");
    }
    else
    {
      $own=__("This request currently has no owner.");
    }
    
    $d=getvalue("people",$v,$dst[$i]);
    $name="$d[1] $d[3]";
    OPT_notify($dst[$i],sprintf(__("OPT request %s milestone change"),"$reqidstr\"$title\""),
	       sprintf(__("Dear %s,\n".
			  "%s changed the milestone of request %s ".
			  "related to the %s project with status %s. ".
			  " The milestone changed from %s to %s. %s\n\n".
			  "The request body follows:\n".
			  "------------------------------------------------------------------------\n".
			  "%s\n".
			  "------------------------------------------------------------------------\n".
			  "This request is accessible on the OPT server at this URL:\n"),$name,"$s[1] $s[2] $s[3]",
		       "$reqidstr\"$title\"","\"$p_n\"","\"$newstat\"","\"$oldmilestone_str\"","\"$milestone_str\"",$own,$comments).
	       "http://$SERVER_NAME$CRM_URL?URL=".
	       rawurlencode("rt/req_view/?proj=$proj&req=$req"),
	       __("You may post comments on the request by replying ".
		  "to this e-mail. Please note only the message body will be ".
		  "uploaded to OPT. You may also post comments by ".
		  "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
		  "please don't quote the original message since the quoted text ".
		  "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
	       "OPT request #$req <$CRM_system_email>");
  }
  OPT_locale();
  unset($category);
  
  // Log the change
  $entry=addslashes("Milestone changed from $oldmilestone_str to $milestone_str.");
  CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '$entry')");
}

// Category changed by PM or owner
if(($req) && (sizeof($category)) && (crm_perm("requests",$req, EDIT)))
{
  unset($dst);       
  $stat = getvalue("requests", "status", $req);
  $sql="update requests set CatID=$category_indx[$category], date=date where id=$req";
  $result=CRM_run_query($sql);
  
  // This is where the notification takes place!
  $rq[]="title";
  $rq[]="request";
  $rq[]="owner";
  $rqt=getvalue("requests",$rq,$req);
  $title=$rqt[0];
  $comments=$rqt[1];
  $owner=$rqt[2];
  
  OPT_confirm(__("Request category successfully updated"));
  
  // If whole team notify is enabled then add all team members 
  if (get_project_setting($proj, "notify_whole_team_on_new_requests") == "1")
  {
    OPT_confirm(__("Notifying project participants..."));
    $result = get_people_involved_with_project($proj, "id");
    while ($myrow=OPT_fetch_row($result))
    {
      $dst[]=$myrow[0];
    }
  }
  
  // Always notify the request owner...
  if ($owner && (!@in_array($owner,$dst)))
  {
    $dst[]=$owner;
  }
  
  // The request submitter(s) if they wish to be notified
  $notify_src=getvalue("requests","notify_src",$req,"");
  $sql="select person from request_submitters where request = $req";
  $submitters_result=CRM_run_query($sql);
  while ($submitter_row=OPT_fetch_row($submitters_result))
  {
    if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
    {
      $dst[]=$submitter_row[0];
    }
  }
  
  $v[]="email";
  $v[]="sal";
  $v[]="fname";
  $v[]="lname";
  $s=getvalue("people",$v,$CRM_user);
  $p_n=getvalue("projects","name",$proj);
  
  $category_str=$category_name[$category];
  $oldcategory_str=$category_name[$oldcategory];
  
  for ($i=0;$i<sizeOf($dst);$i++) 
  {
    OPT_locale($dst[$i]);
    switch ($stat)
    {
      case 1: $newstat="Open"; break;
      case 2: $newstat="Resolved"; break;
      default: $newstat=$extra_statuses[$stat-3];
    }	  
      
    if ($owner)
    {
      $o[]="sal";
      $o[]="fname";
      $o[]="lname";
      $own=getvalue("people",$o,$owner);
      $own=sprintf(__("This request is owned by %s."),"$own[0] $own[1] $own[2]");
    }
    else
    {
      $own=__("This request currently has no owner.");
    }
    
    $d=getvalue("people",$v,$dst[$i]);
    $name="$d[1] $d[3]";
    OPT_notify($dst[$i],sprintf(__("OPT request %s category change"),"$reqidstr\"$title\""),
	       sprintf(__("Dear %s,\n".
			  "%s changed the category of request %s ".
			  "related to the %s project with status %s. ".
			  "The category changed from %s to %s. %s\n\n".
			  "The request body follows:\n".
			  "------------------------------------------------------------------------\n".
			  "%s\n".
			  "------------------------------------------------------------------------\n".
			  "This request is accessible on the OPT server at this URL:\n"),$name,"$s[1] $s[2] $s[3]",
		       "$reqidstr\"$title\"","\"$p_n\"","\"$newstat\"","\"$oldcategory_str\"","\"$category_str\"",$own,$comments).
	       "http://$SERVER_NAME$CRM_URL?URL=".
	       rawurlencode("rt/req_view/?proj=$proj&req=$req"),
	       __("You may post comments on the request by replying ".
		  "to this e-mail. Please note only the message body will be ".
		  "uploaded to OPT. You may also post comments by ".
		  "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
		  "please don't quote the original message since the quoted text ".
		  "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
	       "OPT request #$req <$CRM_system_email>");
  }
  OPT_locale();
  
  // Log the change
  $entry=addslashes("Category changed from $oldcategory_str to $category_str.");
  CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '$entry')");
}

?>
<script language="javascript">
<!--
parent.leftFrame.location='../leftMenu/?proj=<? echo("$proj"); ?>';
// -->
</script>
<form name="statuses" action="." method="POST" style="margin:0;">
<input type="hidden" name="proj" value="<? echo($proj); ?>" />

<?
include "$CRM_path/rt/filters.inc";  // bring in all the filters

// And now for the sorting issue
if (!isset($order))
{
  if (!$CRM_guest)
  {
    $order=read_Xtra("people",$CRM_user,"OPT_rt","order");
  }
  if (!$order)
  {
    $order="date";
  }
}
elseif (!$CRM_guest)
{
  write_Xtra("people",$CRM_user,"OPT_rt","order",$order);
}

// Go get all the requests to display
$cat_order=OPT_parse_order_string($order);
$orderby=OPT_build_order_query($cat_order);
$result=crm_elements("requests","$filter $orderby");

startTables(); // start of request listing
?>

<tr>
<td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">&nbsp;</td>
<?
if ($show_req_ids == "1")  // Optionally display request ID numbers
{
  echo(OPT_header_cell("id",$cat_order,__("ID"),"proj=$proj"));
}
echo(OPT_header_cell("title",$cat_order,__("Title"),"proj=$proj"));
echo(OPT_header_cell("",$cat_order,__("Owner"),"proj=$proj"));
echo(OPT_header_cell("priority",$cat_order,__("Priority"),"proj=$proj"));
echo(OPT_header_cell("date",$cat_order,__("Date"),"proj=$proj"));
echo(OPT_header_cell("status",$cat_order,__("Status"),"proj=$proj"));
if ($show_milestones == "1")
{
  echo(OPT_header_cell("",$cat_order,__("Milestone"),"proj=$proj"));
}
echo(OPT_header_cell("deadline",$cat_order,__("Deadline"),"proj=$proj"));
echo(OPT_header_cell("",$cat_order,__("Category"),"proj=$proj"));
if ($show_hours_column == "1")
{
  echo(OPT_header_cell("",$cat_order,__("Hrs"),"proj=$proj"));
}
?>
</tr>
<?
$col="'$OPT_col_md'";
if (OPT_num_rows($result) == 0)
{
  ?>
 <tr><td colspan="<?echo($table_cols);?>" class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" valign="middle">
    <i>No requests found matching your criteria.</i>
    </td></tr>
    <?
}

// The display loop
while ($myrow=OPT_fetch_array($result))
{
  if ($col=="'$OPT_col_md'")
  {
    $col="'$OPT_col_lt'";
  }
  else
  {
    $col="'$OPT_col_md'";
  }
  
  // New? Only for registered users
  echo("<tr>\n  <td bgcolor=$col align='center'>");
  if (!$CRM_guest)
  {
    $sql="select
              requests.id
            from
              requests, people
            where
              requests.date>people.prevlog and
              requests.id=".$myrow["id"]." and
              people.id=$CRM_user";
    $result2=crm_run_query($sql);
    if (OPT_num_rows($result2))
    {
      echo("  <img src='../../images/$OPT_icon_new'></td>\n");
    }
    else
    {
      echo("  &nbsp;</td>\n");
    }
  }
  else
  {
    echo("  &nbsp;</td>\n");
  }
  
  $id=$myrow["id"];
  
  // Request ID number
  if ($show_req_ids == "1")
  {
    echo("  <td class=\"regular\" align=\"center\" bgcolor=$col><A class=\"regular\" 
              href=\"../req_view/?proj=$proj&req=".$myrow["id"]."\">$id</a></td>\n");
  }
  
  // Title
  $title=htmlspecialchars(stripslashes($myrow["title"]), ENT_QUOTES);
  echo("  <td class=\"regular\" align='left' bgcolor=$col><A class=\"regular\" href=\"../req_view/?proj=$proj&req=".$myrow["id"]."\">$title</a></td>\n");
  
  // Owner (editable by the PM)
  if ((($CRM_user == $myrow["owner"])&& ($only_pm_can_edit_requests == 0))  || $ispm)
  {
    $owner_id=$myrow["owner"];
    echo("<td class=\"regular\" align=\"center\" bgcolor=$col>");
    echo("<select name=\"owner$id\" onChange=\"window.location='./?proj=$proj&req=$id&prev_owner=$owner_id&new_owner='+document.statuses.owner".$id."[document.statuses.owner$id.selectedIndex].value\">");
    echo("<option value='0'>Nobody</option>");
    // Get list of developers that are in groups with access to this project
    for ($i=0; $i<sizeOf($people_disp); $i++)
    {
      $tuple=$people_disp[$i];
      if ($tuple[0]==$myrow["owner"])
      {
	$sel=" selected";
      }
      else
      {
	$sel="";
      }
      echo("<option value=\"".$tuple[0]."\"$sel>".$tuple[1]."</option>\n");
    }
    echo("</select></td>");
  }
  else
  {   // Regular use, just display text
    $src[]="fname";
    $src[]="lname";
    if ($myrow["owner"])
    {
      if (crm_perm("people",$myrow["owner"]))
      {
	$a[0]="<A class=\"regular\" href=\"../../people/admin/?action=display&id=".$myrow["owner"]."\">";
	$a[1]="</A>";
      }
      else
      {
	$a[0]="";
	$a[1]="";
      }
      $src_name=getvalue("people",$src,$myrow["owner"]);
      $src_name=$a[0].$src_name[0]." ".$src_name[1].$a[1];
    }
    else
    {
      $src_name=__("Nobody");
    }
    echo("<td class=\"regular\" align=\"center\" bgcolor=$col>$src_name</td>\n");
  }
  
  
  // Priority
  echo("  <td class=\"regular\" bgcolor=$col align='center'>\n");
  if ((($CRM_user == $myrow["owner"]) && ($only_pm_can_set_request_priority == 0) && ($only_pm_can_edit_requests == 0))
      || $ispm)
  {
    $oldpriority_id=$myrow["priority"];
    echo("    <select name=\"priority$id\" onChange=\"window.location='./?proj=$proj&req=$id&oldpriority=$oldpriority_id&priority='+document.statuses.priority".$id."[document.statuses.priority$id.selectedIndex].value\">\n");
    
    for ($i=0;$i<sizeOf($priorities);$i++) 
    {
      unset($selected);
      if ($i==$myrow["priority"])
      {
	$selected="selected";
      }
      echo("<option value='".($i)."' $selected>".__($priorities[$i])."</option>\n");
    }
    
    echo("    </select>\n");
  }
  else
  {
    echo($priorities[$myrow["priority"]]);
  }
  echo("  </td>\n");
  
  // Date
  $date=niceDate("requests","date",$myrow["id"]);
  echo("  <td class=\"regular\" align=\"center\" bgcolor=$col>$date</td>\n");
  
  // Status (only owner can change or PM if request is not assigned (or PM even if owner and project setting is enabled))
  echo("  <td class=\"regular\" bgcolor=$col align='center'>\n");
  if (($CRM_user == $myrow["owner"]) || ($ispm && $pm_can_change_request_status_even_if_not_owner))
  {
    echo("    <select name=\"stat$id\" onChange=\"window.location='./?proj=$proj&req=$id&stat='+document.statuses.stat".$id."[document.statuses.stat$id.selectedIndex].value\">\n");
    unset($selected);
    if ($myrow["status"] == 1)
    {
      $selected="selected";
    }
    echo("<option value='1' $selected>Open</option>");
    
    for ($i=0;$i<sizeOf($extra_statuses);$i++) 
    {
      unset($selected);
      if ($i+3==$myrow["status"])
      {
	$selected="selected";
      }
      echo("<option value='".($i+3)."' $selected>".__($extra_statuses[$i])."</option>\n");
    }
    
    unset($selected);
    if ($myrow["status"] == 2)
    {
      $selected="selected";
    }
    echo("<option value='2' $selected>Resolved</option>");
    echo("    </select>\n");
  }
  else
  {
    switch ($myrow["status"])
    {
      case 1: echo("Open"); break;
      case 2: echo("Resolved"); break;
      default: echo($extra_statuses[$myrow["status"]-3]);
    }
  }
  echo("  </td>\n");
  
  // Milestone
  if ($show_milestones == "1")
  {
    echo("  <td class=\"regular\" bgcolor=$col align='center'>\n");
    if ((($CRM_user == $myrow["owner"]) && ($only_pm_can_edit_requests == 0)) || $ispm)
    {
      $oldmilestone_id=$myrow["milestone"];
      
      for ($i=0;$i<sizeOf($milestone_indx);$i++)
      {
	if ($milestone_indx[$i] == $oldmilestone_id)
	{
	  $oldmilestone = $i;
	}
      }

      echo("    <select name=\"milestone$id\" onChange=\"window.location='./?proj=$proj&req=$id&oldmilestone=$oldmilestone&milestone='+document.statuses.milestone".$id."[document.statuses.milestone$id.selectedIndex].value\">\n");	  
      
      for ($i=0;$i<sizeOf($milestone_indx);$i++) 
      {
	unset($selected);
	if ($milestone_indx[$i] == $myrow["milestone"])
	{
	  $selected="selected";
	}
	if (strlen($milestone_name[$i]) > 18)
	{
	  $mil_name = substr($milestone_name[$i], 0, 15);
	  $mil_name = $mil_name . '...';
	  echo("<option value='".($i)."' $selected>".__($mil_name)."</option>\n");
	}
	else
	{
	  echo("<option value='".($i)."' $selected>".__($milestone_name[$i])."</option>\n");
	}
      }
      
      echo("    </select>\n");
    }
    else
    {
      for ($i=0;$i<sizeOf($milestone_indx);$i++)
      {
	if ($milestone_indx[$i] == $myrow["milestone"])
	{
	  echo($milestone_name[$i]);
	}
      }
    }
    echo("  </td>\n");
  }
  
  // Deadline
  $deadline=niceDate("requests","deadline",$myrow["id"],1);
  if (!$deadline)
  {
    $deadline="&nbsp;";
  }
  unset($bold);
  if (getvalue("requests","(deadline<now()) and (status<>2)",$myrow["id"]))
  {
    $bold[]="<strong><font color=\"$OPT_col_attention\">";
    $bold[]="</font></strong>";
  }
  else
  {
    $bold[]="";
    $bold[]="";
  }
  echo("  <td class=\"regular\" align=\"center\" bgcolor=$col>$bold[0]$deadline$bold[1]</td>\n");
  
  // Category
  echo("  <td class=\"regular\" bgcolor=$col align='center'>\n");
  if ((($CRM_user == $myrow["owner"]) && ($only_pm_can_edit_requests == 0)) || $ispm)
  {
    $oldcategory_id=$myrow["CatID"];
    
    for ($i=0;$i<sizeOf($category_indx);$i++)
    {
      if ($category_indx[$i] == $oldcategory_id)
      {
	$oldcategory = $i;
      }
    }

    echo("    <select name=\"category$id\" onChange=\"window.location='./?proj=$proj&req=$id&oldcategory=$oldcategory&category='+document.statuses.category".$id."[document.statuses.category$id.selectedIndex].value\">\n");	
      
    for ($i=0;$i<sizeOf($category_indx);$i++) 
    {
      unset($selected);
      if ($category_indx[$i]==$myrow["CatID"])
      {
	$selected="selected";
      }
      if (strlen($category_name[$i]) > 18)
      {
	$cat_name = substr($category_name[$i], 0, 15);
	$cat_name = $cat_name . '...';
	echo("<option value='".($i)."' $selected>".__($cat_name)."</option>\n");
      }
      else
      { 
	echo("<option value='".($i)."' $selected>".__($category_name[$i])."</option>\n");
      }
    }
    echo("    </select>\n");
  }
  else
  {
    for ($i=0;$i<sizeOf($category_indx);$i++)
    {
      if ($category_indx[$i] == $myrow["CatID"])
      {
	echo($category_name[$i]);
      }
    }
  }    
    
  echo("  </td>\n");
  
  // Hours remaining
  if ($show_hours_column == "1")
  {
    $hrs_remaining=getvalue("requests", "TIME_TO_SEC(initial_estimate)/3600", $myrow["id"]);
    if (intval($hrs_remaining) == 0)
    {
      $hrs_remaining="";  // Will be empty string if no tasks and no initial estimate
    }
    else
    {
      $hrs_remaining=sprintf("%.0f", $hrs_remaining);
    }
    $sql="select count(*), sum(TIME_TO_SEC(estimated)/3600 * (100-PercentComplete)/100) from
          task, request2task where request2task.request = ".$myrow["id"]." and request2task.task = task.id";
    $task_hrs_res=CRM_run_query($sql);
    $task_hrs_row=OPT_fetch_row($task_hrs_res);
    if ($task_hrs_row[0] > 0)
    {   // This request has tasks associated with it, so use the sum of their time remaining
      $hrs_remaining="<b>".sprintf("%.0f",$task_hrs_row[1])."</b>"; 
      $total_hours+=$task_hrs_row[1];  // add task sum onto total
    }
    else
    {
      $total_hours+=$hrs_remaining;    // add request estimate onto total 
    }
    echo("  <td class=\"regular\" bgcolor=$col align='center'>$hrs_remaining</td>\n");
  }
  echo("</tr>\n");
}
?>
<tr>
<?
if ($show_hours_column == "1")
{
  $hint_colspan=$table_cols-1;
}
else
{
  $hint_colspan=$table_cols;
}
?>
<td class="small" align="left" bgcolor="<? echo $OPT_col_dk; ?>" colspan="<?echo($hint_colspan);?>">
<? echo(__("You may view any request's details by clicking on the its title. 
                Hours shown are amount of effort remaining.  Those in bold are broken down into 
                tasks and are probably more accurate. The total is shown to the right.")); ?>
</td>
<?
if ($show_hours_column == "1")
{
  ?>
 <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>" >
    <?echo(sprintf("%.0f", $total_hours));?>
    <?
}
?>
</td>
</tr>
<?
endTables();
echo("</form>");
auth_close();
?>
</BODY>
</HTML>
