<?
#
# Request search results page
#
  include "../../include/OPT_lib.php";
  auth_open();
  include "$CRM_inc/email.php";
  checkMail();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Request Search Results")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../images");
  make_main_title(__("Request Search Results"),"../../images");
  if (! $proj) {
    OPT_error(__("Please select a project first"));
    exit;
  }
  if (! crm_perm("projects",$proj)) {
    OPT_error(__("Classified"));
    exit;
  }

  $req=abs($req);

  // Get project settings once
  $show_milestones = get_project_setting($proj, "display_milestones_for_requests");
  $show_req_ids = get_setting("show_request_ids");
  $show_hours_column=get_project_setting($proj, "task_status_hours_remaining");
  $ispm = is_project_manager($proj);

  // Get the additional status values this PM has set.
  $statii=get_project_setting($proj, "request_status_options");
  $extra_statuses=explode("|", $statii);

  // Store names for people in memory to avoid hitting the database over and over
  $people_result=get_people_involved_with_project($proj);
  while ($people_row=OPT_fetch_array($people_result)) 
  {
      $people[] = array($people_row["id"], ($people_row["fname"] . ' ' . $people_row["lname"]));
  }

  // Store this list of priorities 
  $priorities = get_project_setting($proj, "request_priority");
  if (!$priorities) {
      $priorities=array();
  }
  $priorities = explode("|",$priorities);

  // Store this list of categories
  $cat_result=crm_run_query("select id, cat_name from project_categories where project = $proj");
  while ($cat_row=OPT_fetch_row($cat_result))
  {
      $categories[$cat_row[0]] = $cat_row[1];
  }
  $categories[0] = 'n/a';  // Use n/a if request is uncategorized

  // How many columns do we have
  if ($show_req_ids == "1")  // Optionally display request ID numbers
  {
      $table_cols=9;
  }
  else
  {
      $table_cols=8;
  }

  // Extra column for hours if they are important on this project
  if ($show_hours_column == "1")
  {
      $table_cols+=1;
  }
   
?>
  <script language="javascript">
  <!--
    parent.leftFrame.location='../leftMenu/?proj=<? echo("$proj"); ?>';
  // -->
  </script>
<?
  // And now for the sorting issue
  if (!isset($order)) {
    if (!$CRM_guest) {
      $order=read_Xtra("people",$CRM_user,"OPT_rt","order");
    }
    if (!$order) {
      $order="date";
    }
  } elseif (!$CRM_guest) {
    write_Xtra("people",$CRM_user,"OPT_rt","order",$order);
  }

// Save the query they just made for when they search this project next
include "$CRM_path/rt/req_search/save_query_values.inc";

// If this was a "Quick Search" then generate the SQL filter statement ($filter)
if ($quick_search)
{
    include "$CRM_path/rt/req_search/quick_search_filter.inc";
    $filter = get_quick_search_filter($quick_search_type, trim($quick_search_title));
} 
else if ($full_search)
{
    include "$CRM_path/rt/req_search/full_search_filter.inc";
}
else if ($saved_search)
{   
    if (!abs($saved_search_id))
    {
        OPT_error("Sorry.  You must specify a valid saved search to run...");
        exit(); 
    }   
 
    // Wants to run a saved search right away so go get field variables
    $sql="select name, value from search_fields where search = $saved_search_id";
    $result = CRM_run_query($sql);
    while ($row = OPT_fetch_row($result))
    {
        if (($row[0] == "selected_priorities") || ($row[0] == "selected_statuses")
            || ($row[0] == "selected_categories") || ($row[0] == "selected_milestones"))
        {   // This is an array that needs to be expanded
            $$row[0] = explode(",", $row[1]);
        }
        else
        {   // singular variable
            $$row[0] = $row[1];  // setting variable of name equal to value
        }
    }
    include "$CRM_path/rt/req_search/full_search_filter.inc";  // Now run the full search...
}
else
{
    OPT_error("Bad search request.  Please try again.  Contact OPT Administrator if this repeats.");
}

if (!$filter)
{
  OPT_error("Please specify some criteria for your search.");
  exit();
}
        
  // Go get all the requests to display
  $cat_order=OPT_parse_order_string($order);
  $orderby=OPT_build_order_query($cat_order);
  $result=crm_elements("requests","$filter $orderby");

  //echo("Filter: $filter<br />");
  startTables(); // start of request listing
?>

<?
// We need to build up a query string of all search parameters
// so that when a column ordering is clicked that list stays the
// same.
if ($full_search || $saved_search)
{  
   include "$CRM_path/rt/req_search/results_query_string.inc";
}
else if ($quick_search)
{
   $colQS = "quick_search=Search";
   $colQS .= "&quick_search_title=" . urlencode($quick_search_title);
   $colQS .= "&quick_search_type=" . $quick_search_type;
}

?>


<tr>
  <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">&nbsp;</td>
<?
  if ($show_req_ids == "1")  // Optionally display request ID numbers
  {
      echo(OPT_header_cell("id",$cat_order,__("ID"),"proj=$proj&$colQS"));
  }
  echo(OPT_header_cell("title",$cat_order,__("Title"),"proj=$proj&$colQS"));
  echo(OPT_header_cell("",$cat_order,__("Owner"),"proj=$proj&$colQS"));
  echo(OPT_header_cell("priority",$cat_order,__("Priority"),"proj=$proj&$colQS"));
  echo(OPT_header_cell("date",$cat_order,__("Date"),"proj=$proj&$colQS"));
  echo(OPT_header_cell("status",$cat_order,__("Status"),"proj=$proj&$colQS"));
  echo(OPT_header_cell("deadline",$cat_order,__("Deadline"),"proj=$proj&$colQS"));
  echo(OPT_header_cell("",$cat_order,__("Category"),"proj=$proj&$colQS"));
  if ($show_hours_column == "1")
  {
      echo(OPT_header_cell("",$cat_order,__("Hrs"),"proj=$proj&$colQS"));
  }
?>
</tr>
<?
  $col="'$OPT_col_md'";
  if (OPT_num_rows($result) == 0)
  {
 ?>
<tr><td colspan="<?echo($table_cols);?>" class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" valign="middle">
<i>No requests found matching your criteria.</i>
</td></tr>
<?
  }

  // The display loop
  while ($myrow=OPT_fetch_array($result)) {
    if ($col=="'$OPT_col_md'") {
      $col="'$OPT_col_lt'";
    } else {
      $col="'$OPT_col_md'";
    }

    // New? Only for registered users
    echo("<tr>\n  <td bgcolor=$col align='center'>");
    if (!$CRM_guest) {
      $sql="select
              requests.id
            from
              requests, people
            where
              requests.date>people.prevlog and
              requests.id=".$myrow["id"]." and
              people.id=$CRM_user";
      $result2=crm_run_query($sql);
      if (OPT_num_rows($result2)) {
        echo("  <img src='../../images/$OPT_icon_new'></td>\n");
      } else {
        echo("  &nbsp;</td>\n");
      }
    } else {
      echo("  &nbsp;</td>\n");
    }

    $id=$myrow["id"];

    // Request ID number
    if ($show_req_ids == "1")
    {
      echo("  <td class=\"regular\" align=\"center\" bgcolor=$col><A class=\"regular\" 
              href=\"../req_view/?proj=$proj&req=".$myrow["id"]."\">$id</a></td>\n");
    }
    
    // Title
    $title=htmlspecialchars(stripslashes($myrow["title"]), ENT_QUOTES);
    echo("  <td class=\"regular\" align='left' bgcolor=$col><A class=\"regular\" href=\"../req_view/?proj=$proj&req=".$myrow["id"]."\">$title</a></td>\n");

    // Owner 
    $src[]="fname";
    $src[]="lname";
    if ($myrow["owner"]) {
        if (crm_perm("people",$myrow["owner"])) {
            $a[0]="<A class=\"regular\" href=\"../../people/admin/?action=display&id=".$myrow["owner"]."\">";
            $a[1]="</A>";
        } else {
            $a[0]="";
            $a[1]="";
        }
        $src_name=getvalue("people",$src,$myrow["owner"]);
            $src_name=$a[0].$src_name[0]." ".$src_name[1].$a[1];
    } else {
        $src_name=__("Nobody");
    }
    echo("<td class=\"regular\" align=\"center\" bgcolor=$col>$src_name</td>\n");
            

    // Priority
    $priority=$myrow["priority"];
    if (!$priorities[$priority]) {
      $priorities[$priority]=$priority;
    }
    echo("  <td class=\"regular\" align=\"center\" bgcolor=$col>".__($priorities[$priority])."</td>\n");

    // Date
    $date=niceDate("requests","date",$myrow["id"]);
    echo("  <td class=\"regular\" align=\"center\" bgcolor=$col>$date</td>\n");

    // Status (only owner can change or PM if request is not assigned (or PM even if owner and project setting is enabled))
    echo("  <td class=\"regular\" bgcolor=$col align='center'>\n");
    switch ($myrow["status"])
    {
    case 1: echo("Open"); break;
    case 2: echo("Resolved"); break;
    default: echo($extra_statuses[$myrow["status"]-3]);
    }
    echo("  </td>\n");
    
    // Deadline
    $deadline=niceDate("requests","deadline",$myrow["id"],1);
    if (!$deadline) {
      $deadline="&nbsp;";
    }
    unset($bold);
    if (getvalue("requests","(deadline<now()) and (status<>2)",$myrow["id"])) {
      $bold[]="<strong><font color=\"$OPT_col_attention\">";
      $bold[]="</font></strong>";
    } else {
      $bold[]="";
      $bold[]="";
    }
    echo("  <td class=\"regular\" align=\"center\" bgcolor=$col>$bold[0]$deadline$bold[1]</td>\n");

    // Category
    $category=$categories[$myrow["CatID"]];
    echo("  <td class=\"regular\" bgcolor=$col align='center'>$category</td>\n");

    // Hours remaining
    if ($show_hours_column == "1")
    {
        $hrs_remaining=getvalue("requests", "TIME_TO_SEC(initial_estimate)/3600", $myrow["id"]);
        if (intval($hrs_remaining) == 0)
        {
            $hrs_remaining="";  // Will be empty string if no tasks and no initial estimate
        }
        else
        {
            $hrs_remaining=sprintf("%.0f", $hrs_remaining);
        }
        $sql="select count(*), sum(TIME_TO_SEC(estimated)/3600 * (100-PercentComplete)/100) from
          task, request2task where request2task.request = ".$myrow["id"]." and request2task.task = task.id";
        $task_hrs_res=CRM_run_query($sql);
        $task_hrs_row=OPT_fetch_row($task_hrs_res);
        if ($task_hrs_row[0] > 0)
        {   // This request has tasks associated with it, so use the sum of their time remaining
            $hrs_remaining="<b>".sprintf("%.0f",$task_hrs_row[1])."</b>"; 
            $total_hours+=$task_hrs_row[1];  // add task sum onto total
        }
        else
        {
            $total_hours+=$hrs_remaining;    // add request estimate onto total 
        }
        echo("  <td class=\"regular\" bgcolor=$col align='center'>$hrs_remaining</td>\n");
    }
    echo("</tr>\n");
  }
?>
<tr>
 <?
if ($show_hours_column == "1")
{
    $hint_colspan=$table_cols-1;
}
else
{
    $hint_colspan=$table_cols;
}
?>
  <td class="small" align="left" bgcolor="<? echo $OPT_col_dk; ?>" colspan="<?echo($hint_colspan);?>">
    <? echo(__("You may view any request's details by clicking on the its title. 
                Hours shown are amount of effort remaining.  Those in bold are broken down into 
                tasks and are probably more accurate. The total is shown to the right.")); ?>
  </td>
<?
if ($show_hours_column == "1")
{
?>
 <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>" >
 <?echo(sprintf("%.0f", $total_hours));?>
<?
}
?>
  </td>
</tr>
<?
  endTables();
  auth_close();
?>
</BODY>
</HTML>
