<?
// Generates a Gantt chart of the tasks associated with this request (given req as param)

if ($_REQUEST['_jpg_csimd'] == 1)
{
    include ("../../include/OPT_lib.php");
    auth_open();
    if (!crm_perm("requests",$req))
    {
        auth_close();
        exit;
    }
}
include ("$CRM_inc/jpgraph/jpgraph.php");
include ("$CRM_inc/jpgraph/jpgraph_gantt.php");

// Setup Gantt graph
$graph = new GanttGraph(700,0,'auto');
$graph->SetShadow();
$graph->SetBox();


// Set min and max for start and end
$start = INT_MAX;
$end = 0;

// Get all the tasks associated with this request
$sql="select task.id as id, TaskName, StartDate, StartDatePlanned, 
      EndDate, EndDatePlanned, PercentComplete, fname, personID from request2task,       
      task LEFT JOIN person_task ON task.id = person_task.taskID, people
      where request2task.task = task.id and request = $req
      and (StartDate > 0 OR StartDatePlanned > 0) and 
          (EndDate > 0 OR EndDatePlanned > 0) and
      people.id = person_task.personID
      order by people.fname, StartDate, StartDatePlanned"; 
$result = CRM_run_query($sql);
while ($row = OPT_fetch_array($result))
{
    $tasks[] = $row;  //save in array
    
    // See if we need to descrease the start date
    if (($row["StartDate"] < $start) && ($row["StartDate"] > 0))
    {
        $start = $row["StartDate"];
    }
    else if (($row["StartDatePlanned"] < $start) && ($row["StartDatePlanned"] > 0))
    {
        $start = $row["StartDatePlanned"];
    }       

    // See if we need to increase the end date
    if ($row["EndDate"] > $end)
    {
        $end = $row["EndDate"];
    }
    else if ($row["EndDatePlanned"] > $end)
    {
        $end = $row["EndDatePlanned"];
    } 
}

// Now convert to proper format for JpGraph
$start_date=date("Y-m-d", $start);
if (!$end)
{  // If end date is still empty, use now
   $end_date=date("Y-m-d");
}
else
{
   $end_date=date("Y-m-d", $end + 86400);
}

// Only show part of the Gantt
$graph->SetDateRange($start_date,$end_date);

// Determine which header for dates to show
if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365)  
{   // More than two years difference
    $graph->ShowHeaders(GANTT_HYEAR);
}
else if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365*(5/12))  
{   // More than five months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH);
}
else if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365*(2/12))  
{   // More than two months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH | GANTT_HWEEK);
}
else
{   // Less than two months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH | GANTT_HDAY | GANTT_HWEEK);
}

$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
$graph->scale->week->SetFont(FF_FONT1);

$bar_index = 0;  // incremented for each bar on chart

// Get all milestones for this project that fall within this time range
$sql="select due_date, name from project_milestones where project = ".abs($proj)." 
     and due_date >= '".OPT_gpc_slashes($start_date)."' and due_date <= '".OPT_gpc_slashes($end_date)."'";
$result=CRM_run_query($sql);
while ($row = OPT_fetch_row($result))
{
   $ms = new MileStone($bar_index++,"",$row[0],date("M d",strtotime($row[0])));
   $ms->title->SetFont(FF_FONT1,FS_BOLD);
   $graph->Add($ms);  // Add the milestone
   
   $vline = new GanttVLine($row[0], $row[1], "darkred"); // add it as a line as well to really stand out
   $vline->title->SetFont(FF_FONT1,FS_BOLD,10);
   $vline->SetDayOffset(0.5);    // Center the line in the day
   $graph->Add($vline);
}


$last_person = 0;
for ($i=0; $i<sizeOf($tasks); $i++)
{
    $row = $tasks[$i];

    if ($last_person != intVal($row["personID"]))
    {
        // Use milestones without
        $last_person = intVal($row["personID"]);
        $person_name = getvalue("people", "fname", $row["personID"]);
        $ms = new MileStone($bar_index++,$person_name,0,"");
        $ms->title->SetFont(FF_FONT1,FS_BOLD);
        $ms->title->SetColor("black");
        $graph->Add($ms);  // Add the milestone
    }

    // Determine the start date (real overrides planned)
    if ($row["StartDate"])
    {
        $task_start = date("Y-m-d", intVal($row["StartDate"]));
    }
    else
    {
        $task_start = date("Y-m-d", intVal($row["StartDatePlanned"]));
    }

    // Determine the end date (real overrides planned)
    if ($row["EndDate"])
    {
        $task_end = date("Y-m-d", intVal($row["EndDate"]));
    }
    else
    {
        $task_end = date("Y-m-d", intVal($row["EndDatePlanned"]));
    } 

    // Add a caption indicating the percentage of progress if it's in progress
    if ($row["PercentComplete"] && ($row["PercentComplete"] < 100))
    {
        $caption = "[" . $row["PercentComplete"] ."%]";
    }
    else
    {   // Don't show 100% complete as color makes it obvious
         $caption = "";
    }    
    
    $bar = new GanttBar($bar_index++,"Task #".$row["id"],$task_start,$task_end, $caption);
    
    // Set the progress amount on the bar
    $bar->SetPattern(BAND_RDIAG,"yellow");
    $bar->SetFillColor("red");
    $bar->progress->Set($row["PercentComplete"]/100);
    $bar->progress->SetPattern(GANTT_SOLID,"darkgreen");
    
    // Now add a Client side image map to link directly to task with hovering title
    $bar ->SetCSIMTarget ("../../tasks/task/index.php?proj=$proj&task=".$row["id"]."&action=display");
    $bar->SetCSIMAlt(str_replace("\"", "'", $row["TaskName"]));
    $bar->title-> SetCSIMTarget("../../tasks/task/index.php?proj=$proj&task=".$row["id"]."&action=display");
    $bar->title-> SetCSIMAlt("Click to view details");

    $graph->Add($bar);
        
}

$graph->StrokeCSIM('gantt_image.php');
if ($_REQUEST['_jpg_csimd'] == 1)
{
    auth_close();
}
?>
