<?
#
# Request details page
#
# Also adds comments and manages ownership
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Revision 1.0
  include "../../include/OPT_lib.php";
  auth_open();

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Request Details")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../images");
  make_main_title(__("Request Details"),"../../images");

  $req=abs($req);

  // No request selected
  if (!$req && ($Submit != __("Add Request")) && ($Submit != __("Edit Request")))
  {
    OPT_error(__("Please select a request first!"));
    exit;
  }

  if (!$proj)
  {
      $proj=getvalue("requests","aproj",$req);
  }

  // No permissions
  if ($req && !crm_perm("requests",$req))
  {
    OPT_error(__("Classified"));
    exit;
  }

  // Get the additional status values this PM has set.
  $statii=get_project_setting($proj, "request_status_options");
  $extra_statuses=explode("|", $statii);
  $request_owner = getvalue("requests", "owner", $req);

  // See if we should be displaying request IDs
  if(get_setting("request_ids"))
  {
    $reqidstr="#$req, ";
  } else {
    $reqidstr="";
  }

  // Do we need to attach an existing task to this request?
  if (intval($attach_existing_task) > 0)
  { 
      $task_to_attach = intval($attach_existing_task);
      $task_proj = getvalue("task", "ProjectID", $task_to_attach);
      // Does task exist and is it in this project?
      if ($task_proj == $proj)
      {  
          $sql="replace into request2task values ($req, $task_to_attach)";
          CRM_run_query($sql);
          OPT_confirm("Successfully associated existing task #$task_to_attach with this request.");
      }
      else
      {
          OPT_confirm("Sorry, task #$task_to_attach does not exist or is in a different project.");
      }
  }

  // Are we removing an existing task to request link?
  if (intval($delete_task_link) > 0)
  {
      $task_to_delete=intval($delete_task_link);
      $sql="delete from request2task where request=$req and task=$task_to_delete";
      CRM_run_query($sql);
      OPT_confirm("Successfully deleted link to task #$task_to_delete");
  }

  // We have to update the request status
  if (($req) && ($stat) && ($stat!=getvalue("requests","status",$req)) && crm_perm("requests",$req, EDIT))
  {
    unset($dst);
    // If the request was marked as resolved, set the resolved_date to now
    if ($stat == 2)
    {
        $resolved_date='now()';  // MySQL now() will update to current time
    }
    else
    { 
      $resolved_date="0"; // no longer resolved, so no resolved_date
    }
    $sql="update requests set status=\"$stat\", date=date, resolved_date=$resolved_date where id=$req";
    $result=CRM_run_query($sql);

    // This is where the notification takes place!
    $rq[]="title";
    $rq[]="request";
    $rq[]="owner";
    $rqt=getvalue("requests",$rq,$req);
    $title=$rqt[0];
    $comments=$rqt[1];
    $owner=$rqt[2];

    OPT_confirm(__("Request status successfully updated"));

    // We'll find out who should be notified
    // Always notify the request owner...
    if ($owner && (!@in_array($owner,$dst)))
    {
      $dst[]=$owner;
    }

    // The request submitter(s) if they wish to be notified
    $notify_src=getvalue("requests","notify_src",$req,"");
    $sql="select person from request_submitters where request = $req";
    $submitters_result=CRM_run_query($sql);
    while ($submitter_row=OPT_fetch_row($submitters_result))
    {
        if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
        {
            $dst[]=$submitter_row[0];
        }
    }

    $v[]="email";
    $v[]="sal";
    $v[]="fname";
    $v[]="lname";
    $s=getvalue("people",$v,$CRM_user);
    $p_n=getvalue("projects","name",$proj);

    for ($i=0;$i<sizeOf($dst);$i++) 
    {
      OPT_locale($dst[$i]);

      switch ($stat)
      {
      case 1: $newstat="Open"; break;
      case 2: $newstat="Resolved"; break;
      default: $newstat=$extra_statuses[$stat-3];
      }
      if ($owner)
      {
        $o[]="sal";
        $o[]="fname";
        $o[]="lname";
        $own=getvalue("people",$o,$owner);
        $own=sprintf(__("This request is owned by %s."),"$own[0] $own[1] $own[2]");
      }
      else
      {
        $own=__("This request currently has no owner");
      }

      $d=getvalue("people",$v,$dst[$i]);
      $name="$d[1] $d[3]";
      OPT_notify($dst[$i],sprintf(__("OPT request %s status change"),"$reqidstr\"$title\""),
        sprintf(__("Dear %s,\n".
        "%s changed the status of request %s ".
        "related to the %s project to status %s. %s\n\n".
        "The request body follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n".
        "This request is accessible on the OPT server at this URL:\n"),$name,"$s[1] $s[2] $s[3]",
        "$reqidstr\"$title\"","\"$p_n\"","\"$newstat\"",$own,$comments).
        "http://$SERVER_NAME$CRM_URL?URL=".
        rawurlencode("rt/req_view/?proj=$proj&req=$req"),
        __("You may post comments on the request by replying ".
        "to this e-mail. Please note only the message body will be ".
        "uploaded to OPT. You may also post comments by ".
        "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
        "please don't quote the original message since the quoted text ".
        "will also get unnecessarily posted on the OPT system.\n\nThank you!"),
        "OPT request #$req <$CRM_system_email>");
    }
    OPT_locale();
   
    // Log the status change
    $entry=addslashes("Status changed to $newstat.");
    CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '$entry')");
  }

  // We have a new request submission or an update!
  if ((($Submit==__("Add Request")) || ($Submit==__("Edit Request"))) && !$CRM_guest) {
    unset($dst);
    if (!$title) {
      OPT_error(__("You must enter a title for the request to be valid! ".
            "Please click the 'Back' button in your browser and enter one!"));
      auth_close();
      exit;
    }

    if ($deadline) {
      $deadline=OPT_gpc_slashes($deadline);
    } else {
      $deadline="00000000000000";
    }
    $owner=abs($owner);

    $category=abs($category);
    $proj=abs($proj);
    $scomments=OPT_gpc_slashes($comments);
    $stitle=OPT_gpc_slashes($title);
    $notify_src=abs($notify_src);
    $milestone=abs($milestone);

    // If we got a category, but not an owner set the owner as category owner
    if ($category && $no_owner_use_category)
    {
        $owner=getvalue("project_categories", "person", $category);
    }

    if ($initial_estimate)
    {
        $initial_estimate=OPT_gpc_slashes($initial_estimate);
        $estimate_count=sizeOf(explode(":",$initial_estimate));
        if ($estimate_count==1) {
            $initial_estimate.=":00:00";
        } elseif ($estimate_count==2) {
            $initial_estimate.=":00";
        }
    }
    else
    {
        $initial_estimate=0;
    }
    
    // Now add the request submitters with a multi-value insert
    if (!$submitters)
    {  // Must be a client, so they are the only submitter
       $submitters[] = $CRM_user;
    }  

    if ($Submit==__("Add Request")) {

        // Only some users can give it a priority so if didn't get one, it gets the default level
        if (strlen($priority) > 0)
        {
            $priority= abs($priority);
        }
        else
        {
            $priority = get_project_setting($proj, "default_priority_level");
        }
      $action="New";
      $action_phrase = "posted a new";
      $req=OPT_get_ID("requests");
      $sql="insert into requests set id=$req, title=\"$stitle\", aproj=\"$proj\",
            owner=\"$owner\", request=\"$scomments\", notify_src=\"$notify_src\", deadline=\"$deadline\",
            priority=\"$priority\", CatID=\"$category\", 
            resolved_date=0, initial_estimate=\"$initial_estimate\", milestone=\"$milestone\"";
      $result=CRM_run_query($sql);
      // Log the addition of the request
      CRM_run_query("insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, 'Request created')");
    } else {

        // Only some users can give it a priority so if didn't get one, it gets the default level
        if (strlen($priority) > 0)
        {
	  $priority = abs($priority);	  
	  $priority_sql="priority = " . $priority;
        }
        else
        {
            $priority_sql="priority = priority"; // Keeps the same priority as before
        }

        // Figure out what changed and include it in the email (and log it too!)
        $sub_sql="select person from request_submitters where request = $req order by person";
        $sub_res=CRM_run_query($sub_sql);        
        if (OPT_num_rows($sub_res) != sizeOf($submitters))
        {  // Someone was added or deleted
            $submitters_changed = 1;
        }
        while ($sub_row=OPT_fetch_row($sub_res))
        {
            if (!@in_array($sub_row[0], $submitters))
            {
                $submitters_changed = 1;
            }
            $old_submitters[] = $sub_row[0];
        }
        if ($submitters_changed)
        {
            $changed_desc="Submitter(s) changed from ";
            for ($i=0; $i<sizeOf($old_submitters); $i++)
            {
                $old_sub_names[] = getvalue("people", "CONCAT(fname,' ',lname)", $old_submitters[$i]);
            }
            $changed_desc=$changed_desc . implode(", ", $old_sub_names);
            $changed_desc=$changed_desc." to ";
            for ($i=0; $i<sizeOf($submitters); $i++)
            {
                $new_sub_names[] = getvalue("people", "CONCAT(fname,' ',lname)", $submitters[$i]);
            }
            $changed_desc=$changed_desc . implode(", ", $new_sub_names)."\n";
        }
        $prev_owner=getvalue("requests", "owner", $req);
        if ($prev_owner != $owner)
        {
            $prev_owner_name = getvalue("people", "CONCAT(fname,' ',lname)", $prev_owner, "Nobody");
            $new_owner_name = getvalue("people", "CONCAT(fname,' ',lname)", $owner, "Nobody");
            $changed_desc=$changed_desc."Owner changed from $prev_owner_name to $new_owner_name\n";
        }
        $prev_priority=getvalue("requests", "priority", $req);
	if (!sizeOf($priority))
	{
	  $priority = $prev_priority;
	}
        if ($prev_priority != $priority)
        {
            $priorities = preg_split('/\|/',get_project_setting($proj, "request_priority"));
            $changed_desc=$changed_desc."Priority changed from ".$priorities[$prev_priority]." to ".$priorities[$priority]."\n";
        }
        $prev_estimate=getvalue("requests", "initial_estimate", $req);
        if (((get_project_setting($proj,"only_pm_can_see_request_estimate") != '1') || is_project_manager($proj)) 
            && ($prev_estimate != $initial_estimate))
        {
            $changed_desc=$changed_desc."Initial estimate changed from $prev_estimate to $initial_estimate\n";
        }
        $prev_category=getvalue("requests", "CatID", $req);
        if ($prev_category != $category)
        {
            $prev_cat_name = getvalue("project_categories", "cat_name", $prev_category, "n/a");
            $new_cat_name = getvalue("project_categories", "cat_name", $category, "n/a");
            $changed_desc=$changed_desc."Cateogry changed from $prev_cat_name to $new_cat_name\n";
        }
        $prev_milestone=getvalue("requests", "milestone", $req);
        if ($prev_milestone != $milestone)
        {
            $prev_milestone_name = getvalue("project_milestones", "name", $prev_milestone, "n/a");
            $new_milestone_name = getvalue("project_milestones", "name", $milestone, "n/a");
            $changed_desc=$changed_desc."Milestone changed from $prev_milestone_name to $new_milestone_name\n";
        }
        $prev_deadline=getvalue("requests", "DATE_FORMAT(deadline,'%Y-%m-%d')", $req);
        if (strtotime($prev_deadline) != strtotime($deadline))
        {
            if ($prev_deadline == "0000-00-00")
            {
                $prev_deadline='n/a';
            }
            $deadline_str=$deadline;
            if ($deadline == "00000000000000")
            {
                $deadline_str='n/a';
            }
            if ($prev_deadline != $deadline_str)
            {
                $changed_desc=$changed_desc."Deadline changed from ".substr($prev_deadline,0,10)." to ".substr($deadline_str,0,10)."\n";
            }
        }
        $prev_title=getvalue("requests", "title", $req);
        if ($prev_title != stripslashes($stitle))
        {
            $changed_desc=$changed_desc."Title changed from: '$prev_title' to '".stripslashes($stitle)."'\n";
        }
        $prev_desc=getvalue("requests", "request", $req);
        if ($prev_desc != stripslashes($scomments))
        {
            $changed_desc=$changed_desc."Description was changed.\n";
        }
        
        $action = "Updated";
        $action_phrase = "updated a";
        $sql="update requests set title=\"$stitle\", aproj=\"$proj\",
            owner=\"$owner\", request=\"$scomments\", notify_src=\"$notify_src\", deadline=\"$deadline\",
            $priority_sql, initial_estimate=\"$initial_estimate\", 
            CatID=\"$category\", date=date, milestone=\"$milestone\" where id=\"$req\"";
        $result=CRM_run_query($sql);
        // Now log the change 
        $log_query = "insert into log (obj_type, obj_id, edited_by, entry) values ('requests', $req, $CRM_user, '" 
                      . addslashes("Request details edited...\n" . $changed_desc). "')";
        CRM_run_query($log_query);
    }
  
    CRM_run_query("delete from request_submitters where request = $req");
    $insert_sql="insert into request_submitters (request, person) VALUES ";
    for ($i=0; $i<sizeOf($submitters); $i++)
    {
        $insert_sql=$insert_sql . "($req, $submitters[$i]), ";
    }
    $insert_sql = substr($insert_sql, 0, (strlen($insert_sql)-2));
    CRM_run_query($insert_sql);
    
    // Add any associated tasks if needed
    if ($task)
    {
        $sql="replace into request2task values ($req,$task)";
        crm_run_query($sql);
    }

    if ($Submit==__("Add Request"))
    {
        OPT_confirm(__("Request successfully created."));
    }
    elseif ($Submit==__("Edit Request"))
    {
        OPT_confirm(__("Request successfully edited."));
    }

    // If whole team notify is enabled then add all team members 
    if ((($Submit==__("Add Request")) || ($Submit==__("Edit Request"))) && 
        (get_project_setting($proj, "notify_whole_team_on_new_requests") == "1"))
    {
      OPT_confirm(__("Notifying project participants..."));
      $result = get_people_involved_with_project($proj, "id");
      while ($myrow=OPT_fetch_row($result)) {
        $dst[]=$myrow[0];
      }
    }

    // Always notify the request owner...
    if ($owner && (!@in_array($owner,$dst))) {
      $dst[]=$owner;
    }

    // The request submitter(s) if they wish to be notified
    $notify_src=getvalue("requests","notify_src",$req,"");
    for ($i=0; $i<sizeOf($submitters); $i++)
    {
        if (($notify_src == "1") && !@in_array($submitters[$i],$dst))
        {
            $dst[]=$submitters[$i];
        }
    }

    $v[]="email";
    $v[]="sal";
    $v[]="fname";
    $v[]="lname";
    $s=getvalue("people",$v,$CRM_user);
    $p_n=getvalue("projects","name",$proj);

    for ($i=0;$i<sizeOf($dst);$i++) { // >
      OPT_locale($dst[$i]);
      $niceDeadline=niceDate("requests","deadline",$req,1);

      if ($niceDeadline) {
        $niceDeadline=sprintf(__("This request is due on %s."),$niceDeadline);
      } else {
        $niceDeadline=__("This request has no deadline.");
      }

      if ($owner) {
        $o[]="sal";
        $o[]="fname";
        $o[]="lname";
        $own=getvalue("people",$o,$owner);
        $own=sprintf(__("This request is currently owned by %s."),"$own[0] $own[1] $own[2]");
      } else {
        $own=__("This request currently has no owner.");
      }

      if ($changed_desc)
      {
          $changed_text="\nThe items just changed on this request include:\n".
              "------------------------------------------------------------------------\n".
              "$changed_desc".
              "------------------------------------------------------------------------\n";
      }

      $d=getvalue("people",$v,$dst[$i]);
      $name="$d[1] $d[3]";
      OPT_notify($dst[$i],sprintf(__("%s OPT request: %s"),"$action", "\"".stripslashes($title)."\""),
        sprintf(__("Dear %s,\n".
        "%s %s request on OPT ".
        "related to the %s project.  %s\n".
        "The request body follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n".
        "%s".
        "This request is accessible on the OPT server at this URL:\n"),$name,
        "$s[1] $s[2] $s[3]",$action_phrase,"\"$p_n\"","$own $niceDeadline",stripslashes($comments), $changed_text).
        "http://$SERVER_NAME$CRM_URL?URL=".
        rawurlencode("rt/req_view/?proj=$proj&req=$req"),
        __("You may post comments on the request by replying ".
        "to this e-mail. Please note only the message body will be ".
        "uploaded to OPT. You may also post comments by ".
        "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
        "please don't quote the original message since the quoted text ".
        "will also get unnecessarily posted on OPT.\n\nThank you!"),
        "OPT request #$req <$CRM_system_email>");
    }
    OPT_locale();
  }

  // Add a new comment
  if ($addcomment && $comment)
  {
    unset($dst);
    $scomment=OPT_gpc_slashes($comment);
    $sql="insert into request_answers set comment=\"$scomment\",
          src=$CRM_user, request=$req";
    $result=CRM_run_query($sql);
    // This is where the notification takes place!
    $rq[]="title";
    $rq[]="request";
    $rq[]="owner";
    $rqt=getvalue("requests",$rq,$req);
    $title=$rqt[0];
    $comments=$rqt[1];
    $owner=$rqt[2];
    $o[]="sal";
    $o[]="fname";
    $o[]="lname";
    $own=getvalue("people",$o,$CRM_user);
    $own="$own[0] $own[1] $own[2]";

    // We'll find out who's involved.
    $notify_src=getvalue("requests","notify_src",$req,"");
    $sql="select person from request_submitters where request = $req";
    $submitters_result=CRM_run_query($sql);
    while ($submitter_row=OPT_fetch_row($submitters_result))
    {
        if (($notify_src == "1") && !@in_array($submitter_row[0],$dst))
        {
            $dst[]=$submitter_row[0];
        }
    }

    if (($owner) && ($owner!=$CRM_user) && ($owner!=$requestor_id))
    {
        if (!@in_array($owner, $dst))
        { 
             $dst[]=$owner;
        }
    }
    
    // Send to "Additional notifications" if any chosen
    for ($i=0; $i<sizeOf($additional_notifications); $i++)
    {
        if (!@in_array($addtional_notifications[$i], $dst))
        {
           $dst[] = $additional_notifications[$i];
        }
    }

    $v[]="email";
    $v[]="sal";
    $v[]="fname";
    $v[]="lname";
    $s=getvalue("people",$v,$CRM_user);
    $p_n=getvalue("projects","name",$proj);
    $title=stripslashes($title);

    for ($i=0;$i<sizeOf($dst);$i++) // >
    {
      OPT_locale($dst[$i]);
      $d=getvalue("people",$v,$dst[$i]);
      $name="$d[1] $d[3]";
      OPT_notify($dst[$i],sprintf(__("New comment on OPT request %s"),"$reqidstr\"$title\""),
        sprintf(__("Dear %s,\n".
        "%s posted a new comment on request %s ".
        "related to the %s project.\n\n".
        "The request BODY follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n\n".
        "The newly posted COMMENT follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n".
        "This request is accessible on the OPT server at this URL:\n"),$name,
        "$s[1] $s[2] $s[3]","$reqidstr\"$title\"","\"$p_n\"",$comments,stripslashes($comment)).
        "http://$SERVER_NAME$CRM_URL?URL=".
        rawurlencode("rt/req_view/?proj=$proj&req=$req"),
        __("You may post comments on the request by replying ".
        "to this e-mail. Please note only the message body will be ".
        "uploaded to OPT. You may also post comments by ".
        "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
        "please don't quote the original message since the quotation ".
        "will also get unnecessarily posted on OPT.\n\nThank you!"),
        "OPT request #$req <$CRM_system_email>");
    }
    OPT_locale();
  }
?>
  <script language="javascript">
  <!--
    parent.leftFrame.location='../leftMenu/?proj=<? echo("$proj&req=$req"); ?>';
    parent.topFrame.location='../../main_menu/?m1=Projects&m2=Requests&proj=<? echo("$proj&req=$req"); ?>&noupd=1';    
    function deleteTaskLink(task_id)
    {
        if (confirm("Are you sure you want to remove the link to this task? The task will not be deleted, just the association with this request."))
        { 
          document.location="./index.php?proj=<?echo($proj)?>&req=<?echo($req)?>&delete_task_link="+task_id;
        }
    }
  // -->
  </script>
<?
  startTables();
?>
<form name="statuses">
<tr>
  <td class="ah4" bgcolor="<? echo $OPT_col_dk; ?>" align="center" colspan="2">
    <? echo(htmlspecialchars(OPT_gpc_unslash(getvalue("requests","title",$req)))); ?>
    <? if (get_setting("show_request_ids") == "1") { echo(" [#$req]"); } ?>
  </td>
</tr>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right" width="25%"><b><? echo(__("Submitter(s)")); ?></b></td><?
  $sql="select people.id, CONCAT(fname,' ', lname) from request_submitters, people where request_submitters.person = people.id 
        and request_submitters.request = $req";
  $sub_res=CRM_run_query($sql); 
  while ($sub_row = OPT_fetch_row($sub_res))
  {
    if (crm_perm("people",$sub_row[0]))
    {
      $a[0]="<a href=\"../../people/admin/?action=display&id=".$sub_row[0]."\">";
      $a[1]="</A>";
      $src[]=$a[0].$sub_row[1].$a[1];
    }
    else
    {
      $src[]=$sub_row[1];
    }
    $notify_person_ids[] = $sub_row[0];
  }
  if ($src)
  { 
      $src=implode(", ", $src);
      if (getvalue("requests","notify_src",$req,""))
      {
         $notify_names = $src;
      }
  }
  ?>

  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><? echo($src); ?></td>
</tr>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Owner")); ?></b></td><?
  $person_id=getvalue("requests","owner",$req);
  $person_r[]="fname";
  $person_r[]="lname";
  if ($person_id)
  {
    if (crm_perm("people",$person_id))
    {
      $a[0]="<a href=\"../../people/admin/?action=display&id=".$person_id."\">";
      $a[1]="</a>";
    }
    else
    {
      $a[0]="";
      $a[1]="";

    }
    $person_name=getvalue("people",$person_r,$person_id);
    $src=$a[0].$person_name[0]." ".$person_name[1].$a[1];
    if (!@in_array($person_id, $notify_person_ids))
    {
       if ($notify_names)
       {   
           $notify_names .= ", " . $src;
       }
       else
       {   
           $notify_names = $src;
       }
       $notify_person_ids[] = $person_id;
    } 
  }
  else
  {
    $src=__("Nobody");
  }


  // Category of request
   $sql="select cat_name from project_categories, requests 
         where project_categories.id=requests.CatID and requests.id = $req";
   $res1=crm_run_query($sql);
   make_vars($res1);
   if (!$cat_name) {
       $cat_name = "n/a";
  }
  

  // Initial rough estimate (associated with whole request)
  $initial_estimate = makeNiceTime(getvalue("requests", "initial_estimate", $req));

  // Determine the number of hours of remaining effort
  $sql="select task from task, request2task where request2task.task = task.id and 
        task.estimated > 0 and request2task.request = $req";
  $tasks_result=crm_run_query($sql);
  if (OPT_num_rows($tasks_result) > 0) 
  {
      $sql="select SUM(TIME_TO_SEC(estimated)/3600*(1-PercentComplete/100)) from task, request2task where 
            task.id = request2task.task and request2task.request = $req";
      $total_hrs_result=crm_run_query($sql);
      $total_row=OPT_fetch_row($total_hrs_result);
      $total_hours_remaining=$total_row[0];
      $effort=sprintf("%.1f", $total_hours_remaining) . ' hours';
      // Determine the total number of hours worked so far
      $sql="select sum(TIME_TO_SEC(worked))/3600 from task_progress_history, request2task 
            where taskID = request2task.task and request2task.request = $req";
      $total_hrs_result=crm_run_query($sql);
      $total_row=OPT_fetch_row($total_hrs_result);
      $total_hours_remaining=$total_row[0];
      $effort=$effort." (".sprintf("%.1f", $total_hours_remaining) . ' hours worked)';
  }
  else
  {
      $no_tasks_associated = 1;
  }

  // List of associated tasks 
  if ($req)
  {
      $sql="select task, taskname, TIME_TO_SEC(estimated)/3600*(1-PercentComplete/100), 
            TIME_TO_SEC(estimated)/3600 from request2task, 
            task where request2task.task = task.id and request = $req";
      $result=CRM_run_query($sql);
      $tsk="<ul style='margin:0;'>\n";
      while ($task_row=OPT_fetch_row($result))
      {
          $hrs_rem=sprintf("%.1f", $task_row[2]);
          $hrs_total=sprintf("%.1f", $task_row[3]);
          $task_name=stripslashes($task_row[1]);
          $tsk=$tsk."<li><a class='regular' title='$hrs_rem hours remaining out of $hrs_total'
               href='../../tasks/task/?proj=$proj&task=$task_row[0]&action=display' onclick=\"parent.topFrame.location='../../main_menu/?m1=Projects&m2=Tasks&proj=$proj&noupd=1';\">$task_name</a>";
          if (intVal($hrs_rem))
          {
             $tsk=$tsk." <font color='red'>($hrs_rem hrs)</font>";
          }              
          if (($CRM_user == $request_owner) || is_project_manager($proj) || is_admin())
          {   // Only admin, PM or request owner can delete existing task links
              $tsk=$tsk."<a href=\"#\" title=\"Remove task association with request.\" onclick=\"return deleteTaskLink($task_row[0]);\"><img src='../../images/trash.gif' height='15' border='0' /></a>";
          }
          $tsk=$tsk."</li>";
      }
      $tsk=$tsk."</ul>\n";
  }

  // Only team members can attach tasks to a request
  if ((crm_project_participant($CRM_user, $proj, DEVELOPER)) || is_admin())
  {
     $tsk_footer="Attach <input type='button' value='New Task'
           onclick=\"parent.topFrame.location='../../main_menu/?m1=Projects&m2=Tasks&proj=$proj&noupd=1';parent.mainFrame.location='../../tasks/task/?proj=$proj&action=add&req=$req';\" />";
     if ($no_tasks_associated == 1)
     {
         $tsk_footer=$tsk_footer."  or <input type='button' value='Only Task'
           onclick=\"parent.topFrame.location='../../main_menu/?m1=Projects&m2=Tasks&proj=$proj&noupd=1';parent.mainFrame.location='../../tasks/task/?proj=$proj&action=add&req=$req&option=singletask';\" />";
     }
     $tsk_footer=$tsk_footer." or an existing task #: <input type='text' name='attach_existing_task' size='4'/>
                  <input type='button' value='Attach' onclick=\"document.location='../../rt/req_view/?proj=$proj&req=$req&attach_existing_task='+form.attach_existing_task.value;\" />";
  }
 
?>



  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><? echo($src); ?></td>
</tr>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Category")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><? echo($cat_name); ?></td>
</tr>
  <? if ((get_project_setting($proj,"only_pm_can_see_request_estimate") != '1') || is_project_manager($proj))
{
?>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right" nowrap><b><? echo(__("Initial Effort Estimate")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><? echo($initial_estimate); echo(__(" hrs"));?></td>
</tr>
<?
}
// Only show task effort remaining if there are tasks associated with this request
if (!$no_tasks_associated)
{
?>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right" nowrap><b><? echo(__("Task Effort Remaining")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><? echo($effort); ?></td>
</tr>
<?
}
?>


<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right" nowrap><b><? echo(__("Associated Tasks")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><? echo($tsk); ?><? echo($tsk_footer); ?></td>
</tr>

<tr>
  <td valign="top" bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Associated Documents")); ?></b><br />
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left">
  <?
    $sql3 = "SELECT id, title, path, ver FROM documents, document_associations as da 
             WHERE da.doc = id and att_to ='$req' and att_type = 'requests' AND obsoletedby=0";
    $result3 = crm_run_query($sql3);
    if (OPT_num_rows($result3) > 0)
    {
        echo("<ul style='margin:0;'>");
    }    
    while ($resrow=OPT_fetch_array($result3)) {
      echo "<li><a class='regular' href='../../documents/Doc_View/?proj=$proj&doc=$resrow[0]&dir=$resrow[2]'>$resrow[1]</a> (Ver. $resrow[3])</li>\n";
    }
    if (OPT_num_rows($result3) > 0)
    {
        echo("</ul>");
    }
    if (crm_perm("requests", $req, VIEW))
    {  // Anyone who can view this request can attach a document to it
       echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i>(<a class='Regular' href='../../documents/Doc_Add/?proj=$proj&req=$req'>attach new</a>)</i>"; 
    } 
  ?>
  </td>
</tr>

<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Date")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><? echo(niceDate("requests","date",$req)); ?></td>
</tr>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Status")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>">

  <? // only owner can change or PM if request is not assigned
  $req_owner=getvalue("requests", "owner", $req);
  $stat=getvalue("requests","status",$req) ;
 
  // Status (only owner can change or PM if request is not assigned (or PM even if owner and project setting is enabled))
  if (($CRM_user == $req_owner) || (($req_owner == 0) && is_project_manager($proj))
        || (($req_owner > 0) && is_project_manager($proj) && 
            (get_project_setting($proj, "pm_can_change_request_status_even_if_not_owner") == '1')))
  {
      echo("<select name=\"stat\" onChange=\"window.location='./?proj=$proj&req=$req&stat='+document.statuses.stat[document.statuses.stat.selectedIndex].value\">\n");
      unset($selected);
      if ($stat == 1)
      {
          $selected="selected";
      }
      echo("<option value='1' $selected>Open</option>");

      for ($i=0;$i<sizeOf($extra_statuses);$i++) 
      {
          unset($selected);
          if ($i+3==$stat)
          {
              $selected="selected";
          }
          echo("<option value='".($i+3)."' $selected>".__($extra_statuses[$i])."</option>\n");
      }

      unset($selected);
      if ($stat == 2)
      {
          $selected="selected";
      }
      echo("<option value='2' $selected>Resolved</option>");
      echo("</select>\n");
  }
  else
  {
      switch ($stat)
      {
      case 1: echo("Open"); break;
      case 2: echo("Resolved"); break;
      default: echo($extra_statuses[$stat-3]);
      }
  }
 ?>
</td>
</tr>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Priority")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><?
    $priority = getvalue("requests","priority",$req);
    $priorities = preg_split('/\|/',get_project_setting($proj, "request_priority"));
    echo(__($priorities[$priority])."\n");
  ?></td>
</tr>

<?
if (get_project_setting($proj, "display_milestones_for_requests") == '1')
{
?>
<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Project Milestone")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>">
<? 
$sql="select name from project_milestones, requests where requests.id = $req and requests.milestone = project_milestones.id"; 
$milestone_result=CRM_run_query($sql);
 if (OPT_num_rows($milestone_result) == 1)
 {
     $milestone_row=OPT_fetch_row($milestone_result);
     echo("$milestone_row[0]");
 }
 else
 { 
     echo(" n/a");
 }
?>
  </td>
</tr>
<?
} // end of if should display milestone
?>

<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Deadline")); ?></b></td>
  <td class="regular" align="left" bgcolor="<? echo $OPT_col_lt; ?>"><?
    $ddl=niceDate("requests","deadline",$req,1);
    if (!$ddl)
    {
      echo(" n/a");
    }
    else
    {
      echo($ddl);
    }
  ?></td>
</tr>
<tr>
  <td colspan=2 class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b><? echo(__("Request Description")); ?></td>
</tr>


<tr>
  <td colspan=2 class="regular"  align=left bgcolor="<? echo $OPT_col_lt; ?>"><? echo(nl2br(htmlspecialchars(OPT_gpc_unslash(getvalue("requests","request",$req))))); ?></td>
</tr>

  <?  // Show request progress if there is any
  include "$CRM_path/rt/req_view/progress.inc"; 
  ?> 

<?
  $sql="select * from request_answers where request=$req order by date";
  $result=CRM_run_query($sql);
  if (OPT_num_rows($result))
  {
    echo("<tr><td class='regular' bgcolor='$OPT_col_dk' align='center' colspan='2'><b>".__("Comments on this request")."</b></td></tr>\n");
    $src_r[]="fname";
    $src_r[]="lname";
    while ($myrow=OPT_fetch_array($result))
    {
      echo("<tr><td class='regular' bgcolor='$OPT_col_lt' colspan='2'>\n");
      echo("<table width='100%' cellspacing='0' cellpadding='2' border='0'><tr>\n");
      $date=niceDate("request_answers","date",$myrow["id"]);
      if (crm_perm("people",$myrow["src"]))
      {
        $src=getvalue("people",$src_r,$myrow["src"]);
        $a[0]="<A class=\"small\" href=\"../../people/admin/?action=display&id=".$myrow["src"]."\">";
        $a[1]="</A>";
        //Bertelsen edited 1 line: $src changed to $src[0] $src[1] (bux fix)
        $theSrc=sprintf(__("Posted by %s on %s"),"$a[0] $src[0] $src[1] $a[1]",$date);
      }
      else
      {
        $theSrc=sprintf(__("Posted on %s"),$date);
      }
      echo("  <td class=\"small\" bgcolor=\"$OPT_col_md\" align='left'><i>$theSrc</i></td>\n");
      echo("</tr>\n<tr>\n");
      echo("  <td class=\"regular\"  align=left bgcolor=\"$OPT_col_lt\">".nl2br(htmlspecialchars(stripslashes($myrow["comment"])))."</td>\n");
      echo("</tr>\n");
      echo("</table></td></tr>\n");
    }
  }
  if ((!$CRM_guest) && (!$pf))
  {
?>
</form>

<tr>
<td class='regular' bgcolor="<? echo $OPT_col_md; ?>" align="center" colspan="2">
<b><? echo(__("You may post a comment below")); ?></b><br>
<?
// This form submission must be a post as M$ IE won't submit if you enter 
// a large amount of text and use GET as the action!
?>
<form action="./" method="post">
  <input type="hidden" name="req" value="<? echo $req; ?>">
  <input type="hidden" name="proj" value="<? echo $proj; ?>">
  <table cellpadding="2" cellspacing="2" width="100%"><tr><td align="right">
  <textarea name="comment" cols="65" rows="7" wrap="VIRTUAL"></textarea>
  </td><td align="center">
  <i>Also notify:</i></br>
  <select name='additional_notifications[]' multiple size="5">
  <? // Generate a list of team members on the project who aren't automatically notified
     $result = get_people_involved_with_project($proj);
     $notify_person_ids[] = $CRM_user;  // don't want option to notify self given
     while ($row = OPT_fetch_row($result))
     {
        if (!@in_array($row[0], $notify_person_ids))
        {
           echo("<option value='$row[0]'>$row[1] $row[2]</option>");
        }
     }
  ?>
  </select><br />
  <? if ($notify_names)
  {
  ?>
  <span class='small'><? echo($notify_names) ?><br />automatically notified.</span>
  <?
  }
  ?>
  </td></tr></table>
  <input type="submit" name="addcomment" value="<? echo(__("Add Comment")); ?>">
</form>
</td></tr>
<?
  }
  endTables();
  auth_close();
?>
</BODY>
</HTML>
