# MySQL dump 8.14
#
# -----------------------
# Server version	3.23.41

#
# Table structure for table 'absences'
#

CREATE TABLE absences (
  id mediumint(8) unsigned NOT NULL auto_increment,
  notes text NOT NULL,
  start_date timestamp(14) NOT NULL,
  end_date timestamp(14) NOT NULL,
  person mediumint(8) unsigned NOT NULL default '0',
  reason smallint NOT NULL, 
  count_on_timesheet bit NOT NULL default '1',
  PRIMARY KEY  (id),
  KEY person (person)
);

#
# Table structure for table 'absence_backups'
#

CREATE TABLE absence_backups (
  absence mediumint(8) unsigned NOT NULL default '0',
  notes text NOT NULL,
  person mediumint(8) unsigned NOT NULL default '0'
);

#
# Table structure for table 'active_sessions'
#

CREATE TABLE active_sessions (
  sid varchar(32) NOT NULL default '',
  name varchar(32) NOT NULL default '',
  val text,
  changed varchar(14) NOT NULL default '',
  PRIMARY KEY  (name,sid),
  KEY changed (changed)
);

#
# Table structure for table 'admin_help'
#

CREATE TABLE admin_help (
  topic varchar(255) NOT NULL default '',
  content mediumtext NOT NULL,
  PRIMARY KEY  (topic),
  UNIQUE KEY topic (topic)
);

#
# Table structure for table 'amnezia'
#

CREATE TABLE amnezia (
  id mediumint(8) unsigned NOT NULL auto_increment,
  user mediumint(8) unsigned NOT NULL default '0',
  pass_code varchar(32) NOT NULL default '',
  created timestamp(14) NOT NULL,
  PRIMARY KEY  (id)
);

#
# Table structure for table 'code_repositories'
#

CREATE TABLE code_repositories (
  id mediumint(8) unsigned NOT NULL auto_increment,
  project mediumint(8) unsigned NOT NULL default '0',
  name char(16) default '',
  title char(64) default '',
  location char(255) default '',
  cvsusers char(64) default '',
  root_dir char(128) default '/',
  restrictions char(255) default '',
  PRIMARY KEY (id),
  INDEX (project)
);

#
# Table structure for table 'companies'
#

CREATE TABLE companies (
  id mediumint(4) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  addr varchar(255) NOT NULL default '',
  phone varchar(255) NOT NULL default '',
  fax varchar(255) NOT NULL default '',
  email varchar(255) NOT NULL default '',
  iset tinyint(4) unsigned NOT NULL default '0',
  contact mediumint(4) NOT NULL default '0',
  logo mediumblob NOT NULL,
  shortname varchar(255) NOT NULL default '',
  website tinytext NOT NULL,
  status tinyint(4) default NULL,
  notes text,
  payment_contact mediumint(4) unsigned NOT NULL default '0',
  payment_method varchar(255) NOT NULL default '',
  payment_delay mediumint(4) unsigned NOT NULL default '0',
  payment_code varchar(255) NOT NULL default '',
  payroll_contact mediumint(4) NOT NULL default '0',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'company2project'
#
CREATE TABLE company2project (
    company mediumint(4) unsigned NOT NULL,
    project mediumint(8) NOT NULL,
    role ENUM('Developer', 'Customer') NOT NULL default 'Customer'
);

#
# Table structure for table 'document_answers'
#

CREATE TABLE document_answers (
  id mediumint(8) unsigned NOT NULL auto_increment,
  document mediumint(8) unsigned NOT NULL default '0',
  src mediumint(8) unsigned NOT NULL default '0',
  comment mediumtext NOT NULL,
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY document (document),
  KEY date (date)
);

#
# Table structure for table 'document_part'
#

CREATE TABLE document_part (
  id mediumint(8) unsigned NOT NULL auto_increment,
  document mediumint(8) unsigned NOT NULL default '0',
  content longblob NOT NULL,
  PRIMARY KEY  (id),
  KEY document (document)
);

#
# Table structure for table 'documents'
#

CREATE TABLE documents (
  id mediumint(8) unsigned NOT NULL auto_increment,
  src mediumint(8) unsigned NOT NULL default '0',
  dst mediumint(8) unsigned NOT NULL default '0',
  ttype enum('people','sets') NOT NULL default 'people',
  aproj mediumint(8) unsigned NOT NULL default '0',
  title varchar(255) NOT NULL default '',
  doc mediumtext NOT NULL,
  reply mediumint(8) unsigned NOT NULL default '0',
  lang char(2) NOT NULL default '',
  alias mediumint(8) unsigned NOT NULL default '0',
  flags tinyint(3) unsigned NOT NULL default '0',
  chout tinyint(1) unsigned NOT NULL default '0',
  ver varchar(255) NOT NULL default '',
  chinby mediumint(8) unsigned NOT NULL default '0',
  chindate timestamp(14) NOT NULL,
  choutby mediumint(8) unsigned NOT NULL default '0',
  choutdate timestamp(14) NOT NULL,
  dststr varchar(255) NOT NULL default '',
  content longblob NOT NULL,
  asize int(10) unsigned NOT NULL default '0',
  fname varchar(255) NOT NULL default '',
  type varchar(255) NOT NULL default '',
  obsoletedby mediumint(8) unsigned NOT NULL default '0',
  path mediumint(8) NOT NULL default '0',
  locked_by mediumint(8) NOT NULL default '0', 
  lock_date datetime NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY src (src),
  KEY dst (dst),
  KEY aproj (aproj),
  KEY reply (reply),
  KEY alias (alias),
  KEY choutby (choutby),
  KEY chinby (chinby),
  KEY obsoletedby (obsoletedby),
  KEY path (path)
);

#
# Table structure for table 'document_associations'
#
CREATE TABLE document_associations (
  doc mediumint(8) unsigned NOT NULL default '0',
  att_to mediumint(8) unsigned NOT NULL default '0',
  att_type enum('know', 'requests', 'task') NOT NULL default 'task',
  key (doc, att_to, att_type)
);

#
# Table structure for table 'e_attach'
#

CREATE TABLE e_attach (
  id mediumint(8) unsigned NOT NULL auto_increment,
  e_mail mediumint(8) unsigned NOT NULL default '0',
  content longblob NOT NULL,
  size int(10) unsigned NOT NULL default '0',
  mtype varchar(255) NOT NULL default '',
  fname varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY e_mail (e_mail)
);

#
# Table structure for table 'e_attach_part'
#

CREATE TABLE e_attach_part (
  id mediumint(8) unsigned NOT NULL auto_increment,
  e_attach mediumint(8) unsigned NOT NULL default '0',
  content longblob NOT NULL,
  PRIMARY KEY  (id),
  KEY e_attach (e_attach)
);

#
# Table structure for table 'email'
#

CREATE TABLE email (
  id mediumint(8) unsigned NOT NULL auto_increment,
  title varchar(255) NOT NULL default '',
  src mediumint(8) unsigned NOT NULL default '0',
  body text NOT NULL,
  date timestamp(14) NOT NULL,
  project mediumint(8) unsigned NOT NULL default '0',
  emailSrc varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY project (project)
);

#
# Table structure for table 'events'
#

CREATE TABLE events (
  id mediumint(8) unsigned NOT NULL auto_increment,
  title varchar(255) NOT NULL default '',
  description text NOT NULL,
  start_date timestamp(14) NOT NULL,
  end_date timestamp(14) NOT NULL,
  project mediumint(8) unsigned NOT NULL default '0',
  src mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY project (project)
);

#
# Table structure for table 'event_comments'
#

CREATE TABLE event_comments (
  id mediumint(8) unsigned NOT NULL auto_increment,
  event mediumint(8) unsigned NOT NULL default '0',
  src mediumint(8) unsigned NOT NULL default '0',
  comment mediumtext NOT NULL,
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY event (event),
  KEY date (date)
);

#
# Table structure for table 'failed_login'
#

CREATE TABLE failed_login (
  id mediumint(8) unsigned NOT NULL auto_increment,
  ip varchar(255) NOT NULL default '',
  count tinyint(3) unsigned NOT NULL default '1',
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY ip (ip)
);

#
# Table structure for table 'forum_subscriptions'
#

CREATE TABLE forum_subscriptions (
  id mediumint(8) unsigned NOT NULL default '0',
  src mediumint(8) unsigned NOT NULL default '0',
  notify tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'forums'
#

CREATE TABLE forums (
  id mediumint(8) unsigned NOT NULL auto_increment,
  att_type enum('system','people','companies','nl_list','nl_issue','nl_entries','know','ip','documents','email','e_attach','help','mime_icons','news','projects','requests','task','task_category') NOT NULL default 'system',
  att_id mediumint(8) unsigned NOT NULL default '0',
  notify tinyint(3) unsigned NOT NULL default '0',
  title varchar(255) NOT NULL default '',
  content mediumtext NOT NULL,
  src mediumint(8) NOT NULL default '0',
  date timestamp(14) NOT NULL,
  parent mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY att_type (att_type,att_id),
  KEY parent (parent)
);

#
# Table structure for table 'help'
#

CREATE TABLE help (
  topic varchar(255) NOT NULL default '',
  content mediumtext NOT NULL,
  PRIMARY KEY  (topic),
  UNIQUE KEY topic (topic)
);

#
# Table structure for table 'help_notes'
#

CREATE TABLE help_notes (
  id mediumint(8) unsigned NOT NULL auto_increment,
  topic varchar(255) NOT NULL default '',
  content mediumtext NOT NULL,
  src mediumint(8) NOT NULL default '0',
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY topic (topic)
);

#
# Table structure for table 'installed_plugins'
#

CREATE TABLE installed_plugins (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  version varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'ip'
#

CREATE TABLE ip (
  id mediumint(8) unsigned NOT NULL auto_increment,
  ip1 tinyint(3) unsigned default NULL,
  ip2 tinyint(3) unsigned default NULL,
  ip3 tinyint(3) unsigned default NULL,
  ip4 tinyint(3) unsigned default NULL,
  mask_bits tinyint(3) unsigned default NULL,
  description varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'know'
#

CREATE TABLE know (
  id mediumint(8) unsigned NOT NULL auto_increment,
  authorname varchar(255) NOT NULL default '',
  authormail varchar(255) NOT NULL default '',
  src mediumint(8) unsigned NOT NULL default '0',
  company mediumint(8) unsigned NOT NULL default '0',
  date timestamp(14) NOT NULL,
  lang char(2) NOT NULL default '',
  title varchar(255) default NULL,
  entry mediumtext NOT NULL,
  keywords varchar(255) NOT NULL default '',
  flags tinyint(3) unsigned default NULL,
  server mediumint(8) unsigned NOT NULL default '0',
  uid varchar(32) NOT NULL default '',
  imported mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY uid (uid),
  KEY src (src),
  KEY date (date),
  KEY company (company),
  KEY uid_2 (uid)
);

#
# Table structure for table 'know_answers'
#

CREATE TABLE know_answers (
  id mediumint(8) unsigned NOT NULL auto_increment,
  know mediumint(8) unsigned NOT NULL default '0',
  authorname varchar(255) NOT NULL default '',
  authormail varchar(255) NOT NULL default '',
  src mediumint(8) unsigned NOT NULL default '0',
  lang char(2) NOT NULL default '',
  comment mediumtext NOT NULL,
  date timestamp(14) NOT NULL,
  flags tinyint(3) default NULL,
  uid varchar(32) NOT NULL default '',
  server mediumint(8) unsigned NOT NULL default '0',
  imported mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY uid (uid),
  KEY know (know),
  KEY date (date),
  KEY uid_2 (uid)
);

#
# Table structure for table 'know_log'
#

CREATE TABLE know_log (
  id mediumint(8) unsigned NOT NULL auto_increment,
  entry_type enum('node','server','client') NOT NULL default 'node',
  datain bigint(20) unsigned NOT NULL default '0',
  dataincount mediumint(8) NOT NULL default '0',
  dataout bigint(20) unsigned NOT NULL default '0',
  dataoutcount mediumint(8) NOT NULL default '0',
  date timestamp(14) NOT NULL,
  intrvl char(1) NOT NULL default 'm',
  PRIMARY KEY  (id),
  KEY entry_type (entry_type,date)
);

#
# Table structure for table 'know_node'
#

CREATE TABLE know_node (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  url varchar(255) NOT NULL default '',
  status char(3) default NULL,
  date timestamp(14) NOT NULL,
  lastresponded timestamp(14) NOT NULL,
  home varchar(255) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY url (url),
  KEY url_2 (url)
);

#
# Table structure for table 'know_servers'
#

CREATE TABLE know_servers (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  url varchar(255) NOT NULL default '',
  status char(3) default NULL,
  date timestamp(14) NOT NULL,
  lastresponded timestamp(14) NOT NULL,
  home varchar(255) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY url (url),
  KEY url_2 (url)
);

#
# Table structure for table 'know_servers_temp'
#

CREATE TABLE know_servers_temp (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  url varchar(255) NOT NULL default '',
  status char(3) default NULL,
  date timestamp(14) NOT NULL,
  lastresponded timestamp(14) NOT NULL,
  home varchar(255) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY url (url),
  KEY url_2 (url)
);

#
# Table structure for table 'know_votes'
#

CREATE TABLE know_votes (
  know mediumint(8) unsigned NOT NULL,
  person mediumint(8) unsigned NOT NULL default '0',
  vote smallint NOT NULL,
  PRIMARY KEY (know, person)
);

#
# Table structure for table 'lang'
#

CREATE TABLE lang (
  id char(2) NOT NULL default '',
  name varchar(255) NOT NULL default '',
  encoding varchar(255) NOT NULL default '',
  installed varchar(255) NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY id (id),
  KEY installed (installed)
);

#
# Table structure for table 'log'
#

CREATE TABLE log (
  id mediumint(8) unsigned NOT NULL auto_increment,
  obj_type enum('system','people','companies','documents','projects','requests','task') NOT NULL default 'system',
  obj_id mediumint(8) unsigned NOT NULL default '0',
  entry varchar(255) NOT NULL default '',
  date timestamp(14) NOT NULL,
  edited_by mediumint(8) NOT NULL default '0',
  PRIMARY KEY (id),
  KEY (obj_type, obj_id),
  KEY date (date)
);

#
# Table structure for table 'mail_repository'
#

CREATE TABLE mail_repository (
  id mediumint(8) unsigned NOT NULL auto_increment,
  project mediumint(8) unsigned NOT NULL default '0',
  email varchar(255) NOT NULL default '',
  entry_type tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY email (email),
  KEY email_2 (email)
);

#
# Table structure for table 'mail_xtra'
#

CREATE TABLE mail_xtra (
  id mediumint(8) unsigned NOT NULL auto_increment,
  entry_type varchar(248) NOT NULL default '',
  entry_id mediumint(8) unsigned NOT NULL default '0',
  email varchar(255) default NULL,
  PRIMARY KEY  (id),
  KEY entry_type (entry_type,entry_id),
  KEY email (email)
);

#
# Table structure for table 'meeting'
#

CREATE TABLE meeting (
  id mediumint(8) unsigned NOT NULL auto_increment,
  mdate timestamp(14) NOT NULL,
  topic char(255) not null,
  creator mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'meeting2person'
#

CREATE TABLE meeting2person (
  meeting mediumint(8) unsigned NOT NULL default '0',
  person mediumint(8) unsigned NOT NULL default '0',
  shortname varchar(4) default NULL,
  PRIMARY KEY  (meeting,person)
);

#
# Table structure for table 'meeting2project'
#

CREATE TABLE meeting2project (
  project mediumint(8) unsigned NOT NULL default '0',
  meeting mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (project,meeting)
);

#
# Table structure for table 'meeting2task'
#

CREATE TABLE meeting2task (
  paragraph mediumint(8) unsigned NOT NULL default '0',
  task mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (paragraph,task)
);

#
# Table structure for table 'meetingparagraph'
#

CREATE TABLE meetingparagraph (
  id mediumint(8) unsigned NOT NULL auto_increment,
  section mediumint(8) unsigned NOT NULL default '0',
  ptitle varchar(255) default NULL,
  ptext mediumtext,
  after mediumint(8) unsigned default NULL,
  PRIMARY KEY  (id)
);

#
# Table structure for table 'meetingsection'
#

CREATE TABLE meetingsection (
  id mediumint(8) unsigned NOT NULL auto_increment,
  meeting mediumint(8) unsigned NOT NULL default '0',
  title varchar(255) default NULL,
  after mediumint(8) unsigned default NULL,
  PRIMARY KEY  (id)
);

#
# Table structure for table 'mime_icons'
#

CREATE TABLE mime_icons (
  mime varchar(255) NOT NULL default '',
  icon blob NOT NULL,
  ftype varchar(255) NOT NULL default '',
  size smallint(5) unsigned NOT NULL default '0',
  descr varchar(200) default NULL,
  extension char(3) default NULL,
  PRIMARY KEY  (mime),
  UNIQUE KEY mime_2 (mime),
  KEY mime (mime)
);

#
# Table structure for table 'mime_translate'
#

CREATE TABLE mime_translate (
  linux_mime varchar(255) NOT NULL default '',
  web_mime varchar(255) NOT NULL default '',
  PRIMARY KEY  (linux_mime),
  KEY web_mime (web_mime)
);

#
# Table structure for table 'misc_time'
#

CREATE TABLE misc_time (
  id mediumint(8) unsigned NOT NULL auto_increment,
  project mediumint(8) unsigned NOT NULL,
  reason smallint NOT NULL, 
  person mediumint(8) unsigned NOT NULL,
  day date NOT NULL,
  worked float unsigned NOT NULL,
  comment mediumtext NOT NULL,
  PRIMARY KEY  (id)
);


#
# Table structure for table 'month'
#

CREATE TABLE month (
  monID tinyint(4) NOT NULL default '1',
  monName_en varchar(20) NOT NULL default '',
  PRIMARY KEY  (monID)
);

#
# Table structure for table 'news'
#

CREATE TABLE news (
  id mediumint(8) unsigned NOT NULL auto_increment,
  title varchar(255) NOT NULL default '',
  src mediumint(8) unsigned NOT NULL default '0',
  company mediumint(8) unsigned NOT NULL default '0',
  intro mediumtext NOT NULL,
  story mediumtext NOT NULL,
  chindate timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY company (company)
);

#
# Table structure for table 'news_answers'
#

CREATE TABLE news_answers (
  id mediumint(8) unsigned NOT NULL auto_increment,
  story mediumint(8) unsigned NOT NULL default '0',
  src mediumint(8) unsigned NOT NULL default '0',
  comment mediumtext NOT NULL,
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY story (story),
  KEY date (date)
);

#
# Table structure for table 'nl_entries'
#

CREATE TABLE nl_entries (
  id mediumint(8) unsigned NOT NULL auto_increment,
  nl mediumint(8) unsigned NOT NULL default '0',
  title varchar(255) default NULL,
  src mediumint(8) unsigned NOT NULL default '0',
  entry mediumtext NOT NULL,
  sent mediumint(8) unsigned NOT NULL default '0',
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY nl (nl)
);

#
# Table structure for table 'nl_issue'
#

CREATE TABLE nl_issue (
  id mediumint(8) unsigned NOT NULL auto_increment,
  date timestamp(14) NOT NULL,
  nl mediumint(8) unsigned NOT NULL default '0',
  issue mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY nl (nl),
  KEY issue (issue)
);

#
# Table structure for table 'nl_list'
#

CREATE TABLE nl_list (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) default NULL,
  own_type enum('company','project') NOT NULL default 'company',
  owner mediumint(8) unsigned NOT NULL default '0',
  active tinyint(3) unsigned NOT NULL default '1',
  send_type enum('days','entries') NOT NULL default 'days',
  send_interval tinyint(3) unsigned NOT NULL default '7',
  date timestamp(14) NOT NULL,
  lastsent timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY own_type (own_type),
  KEY owner (owner),
  KEY send_type (send_type)
);

#
# Table structure for table 'pdf_docs'
#

CREATE TABLE pdf_docs (
  id mediumint(8) unsigned NOT NULL auto_increment,
  document mediumint(8) unsigned NOT NULL default '0',
  content longblob NOT NULL,
  fname varchar(255) NOT NULL default '',
  fsize int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY document (document)
);

#
# Table structure for table 'people'
#

CREATE TABLE people (
  id mediumint(8) unsigned NOT NULL auto_increment,
  fname varchar(255) NOT NULL default '',
  lname varchar(255) NOT NULL default '',
  mname varchar(255) NOT NULL default '',
  sal varchar(255) NOT NULL default '',
  position varchar(255) NOT NULL default '',
  company mediumint(8) unsigned NOT NULL default '0',
  email varchar(255) NOT NULL default '',
  addr varchar(255) NOT NULL default '',
  mphone varchar(255) NOT NULL default '',
  wphone varchar(255) NOT NULL default '',
  fax varchar(255) NOT NULL default '',
  hphone varchar(255) NOT NULL default '',
  photo mediumblob NOT NULL,
  uname varchar(255) NOT NULL default '',
  pwd varchar(255) NOT NULL default '',
  preflang char(2) NOT NULL default '',
  lastlog timestamp(14) NOT NULL,
  settings varchar(255) NOT NULL default '',
  iscontact tinyint(4) NOT NULL default '0',
  status tinyint(1) default NULL,
  prevlog timestamp(14) NOT NULL,
  notes text,
  ispayment tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  UNIQUE KEY email (email),
  KEY company (company)
);

#
# Table structure for table 'people_proj'
#

CREATE TABLE people_proj (
  person mediumint(8) unsigned NOT NULL default '0',
  project mediumint(8) unsigned NOT NULL default '0',
  role ENUM('Developer', 'Customer') NOT NULL default 'Customer',
  PRIMARY KEY  (person,project,role),
  KEY project (project)
);

#
# Table structure for table 'person_shortcut'
#

CREATE TABLE person_shortcut (
  person bigint(20) unsigned NOT NULL default '1',
  sh_no tinyint(3) unsigned NOT NULL default '0',
  sh_loc varchar(255) NOT NULL default '',
  PRIMARY KEY  (person,sh_no),
  UNIQUE KEY person (person,sh_no)
);

#
# Table structure for table 'person_task'
#

CREATE TABLE person_task (
  personID bigint(20) unsigned NOT NULL default '1',
  taskID bigint(20) unsigned NOT NULL default '1',
  owner enum('Y','N') NOT NULL default 'N'
);

#
# Table structure for table 'projects'
#

CREATE TABLE projects (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  description varchar(255) NOT NULL default '',
  active tinyint(3) unsigned NOT NULL default '0',
  cost_code varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'project_managers'
#

CREATE TABLE project_managers (
  id mediumint(8) unsigned NOT NULL auto_increment,
  project mediumint(8) unsigned NOT NULL default '0',
  manager varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY manager (manager),
  KEY project (project)
);

#
# Table structure for table 'project_settings'
#

CREATE TABLE project_settings (
  id mediumint(8) unsigned NOT NULL auto_increment,
  project mediumint(8) unsigned NOT NULL default '0',
  name varchar(255) NOT NULL default '',
  value varchar(255) NOT NULL default '',
  default_val varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY name (name),
  KEY project (project)
);

#
# Table structure for table 'project_categories'
#

CREATE TABLE project_categories (
  id mediumint(9) NOT NULL auto_increment,
  cat_name varchar(255) NOT NULL default 'Unknown',
  person mediumint(8) unsigned NOT NULL default '0',
  project mediumint(9) NOT NULL default '0',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'project_log'
#

CREATE TABLE project_log (
  id mediumint(8) unsigned NOT NULL auto_increment,
  project mediumint(8) unsigned NOT NULL default '0',
  entry varchar(255) NOT NULL default '',
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY date (date)
);

#
# Table structure for table 'project_milestones'
#

CREATE TABLE project_milestones (
  id mediumint(9) NOT NULL auto_increment,
  name varchar(255) NOT NULL default 'Unknown',
  project mediumint(9) NOT NULL default '0',
  due_date date NOT NULL,
  PRIMARY KEY  (id)
);

#
# Table structure for table 'request_answers'
#

CREATE TABLE request_answers (
  id mediumint(8) unsigned NOT NULL auto_increment,
  request mediumint(8) unsigned NOT NULL default '0',
  src mediumint(8) unsigned NOT NULL default '0',
  comment mediumtext NOT NULL,
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (id),
  KEY request (request),
  KEY date (date)
);

#
# Table structure for table 'requests'
#

CREATE TABLE requests (
  id mediumint(8) unsigned NOT NULL auto_increment,
  title varchar(255) NOT NULL default '',
  aproj mediumint(8) unsigned NOT NULL default '0',
  src mediumint(8) unsigned NOT NULL default '0',
  owner mediumint(8) unsigned NOT NULL default '0',
  date timestamp(14) NOT NULL,
  request mediumtext NOT NULL,
  deadline timestamp(14) NOT NULL,
  status smallint NOT NULL default 1,
  notify_src bit NOT NULL default 1,
  reminded mediumint(8) unsigned NOT NULL default '0',
  priority char(255) NOT NULL default '',  
  CatID mediumint(9) NOT NULL default '0',
  milestone mediumint(9) NOT NULL default '0',
  resolved_date timestamp(14) NOT NULL, 
  initial_estimate TIME NOT NULL default 0,
  PRIMARY KEY  (id),
  KEY aproj (aproj),
  KEY owner (owner),
  KEY date (date),
  KEY status (status),
  KEY deadline (deadline)
);

#
# Table structure for table 'request2task'
#

CREATE TABLE request2task (
  request mediumint(8) unsigned NOT NULL default '0',
  task mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (request,task)
);

#
# Table structure for table 'request_submitters'
#

CREATE TABLE request_submitters (
  id mediumint(8) unsigned NOT NULL auto_increment,
  request mediumint(8) unsigned NOT NULL default '0',
  person mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY request (person),
  KEY person (person)
);

#
# Table structure for table 'searches'
#

CREATE TABLE searches (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  person mediumint(8) unsigned NOT NULL default '0',
  project mediumint(8) unsigned NOT NULL default '0',
  type enum ('requests', 'tasks', 'documents', 'meetings', 'emails') NOT NULL,
  PRIMARY KEY  (id),
  KEY (name),
  KEY (person, project, type)
);

#
# Table structure for table 'search_fields'
#

CREATE TABLE search_fields (
  search mediumint(8) unsigned NOT NULL,
  name varchar(255) NOT NULL default '',
  value text NOT NULL default '',
  KEY (search),
  KEY (name)
);

#
# Table structure for table 'settings'
#

CREATE TABLE settings (
  id mediumint(8) unsigned NOT NULL auto_increment,
  name varchar(255) NOT NULL default '',
  value varchar(255) NOT NULL default '',
  default_val varchar(255) NOT NULL default '',
  PRIMARY KEY  (id),
  KEY name (name)
);

#
# Table structure for table 'task'
#

CREATE TABLE task (
  id bigint(20) NOT NULL auto_increment,
  TaskName varchar(255) NOT NULL default 'Unnamed',
  CatID mediumint(9) NOT NULL default '0',
  StartDatePlanned int(11) default '0',
  StartDate int(11) default '0',
  EndDatePlanned int(11) default '0',
  EndDate int(11) default '0',
  DateSet date NOT NULL default '0000-00-00',
  TaskDesc text NOT NULL default '',
  ProjectID bigint(20) NOT NULL default '0',
  PercentComplete tinyint(3) unsigned NOT NULL default '0',
  StatusUpdated int(14) unsigned NOT NULL default '0',
  active enum('1','0') NOT NULL default '1',
  date timestamp(14) NOT NULL,
  parent mediumint(8) unsigned NOT NULL default '0',
  PercentOfParent tinyint(3) unsigned NOT NULL default '0',
  estimated time default 0 not null,    
  PRIMARY KEY  (id),
  KEY ProjectID (ProjectID)
);

#
# Table structure for table 'task_history'
#

CREATE TABLE task_history (
  id bigint(20) unsigned NOT NULL auto_increment,
  taskID bigint(20) NOT NULL default '0',
  record mediumtext NOT NULL,
  authorID int(11) NOT NULL default '0',
  Posted int(11) NOT NULL default '0',
  subject varchar(255) NOT NULL default '',
  PRIMARY KEY  (id)
);

#
# Table structure for table 'task_estimate_history'
#
CREATE TABLE task_estimate_history (
  id bigint(20) unsigned NOT NULL auto_increment,
  taskID bigint(20) unsigned NOT NULL default '0',
  estimated time default 0 not null,
  date timestamp(14) NOT NULL,
  estimator mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY taskID (taskID)
);  

#
# Table structure for table 'task_progress_history'
#

CREATE TABLE task_progress_history (
  id bigint(20) unsigned NOT NULL auto_increment,
  taskID bigint(20) unsigned NOT NULL default '0',
  progress tinyint(3) unsigned NOT NULL default '0',
  remaining float NOT NULL default 0,
  date timestamp(14) NOT NULL,
  worked time default NULL,
  workfrom time default NULL,
  workto time default NULL, 
  comment mediumtext NOT NULL,
  person mediumint(8) unsigned NOT NULL default '0',
  PRIMARY KEY  (id),
  KEY taskID (taskID)
);

#
# Table structure for table 'user_settings'
#

CREATE TABLE user_settings (
  id mediumint(8) unsigned NOT NULL auto_increment,
  person mediumint(8) unsigned NOT NULL default '0',
  project mediumint(8) unsigned NOT NULL default '0',
  type char(25) not null default '',
  name char(25) not null default '',
  value char(25) not null default '',
  PRIMARY KEY (id),
  KEY setting_key (person, project, type, name)  
);

#
# Table structure for table 'xtra_param'
#

CREATE TABLE xtra_param (
  id mediumint(8) unsigned NOT NULL auto_increment,
  obj_type varchar(100) NOT NULL default '',
  obj_id mediumint(8) unsigned NOT NULL default '0',
  param_class varchar(40) NOT NULL default '',
  param_name varchar(100) NOT NULL default '',
  param_value mediumtext NOT NULL,
  PRIMARY KEY  (id),
  KEY obj_type (obj_type,obj_id,param_name,param_class)
);

#
# Table structure for table 'people_proj_added'
#

CREATE TABLE people_proj_added (
  person mediumint(8) unsigned NOT NULL default '0',
  project mediumint(8) unsigned NOT NULL default '0',
  date timestamp(14) NOT NULL,
  PRIMARY KEY  (person,project),
  KEY project (project)
);



#
# Dumping data for table 'settings'
#

INSERT INTO settings VALUES (1,'notify','1','1');
INSERT INTO settings VALUES (2,'remind_interval','7','7');
INSERT INTO settings VALUES (3,'know_public','1','1');
INSERT INTO settings VALUES (4,'know_allow_external','1','1');
INSERT INTO settings VALUES (5,'know_allow_node','0','0');
INSERT INTO settings VALUES (6,'know_server_name','Unnamed','Unnamed');
INSERT INTO settings VALUES (7,'know_node','opt.lanifex.com/know/know_server/node.php','opt.lanifex.com/know/know_server/node.php');
INSERT INTO settings VALUES (8,'know_forbid_unknown','0','0');
INSERT INTO settings VALUES (9,'home_page','http://www.sourceforge.net/projects/outreach/','http://www.sourceforge.net/projects/outreach/');
INSERT INTO settings VALUES (10,'know_log_interval','m','m');
INSERT INTO settings VALUES (11,'disable_upgrade_search','0','0');
INSERT INTO settings VALUES (12,'proxy_host','','');
INSERT INTO settings VALUES (13,'proxy_port','','');
INSERT INTO settings VALUES (14,'login_interval','5','5');
INSERT INTO settings VALUES (15,'login_attempts','5','5');
INSERT INTO settings VALUES (16,'mail_interface','1','1');
INSERT INTO settings VALUES (17,'language','en','en');
INSERT INTO settings VALUES (18,'allow_forgot_password','1','1');
INSERT INTO settings VALUES (19, 'allow_user_create_by_all','0','0');
INSERT INTO settings VALUES (20, 'show_request_ids','1','1');
INSERT INTO settings VALUES (21, 'timesheet_nonproj_reasons','Sick/Medical|Vacation|Stat Holiday|Training','Sick/Medical|Vacation|Stat Holiday|Training');
INSERT INTO settings VALUES (22, 'list_all_projects_even_if_no_access', '0','0');
INSERT INTO settings VALUES (23, 'hide_other_groups_from_all_but_first_group', '0','0');
INSERT INTO settings VALUES (24, 'allow_all_participants_to_edit_meetings','1','1');

#
# Dumping data for table 'project_settings' (defaults are for project id=zero)
#
INSERT INTO project_settings VALUES (1,0,'default_priority_level','4','4');
INSERT INTO project_settings VALUES (2,0,'display_milestones_for_requests','0','0');
INSERT INTO project_settings VALUES (3,0,'notify_whole_team_on_new_requests','0','0');
INSERT INTO project_settings VALUES (4,0,'only_pm_can_edit_requests','0','0');
INSERT INTO project_settings VALUES (5,0,'only_pm_can_see_request_estimate','0','0');
INSERT INTO project_settings VALUES (6,0,'only_pm_can_set_request_priority','0','0');
INSERT INTO project_settings VALUES (7,0,'pm_can_change_request_status_even_if_not_owner', '0', '0');
INSERT INTO project_settings VALUES (8,0,'prompt_set_request_status_on_task_complete', '2', '2');
INSERT INTO project_settings VALUES (9,0,'request_priority','Critical|High|Medium|Low|New','Critical|High|Medium|Low|New');
INSERT INTO project_settings VALUES (10,0,'request_status_options','Stalled','Stalled');
INSERT INTO project_settings VALUES (11,0,'software_project','0','0');
INSERT INTO project_settings VALUES (12,0,'task_status_hours_remaining','1','1');
INSERT INTO project_settings VALUES (13,0,'allow_multiple_requests_per_task','0','0');
INSERT INTO project_settings VALUES (14,0,'allow_hidden_documents','1','1');
INSERT INTO project_settings VALUES (15,0,'allow_whole_team_to_update_documents','1','1');

#
# Dumping data for table 'lang'
#

INSERT INTO lang VALUES ('ab','Abkhazian','','0');
INSERT INTO lang VALUES ('om','Afan (Oromo)','','0');
INSERT INTO lang VALUES ('aa','Afar','','0');
INSERT INTO lang VALUES ('af','Afrikaans','','0');
INSERT INTO lang VALUES ('sq','Albanian','','0');
INSERT INTO lang VALUES ('am','Amharic','','0');
INSERT INTO lang VALUES ('ar','Arabic','','0');
INSERT INTO lang VALUES ('hy','Armenian','','0');
INSERT INTO lang VALUES ('as','Assamese','','0');
INSERT INTO lang VALUES ('ay','Aymara','','0');
INSERT INTO lang VALUES ('az','Azerbaijani','','0');
INSERT INTO lang VALUES ('ba','Bashkir','','0');
INSERT INTO lang VALUES ('eu','Basque','','0');
INSERT INTO lang VALUES ('bn','Bengali; Bangla','','0');
INSERT INTO lang VALUES ('dz','Bhutani','','0');
INSERT INTO lang VALUES ('bh','Bihari','','0');
INSERT INTO lang VALUES ('bi','Bislama','','0');
INSERT INTO lang VALUES ('br','Breton','','0');
INSERT INTO lang VALUES ('bg','Bulgarian','','0');
INSERT INTO lang VALUES ('my','Burmese','','0');
INSERT INTO lang VALUES ('be','Byelorussian','','0');
INSERT INTO lang VALUES ('km','Cambodian','','0');
INSERT INTO lang VALUES ('ca','Catalan','','0');
INSERT INTO lang VALUES ('zh','Chinese','','0');
INSERT INTO lang VALUES ('co','Corsican','','0');
INSERT INTO lang VALUES ('hr','Croatian','','0');
INSERT INTO lang VALUES ('cs','Czech','','0');
INSERT INTO lang VALUES ('da','Danish','','0');
INSERT INTO lang VALUES ('nl','Dutch','','0');
INSERT INTO lang VALUES ('en','English','','0');
INSERT INTO lang VALUES ('eo','Esperanto','','0');
INSERT INTO lang VALUES ('et','Estonian','','0');
INSERT INTO lang VALUES ('fo','Faroese','','0');
INSERT INTO lang VALUES ('fj','Fiji','','0');
INSERT INTO lang VALUES ('fi','Finnish','','0');
INSERT INTO lang VALUES ('fr','French','','0');
INSERT INTO lang VALUES ('fy','Frisian','','0');
INSERT INTO lang VALUES ('gl','Galician','','0');
INSERT INTO lang VALUES ('ka','Georgian','','0');
INSERT INTO lang VALUES ('de','German','','0');
INSERT INTO lang VALUES ('el','Greek','','0');
INSERT INTO lang VALUES ('kl','Greenlandic','','0');
INSERT INTO lang VALUES ('gn','Guarani','','0');
INSERT INTO lang VALUES ('gu','Gujarati','','0');
INSERT INTO lang VALUES ('ha','Hausa','','0');
INSERT INTO lang VALUES ('he','Hebrew','','0');
INSERT INTO lang VALUES ('hi','Hindi','','0');
INSERT INTO lang VALUES ('hu','Hungarian','','0');
INSERT INTO lang VALUES ('is','Icelandic','','0');
INSERT INTO lang VALUES ('id','Indonesian','','0');
INSERT INTO lang VALUES ('ia','Interlingua','','0');
INSERT INTO lang VALUES ('ie','Interlingue','','0');
INSERT INTO lang VALUES ('iu','Inuktitut','','0');
INSERT INTO lang VALUES ('ik','Inupiak','','0');
INSERT INTO lang VALUES ('ga','Irish','','0');
INSERT INTO lang VALUES ('it','Italian','','0');
INSERT INTO lang VALUES ('ja','Japanese','','0');
INSERT INTO lang VALUES ('jv','Javanese','','0');
INSERT INTO lang VALUES ('kn','Kannada','','0');
INSERT INTO lang VALUES ('ks','Kashmiri','','0');
INSERT INTO lang VALUES ('kk','Kazakh','','0');
INSERT INTO lang VALUES ('rw','Kinyarwanda','','0');
INSERT INTO lang VALUES ('ky','Kirghiz','','0');
INSERT INTO lang VALUES ('ko','Korean','','0');
INSERT INTO lang VALUES ('ku','Kurdish','','0');
INSERT INTO lang VALUES ('rn','Kurundi','','0');
INSERT INTO lang VALUES ('lo','Laothian','','0');
INSERT INTO lang VALUES ('la','Latin','','0');
INSERT INTO lang VALUES ('lv','Latvian; Lettis','','0');
INSERT INTO lang VALUES ('ln','Lingala','','0');
INSERT INTO lang VALUES ('lt','Lithuanian','','0');
INSERT INTO lang VALUES ('mk','Macedonian','','0');
INSERT INTO lang VALUES ('mg','Malagasy','','0');
INSERT INTO lang VALUES ('ms','Malay','','0');
INSERT INTO lang VALUES ('ml','Malayalam','','0');
INSERT INTO lang VALUES ('mt','Maltese','','0');
INSERT INTO lang VALUES ('mi','Maori','','0');
INSERT INTO lang VALUES ('mr','Marathi','','0');
INSERT INTO lang VALUES ('mo','Moldavian','','0');
INSERT INTO lang VALUES ('mn','Mongolian','','0');
INSERT INTO lang VALUES ('na','Nauru','','0');
INSERT INTO lang VALUES ('ne','Nepali','','0');
INSERT INTO lang VALUES ('no','Norwegian','','0');
INSERT INTO lang VALUES ('oc','Occitan','','0');
INSERT INTO lang VALUES ('or','Oriya','','0');
INSERT INTO lang VALUES ('ps','Pashto; Pushto','','0');
INSERT INTO lang VALUES ('fa','Persian (Farsi)','','0');
INSERT INTO lang VALUES ('pl','Polish','','0');
INSERT INTO lang VALUES ('pt','Portuguese','','0');
INSERT INTO lang VALUES ('pa','Punjabi','','0');
INSERT INTO lang VALUES ('qu','Quechua','','0');
INSERT INTO lang VALUES ('rm','Rhaeto-Romance','','0');
INSERT INTO lang VALUES ('ro','Romanian','ISO-8859-2','0');
INSERT INTO lang VALUES ('ru','Russian','','0');
INSERT INTO lang VALUES ('sm','Samoan','','0');
INSERT INTO lang VALUES ('sg','Sangho','','0');
INSERT INTO lang VALUES ('sa','Sanskrit','','0');
INSERT INTO lang VALUES ('gd','Scots Gaelic','','0');
INSERT INTO lang VALUES ('sr','Serbian','','0');
INSERT INTO lang VALUES ('sh','Serbo-Croatian','','0');
INSERT INTO lang VALUES ('st','Sesotho','','0');
INSERT INTO lang VALUES ('tn','Setswana','','0');
INSERT INTO lang VALUES ('sn','Shona','','0');
INSERT INTO lang VALUES ('sd','Sindhi','','0');
INSERT INTO lang VALUES ('si','Singhalese','','0');
INSERT INTO lang VALUES ('ss','Siswati','','0');
INSERT INTO lang VALUES ('sk','Slovak','','0');
INSERT INTO lang VALUES ('sl','Slovenian','','0');
INSERT INTO lang VALUES ('so','Somali','','0');
INSERT INTO lang VALUES ('es','Spanish','','0');
INSERT INTO lang VALUES ('su','Sundanese','','0');
INSERT INTO lang VALUES ('sw','Swahili','','0');
INSERT INTO lang VALUES ('sv','Swedish','','0');
INSERT INTO lang VALUES ('tl','Tagalog','','0');
INSERT INTO lang VALUES ('tg','Tajik','','0');
INSERT INTO lang VALUES ('ta','Tamil','','0');
INSERT INTO lang VALUES ('tt','Tatar','','0');
INSERT INTO lang VALUES ('te','Telugu','','0');
INSERT INTO lang VALUES ('th','Thai','','0');
INSERT INTO lang VALUES ('bo','Tibetan','','0');
INSERT INTO lang VALUES ('ti','Tigrinya','','0');
INSERT INTO lang VALUES ('to','Tonga','','0');
INSERT INTO lang VALUES ('ts','Tsonga','','0');
INSERT INTO lang VALUES ('tr','Turkish','','0');
INSERT INTO lang VALUES ('tk','Turkmen','','0');
INSERT INTO lang VALUES ('tw','Twi','','0');
INSERT INTO lang VALUES ('ug','Uigur','','0');
INSERT INTO lang VALUES ('uk','Ukrainian','','0');
INSERT INTO lang VALUES ('ur','Urdu','','0');
INSERT INTO lang VALUES ('uz','Uzbek','','0');
INSERT INTO lang VALUES ('vi','Vietnamese','','0');
INSERT INTO lang VALUES ('vo','Volapuk','','0');
INSERT INTO lang VALUES ('cy','Welsh','','0');
INSERT INTO lang VALUES ('wo','Wolof','','0');
INSERT INTO lang VALUES ('xh','Xhosa','','0');
INSERT INTO lang VALUES ('yi','Yiddish','','0');
INSERT INTO lang VALUES ('yo','Yoruba','','0');
INSERT INTO lang VALUES ('za','Zhuang','','0');
INSERT INTO lang VALUES ('zu','Zulu','','0');

#
# Dumping data for table 'month'
#

INSERT INTO month VALUES (1,'January');
INSERT INTO month VALUES (2,'February');
INSERT INTO month VALUES (3,'March');
INSERT INTO month VALUES (4,'April');
INSERT INTO month VALUES (5,'May');
INSERT INTO month VALUES (6,'June');
INSERT INTO month VALUES (7,'July');
INSERT INTO month VALUES (8,'August');
INSERT INTO month VALUES (9,'September');
INSERT INTO month VALUES (10,'October');
INSERT INTO month VALUES (11,'November');
INSERT INTO month VALUES (12,'December');

