<?
#
# The second setup page
#
# Uses the data in index.php to accomplish the following tasks:
# 1. Creates the main and demo databases from opt_init.sql;
# 2. Tests the existence and creates the temp directory if needed
# 3. Sets up opt/include/OPT_lib.php
#
# Also displays the form for the second data entry page
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Windows support, Eric Pignot, August 2002
# Revision 1.1

?><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>Outreach Project Tool Setup</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt.css">
</HEAD>
<?
  $autorun=true;
  include("setup_lib.php");

  if (!($CRM_email && $CRM_path && $CRM_db_host && $CRM_db_db &&
  $CRM_db_uname && $temp_CRM_dir &&
  (($CRM_may_demo && $CRM_db_demo_db) || (!$CRM_may_demo)))) {
    echo("<h4><b>Failed</b>: You missed some fields. Please go back and try again.</h4>");
    killinstall(0);
  }

  // Testing and creating the temp directory
  $err=0;
  if (!is_dir($temp_CRM_dir)) {
    $err=!mkdir($temp_CRM_dir,0777);
  } if (!$err) {
    $fd = @fopen("$temp_CRM_dir/OPT_write_test", "w");
    if (!$fd) {
      $err=1;
    } else {
      fwrite($fd, "# OPT test. Please delete this file - OPT should have.");
      fclose($fd);
    }
  }
  if ($err!=0) {
    echo("<h4><b>Failed</b>: Make sure the user <i>$apache_user</i> has read/write rights in the
          temporary directory you have set ($temp_CRM_dir). You must also make sure that the user has
          access to the respective directory (i.e. check the whole path)!</h4>");
    killinstall(0);
  }
  unlink("$temp_CRM_dir/OPT_write_test");

  // Setting up the regular database
if (!$CRM_db_db_exists) {
    if (!$CRM_db_db_created) {
        $db_test=OPT_db("create database $CRM_db_db");
        if ($db_test=="NOCONNECT") {
            echo("<h4><b>Failed</b>: Can't connect to the mySQL server [main db]. Please go back and try again.</h4>");
            exit;
        }
        if ($db_test=="NOCREATE") {
            echo("<h4><strong>Failed</strong>: Either the username/password for the mySQL connection are invalid
              or the database name you specified ($CRM_db_db) is already in use - or the user you specified
              isn't allowed to create databases. Please go back and try again.</h4>");
            exit;
        }
    }
    
    $finished=1;
    
    $pwd="";
    if ($CRM_db_pwd) {
        $pwd="-p$CRM_db_pwd";
    }
    
    $pwd = realpath(".");
    
    if(!install_SQL("opt_init.sql")) {
        echo("<h4><b>Failed</b>: Unable to create the required tables.</h4>");
        killinstall($finished);
    }
   
    // Note since some hosting environments disallow the LOCAL keyword for MySQL data loads
    // we'll only use it if the hostname is not localhost.
    if ($CRM_db_host != "localhost")
    {
        $local = "local";
    }

    if ((!CRM_run_query("load data $local infile '$pwd/help.txt' into table help",1)) ||
        (!CRM_run_query("load data $local infile '$pwd/admin_help.txt' into table admin_help",0)) ||
        (!CRM_run_query("load data $local infile '$pwd/mime_translate.txt' into table mime_translate",0)) ||
        (!CRM_run_query("load data $local infile '$pwd/mime_icons.txt' into table mime_icons",0))) {
        echo("<h4><strong>Failed</strong>: Unable to set up the required tables. - $pwd</h4>");
        killinstall($finished);
    }
    
    // Setting up the demo users
    $sql="insert into people
          set fname='Demo', lname='Admin',
              uname='admin_demo', pwd='".md5("demo")."', company=1, email='admin_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=1, preflang=\"en\", iscontact=1, id=1";
    crm_run_query($sql);

    $sql="insert into people
          set fname='Demo', lname='Manager',
              uname='manager_demo', pwd='".md5("demo")."', company=2, email='manager_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=5, preflang=\"en\", iscontact=1, id=2";
    crm_run_query($sql);

    $sql="insert into people
          set fname='Demo', lname='Developer',
              uname='developer_demo', pwd='".md5("demo")."', company=2, email='developer_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=5, preflang=\"en\", id=3";
    crm_run_query($sql);

    $sql="insert into people
          set fname='Demo', lname='Consultant',
              uname='consultant_demo', pwd='".md5("demo")."', company=3, email='consultant_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=5, preflang=\"en\", id=4";
    crm_run_query($sql);

    $sql="insert into people
          set fname='Demo', lname='Customer',
              uname='customer_demo', pwd='".md5("demo")."', company=4, email='customer_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=5, preflang=\"en\", iscontact=1, id=5";
    crm_run_query($sql);
} // End of if not db exists

// Setting up the demo database
if ((!$CRM_demo_db_exists) && $CRM_db_demo_db) {
    if (!$CRM_demo_db_created) {
        $db_test=OPT_db("create database $CRM_db_demo_db");
        if ($db_test=="NOCONNECT") {
            echo("<h4><b>Failed</b>: Can't connect to the mySQL server [demo db]. Please go back and try again.</h4>");
            killinstall($finished);
        }
        if ($db_test=="NOCREATE") {
            echo("<h4><b>Failed</b>: Either the username/password for the mySQL connection are invalid
              or the database name you specified ($CRM_db_demo_db) is already in use - or the user you specified
              isn't allowed to create databases. Please go back and try again.</h4>");
        killinstall($finished);
        }
    }
    
    $finished=2;
    
    // Setting up the demo database
    // Temporarily using the demo database
    $CRM_demo=1;
    
    
    if (!install_SQL("opt_init.sql")) {
        echo("<h4><b>Failed</b>: Unable to create the required tables for the demo database.</h4>");
        killinstall($finished);
    }
    
    if ((!CRM_run_query("load data $local infile '$pwd/help.txt' into table help",0)) ||
        (!CRM_run_query("load data $local infile '$pwd/admin_help.txt' into table admin_help",0)) ||
        (!CRM_run_query("load data $local infile '$pwd/mime_translate.txt' into table mime_translate",0)) ||
        (!CRM_run_query("load data $local infile '$pwd/mime_icons.txt' into table mime_icons",0))) {
        echo("<h4><b>Failed</b>: Unable to set up the required tables for the demo database.</h4>");
        killinstall($finished);
    }
    
    // Setting up the demo users in the demo db
    $sql="insert into people
          set fname='Demo', lname='Admin',
              uname='admin_demo', pwd='".md5("demo")."', company=1, email='admin_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=1, preflang=\"en\", iscontact=1, id=1";
    crm_run_query($sql);
    
    $sql="insert into people
          set fname='Demo', lname='Manager',
              uname='manager_demo', pwd='".md5("demo")."', company=2, email='manager_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=5, preflang=\"en\", iscontact=1, id=2";
    crm_run_query($sql);
    
    $sql="insert into people
          set fname='Demo', lname='Developer',
              uname='developer_demo', pwd='".md5("demo")."', company=2, email='developer_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=5, preflang=\"en\", id=3";
    crm_run_query($sql);

    $sql="insert into people
          set fname='Demo', lname='Consultant',
              uname='consultant_demo', pwd='".md5("demo")."', company=3, email='consultant_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=5, preflang=\"en\", id=4";
    crm_run_query($sql);

    $sql="insert into people
          set fname='Demo', lname='Customer',
              uname='customer_demo', pwd='".md5("demo")."', company=4, email='customer_demo@localhost',
              lastlog='00000000000000', prevlog='00000000000000', status=1, preflang=\"en\", iscontact=1, id=5";
    crm_run_query($sql);


    $sql="insert into companies set shortname='Admin Group', name='Admin Group', status=1, id=1, contact=1";
    crm_run_query($sql);
    $sql="insert into companies set shortname='Dev Group', name='Dev Group', status=1, id=2, contact=2";
    crm_run_query($sql);
    $sql="insert into companies set shortname='Consultants', name='Consultants', status=1, id=3";
    crm_run_query($sql);
    $sql="insert into companies set shortname='A Customer Group', name='A Customer Group', status=1, id=4, contact=5";
    crm_run_query($sql);

    // Back to the regular database
    $CRM_demo=0;
} // end of if not db demo exists

  // Create the proper settings in OPT_lib.php
  $temp=$SCRIPT_NAME;
  $temp=explode("/",$temp);
  for ($i=0;$i<sizeOf($temp)-2;$i++) { //>
    $CRM_URL.=$temp[$i]."/";
  }
  $CRM_URL=substr($CRM_URL,0,-1);
  parseInitFile("../include/init_OPT_lib.txt","../include/OPT_lib.php");
  parseInitFile("../include/init_mail_retrieve.txt","../include/mail_retrieve.pl");

?>
<div class="regular" align="center">
<form action="./setup2.php" method="POST">
  <table border="0" cellspacing="1" cellpadding="2" width="90%">

  <tr>
    <td align="center" bgcolor="<? echo $OPT_col_dk; ?>" class="regular" colspan="2">
      This is step 2 of the OPT installation set up. You have successfully set up the
      OPT database. Please fill in the form below for initial server settings.
      <p>All of the data in this page may be altered from the OPT interface at a later time.
    </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <strong>Administrative company</strong><br>
      &nbsp;<input type="text" name="compName" size="25">&nbsp;
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
    This will be the short name for the primary company in OPT. When so configured, OPT will give users in this group distinct rights from users in other groups.  In this case, the primary group can see all other groups (customers), but customers are not able to see other customers or their projects.
    </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <strong>Username</strong><br>
      &nbsp;<input type="text" name="uname" size="25" value="admin">&nbsp;
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
    This will be the username for the first user in OPT.  It is an administrative user similar to 'root' on Unix systems. Use this user to access the OPT server and start adding users and companies. It is recommended that you create a regular user account for yourself once logged in for day to day use of OPT.  You would then only use this administrative login for system configuration and maintenance.
    </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <strong>Password</strong><br>
      &nbsp;<input type="password" name="pwd" size="25">&nbsp;
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
        Please choose a password for the previously defined user.
    </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <strong>Confirm password</strong><br>
      &nbsp;<input type="password" name="pwd2" size="25">&nbsp;
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
        Please confirm the previously defined password (type it again).
    </td>
  </tr>

  <tr>
     <td bgcolor="<? echo $OPT_col_dk; ?>" class="regular" align="center" colspan="2">
        <b>Incoming Email Handler configuration</b>
     </td>
  </tr>

  <tr>
     <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" colspan="2">
    <p>OPT uses a Perl script to handle replies to its email notifications.  This allows users to comment on items
    simply by replying to an email message.  In order for this to be enabled the following must be done:
    <?
    $email_split = explode("@", $CRM_system_email);
    $email_name = $email_split[0];
    ?>
    <ol>
    
          <li>Add the following line to /etc/aliases and then run 'newaliases' as root.<br>
             <code><?echo($email_name);?>: "| /usr/bin/perl <?echo($CRM_path);?>/include/mail_retrieve.pl"</code></li>
          <li>Allow sendmail to invoke Perl:  <code>ln -s /usr/bin/perl /etc/smrsh/</code></li>
          <li>Make sure mail_retrieve.pl has exec permissions set for all users ("chmod a+x mail_retrieve.pl")</li>
    </ol>
          <p>These instructions work for Sendmail on Red Hat Linux, however there are a number of other ways to configure this on other distributions with different MTAs.  See the INSTALL.email file in the OPT download for further details.</p>
     </td>
  </tr>

  <tr>
     <td bgcolor="<? echo $OPT_col_dk; ?>" class="regular" align="center" colspan="2">
        <b>Optional Knowledge Base Settings Below</b>
     </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <input type="checkbox" name="know_allow_external" value="1" checked> Allow external access
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
        If you leave this setting on then your OPT server will access other servers on the
        internet for knowledge entries.
        <p>The suggested policy is leaving this and the next checkbox set unless you're
        really limited on traffic (expect less than 100K per month for regular use).
    </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <input type="checkbox" name="know_public" value="1"> This is a public server
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
        If this is checked, then your server will serve public knowledge entries
        users post to other servers upon request.
    </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <strong>Server name</strong><br>
      &nbsp;<input type="text" name="servname" size="25">&nbsp;
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
        This will be this server's name in the OPT knowledge network.
        <p>If you decide to become part of the knowledge network then people from outside your
        server will see this name as the originating machine of knowledge entries and comments.
    </td>
  </tr>

  <tr>
    <td bgcolor="<? echo $OPT_col_lt; ?>" class="regular" align="center">
      <strong>Company homepage</strong><br>
      &nbsp;<input type="text" name="homepage" size="25">&nbsp;
    </td>
    <td bgcolor="<? echo $OPT_col_md; ?>" class="small">
        This will be this server's homepage in the OPT knowledge network.
        <p>If you decide to become part of the knowledge network then people from outside your
        server will be able to use this link attached to the server name defined above. We suggest
        setting this to your organization's homepage. Don't forget to add &quot;http://&quot; at
        the beginning of the URL.
    </td>
  </tr>

  <tr>
    <td align="center" bgcolor="<? echo $OPT_col_dk; ?>" class="regular" colspan="2">
      <strong>IMPORTANT!</strong> The setup process is thoroughly finished only when you get a
      message saying so. Before that, anyone with access to this machine will be
      able to "configure" your OPT server.
      <p>Leaving the system in this state is generally not a good idea. So if you have problems
      with the installation process please manually delete opt/include/setup_lock/lock01 so other people
      won't have access to this page!
    </td>
  </tr>

  <tr>
    <td align="center" bgcolor="<? echo $OPT_col_md; ?>" class="regular" colspan="2">
      <input type="hidden" name="CRM_db_db_exists" value="<? echo $CRM_db_db_exists ?>">
      <input type="submit" name="action" value="Create these settings">
    </td>
  </tr>

  </table>
</form>
</div>
</BODY>
</HTML>
