<?
#
# The setup library
#
# Contains the functions used by setup.php
# They are defined here instead of setup.php for easier reading of setup.php
#
# Bogdan Stancescu <bogdan@lanifex.com>, November 2001
# Windows support, Eric Pignot, August 2002
# Revision 1.1

  // Autorun code
  if ($autorun) {
    $inc="../include";
    $lock="$inc/setup_lock";

    if (!$noinclude) {
      include("$inc/general.php");
      include("$inc/db/mysql.php");
      include("$inc/gui.php");
    }

    mainBody("../images");
    make_main_title("Outreach Project Tool Setup","../images");

    // Test whether OS is windows or not
    $os = strtolower($HTTP_ENV_VARS["OS"]);
    if (strpos(" ".$os, "win")) {
      $os_is_win = true;
    } else {
      $os_is_win = false; // Just in case
    }

    if ($os_is_win) {
      if (isphpver("4.1.0")) {
        $apache_user=$_ENV["USERNAME"];
      } else {
        if (!$HTTP_ENV_VARS) {
          global $HTTP_ENV_VARS;
        }
        $apache_user=$HTTP_ENV_VARS["USERNAME"];
      }
    } else {
      $apache_user=exec("whoami");
    }

    if (!$apache_user) {
      $apache_user="running Apache";
    }

    if (!@unlink("$lock/lock01")) {
      if (!is_file("$lock/lock01")) {
        echo("<h4><b>Failed</b>: This system has already been set up.<br>You may copy the include directory
              again from the source over the installed one if you can't make out the settings.<br>".
              "If you're positive the system hasn't been set up yet, please make sure user <i>$apache_user</i> ".
              "has read/write rights throughout the opt/include directory.</h4>");
      } else {
        echo("<h4><b>Failed</b>: Make sure user <i>$apache_user</i> has read/write rights throughout the
              opt/include directory.</h4>");
      }
      exit;
    }
    $fd = fopen("$lock/lock01", "w");
    fwrite($fd, "# OPT installation lock. Delete this file if you have problems installing!");
    fclose($fd);

  }

  function killinstall($tasks)
  {
    if ($tasks>=1) {
      global $CRM_db_db_exists;
      if (!$CRM_db_db_exists) {
        global $CRM_db_db;
        OPT_db("drop database $CRM_db_db");
      }
    }
    if ($tasks>=2) {
      global $CRM_demo_db_exists, $CRM_db_demo_db;
      if ((!$CRM_demo_db_exists) && $CRM_db_demo_db) {
        OPT_db("drop database $CRM_db_demo_db");
      }
    }
    exit;
  }

  // This function is used for creating a database,
  // so CRM_run_query wouldn't have been useful since
  // it expects the database to exist already
  // (perfectionists would've named it CRM_run_query_on_database() :-) )
  function OPT_db($sql) {
    global $CRM_db_host, $CRM_db_uname, $CRM_db_pwd;

    $db = mysql_connect($CRM_db_host, $CRM_db_uname, $CRM_db_pwd);
    if (!$db) {
      return("NOCONNECT");
    }
    $result = @mysql_query ("$sql");
    if (($process_errors) || (!$result)) {
      return("NOCREATE");
    } else {
      return("OK");
    }
  }

  // Feeds a file line-by-line to mySQL.
  // Although running mysql "< file" //>
  // is the regular way to do this, it is way more reliable
  // to do it using PHP calls - that many problems encountered
  // while testing!
  // Obviously, the functionality is limited but we
  // don't need more than this here.
  function install_SQL($file)
  {
    $fr=fopen($file,"r");
    if (!$fr) {
      return(false);
    }
    $SQLline="";
    while (!feof($fr)) {
      $SQLline.=trim(fgets($fr,4096));
      if ($SQLline[0]=="#") {
        $SQLline="";
      } elseif (substr($SQLline,-2)==");") {
        if (!crm_run_query($SQLline)) {
          return(false);
        }
        $SQLline="";
      }
    }
    fclose($fr);
    return(true);
  }

  // Parses an init file and changes special placeholder lines to
  // proper PHP formatting.
  function parseInitFile($init_file, $final_file)
  {
    $fr=@fopen($init_file, "r");
    if (!$fr) {
      echo("<h4><strong>Failed</strong>: Unable to open $init_file for reading!</h4>");
      killinstall($finished);
    }

    $fw=@fopen($final_file, "w");
    if (!$fw) {
      echo("<h4><strong>Failed</strong>: Unable to open $final_file for writing!</h4>");
      killinstall($finished);
    }

    while (!feof($fr)) {
      $buffer=fgets($fr, 4096);
      if (substr($buffer,0,5)=="#OPT*") {
        list($dump,$var)=explode("*",$buffer);
        if ($var) {
          global $$var;
          $buffer="  \$$var=\"".$$var."\";\n";
        } else {
          $buffer="";
        }
      }
      if ($buffer) {
        fputs($fw,$buffer);
      }
    }
    fclose($fw);
    fclose($fr);
  }

?>
