<?
#
# Main tasks page
#
# Displays the list of tasks related to a project
#
# Irina Nikitina <irina@lanifex.com>, November 2001
# Beautified Bogdan Stancescu <bogdan@lanifex.com>, December 2001
# Revision 1.01
  include "../include/OPT_lib.php";
  auth_open();
  include "$CRM_path/tasks/task/task_lib.php";
  include "$CRM_path/tasks/calculate_status.inc";
  include "$CRM_inc/email.php";
  checkMail();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>Tasks List</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  if (!crm_perm("projects",$proj))
  {
    echo("Page not found");
    auth_close();
    exit;
  }

  // Get project settings once
  $show_hours_column=get_project_setting($proj, "task_status_hours_remaining");

  mainBody("../images");
  make_main_title("Task List","../images");
  startTables();

  $parent=abs($parent);

?>
<form name="filters" style="margin:0;" action="index.php" method="post">
<?
  include "$CRM_path/tasks/filters.inc";
?>
</form>

<?
  if ($parent)
  {
      echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_md\" align=\"center\" colspan=\"10\">\n");
      echo("<b><a class=\"regular\" href=\"./?proj=$proj&parent=".getvalue("task","parent",$parent)."\">[Up one level to parent task]</a></b>");
      echo("</td><tr>\n");
  }
?>
    <tr>
      <td class='regular' bgcolor='<? echo $OPT_col_dk ?>' align='center' rowspan='2'>
        &nbsp;&nbsp;
      </td>
      <td class='regular' bgcolor='<? echo $OPT_col_dk ?>' align='center' colspan='3'>
        <b>Task</b>
      </td>
      <td class='regular' bgcolor='<? echo $OPT_col_dk ?>' align='center' rowspan='2'>
        <b>Owner</b>
      </td>
      <td class='regular' bgcolor='<? echo $OPT_col_dk ?>' align='center' rowspan='2'>
        <b>Status</b>
      </td>
      <?
      if ($show_hours_column == "1")
      { 
          $complete_colspan="4";
      }
      else
      {
          $complete_colspan="3";
      } 
      ?>
      <td class='regular' bgcolor='<? echo $OPT_col_dk ?>' align='center' colspan='<?echo($complete_colspan)?>'>
        <b>Complete</b>
      </td>
      <td class='regular' bgcolor='<? echo $OPT_col_dk ?>' rowspan='2' align='center'>
        <b>Status<br>Updated</b>
      </td>
    </tr>
    <tr>
      <td class='small' align='center' bgcolor='<? echo $OPT_col_dk ?>'>
        <? echo("<font color=\"$OPT_col_dimmed\"><b>Inf-&gt;P</b></font>"); ?>
      </td>
      <td class='small' align='center' bgcolor='<? echo $OPT_col_dk ?>'>
        <b>Name</b>
      </td>
      <td class='small' align='center' bgcolor='<? echo $OPT_col_dk ?>'>
        <b>Sub</b>
      </td>
      <td class='small' align='center' bgcolor='<? echo $OPT_col_dk ?>'>
        <? echo("<font color=\"$OPT_col_dimmed\"><b>C-&gt;Inf</b></font>"); ?>
      </td>
      <td class='small' align='center' bgcolor='<? echo $OPT_col_dk ?>'>
        <? echo("<font color=\"$OPT_col_dimmed\"><b>Loc</b></font>"); ?>
      </td>
      <td class='small' align='center' bgcolor='<? echo $OPT_col_dk ?>'>
        <b>Tot</b>
      </td>
      <?
      if ($show_hours_column == "1")
      { 
      ?>
      <td class='small' align='center' bgcolor='<? echo $OPT_col_dk ?>'>
        <b>Hrs</b>
      </td>
      <?
      }
      ?>
    </tr>
<?
  $sql="select distinct(id), TaskName, CatID, StartDate, StartDatePlanned, EndDate, EndDatePlanned, 
               DateSet, TaskDesc, ProjectID, PercentComplete, StatusUpdated, active, date, parent,
               PercentOfParent, TIME_TO_SEC(estimated) as secs_estimated
        from task LEFT JOIN person_task ON task.id = person_task.taskID
        where
          ProjectID=$proj and active='1' and parent=$parent
          $owner_filter_sql $status_filter_sql $category_filter_sql
          order by CatID, date";
  $cat="0";
  $result=crm_run_query($sql);

if (OPT_num_rows($result) == 0)
{
?>
   <tr><td colspan="11" class="regular" align="center" bgcolor="<? echo $OPT_col_lt; ?>" valign="middle">
   <i>No tasks found matching your criteria.</i>
   </td></tr>
<?
}
?>

<?
  while (make_vars($result))
  {
    // Different category?
    if (($CatID) && ($cat!=$CatID))
    {
      echo "    <tr>\n      <td class='regular' colspan='11' bgcolor=\"$OPT_col_md\" align='left'>\n";
      $sql="select cat_name FROM project_categories where id=$CatID";
      $res=crm_run_query($sql);
      make_vars($res);
      echo "<b>".$cat_name."</b></td></tr>\n";
      $cat=$CatID;
    }
    // New task?
    if ($CRM_guest)
    {
      $newicon="&nbsp;&nbsp;";
    }
    else
    {
      $sql="select
              task.id
            from
              task, people
            where
              task.date>people.prevlog and
              people.id=$CRM_user and
              task.id=$id";
      $result2=crm_run_query($sql);
      $newicon="&nbsp;&nbsp;";
      if (OPT_num_rows($result2))
      {
        $newicon="<img src=\"../images/$OPT_icon_new\" alt=\"New Task!\">";
      }
    }

    // Task name and children
    $sql="select count(*) from task where parent=$id and active=1";
    $result2=CRM_run_query($sql);
    $myrow=OPT_fetch_row($result2);
    if ($myrow[0])
    {
      $sub="<a class=\"regular\" href=\"./?proj=$proj&parent=$id\">[+$myrow[0]]</a>\n";
    }
    else
    {
      $sub="&nbsp;";
    }
    ?>
    <tr>
      <td class='regular' bgcolor='<? echo $OPT_col_lt ?>' align="center">
        <? echo $newicon; ?>
      </td>
      <td class='small' bgcolor='<? echo $OPT_col_lt ?>' align='right'>
        <?
          $inf=getvalue("task","PercentOfParent",$id);
          if ($inf)
          {
            $inf.="%";
          }
          else
          {
            $inf="&nbsp;";
          }
          echo("<font color=\"$OPT_col_dimmed\">$inf</font>");
        ?>
      </td>
      <td class='regular' bgcolor='<? echo $OPT_col_lt ?>' align='left'>
        <a class="regular" href="./task/?proj=<? echo $proj ?>&task=<? echo $id ?>&action=display"><? echo(stripslashes($TaskName)) ?></a>
      </td>
      <td class='regular' bgcolor='<? echo $OPT_col_lt ?>' align='center'>
        <? echo $sub ?>
      </td>
      <td class='regular' bgcolor='<? echo $OPT_col_lt ?>' align='left'>
    <?
    $owner=false;
    $sql2 = "select
              people.fname, people.lname, people.id
            from
              people, person_task
            where
              people.id=person_task.personID and
              person_task.taskID=$id and
              person_task.owner='Y'";
    $result2 = crm_run_query($sql2);
    $first_person=1;
    while ($myrow=OPT_fetch_array($result2))
    {
      $fname=$myrow[0];
      $lname=$myrow[1];
      if ($first_person != 1) { echo ("<br />"); } else { $first_person=0; }
      echo "<a class='regular' href='../people/admin/?action=display&id=$myrow[2]'>$fname $lname</a>";
      $owner=true;
    }
    if (!$owner)
    {
      echo("&nbsp;");
    }
    echo "</td>\n<td class='regular' bgcolor='$OPT_col_lt' align='center'>";
    // We'll calculate the proper progress from all the influences below
    list($totalcount,$affectcount,$complete,$affect,$personal, $T_time, $T_estimated)=compute_progress($id);
    $icons = determineStatusIcons($StartDatePlanned, $EndDatePlanned, $complete);
    if ($icons)
    {
      echo $icons;
    }
    else
    {
      echo("&nbsp;");
    }

    // Percent Complete
    $affected=100-$personal;
    echo "\n</td><td class='small' bgcolor='$OPT_col_lt' align='right'>\n";
    if (!$affected)
    {
      $affected="&nbsp;";
    }
    else
    {
      $affected.="%";
    }
    echo("<font color=\"$OPT_col_dimmed\">$affected</font>");
    echo "\n</td><td class='small' bgcolor='$OPT_col_lt' align='right'>\n";
    if (($PercentComplete!=0)&&($PercentComplete!=100))
    {
      $PercentComplete.="%";
    }
    else
    {
      $PercentComplete="&nbsp;";
    }
    echo("<font color=\"$OPT_col_dimmed\">$PercentComplete</font>\n");
    echo "\n</td><td class='regular' bgcolor='$OPT_col_lt' align='right'>\n";
    $complete=abs($complete);
    echo("$complete%</td>");

    // Hours remaining
    if ($show_hours_column == "1")
    { 
        $hrs_remaining = sprintf("%.0f", ((100-$complete)/100 * $T_estimated/3600));
        $total_hours+=$hrs_remaining;
        echo("<td class='regular' bgcolor='$OPT_col_lt' align='center'>$hrs_remaining</td>");
    }
    
    // Status updated
    echo"<td class='regular' bgcolor='$OPT_col_lt'>";
    if ($StatusUpdated!=0)
    {
      echo niceDate("task","from_unixtime(StatusUpdated)",$id,1);
    }
    else
    {
      echo("&nbsp;");
    }
    echo "</td></tr>";
  }
?>
<tr>
<?
if ($show_hours_column == "1")
{       
    $hint_colspan="9";
}
else
{
    $hint_colspan="11";
}
?>
  <td class="small" align="left" bgcolor="<? echo $OPT_col_dk; ?>" colspan="<?echo($hint_colspan);?>">
    <? echo(__("You may view any task's details by clicking on the its title. 
                Hours shown are amount of effort remaining. The total is shown to the right.")); ?>
  </td>
<?
if ($show_hours_column == "1")
{
?>
  <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>" >
    <?echo(sprintf("%.0f", $total_hours));?>
  </td>
  <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>" >&nbsp;</td>
<?
  }
?>
</tr>


<?
  endTables();
?>

<script language="javascript">
<!--
     parent.leftFrame.location='leftmenu/?proj=<? echo $proj; ?>';
// -->
</script>
<?
  auth_close();
?>
</BODY>
</HTML>
