<?
# Title: 		Detailed Task Report
# Description: 	Based on "task report - people" by Bogdan Stancescu <bogdan@lanifex.com>, February 2002 # Revision 1.0
# 				Displays the list of tasks related to a project with detailed info
# Author: 		Tony Bierman <BiermanA@honi.com>, March 2002
# Revision: 	0.4 beta

  include "../../include/OPT_lib.php";
  auth_open();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>Detailed Task Report</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?

Function SetStartIcons($StartDatePlanned,$StartDate,$EndDatePlanned,$EndDate,$active,$PercentComplete){
  $now=time();
  $sdif=$now-$StartDatePlanned;  //positive means were past estimate
  $edif=$now-$EndDatePlanned;        //positive means were past estimate
  $icons='';
  $IsIcon=false;
  // if the task is not active
  if ($active){
    if ($sdif < 0){ // We're before the start date
      // blue clock
      $icons.='<img src="../../images/icons/clock.gif" alt="This task has not started yet" border="0">';
      $IsIcon=true;
    }
    else // Nope, were passed the start date
    {
      if ($StartDatePlanned !=0 and $PercentComplete==0){  // add a red clock for missing the planned start date
        $icons.='<img src="../../images/icons/clock-due.gif" alt="This task is past its start date with no reported progress" border="0">';
        $IsIcon=true;
      }
      else {
        if ($PercentComplete>0 and $PercentComplete<100 and $edif<0){
              $icons.='<img src="../../images/icons/progress.gif" alt="Task in progress, '.$PercentComplete.'% complete" border="0">';
              $IsIcon=true;
        }
      }
      if ($StartDatePlanned==0 and $PercentComplete==0){ // No start date has been planned
        $icons.='<img src="../../images/icons/clock-due.gif" alt="A start date has not been scheduled for this task" border="0">';
        $IsIcon=true;
      }
    }
  }
  if (!$IsIcon){
    $icons.='<img src="../../images/spacer.gif" border="0" width="16">';
  }

  Return ($icons);
}

Function SetEndIcons($StartDatePlanned,$StartDate,$EndDatePlanned,$EndDate,$active,$PercentComplete){
  $now=time();
  $edif=$now-$EndDatePlanned;        //positive means were past the estimate
  $icons='';
  $IsIcon=false;
  if ($StartDatePlanned and $StartDate and $EndDatePlanned and $EndDate and $PercentComplete>=100){  //Is progress reported as complete?
    $icons='<img src="../../images/icons/done.gif" alt="Task completed" border="0">';
	$IsIcon=true;
  }

  if ($active){// Do we have an active task?
    if ($edif > 0) {// Are we past the completion date?
      if ($PercentComplete>0 and $PercentComplete<100) {
        $icons.='<img src="../../images/icons/progress-due.gif" alt="This task is past scheduled finish date, only '.$PercentComplete.'% complete" border="0">';
        $IsIcon=true;
	  }
    }
  }

  if (!$IsIcon){
    $icons.='<img src="../../images/spacer.gif" border="0" width="16">';
  }
Return ($icons);
}


  $proj=abs($proj);

  if ((!crm_perm("projects",$proj)) || (!$proj))
  {
    echo("Page not found");
    auth_close();
    exit;
  }
  mainBody("../../images");
  make_main_title("Detailed Task Report","../../images");

  startTables();

  $sql="select
          p.id,
          p.fname,
          p.lname,
          t.id,
          t.PercentComplete
        from
          person_task as pt,
          task as t,
          people as p
        where
          p.id=pt.personID AND
          pt.taskID=t.id AND
          t.projectID=$proj AND
          t.active=1 AND
          pt.owner=\"Y\"
        order by
          p.fname,
          p.lname,
          t.date DESC";
  $p=-1;
  $result=CRM_run_query($sql);
  while ($myrow=OPT_fetch_row($result))
  {
    if (!$beenHere)
    {
      echo("<tr>\n");
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_dk\" align=\"center\">\n");
      echo("    <b>Name</b>\n");
      echo("    <div class=\"small\">[Person/Task]</div>\n");
      echo("  </td>\n");
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_dk\" align=\"center\">\n");
      echo("    <b>Start</b>\n");
      //echo("    <div class=\"small\">[Per project/Per task]</div>\n");
      echo("  </td>\n");
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_dk\" align=\"center\">\n");
      echo("    <b>Finish</b>\n");
      //echo("    <div class=\"small\">[Per project/Per task]</div>\n");
      echo("  </td>\n");
      echo("</tr>\n");
      $beenHere=true;
    }
    if ($p!=$myrow[0])
    {
      // *********** PERSON ***********
      // Person row start
      echo("<tr>\n");

      // Person name
      echo("  <td colspan='3' class=\"regular\" bgcolor=\"$OPT_col_md\">\n");
	  echo("<a class='regular' href='../../people/admin/?action=display&id=$myrow[0]'><b>$myrow[1] $myrow[2]<b></a>");
      //echo("    <b>$myrow[1] $myrow[2]<b>\n");
      echo("  </td>\n");

      //echo("  <td class=\"regular\" bgcolor=\"$OPT_col_md\">\n");
      //echo("  </td>\n");

      //echo("  <td class=\"regular\" bgcolor=\"$OPT_col_md\">\n    <b>");
      //echo("</b>\n  </td>\n");

      // Person row ending
      echo("</tr>\n");
      $p=$myrow[0];
    }

    // *********** TASK ***********
    // Task row start
    echo("<tr>\n");

    // Task name
    echo("  <td class=\"regular\" bgcolor=\"$OPT_col_lt\">\n");
    //echo("    &nbsp;&nbsp;".getvalue("task","taskName",$myrow[3])."\n");
    echo("    &nbsp;&nbsp;<a href='../task/?proj=$proj&task=$myrow[3]&action=display'>".getvalue("task","taskName",$myrow[3])."\n</a>");
    echo("  </td>\n");

    $sql="select StartDatePlanned, StartDate, EndDatePlanned, EndDate, PercentComplete, active from task where id=$myrow[3]";
    $result2=CRM_run_query($sql);
    list($StartDatePlanned, $StartDate, $EndDatePlanned, $EndDate, $PercentComplete, $active)=OPT_fetch_row($result2);

    // StartDatePlanned
    echo("  <td class=\"regular\" bgcolor=\"$OPT_col_lt\">\n");
           $time=$StartDatePlanned;
    if ($time)
    {
      if ($time<time())
      {
                $time="<strong>".date("M d Y",$time)."</strong>";
      }
      else
      {
        $time=date("M d Y",$time);
      }
    }
    else
    {
      $time="n/a";
    }
	if ($StartDate){  // do we have an actual?
	  $time = "<strong><font color=\"$OPT_col_dimmed\">".date("M d Y",$StartDate)."</font></strong>";
	  $diff = "<font class=\"small\" color=\"$OPT_col_dimmed\">[Planned +".date ("d",$StartDate - $StartDatePlanned)." days]"."</font>";
	}
	// Print the text and any icons
    echo(SetStartIcons($StartDatePlanned,$StartDate,$EndDatePlanned,$EndDate,$active,$PercentComplete));
	echo("    ".$time."&nbsp;");
	
	if ($StartDate){  // do we have an actual?
	  echo("<br/>&nbsp;&nbsp;&nbsp;&nbsp;".$diff);
	}
	
	
    echo("  </td>\n");

    // EndDatePlanned
    echo("  <td class=\"regular\" bgcolor=\"$OPT_col_lt\">\n");
         $time=$EndDatePlanned;
    if ($time)  // do we have a plan?
    {
      if ($time<time())  // are we past the planned end date?
      {
                $time="<strong><font color=\"$OPT_col_attention\">".date("M d Y",$time)."</font></strong>";
      }
      else // nope, we're still in the game
      {
        $time=date("M d Y",$time);
      }
    }
    else // no plan
    {
      $time="n/a";
    }
    if ($EndDate)  // do we have an actual?
    {
      $time="<strong><font color=\"$OPT_col_dimmed\">".date("M d Y",$EndDate)."</font></strong>";
	  $diff = "<font class=\"small\" color=\"$OPT_col_dimmed\">[Planned +".date ("d",$EndDate - $EndDatePlanned)." days]"."</font>";
    }

        // Print the text and any icons
    echo(SetEndIcons($StartDatePlanned,$StartDate,$EndDatePlanned,$EndDate,$active,$PercentComplete));
    echo("    ".$time."&nbsp");
	
	if ($EndDate){  // do we have an actual?
	  echo("<br/>&nbsp;&nbsp;&nbsp;&nbsp;".$diff);
	}
	
	
	
    echo("</td>\n");

    // Task row ending
    echo("</tr>\n");

  }
	endTables();
	echo("<br/>\n");

  $img_path="../../images";

  include "$CRM_path/tasks/icons_legend.inc";

?>
<script language="javascript">
<!--
parent.leftFrame.location='../leftmenu/?proj=<? echo $proj; ?>';
// -->
</script>
</BODY>
</HTML>
