<?php
if ($_REQUEST['_jpg_csimd'] == 1)
{
    include ("../../include/OPT_lib.php");
    auth_open();
    if (!crm_perm("projects",$proj))
    {
        auth_close();
        exit;
    }
}
include ("$CRM_inc/jpgraph/jpgraph.php");
include ("$CRM_inc/jpgraph/jpgraph_gantt.php");

// Setup Gantt graph
$graph = new GanttGraph(700,0,'auto');
$graph->SetShadow();
$graph->SetBox();

// If we didn't get all the variables we'd like, retrieve them from user_settings;
if (!$start_date || !$end_date)
{
    $sql="select name, value from user_settings where (type = 'task_gantt_chart'  or type = 'task_filters')
         and project = $proj and person = $CRM_user";
    $result=CRM_run_query($sql);
    while ($row = OPT_fetch_row($result))
    {
        $$row[0] = $row[1];  // Assign value to variable name
    }
}

// If we still don't have a start and end date, then let's use some defaults
if (!$start_date || !$end_date)
{  
    $start_date = date("Y-m-d", mktime(0,0,0, date(m)-1, date(d),date(Y))); // One month ago 
    $end_date = date("Y-m-d", mktime(0,0,0, date(m)+1, date(d),date(Y))); // One month from now
}


// Only show part of the Gantt
$graph->SetDateRange($start_date,$end_date);

// Determine which header for dates to show
if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365)  
{   // More than two years difference
    $graph->ShowHeaders(GANTT_HYEAR);
}
else if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365*(5/12))  
{   // More than five months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH);
}
else if ((strtotime($end_date) - strtotime($start_date)) > 60*60*24*365*(2/12))  
{   // More than two months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH | GANTT_HWEEK);
}
else
{   // Less than two months
    $graph->ShowHeaders(GANTT_HYEAR | GANTT_HMONTH | GANTT_HDAY | GANTT_HWEEK);
}

$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
$graph->scale->week->SetFont(FF_FONT1);

$bar_index = 0;  // incremented for each bar on chart

// Get all milestones for this project that fall within this time range
$sql="select due_date, name from project_milestones where project = ".abs($proj)." 
     and due_date >= '".OPT_gpc_slashes($start_date)."' and due_date <= '".OPT_gpc_slashes($end_date)."'";
$result=CRM_run_query($sql);
while ($row = OPT_fetch_row($result))
{
   $ms = new MileStone($bar_index++,"",$row[0],date("M d",strtotime($row[0])));
   $ms->title->SetFont(FF_FONT1,FS_BOLD);
   $graph->Add($ms);  // Add the milestone
   
   $vline = new GanttVLine($row[0], $row[1], "darkred"); // add it as a line as well to really stand out
   $vline->title->SetFont(FF_FONT1,FS_BOLD,10);
   $vline->SetDayOffset(0.5);    // Center the line in the day
   $graph->Add($vline);
}

// Now get all tasks that have both meet the filter criteria
if ($status_filter ==  1)
{   // "All"
    $status_filter_sql="";
}
else if ($status_filter ==  2)
{   // "Uncomplete"
    $status_filter_sql=" and PercentComplete < 100";
}
else if ($status_filter == 3)
{   // "In Progress"
    $status_filter_sql=" and PercentComplete > 0 and PercentComplete < 100 and ((EndDatePlanned = 0) OR (EndDatePlanned > now()))";
}
else if ($status_filter ==  4)
{   // "Overdue"
    $status_filter_sql=" and PercentComplete < 100 and EndDatePlanned < now()";
}
else if ($status_filter ==  5)
{   // "Pending"
    $status_filter_sql=" and PercentComplete = 0";
}
else if ($status_filter ==  6)
{   // "Completed Recently" this week
    $status_filter_sql=" and PercentComplete = 100 and FROM_UNIXTIME(EndDate) > (NOW() - INTERVAL 7 DAY)";
}
else if ($status_filter ==  7)
{   // "Completed"
    $status_filter_sql=" and PercentComplete = 100";
}
else
{   // Default is 'uncompleted'
    $status_filter_sql=" and PercentComplete < 100";
}

// Generate Owner filter
if (sizeOf($owner_filter) && ($owner_filter > 0))
{  
    $owner_filter_sql=" and person_task.personID=$owner_filter and person_task.owner='Y'";
}
else if (sizeOf($owner_filter) && ($owner_filter == -2))
{
    $owner_filter_sql=" and person_task.personID IS NULL";
}  

// Append Category filter
if (sizeOf($category_filter) && ($category_filter >= 0))
{
    $category_filter_sql = " and CatID= '$category_filter'";
}

// Find all tasks that would fall into this range (even if just partially)
$sql="select distinct(task.id) as id, TaskName, StartDate, StartDatePlanned, EndDate, EndDatePlanned, 
               DateSet, TaskDesc, ProjectID, PercentComplete, StatusUpdated, active, date, parent,
               PercentOfParent, TIME_TO_SEC(estimated) as secs_estimated, personID, fname
        from task LEFT JOIN person_task ON task.id = person_task.taskID, people
        where
          ProjectID=$proj and active='1' and person_task.personID = people.id and 
          ((StartDate > 0) and (StartDate < UNIX_TIMESTAMP('$end_date'))
           OR (StartDatePlanned > 0) and (StartDatePlanned < UNIX_TIMESTAMP('$end_date')))
          and
          (EndDate > UNIX_TIMESTAMP('$start_date') OR EndDatePlanned > UNIX_TIMESTAMP('$start_date'))
          $owner_filter_sql $status_filter_sql $category_filter_sql
        order by people.fname, StartDate, StartDatePlanned";
$result=crm_run_query($sql);
$last_person = 0;
while ($row = OPT_fetch_array($result))
{
    if ($last_person != intVal($row["personID"]))
    {
        // Use milestones without date to indicate a person label
        $last_person = intVal($row["personID"]);
        $ms = new MileStone($bar_index++,$row["fname"],0,"");
        $ms->title->SetFont(FF_FONT1,FS_BOLD);
        $ms->title->SetColor("black");
        $graph->Add($ms);  // Add the milestone
    }

    // Determine the start date (real overrides planned)
    if ($row["StartDate"])
    {
        $task_start = date("Y-m-d", intVal($row["StartDate"]));
    }
    else
    {
        $task_start = date("Y-m-d", intVal($row["StartDatePlanned"]));
    }

    // Determine the end date (real overrides planned)
    if ($row["EndDate"])
    {
        $task_end = date("Y-m-d", intVal($row["EndDate"]));
    }
    else
    {
        $task_end = date("Y-m-d", intVal($row["EndDatePlanned"]));
    } 

    // Add a caption indicating the percentage of progress if it's in progress
    if ($row["PercentComplete"] && ($row["PercentComplete"] < 100))
    {
        $caption = "[" . $row["PercentComplete"] ."%]";
    }
    else
    {
        $caption = "";
    }    
    
    $bar = new GanttBar($bar_index++,"Task #".$row["id"],$task_start,$task_end, $caption);
    
    // Set the progress amount on the bar
    $bar->SetPattern(BAND_RDIAG,"yellow");
    $bar->SetFillColor("red");
    $bar->progress->Set($row["PercentComplete"]/100);
    $bar->progress->SetPattern(GANTT_SOLID,"darkgreen");
    
    // Now add a Client side image map to link directly to task with hovering title
    $bar ->SetCSIMTarget ("../task/index.php?proj=$proj&task=".$row["id"]."&action=display");
    $bar->SetCSIMAlt(str_replace("\"", "'", $row["TaskName"]));
    $bar->title-> SetCSIMTarget("../task/index.php?proj=$proj&task=".$row["id"]."&action=display");
    $bar->title-> SetCSIMAlt("Click to view details");

    $graph->Add($bar);
}

$graph->StrokeCSIM('gantt_image.php');
if ($_REQUEST['_jpg_csimd'] == 1)
{
    auth_close();
}
?>
