<?
#
# Task report - people
#
# Displays the list of tasks related to a project with detailed people info
#
# Bogdan Stancescu <bogdan@lanifex.com>, February 2002
# Revision 1.0
  include "../../include/OPT_lib.php";
  auth_open();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>Tasks Report - People/Time</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?

  $proj=abs($proj);

  if ((!crm_perm("projects",$proj)) || (!$proj))
  {
    echo("Page not found");
    auth_close();
    exit;
  }
  mainBody("../../images");
  make_main_title("Task Report - People/Time","../../images");

  startTables();

  $sql="select
          p.id,
          p.fname,
          p.lname,
          t.id,
          t.PercentComplete,
          tph.progress,
          tph.worked,
          tph.date
        from
          task as t,
          people as p,
          task_progress_history as tph
        where
          p.id=tph.person AND
          t.projectID=$proj AND
          t.active=1 AND
          tph.taskID=t.id
        order by
          p.fname,
          p.lname,
          tph.date ASC";
  $p=-1;
  $result=CRM_run_query($sql);
  while ($myrow=OPT_fetch_row($result))
  {
    if (!$beenHere)
    {
      echo("<tr>\n");
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_dk\" align=\"center\">\n");
      echo("    <b>Name</b>\n");
      echo("    <div class=\"small\">[Person/Task]</div>\n");
      echo("  </td>\n");
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_dk\" align=\"center\">\n");
      echo("    <b>Time Period</b>\n");
      echo("    <div class=\"small\">[Per project/Per task]</div>\n");
      echo("  </td>\n");
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_dk\" align=\"center\">\n");
      echo("    <b>Time Worked</b>\n");
      echo("    <div class=\"small\">[Per project/Per task]</div>\n");
      echo("  </td>\n");
      echo("</tr>\n");
      $beenHere=true;
    }
    if ($p!=$myrow[0])
    {
      // *********** PERSON ***********
      // Person row start
      echo("<tr>\n");

      // Person name
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_md\">\n");
      echo("    <b>$myrow[1] $myrow[2]<b>\n");
      echo("  </td>\n");

      // Person period
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_md\">\n    <b>");
      $sql="select min(tph.date), max(tph.date)
            from
              task as t,
              task_progress_history as tph
            where
              t.projectID=$proj AND
              t.active=1 AND
              tph.taskID=t.id AND
              tph.person=$myrow[0]";
      $result2=CRM_run_query($sql);
      list($mindate,$maxdate)=OPT_fetch_row($result2);
      if ($mindate)
      {
        echo(niceDate("people",$mindate,$myrow[0],1)." - ".niceDate("people",$maxdate,$myrow[0],1));
      }
      else
      {
        echo("n/a");
      }
      echo("</b>\n  </td>\n");

      // Person time
      echo("  <td class=\"regular\" bgcolor=\"$OPT_col_md\">\n");
      $sql="select sec_to_time(sum(time_to_sec(worked)))
            from
              task as t,
              task_progress_history as tph
            where
              t.projectID=$proj AND
              t.active=1 AND
              tph.taskID=t.id AND
              tph.person=$myrow[0]";
      $result2=CRM_run_query($sql);
      list($time)=OPT_fetch_row($result2);
      $time=makeNiceTime($time);
      echo("    <b>$time<b>\n");
      echo("  </td>\n");

      // Person row ending
      echo("</tr>\n");
      $p=$myrow[0];
      $prevdate="n/a";
    }

    // *********** Period ***********
    // Period row start
    echo("<tr>\n");

    // Period - Task name
    echo("  <td class=\"regular\" bgcolor=\"$OPT_col_lt\">\n");
    echo("    &nbsp;&nbsp;".getvalue("task","taskName",$myrow[3])."\n");
    echo("  </td>\n");

    // Period
    echo("  <td class=\"regular\" bgcolor=\"$OPT_col_lt\">\n");
    echo("$prevdate - ".($prevdate=niceDate("people",$myrow[7],$myrow[0])));
    echo("  </td>\n");

    // Period time
    echo("  <td class=\"regular\" bgcolor=\"$OPT_col_lt\">\n");
    $time=makeNiceTime($myrow[6]);
    echo("    $time [$myrow[5]%]");
    echo("  </td>\n");

    // Period row ending
    echo("</tr>\n");
  }

  endTables();
?>
<script language="javascript">
<!--
parent.leftFrame.location='../leftmenu/?proj=<? echo $proj; ?>';
// -->
</script>
</BODY>
</HTML>
