<?
#
# Add task routine
#
# Irina Nikitina <irina@lanifex.com>, November 2001
# Revision 1.0

  if ((!$TaskName) || ($TaskName=='')) {
    $TaskName=__("Name not set");
  }
  if ((!$catID)&&($catID=='')) {
    $catID=0;
  }
  $parent=abs($parent);

  $PercentOfParent=abs($PercentOfParent);
  $sql="select sum(PercentOfParent) from task where parent=$parent and active=1 and ProjectID=$proj";
  $result=crm_run_query($sql);
  $myrow=OPT_fetch_row($result);

  if ($myrow[0]+$PercentOfParent>100) {
    $PercentOfParent=100-$myrow[0];
    $trimmed=true;
  }

  if ($trimmed && $debug_trimming) {
    $trimmed_total=$myrow[0];
    echo("<b>Trimmed due to the following tasks:</b>\n");
    $sql="select id, TaskName, PercentOfParent from task where parent=$parent and active=1";
    $result=OPT_run_query($sql);
    while ($myrow=OPT_fetch_row($result)) {
      if ($myrow[2])
        echo("<BR />$myrow[2]% - <A HREF='./?action=display&task=$myrow[0]'>$myrow[1]</A>\n");
    }
    echo("<br><b>Total:</b> $trimmed_total% =&gt; limit = ".(100-$trimmed_total));
  }

  // BEGIN Bertelsen
  if($estimated) {
    $exploded_estimate=explode(":",$estimated);
    $est_count=sizeOf($exploded_estimate);
    $remaining=0;
    if ($est_count==1) {
      $remaining=intVal($estimated);
      $estimated.=":00:00";
    } elseif ($est_count==2) {  
      $remaining=intVal($exploded_estimate[0]);
      $remaining=$remaining + ($exploded_estimate[1])/60;  // will get rounded to nearest int
      $estimated.=":00";
    }
  } else {
    $remaining=0;
    $estimated = "00:00:00";
  }
  $task=OPT_get_ID("task");
  $sql="INSERT INTO task
        SET
          id=$task,
          TaskName='".OPT_gpc_slashes($TaskName)."',
          StartDatePlanned=unix_timestamp(\"$nice_sdate\"),
          EndDatePlanned=unix_timestamp(\"$nice_edate\"),
          catID='$catID',
          TaskDesc='".OPT_gpc_slashes($TaskDesc)."',
          DateSet=curdate(),
          ProjectID=$proj,
          parent=$parent,
          PercentOfParent=$PercentOfParent,
          estimated='$estimated'";
  $result=crm_run_query($sql);
  // END Bertelsen

  // Store a history of estimates for this task (including identity of estimator)
  $history_sql="insert into task_estimate_history (taskID, estimated, estimator) VALUES
                   ('$task', '$estimated', $CRM_user)";
  crm_run_query($history_sql);  //  Needed for graphing changes in estimate for a task

  // Store an entry in task progress history to give a started point (with no hours worked)
  if ($estimated && ($remaining > 0))
  {
        $progress_sql="insert into task_progress_history (taskID, progress, worked, remaining, person)
                       values ($task, 0, 0, $remaining, $CRM_user)";
        crm_run_query($progress_sql);  // Starting point for progress graphs
  }             

  // Propagating start/end dated upward in the tree
  $changes=propagate_task($task);

  if ($people && ($people[0]!="")) {
    while(list($key,$value)=each($people)) {
      $sql2 = "INSERT INTO person_task SET personID=$value,taskID=$task";
      $res=crm_run_query($sql2);

      // Generate a list of people to notify
      if (($value != $CRM_user) && (!@in_array($value,$dst)))
      {
         $dst[]=$value; 
      }
    }
  }

  if ($owner &&($owner!='')) {
    $sql2="DELETE FROM person_task WHERE personID=$owner AND taskID=$task";
    $res=crm_run_query($sql2);
    $sql2 = "INSERT  INTO person_task SET personID=$owner,taskID=$task,owner='Y'";
    $res=crm_run_query($sql2);
  }

  // Add any associated requests if needed
  if ($req)
  {
    $sql="replace into request2task values ($req,$task)";
    crm_run_query($sql);
  }

  // Notify all involved with this task of its creation
  $v[]="email";
  $v[]="sal";
  $v[]="fname";
  $v[]="lname";
  $s=getvalue("people",$v,$CRM_user);
  $p_n=getvalue("projects","name",$proj);

  for ($i=0;$i<sizeOf($dst);$i++) {
      OPT_locale($dst[$i]);
      $niceDeadline=niceDate("task","StartDatePlanned",$task,1);

      if ($niceDeadline) {
        $niceDeadline=sprintf(__("This task is due on %s."),$niceDeadline);
      } else {
        $niceDeadline=__("This task has no deadline.");
      }

      if ($owner) {
        $o[]="sal";
        $o[]="fname";
        $o[]="lname";
        $own=getvalue("people",$o,$owner);
        $own=sprintf(__("This task is currently owned by %s."),"$own[0] $own[1] $own[2]");
      } else {
        $own=__("This task currently has no owner.");
      }

      $d=getvalue("people",$v,$dst[$i]);
      $name="$d[1] $d[3]";
      OPT_notify($dst[$i],sprintf(__("New OPT task: %s"), "\"".stripslashes($TaskName)."\""),
        sprintf(__("Dear %s,\n".
        "%s created a new task in OPT ".
        "related to the %s project.  %s\n".
        "The task description follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n".
        "This task is accessible on the OPT server at this URL:\n"),$name,
        "$s[1] $s[2] $s[3]","\"$p_n\"","$own $niceDeadline",stripslashes($TaskDesc)).
        "http://$SERVER_NAME$CRM_URL?URL=".
        rawurlencode("tasks/task/?proj=$proj&task=$task&action=display"),
        __("You may post comments on this task by replying ".
        "to this e-mail. Please note only the message body will be ".
        "uploaded to OPT. You may also post comments by ".
        "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
        "please don't quote the original message since the quoted text ".
        "will also get unnecessarily posted on OPT.\n\nThank you!"),
        "OPT task #$task <$CRM_system_email>");
    }
    OPT_locale();
?>
