<?
#
# Task details routine
#
# Irina Nikitina <irina@lanifex.com>, November 2001
# Beautified Bogdan Stancescu <bogdan@lanifex.com>, December 2001
# Revision 1.0

  if ($action=="add_history_record" && crm_perm("task",$task, VIEW)) 
  {
     include "$CRM_path/tasks/task/add_history_record.inc";
  }

  if ($action=="add_now") {
    OPT_confirm(__("New task successfully added."));
  }
  if ($action=="mod_now") {
    OPT_confirm(__("Task successfully edited."));
  }
  if ($trimmed) {
    OPT_message(__("The percent of parent info has been trimmed."));
  }
  if ($changes) {
    OPT_message(sprintf(__("%d other parent task date(s) have been altered."),$changes));
  }
  $sql="select *, (TIME_TO_SEC(estimated)/3600*(100-PercentComplete)/100) hrs_remaining,
               (TIME_TO_SEC(estimated)/3600) max_hrs_remaining from task where id=$task";
  $res=crm_run_query($sql);
  make_vars($res);
  list($totalcount,$affectcount,$complete,$affect,$personal,$time,$total_estimated)=compute_progress($task);
  include "$CRM_path/tasks/calculate_status.inc";
  $icons = determineStatusIcons($StartDatePlanned, $EndDatePlanned, $complete, "../../");

  // Do we need to attach an existing request to this task
  if (intval($attach_existing_request) > 0)
  { 
      $request_to_attach = intval($attach_existing_request);
      $request_proj = getvalue("requests", "aproj", $request_to_attach);
      // Does request exist and is it in this project?
      if ($request_proj == $proj)
      {  
          $sql="replace into request2task values ($request_to_attach, $task)";
          CRM_run_query($sql);
          OPT_confirm("Successfully associated existing request #$request_to_attach with this task.");
      }
      else
      {
          OPT_confirm("Sorry, request #$request_to_attach does not exist or is in a different project.");
      }
  }

?>
<script language="javascript">
<!--
parent.leftFrame.location='../leftmenu/?task=<? echo $task; ?>&proj=<? echo $proj; ?>&parent=<? echo $parent ?>';

<? if (get_project_setting($proj, "task_status_hours_remaining") == "1")
{
?>
  function validate(str) {
    var myExp = /\d{1,}/;
    if (myExp.test(str)) {
      c=parseInt(str,10) ;
      if ((c<=<?echo($max_hrs_remaining);?>) && (c>=0)) {
        return true;
      } else {
        return window.confirm("You indicate the hours of effort remaining is more than the total estimated <?echo($max_hrs_remaining);?> hours for this task.  Are you sure you wish to increase the total estimated hours and set progress to 0%?");
      };
    } else {
      window.alert("The hours of effort remaining must be a valid number.");
      return false;
    };
  }

<?  // PM can chose a custom status to be the default on task completion
    $default_prompt_status = get_project_setting($proj, "prompt_set_request_status_on_task_complete");
    if ($default_prompt_status > 0)
    {
       $statii=get_project_setting($proj, "request_status_options");
       $extra_statuses=explode("|", $statii);
       switch ($default_prompt_status)
       {
          case 1: $status_name="Open"; break;
          case 2: $status_name="Resolved"; break;
          default: $status_name=$extra_statuses[$default_prompt_status-3];
       }
?>
       // This is called if the user just closed the last task on a request which they own, 
       // If they say yes, this will also mark the request as resolved (or other status chosen by PM).
       function promptToResolveRequest(request_id, request_name)
       {
           if (confirm("You've just completed the only task with time remaining on the original request:\n"+request_name+"\nWould you like to move this request to '<?echo($status_name)?>' status?"))
           {   // Jump to the request, setting its status to resolved.
              location.href="../../rt/req_view/?proj=<?echo($proj)?>&stat=<?echo($default_prompt_status)?>&req="+request_id;
           }
       }
<?
     }   // end of should prompt to change request status on resolve
}  // end of if task_status_hours_remaining
else
{
?>
  function validate(str) {
    var WarningMsg = "<? echo(__("The completion percent value range should be a decimal from 0 to 100")); ?>";
    var myExp = /\d{1,}/;
    if (myExp.test(str)) {
      c=parseInt(str,10) ;
      if ((c<=100) && (c>=0)) {
        return true;
      } else {
        window.alert(WarningMsg);
        return false;
      };
    } else {
      window.alert(WarningMsg);
      return false;
    };
  }
<?
}
?>

// -->
</script>
<?
  startTables();
?>
<tr>
  <td bgcolor="<? echo $OPT_col_dk ?>" class="ah4" colspan="3">
    <? echo(stripslashes($TaskName)); ?> [#<?echo($id)?>]
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><?echo(__("Status"));?></b>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" colspan="2" align="left">
    <? echo $icons; ?>
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right" width="40%">
    <b><? echo(__("Category")); ?></b>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      $sql="select * from project_categories where id=$CatID";
      $res1=crm_run_query($sql);
      make_vars($res1);
      echo $cat_name;
      if (!$cat_name) {
        echo(__("n/a"));
      }
    ?>
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Sub-task of")); ?></b>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      $parent=getvalue("task","parent",$task);
      if (!$parent) {
        echo(__("Project"));
      } else {
        echo("<a class=\"regular\" href=\"./?action=display&task=$parent\">".getvalue("task","TaskName",$parent)."</a>");
      }
    ?>
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Percent of parent")); ?></b>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <? echo abs($PercentOfParent) ?>%
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Description")); ?></b>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>"  align="left" colspan="2">
    <? echo(stripslashes($TaskDesc)); ?>&nbsp;
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Owner")); ?></b>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>"  align="left" colspan="2">
    <?
      $sql2 = "select
                people.fname,people.lname,people.id
              from
                people, person_task
              where
                people.id=person_task.personID and
                person_task.taskID=$task and
                person_task.owner='Y'";
      $result2 = crm_run_query($sql2);
      while ($myrow=OPT_fetch_array($result2)){
      $fname=$myrow[0];
      $lname=$myrow[1];
      echo "<a class='regular' href='../../people/admin/?action=display&id=$myrow[2]'>$fname $lname</a>";};
      if (!($fname || $lname)) {
        echo(__("n/a"));
        $no_owner_found=1;
      }
    ?>
  </td>
</tr>

<?  // People involved (only show if more than just owner)
      $sql2 = "select
                people.fname,people.lname,people.id
              from
                people, person_task
              where
                people.id=person_task.personID and
                person_task.taskID=$task
              order by fname";
      $result2 = crm_run_query($sql2);
if ((OPT_num_rows($result2) > 1) || ((OPT_num_rows($result2) == 1) && $no_owner_found))
{
?>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("People involved")); ?></b>
    <div class='small'><?echo(__("These are the team members who will be working on this task, including the task owner."));?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
<?
      while ($myrow=OPT_fetch_array($result2)){
      $fname=$myrow[0];
      $lname=$myrow[1];
      echo "<a class='regular' href='../../people/admin/?action=display&id=$myrow[2]'>$fname $lname</a><br>\n";};
      if (!($fname || $lname)) {
        echo(__("n/a"));
      }
    ?>
  </td>
</tr>
<?
        } // end if more than than just owner
?>




<?
  // List of associated requests
  if ($task)
  {
      $sql="select request2task.request, requests.title, requests.owner from request2task, requests 
           where request2task.request = requests.id and task = $task";
      $result=CRM_run_query($sql);
      $req_list="<ul style='margin:0;'>";
      while ($req_row=OPT_fetch_row($result))
      {
          $owner_name=getvalue("people", "CONCAT(fname, ' ', lname)", $req_row[2]);
          $req_list=$req_list."<li><a class='regular' title='Owned by $owner_name'
               href='../../rt/req_view/?proj=$proj&req=$req_row[0]'onclick=\"parent.topFrame.location='../../main_menu/?m1=Projects&m2=Requests&proj=$proj&noupd=1';\">".stripslashes($req_row[1])."</a></li>";
          if ((get_project_setting($proj, "allow_multiple_requests_per_task") == "0") && (1 == OPT_num_rows($result)))
          {
             $request_id = $req_row[0];    // used at end of file in Javascript
             $request_title = $req_row[1]; // used at end of file in Javascript
          }
      }
      $req_list.="</ul>";
  }

  // Allow them to attach another request
  if ((get_project_setting($proj, "allow_multiple_requests_per_task") == "1") && crm_project_participant($CRM_user, $proj, DEVELOPER))
  {
     $req_list= $req_list."<form style='margin:0;'><input type='button' value='New Request'
           onclick=\"parent.mainFrame.location='../../rt/req_create/?proj=$proj&task=$task';parent.topFrame.location='../../main_menu/?m1=Projects&m2=Requests&proj=$proj&noupd=1';\">";
     $req_list=$req_list." or an existing request #: <input type='text' name='attach_existing_request' size='4'/>
                  <input type='button' value='Attach' onclick=\"document.location='../../tasks/task/index.php?action=display&proj=$proj&task=$task&attach_existing_request='+form.attach_existing_request.value;\" /></form>";
  }

  if ($req_list)
  {
?>

<tr>
  <td class="regular" bgcolor="<? echo $OPT_col_md; ?>" align="right"><b><? echo(__("Associated Requests")); ?></b></td>
  <td class="regular" bgcolor="<? echo $OPT_col_lt; ?>" colspan="2" align='left'><? echo($req_list); ?></td>
</tr>

<?
} // end of if ($req_list)
?>

<?
///////////////////////
// BEGIN CHANGE Karsten Jennissen, display Documents
///////////////////////
?>
<tr>
  <td valign="top" bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Associated Documents")); ?></b><br />
    <? ?>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
  <?
    $sql3 = "SELECT id, title, path, ver FROM documents, document_associations as da 
             WHERE da.doc = id and att_to ='$task' and att_type = 'task' AND obsoletedby=0";
    $result3 = crm_run_query($sql3);
    if (OPT_num_rows($result3) > 0)
    {
        echo("<ul style='margin:0;'>");
    }    
    while ($resrow=OPT_fetch_array($result3)) {
      echo "<li><a class='regular' href='../../documents/Doc_View/?proj=$proj&doc=$resrow[0]&dir=$resrow[2]'>$resrow[1]</a> (Ver. $resrow[3])</li>\n";
    }
    if (OPT_num_rows($result3) > 0)
    {
        echo("</ul>");
    }
    if (crm_perm("task", $task, EDIT))
    {  // Anyone who can EDIT this task can attach a document to it.
        echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i>(<a class='regular' href='../../documents/Doc_Add/?proj=$proj&task=$task'>attach new</a>)</i>"; 
    }    
  ?>
  </td>
</tr>
<?
///////////////////////
// END CHANGE Karsten Jennissen, display Documents
///////////////////////
?>

<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Start date")); ?></b>
    <div class="small"><? echo(__("Planned/estimated/desired")); ?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      if ($StartDatePlanned!=0) {
        echo niceDate("task","from_unixtime(StartDatePlanned)",$task,1);
      } else {
        echo(__("n/a"));
      }
    ?>
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("End date")); ?></b>
    <div class="small">Planned/estimated/desired</div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      if ($EndDatePlanned!=0) {
        echo(niceDate("task","from_unixtime(EndDatePlanned)",$task,1));
      } else {
        echo(__("n/a"));
      }
    ?>
  </td>
</tr>
<?
// BEGIN CHANGE Bertelsen, estimated time tasks
?>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <strong>Estimated time</strong>
    <div class="small">Estimated hours to finish this task:</div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
    $sql="select sec_to_time($total_estimated-time_to_sec('$estimated')), sec_to_time($total_estimated)";
    $result=CRM_run_query($sql);
    $myrow=OPT_fetch_row($result);
    $sub_estimated = $myrow[0];
    $total_estimated = $myrow[1];
    if ($estimated) {
      echo(substr($estimated,0,strlen($estimated)-3));
    } else {
      echo("00:00");
    }
    ?>
  </td>
</tr>

<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <strong>Total estimated time</strong>
    <div class="small">Estimated hours to finish this task and subtasks:</div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
    if ($total_estimated) {
      echo(substr($total_estimated,0,strlen($total_estimated)-3));
    } else {
      echo("00:00");
    }
    ?>
  </td>
</tr>
<?
// END CHANGE Bertelsen, estimated time tasks
?>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Time worked")); ?></b>
    <div class="small"><? echo(__("The sum of all hours submitted below for this task")); ?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      $sql="select sec_to_time(sum(time_to_sec(worked))) from task_progress_history where taskID=$task";
      $result=CRM_run_query($sql);
      $myrow=OPT_fetch_row($result);
      if ($myrow[0]) {
        echo(substr($myrow[0],0,strlen($myrow[0])-3));
      } else {
        echo("00:00");
      }
    ?>
  </td>
</tr>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Total time worked")); ?></b>
    <div class="small"><? echo(__("The sum of all durations submitted below for this task and subtasks")); ?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      $sql="select sec_to_time($time)";
      $result=CRM_run_query($sql);
      $myrow=OPT_fetch_row($result);
      if ($myrow[0]) {
        echo(substr($myrow[0],0,strlen($myrow[0])-3));
      } else {
        echo("00:00");
      }
    ?>
  </td>
</tr>
<?
  if ($personal!=100) {
?>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Progress")); ?></b>
    <div class="small"><? echo(__("The real progress of this task")); ?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      $complete=abs($complete);
      $affectcount=abs($affectcount);
      $totalcount=abs($totalcount)-1;
      $affectpercent=100-$personal;
      echo("$complete% <div class=\"small\">[<a class=\"small\" href=\"../?proj=$proj&parent=$task\">".
        sprintf(__("Affected %d%% by %d subtask(s)"),
        $affectpercent,$affectcount)."</a>]</div>");
    ?>
  </td>
</tr>
<?
  }
  if ($StartDate!=0) {
?>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Started")); ?></b>
    <div class="small"><? echo(__("When the first progress change occured")); ?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      echo niceDate("task","from_unixtime(StartDate)",$task,1);
    ?>
  </td>
</tr>
<?
  }

  if ($EndDate!=0) {
?>
<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Complete")); ?></b>
    <div class="small"><? echo(__("When the progress was set to 100%")); ?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left" colspan="2">
    <?
      echo niceDate("task","from_unixtime(EndDate)",$task,1);
    ?>
  </td>
</tr>
<?
  }
  if ($personal) {
    if($task) {
      $sql="select personid from person_task where taskid=$task  and personid=$CRM_user";
      $is_involved=OPT_num_rows(crm_run_query($sql));
    }
    // Only people listed as involved with this task can record progress against it
    if ($is_involved)
    {
?>
<form onSubmit="return validate(document.status_update.complete.value);" name="status_update" method="post" action="<? echo "./?proj=$proj&task=$task"; ?>">
<input type="hidden" name="action" value="mod_status">


     <? // Project manager can require users task status updates to be in hours completed and hour remaining
     if (get_project_setting($proj, "task_status_hours_remaining") == "1")
     {
         if (($hrs_remaining < 1) && ($hrs_remaining > 0))
         {
             $value=sprintf("%.2f", $hrs_remaining);  // Give a decimal point 
         }        
         else
         {
             $value=sprintf("%d", $hrs_remaining);  // Round to nearest hour
         }
         $units="hrs ([h] format only)";
         $title="Hours remaining";
         $hint="This is the estimated effort remaining for this task in hours.";
     }
     else  // Default is to let them enter percent complete instead of hours remaining
     {
         $value=$PercentComplete;
         $units="% complete";
         $title="Status";
         $hint="This is the current status - you may type in a new value and click \"Change\" in order to update.";
     }
    ?>

<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__($title)); ?></b>
    <div class="small"><? echo(__($hint)); ?></div>
  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left">
    <table border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td>
        <input type="text" size="7" name="complete" value="<? echo $value; ?>">
      </td>
      <td class="small">
        &nbsp;<? echo(__($units)); ?>
      </td>
    </tr>
    </table>
  </td>
  <td align="center" rowspan="2" bgcolor="<? echo $OPT_col_lt ?>">
    &nbsp;<input type="submit" name="modify" value="Change">&nbsp;
  </td>
</tr>

<tr>
  <td bgcolor="<? echo $OPT_col_md ?>" align="right">
    <b><? echo(__("Time just worked")); ?></b>
    <div class="small"><? echo(__("This is for the actual time you just worked on this task.<br />  This time will appear on your timesheets for today.")); ?></div>

  </td>
  <td bgcolor="<? echo $OPT_col_lt ?>" align="left">
    <table border="0" cellspacing="0" cellpadding="0">
    <tr>
      <td>
        <input type="text" size="7" maxsize="6" name="worked">
      </td>
      <td class="small">
        &nbsp;<? echo(__("[h] or [h:m] format")); ?>
      </td>
    </tr>
    </table>
  </td>
</tr>
</form>
<?
    }
  }
?>


<?
  endTables();
?>


<?  // If there was only one associated request and its task completed, prompt to auto-resolve
    // If task was just completed, mod_status.inc set task_just_completed
if (get_project_setting($proj, "allow_multiple_requests_per_task") != "1")
{
  if ($task_just_completed && ($CRM_user == getvalue("requests", "owner", $request_id)))
  {
      $sql="select id from task left join request2task on task.id = request2task.task 
      where request2task.request=$request_id and task.PercentComplete < 100";
      $unfin_result=CRM_run_query($sql);
      if (OPT_num_rows($unfin_result) == 1)
      {
         $unfin_row=OPT_fetch_row($unfin_result);
         if ($unfin_row[0] == $task)
         {  // Only one task not yet complete, MySQL hasn't caught up yet.
            $show_prompt=1;
         } 
      }
      else if (OPT_num_rows($unfin_result) == 0)
      {
          $show_prompt=1;
      }
  }
  if ($show_prompt)
  {
    ?>
      <script language="javascript">
      <!--
      promptToResolveRequest(<?echo($request_id)?>, "<?echo(addslashes($request_title))?>");
       -->
      </script>
    <?
  }  // end of if prompt for request close
}
?>
