<?php
//  Shows all the changes to the estimated hours for this task
//  When they happened and who changed them
include ("../../include/OPT_lib.php");
auth_open();
include ("$CRM_inc/jpgraph/jpgraph.php");
include ("$CRM_inc/jpgraph/jpgraph_bar.php");

$est_sql="select date, TIME_TO_SEC(estimated)/3600, fname, lname, task_estimate_history.id
          from task_estimate_history, people where estimator = people.id and taskID = $task";

$est_result=crm_run_query($est_sql);

$changes=OPT_num_rows($est_result);
while ($est_row = OPT_fetch_row($est_result))
{
    $datay[] =$est_row[1];
    $xval = $est_row[2] . " " . $est_row[3] . "\n(" . niceDate("task_estimate_history", "date", $est_row[4],0) .")"; 
    $datax[] = $xval;
}

// Setup the graph. 
$height=250;
$width=700;
$graph = new Graph($width,$height,"auto");	
$graph->img->SetMargin(60,20,20,40);
$graph->SetScale("textlin");
$graph->SetMarginColor("silver");
$graph->SetShadow();

// Setup font for axis
$graph->xaxis->SetFont(FF_VERDANA,FS_NORMAL,8);
$graph->yaxis->SetFont(FF_VERDANA,FS_NORMAL,8);

// Show 0 label on Y-axis (default is not to show)
$graph->yscale->ticks->SupressZeroLabel(false);

// Setup X-axis labels
$graph->xaxis->SetTickLabels($datax);

// Setup Y axis title
$graph->yaxis->title->Set("Estimated Effort (Hours)");

// Create the bar plot
$bplot = new BarPlot($datay);
$bplot->SetWidth(0.6);
$bplot->value->show();

// Setup color for gradient fill style 
$bplot->SetFillGradient("royalblue4","lightsteelblue",GRAD_MIDVER);

// Set color for the frame of each bar
$bplot->SetColor("navy");
$graph->Add($bplot);

// Finally send the graph to the browser
$graph->Stroke();

auth_close();
?>