<?
#
# Task editing routine
#
# Irina Nikitina <irina@lanifex.com>, November 2001
# Revision 1.0
  if ((!$TaskName) || ($TaskName=='')) {
    $TaskName=__("Name not set");
  }
  if (($smonth!='')&&($sday!='')&&($syear!='')) {
    $sdate=mktime (0, 0, 0, $smonth, $sday, $syear );
  } else {
    $sdate=0;
  }
  if (($emonth!='')&&($eday!='')&&($eyear!='')) {
    $edate=mktime (0, 0, 0, $emonth, $eday, $eyear );
  } else {
    $edate=0;
  }
  $task=abs($task);
  $parent=abs($parent);

  $PercentOfParent=abs($PercentOfParent);
  $sql="select sum(PercentOfParent) from task where parent=$parent and active=1 and id!=$task and ProjectID=$proj";
  $result=crm_run_query($sql);
  $myrow=OPT_fetch_row($result);

  if ($myrow[0]+$PercentOfParent>100) {
    $PercentOfParent=100-$myrow[0];
    $trimmed=true;
  }

  if ($trimmed && $debug_trimming) {
    $trimmed_total=$myrow[0];
    echo("<b>Trimmed due to the following tasks:</b>\n");
    $sql="select id, TaskName, PercentOfParent from task where parent=$parent and active=1 and id!=$task and ProjectID=$proj";
    $result=OPT_run_query($sql);
    while ($myrow=OPT_fetch_row($result)) {
      if ($myrow[2])
        echo("<BR />$myrow[2]% - <A HREF='./?action=display&task=$myrow[0]'>$myrow[1]</A>\n");
    }
    echo("<br><b>Total:</b> $trimmed_total% =&gt; limit = ".(100-$trimmed_total));
  }

  $cur_estimate=getvalue("task", "estimated", $task);
  if($estimated) {
    $est_count=sizeOf(explode(":",$estimated));
    if ($est_count==1) {
      $estimated.=":00:00";
    } elseif ($est_count==2) {
      $estimated.=":00";
    }
  } else {
    $estimated = "00:00:00";
  }

  // Determine what if anything changed on this task
  $prev_task_name = getvalue("task", "TaskName", $task);
  if ($TaskName != $prev_task_name)
  {
     $changed_desc .= "Task title changed from '$prev_task_name' to '$TaskName'.\n";
  }
  $prev_start_date = getvalue("task", "DATE_FORMAT(FROM_UNIXTIME(StartDatePlanned),'%Y-%m-%d')", $task);
  if (strtotime($prev_start_date) != strtotime($nice_sdate))
  {
     if ($prev_start_date == "0000-00-00")
     {
        $prev_start_date='n/a';
     }
     $start_date_str=$nice_sdate;
     if ($nice_sdate == "00000000000000")
     {
        $start_date_str='n/a';
     }
     if ($prev_start_date != $start_date_str)
     {
        $changed_desc .= "Planned start date changed from ".substr($prev_start_date,0,10)." to ".substr($start_date_str,0,10)."\n";
     }       
  }
  $prev_end_date = getvalue("task", "DATE_FORMAT(FROM_UNIXTIME(EndDatePlanned),'%Y-%m-%d')", $task);
  if (strtotime($prev_end_date) != strtotime($nice_edate))
  {
     if ($prev_end_date == "0000-00-00")
     {
        $prev_end_date='n/a';
     }
     $end_date_str=$nice_edate;
     if ($nice_sdate == "00000000000000")
     {
        $end_date_str='n/a';
     }
     if ($prev_end_date != $end_date_str)
     {
        $changed_desc .= "Planned end date changed from ".substr($prev_end_date,0,10)." to ".substr($end_date_str,0,10)."\n";
     }       
  }
  $catID = abs($catID);
  $prev_category=getvalue("task", "CatID", $task);
  if ($prev_category != $catID)
  {
     $prev_cat_name = getvalue("project_categories", "cat_name", $prev_category, "n/a");
     $new_cat_name = getvalue("project_categories", "cat_name", $catID, "n/a");
     $changed_desc=$changed_desc."Cateogry changed from $prev_cat_name to $new_cat_name\n";
  }

  $prev_estimated=getvalue("task", "estimated", $task);
  if ($prev_estimated != stripslashes($estimated))
  {
     $changed_desc=$changed_desc."Estimated effort changed from $prev_estimated to $estimated\n";
  }
  
  $prev_desc=getvalue("task", "TaskDesc", $task);
  if ($prev_desc != stripslashes($TaskDesc))
  {
     $changed_desc=$changed_desc."Description was changed.\n";
  }


  // Now actually update the task
  $sql="UPDATE task
        SET
          TaskName='".OPT_gpc_slashes($TaskName)."',
          StartDatePlanned=unix_timestamp(\"$nice_sdate\"),
          EndDatePlanned=unix_timestamp(\"$nice_edate\"),
          catID='$catID',
          TaskDesc='".OPT_gpc_slashes($TaskDesc)."',
          ProjectID=$proj,
          parent=$parent,
          PercentOfParent=$PercentOfParent,
          estimated='$estimated',
          date=date
        WHERE
          id=$task";
  $result=crm_run_query($sql);

  // Now log the change, if anything to log
  if ($changed_desc)
  {
     $log_query = "insert into log (obj_type, obj_id, edited_by, entry) values ('task', $task, $CRM_user, '" 
                      . addslashes("Task details edited...\n" . $changed_desc). "')";
     CRM_run_query($log_query);
  }

  // Store a history of estimates for this task (including identity of estimator)
  if ($cur_estimate != $estimated)
  {
    $history_sql="insert into task_estimate_history (taskID, estimated, estimator) VALUES
                   ('$task', '$estimated', $CRM_user)";
    crm_run_query($history_sql);  //  Needed for graphing changes in estimate for a task
    
    // Also need to store a task_progress_history entry now that the estimate has changed
    $percent_complete=getvalue("task", "PercentComplete", $task);
    $progress_sql="insert into task_progress_history set progress='$percent_complete', taskID='$task', 
          worked='0', remaining=TIME_TO_SEC('$estimated')*(100-$percent_complete)/3600/100, person=$CRM_user";
    crm_run_query($progress_sql);   
  }

  // Propagating start/end times upward in the tree
  $changes=propagate_task($task);

  // Before we assign new people to the task we need to remove all the old records
  $sql2="DELETE FROM person_task WHERE taskID=$task";
  $res=crm_run_query($sql2);

  if ($people && ($people[0]!="")) {
    while(list($key,$value)=each($people)) {
      $sql2 = "INSERT INTO person_task SET personID=$value,taskID=$task";
      $res=crm_run_query($sql2);

       // Generate a list of people to notify
      if (($value != $CRM_user) && (!@in_array($value,$dst)))
      {
         $dst[]=$value; 
      }
    }
  }

  if ($owner && ($owner!='')) {
    $sql2="DELETE FROM person_task WHERE personID=$owner AND taskID=$task";
    $res=crm_run_query($sql2);
    $sql2 = "INSERT  INTO person_task SET personID=$owner,taskID=$task,owner='Y'";
    $res=crm_run_query($sql2);
  }

  // Notify all involved with this task of the changes
  $v[]="email";
  $v[]="sal";
  $v[]="fname";
  $v[]="lname";
  $s=getvalue("people",$v,$CRM_user);
  $p_n=getvalue("projects","name",$proj);

  for ($i=0;$i<sizeOf($dst);$i++) {
      OPT_locale($dst[$i]);
      $niceDeadline=niceDate("task","StartDatePlanned",$task,1);

      if ($niceDeadline) {
        $niceDeadline=sprintf(__("This task is due on %s."),$niceDeadline);
      } else {
        $niceDeadline=__("This task has no deadline.");
      }

      if ($owner) {
        $o[]="sal";
        $o[]="fname";
        $o[]="lname";
        $own=getvalue("people",$o,$owner);
        $own=sprintf(__("This task is currently owned by %s."),"$own[0] $own[1] $own[2]");
      } else {
        $own=__("This task currently has no owner.");
      }

      $d=getvalue("people",$v,$dst[$i]);
      $name="$d[1] $d[3]";
      OPT_notify($dst[$i],sprintf(__("Updated OPT task: %s"), "\"".stripslashes($TaskName)."\""),
        sprintf(__("Dear %s,\n".
        "%s updated a task in OPT ".
        "related to the %s project. %s\n".
        "The task description follows:\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "------------------------------------------------------------------------\n".
        "%s\n".
        "This task is accessible on the OPT server at this URL:\n"),$name,
        "$s[1] $s[2] $s[3]","\"$p_n\"","$own $niceDeadline",stripslashes($TaskDesc),$changed_text).
        "http://$SERVER_NAME$CRM_URL?URL=".
        rawurlencode("tasks/task/?proj=$proj&task=$task&action=display"),
        __("You may post comments on this task by replying ".
        "to this e-mail. Please note only the message body will be ".
        "uploaded to OPT. You may also post comments by ".
        "visiting the OPT site.\n\nIMPORTANT!\nIn case you reply to this e-mail, ".
        "please don't quote the original message since the quoted text ".
        "will also get unnecessarily posted on OPT.\n\nThank you!"),
        "OPT task #$task <$CRM_system_email>");
    }
    OPT_locale()

?>
