<?
#
# Task status change routine
#
# Irina Nikitina <irina@lanifex.com>, November 2001
# Bogdan Stancescu <bogdan@lanifex.com>, December 2001
# Revision 1.1
  $sql="SELECT PercentComplete, StartDate, TIME_TO_SEC(estimated) estimated_secs FROM task WHERE id=$task";
  $result=crm_run_query($sql);
  make_vars($result);

  // Handle case where "complete" was hours remaining to be worked; convert to PercentComplete
  if (get_project_setting($proj, "task_status_hours_remaining"))
  {
        $hrs_remaining = myfloatval($complete);  // store the value they provided
        if ($estimated_secs != 0)
        {       
           $complete = intVal(100 - ($complete*3600*100/$estimated_secs));
        }
        else
        {
           $complete = 100;  // We're now complete if no hours remaining
        }       

        if ($complete > 100)
        {
           $complete = 100;
        }
        else if ($complete < 0)
        {  // User increased the hours remaining past total estimated for this task!
           $complete = 0; // Reset to no progress
           $sql = "update task set estimated = SEC_TO_TIME($hrs_remaining*3600) where id=$task";
           crm_run_query($sql);  // Increase the estimate to match hours remaining 

           // Now we must record the change in total estimate for hours
           $sql="insert into task_estimate_history (taskID, estimated, estimator) VALUES
                 ('$task', SEC_TO_TIME($hrs_remaining*3600), $CRM_user)";
           crm_run_query($sql);  //  Needed for graphing changes in estimate for a task
	   
	   // Also need to store a task_progress_history entry now that the estimate has changed
	   $percent_complete=getvalue("task", "PercentComplete", $task);
	   $progress_sql="insert into task_progress_history set progress='$complete', taskID='$task',
             worked='0', remaining=$hrs_remaining*(100-$complete)/100, person=$CRM_user";
	   crm_run_query($progress_sql);
        }
  } 
  else
  {
        $hrs_remaining = (100-$complete) * $estimated_secs / 3600 / 100;
  }

  // Now that we've got the true completion percentage
  if ($complete!=0) {
    if ($StartDate == 0) {
      $sd=time();
    } else {
      $sd=$StartDate;
    }
  } else {
    $sd=0;
  }
  if ($complete==100) {
    $ed=time();
    $task_just_completed = 1;  // flag to possibly trigger a dialog asking if request should be resolved. (display.inc)
  } else {
    $ed=0;
  }
  
  $sql="UPDATE task SET PercentComplete='$complete',StartDate=$sd, EndDate=$ed, 
        StatusUpdated=".time().", date=date WHERE id=$task";
  $result=OPT_run_query($sql);
  $changes=propagate_task($task);

  $sql="select progress from task_progress_history where taskID='$task' order by date desc limit 1";
  list($oldprog)=OPT_fetch_row(crm_run_query($sql));
  if (($complete!=$oldprog) || ($worked)) {
    $work_count=sizeOf(explode(":",$worked));
    if ($work_count==1) {
      $worked.=":00:00";
    } elseif ($work_count==2) {
      $worked.=":00";
    }
    $sql="insert into task_progress_history set progress='$complete', taskID='$task', 
          worked='$worked', remaining='$hrs_remaining', person=$CRM_user";
    crm_run_query($sql);
  }
?>
