<?
#
# Task search results page
#
  include "../../include/OPT_lib.php";
  auth_open();
  include "$CRM_path/tasks/task/task_lib.php";
  include "$CRM_path/tasks/calculate_status.inc";
  include "$CRM_inc/email.php";
  checkMail();
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE><? echo(__("Task Search Results")); ?></TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  mainBody("../../images");
  make_main_title(__("Task Search Results"),"../../images");
  if (! $proj) {
    OPT_error(__("Please select a project first"));
    exit;
  }
  if (! crm_perm("projects",$proj)) {
    OPT_error(__("Classified"));
    exit;
  }

  // Get project settings once
  $show_hours_column=get_project_setting($proj, "task_status_hours_remaining");
  $ispm = is_project_manager($proj);

  // Get the additional status values this PM has set.
  $statii=get_project_setting($proj, "request_status_options");
  $extra_statuses=explode("|", $statii);

  // Store names for people in memory to avoid hitting the database over and over
  $people_result=get_people_involved_with_project($proj);
  while ($people_row=OPT_fetch_array($people_result)) 
  {
      $people[] = array($people_row["id"], ($people_row["fname"] . ' ' . $people_row["lname"]));
  }

  // Store this list of priorities 
  $priorities = get_project_setting($proj, "request_priority");
  if (!$priorities) {
      $priorities=array();
  }
  $priorities = explode("|",$priorities);

  // Store this list of categories
  $cat_result=crm_run_query("select id, cat_name from project_categories where project = $proj");
  while ($cat_row=OPT_fetch_row($cat_result))
  {
      $categories[$cat_row[0]] = $cat_row[1];
  }
  $categories[0] = 'n/a';  // Use n/a if request is uncategorized

  // How many columns do we have
  if ($show_req_ids == "1")  // Optionally display request ID numbers
  {
      $table_cols=9;
  }
  else
  {
      $table_cols=8;
  }

  // Extra column for hours if they are important on this project
  if ($show_hours_column == "1")
  {
      $table_cols+=1;
  }
   


// Save the query they just made for when they search this project next
include "$CRM_path/tasks/task_search/save_query_values.inc";

// If this was a "Quick Search" then generate the SQL filter statement ($filter)
if ($quick_search)
{
    include "$CRM_path/tasks/task_search/quick_search_filter.inc";
    $filter = get_quick_search_filter($quick_search_type, trim($quick_search_title));
} 
else if ($full_search)
{
    include "$CRM_path/tasks/task_search/full_search_filter.inc";
}
else if ($saved_search)
{   
    if (!abs($saved_search_id))
    {
        OPT_error("Sorry.  You must specify a valid saved search to run...");
        exit(); 
    }   
 
    // Wants to run a saved search right away so go get field variables
    $sql="select name, value from search_fields where search = $saved_search_id";
    $result = CRM_run_query($sql);
    while ($row = OPT_fetch_row($result))
    {   
        if (($row[0] == "selected_statuses") || ($row[0] == "selected_categories"))
        {   // This is an array that needs to be expanded
            $$row[0] = explode(",", $row[1]);
        }
        else
        {   // singular variable
            $$row[0] = $row[1];  // setting variable of name equal to value
        }
    }
    include "$CRM_path/tasks/task_search/full_search_filter.inc";  // Now run the full search...
}
else
{
    OPT_error("Bad search request.  Please try again.  Contact OPT Administrator if this repeats.");
}

if (!$filter)
{
  OPT_error("Please specify some criteria for your search.");
  exit();
}
        
  // Go get all the requests to display
  $cat_order=OPT_parse_order_string($order);
  $orderby=OPT_build_order_query($cat_order);
  $result=crm_elements("task","$filter $orderby");

//echo("Filter: $filter<br />");
  startTables(); // start of request listing
?>

<?
// We need to build up a query string of all search parameters
// so that when a column ordering is clicked that list stays the
// same.
if ($full_search || $saved_search)
{  
   include "$CRM_path/tasks/task_search/results_query_string.inc";
}
else if ($quick_search)
{
   $colQS = "quick_search=Search";
   $colQS .= "&quick_search_title=" . urlencode($quick_search_title);
   $colQS .= "&quick_search_type=" . $quick_search_type;
}

?>

<tr>
  <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>">&nbsp;</td>
<?
echo(OPT_header_cell("id",$cat_order,__("ID"),"proj=$proj&$colQS"));
echo(OPT_header_cell("TaskName",$cat_order,__("Task"),"proj=$proj&$colQS"));
?>
  <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Owner</b></td>
  <td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Status</b></td>
<?
echo(OPT_header_cell("PercentComplete",$cat_order,__("Complete"),"proj=$proj&$colQS"));
if ($show_hours_column == "1")
{ 
?>
<td class="regular" align="center" bgcolor="<? echo $OPT_col_dk; ?>"><b>Hrs Left</b></td>
<?
}
?>
</tr>
<?
  $col="'$OPT_col_md'";
  if (OPT_num_rows($result) == 0)
  {
 ?>
<tr><td colspan="<?echo($table_cols);?>" class="regular" align="center" bgcolor="<? echo $OPT_col_md; ?>" valign="middle">
<i>No requests found matching your criteria.</i>
</td></tr>
<?
  }

// The display loop
while ($myrow=OPT_fetch_array($result)) {
    echo("<tr>");
    if ($col=="$OPT_col_md") {
      $col="$OPT_col_lt";
    } else {
      $col="$OPT_col_md";
    }

    // New task?
    if ($CRM_guest)
    {
        $newicon="&nbsp;&nbsp;";
    }
    else
    {
        $sql="select
              task.id
            from
              task, people
            where
              task.date>people.prevlog and
              people.id=$CRM_user and
              task.id=". $myrow["id"];
        $result2=crm_run_query($sql);
        $newicon="&nbsp;&nbsp;";
        if (OPT_num_rows($result2))
        {
            $newicon="<img src=\"../../images/$OPT_icon_new\" alt=\"New Task!\">";
        }
    }
    echo("<td class='regular' bgcolor='$col' align='center'>$newicon</td>");
   
    // Task ID
    echo("<td class='regular' bgcolor='$col' align='center'><a href='../task/?proj=$proj&task=".$myrow["id"]."&action=display'>".
         $myrow["id"]."</a></td>");

    // Taskname
    echo("<td class='regular' bgcolor='$col' align='left'><a href='../task/?proj=$proj&task=".$myrow["id"]."&action=display'>".
         $myrow["TaskName"]."</a></td>");

    // Owner
    echo("<td class='regular' bgcolor='$col' align='center'>");
    $owner=false;
    $sql2 = "select
              people.fname, people.lname, people.id
            from
              people, person_task
            where
              people.id=person_task.personID and
              person_task.taskID=".$myrow["id"]." and
              person_task.owner='Y'";
    $result2 = crm_run_query($sql2);
    $first_person=1;
    while ($myrow2=OPT_fetch_array($result2))
    {
      $fname=$myrow2[0];
      $lname=$myrow2[1];
      if ($first_person != 1) { echo ("<br />"); } else { $first_person=0; }
      echo "<a class='regular' href='../../people/admin/?action=display&id=$myrow2[2]'>$fname $lname</a>";
      $owner=true;
    }
    if (!$owner)
    {
      echo("&nbsp;");
    }
    echo("</td>");


    // Status
    echo("<td class='regular' bgcolor='$col' align='center'>");
    list($totalcount,$affectcount,$complete,$affect,$personal, $T_time, $T_estimated)=compute_progress($myrow["id"]);
    $icons = determineStatusIcons($StartDatePlanned, $EndDatePlanned, $complete, "../../");
    if ($icons)
    {
      echo $icons;
    }
    else
    {
      echo("&nbsp;");
    }
    echo("</td>");

    // Complete
    echo("<td class='regular' bgcolor='$col' align='center'>");
    $PercentComplete=$myrow["PercentComplete"];
    $PercentComplete.="%";
    echo("$PercentComplete</td>");

    // Hours remaining
    if ($show_hours_column == "1")
    { 
        $hrs_remaining = sprintf("%.0f", ((100-$complete)/100 * $T_estimated/3600));
        $total_hours+=$hrs_remaining;
        echo("<td class='regular' bgcolor='$col' align='center'>$hrs_remaining</td>");
    }
    echo("</tr>");
}
?>

<?
  endTables();
  auth_close();
?>
</BODY>
</HTML>
