<?
#
# Main tasks page
#
# Displays the list of tasks related to a project
#
# Irina Nikitina <irina@lanifex.com>, November 2001
# Beautified Bogdan Stancescu <bogdan@lanifex.com>, December 2001
# Revision 1.01
  include "../include/OPT_lib.php";
  auth_open();
  include "$CRM_path/tasks/task/task_lib.php";
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN" "http://www.w3.org/TR/REC-html40/loose.dtd">
<HTML>
<HEAD>
<TITLE>Task Tree</TITLE>
<LINK REL=STYLESHEET TYPE="text/css" HREF="../include/opt_css.php">
<? echo $_OPT["head_xtra"]; ?>
</HEAD>
<?
  if (!crm_perm("projects",$proj))
  {
    echo("Page not found");
    auth_close();
    exit;
  }
  mainBody("../images");
  make_main_title("Task Tree","../images");

  list($count)=OPT_fetch_row(crm_run_query("select count(*) from task where active=1 and parent=0 and projectID=$proj"));
  if (!$count)
  {
    echo("<br><div class=\"regular\" align=\"center\"><i>No tasks set for this project</i></div>");
    echo("</body></html>");
    auth_close();
    exit;
  }
  startTables();
  if ($parent)
  {
    echo("<tr><td class=\"regular\" bgcolor=\"$OPT_col_md\" align=\"center\" colspan=\"10\">\n");
    echo("<b><a class=\"regular\" href=\"./?proj=$proj&parent=".getvalue("task","parent",$parent)."\">[Up one level]</a></b>");
    echo("</td><tr>\n");
  }

  $maxLev=0;

  function renderLevel($level=0,$parent=0)
  {
    global $maxLev, $proj, $OPT_col_lt, $OPT_col_md, $OPT_col_dimmed, $OPT_col_dk,
           $strings, $levels, $percents, $locals, $OPT_col_dk_dk, $OPT_col_bg;

    if ($level%2)
    {
      $col=$OPT_col_bg;
    }
    else
    {
      $col=$OPT_col_dk;
    }
    $sql="select id, TaskName, CatID, PercentComplete
          from task
          where
            ProjectID=$proj and
            active='1' and
            parent=$parent
          order by CatID, date DESC";
    $cat="0";
    $result=crm_run_query($sql);
    while (list($id,$TaskName,$CatID,$PercentComplete)=OPT_fetch_row($result))
    {
      if (!$AlreadySet)
      {
        if ($level>$maxLev)
        {
          $maxLev=$level;
        }
        $AlreadySet=true;
      }

      list($totalcount,$affectcount,$complete,$affect,$personal)=compute_progress($id);
      $affected=(100-$personal)."%";

      $sql="select count(*) from task where parent=$id and active=1";
      $result2=CRM_run_query($sql);
      $myrow=OPT_fetch_row($result2);
      if ($myrow[0])
      {
        $sub="<a class=\"regular\" href=\"./?proj=$proj&parent=$id\">[+$myrow[0]]</a>\n";
      }
      else
      {
        $sub="[+0]";
      }
      $tmp_str="</td><td class='small' bgcolor='$col' align='right'>";
      $inf=abs(getvalue("task","PercentOfParent",$id));
      $inf.="%";
      $tmp_str.="<font color=\"$OPT_col_dimmed\">$inf</font>\n";
      $tmp_str.="\n</td><td class='small' bgcolor='$OPT_col_md' align='right'>\n";
      $tmp_str.="<font color=\"$OPT_col_dimmed\">$affected</font>";
      $tmp_str.="</td><td class='regular' bgcolor='$OPT_col_md' colspan='3' >\n";
      $tmp_str.="$sub\n";
      $tmp_str.="<a class='regular' href='./task/?proj=$proj&task=$id&action=display'>$TaskName</a>\n";

      $tmp_str.="</td><td class='regular' bgcolor='$OPT_col_md' colspan='2' >\n";
      $owner=false;
      $sql2 = "select
                people.fname, people.lname, people.id
              from
                people, person_task
              where
                people.id=person_task.personID and
                person_task.taskID=$id and
                person_task.owner='Y'";
      $result2 = crm_run_query($sql2);
      while ($myrow=OPT_fetch_array($result2))
      {
        $fname=$myrow[0];
        $lname=$myrow[1];
        $tmp_str.="<a class='regular' href='../people/admin/?action=display&id=$myrow[2]'>$fname $lname</a>";
        $owner=true;
      }
      if (!$owner)
      {
        $tmp_str.="&nbsp;";
      }

      $tmp_str.="</td>";

      $levels[]=$level;
      $strings[]=$tmp_str;
      $percents[]=abs($complete);
      $locals[]=abs($PercentComplete)."%";

      renderLevel($level+1,$id);
    }
  }

  function renderBar($level)
  {
    global $maxLev, $OPT_col_lt, $OPT_col_dk_dk, $OPT_col_bg, $OPT_col_dk, $pf;

    if ($pf)
    {
      return(true);
    }
    if ($level%2)
    {
      $col=$OPT_col_bg;
    }
    else
    {
      $col=$OPT_col_dk;
    }

    echo("<tr><td colspan=\"2\" bgcolor=\"$OPT_col_lt\">\n");
    echo("<img src=\"../images/spacer.gif\">\n");
    echo("</td>\n");

    for($j=2;$j<=$level+2;$j++) // >
    {
      if ($j%2)
      {
        $col=$OPT_col_bg;
      }
      else
      {
        $col=$OPT_col_dk;
      }

      echo("<td bgcolor=\"$col\"><img src=\"../images/spacer.gif\"></td>\n");
    }
    echo("<td colspan=\"".($maxLev-$level+8)."\" bgcolor=\"$col\">\n");
    echo("<img src=\"../images/spacer.gif\">\n");
    echo("</td></tr>\n");
  }
  renderLevel();

  echo("<tr>\n");
  echo("<td bgcolor=\"$OPT_col_lt\" class=\"small\" align=\"center\">\n");
  echo("<b>Tot</b>\n");
  echo("</td>\n");
  echo("<td bgcolor=\"$OPT_col_lt\" class=\"small\" align=\"center\">\n");
  echo("<b>Loc</b>\n");
  echo("</td>\n");
  echo("<td bgcolor=\"$OPT_col_dk\" class=\"small\" align=\"center\">\n");
  echo("<b>Inf-&gt;P</b>\n");
  echo("</td>\n");
  echo("<td bgcolor=\"$OPT_col_dk\" class=\"small\" align=\"center\">\n");
  echo("<b>C-&gt;Inf</b>\n");
  echo("</td>\n");
  echo("<td bgcolor=\"$OPT_col_dk\" class=\"small\" colspan=\"3\" align=\"center\">\n");
  echo("<b>Name</b>\n");
  echo("</td>\n");
  echo("<td bgcolor=\"$OPT_col_dk\" class=\"small\" colspan=\"2\" align=\"center\">\n");
  echo("<b>Owner</b>\n");
  echo("</td>\n");
  echo("<td bgcolor=\"$OPT_col_dk\" class=\"small\" colspan=\"".($maxLev)."\" align=\"center\">\n");
  echo("&nbsp;\n");
  echo("</td>\n");
  for ($i=0;$i<sizeOf($strings);$i++) // >
  {
    if ($oldLev > $levels[$i])
    {
      renderBar($oldLev);
    }
    elseif ($oldLev < $levels[$i]) // >
    {
      renderBar($levels[$i]);
    }
    echo("<tr>\n");
    echo("<td bgcolor=\"$OPT_col_lt\" align=\"right\"><b>".round($percents[$i])."%</b></td>\n");
    echo("<td bgcolor=\"$OPT_col_lt\" align=\"right\">$locals[$i]</td>\n");
    for($j=1;$j<=$levels[$i];$j++) // >
    {
      if ($j%2==0)
      {
        $col=$OPT_col_bg;
      }
      else
      {
        $col=$OPT_col_dk;
      }

      echo("<td bgcolor=\"$col\">&nbsp;</td>\n");
    }
    echo($strings[$i]);
    if ($levels[$i]!=$maxLev)
    {
      echo("<td bgcolor=\"$OPT_col_md\" colspan=\"".($maxLev-$levels[$i])."\">&nbsp;</td>\n");
    }
    echo("</tr>\n");
    $oldLev=$levels[$i];
  }
  renderBar(0);

  endTables();
  if ($no_tasks==1)
  {
    echo "<br><div class='regular' align='center'><i>No tasks set for this project</i></div>";
  }
  echo("<br>\n");
?>
<script language="javascript">
<!--
parent.leftFrame.location='leftmenu/?proj=<? echo $proj; ?>';
// -->
</script>
<?
  auth_close();
?>
</BODY>
</HTML>
